
note
	
	description: "[
		Object that can handle a condition (error, warning,
		information, etc).
		]"
	author: "David Hollenberg"
	date: "October 26, 2003"

deferred class CONDITION_HANDLER
inherit
	ANY
		redefine
			default_create
		end
	EXCEPTIONS
		export
			{NONE} all
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
			-- Initialize handler
		do
			create notify_actions
		end

feature -- Properties

	notify_actions: STRING_ACTION_SEQUENCE
			-- Actions to be executed when user chooses
			-- notify option, if option is available

	depth: INTEGER
			-- Depth of condition handling stack (used to
			-- prevent infinite recursion)

feature -- Operations

	handle (cond: APPLICATION_CONDITION)
			-- Handle condition `cond'
		require
			condition_exists: cond /= Void
			condition_valid: cond.is_valid
			condition_type_known: not cond.is_unknown
		deferred
		end

feature {NONE} -- Implementation

	handle_recursion_too_deep (cond: APPLICATION_CONDITION)
			-- Handle "recursion too deep" error for `cond'
		do
			raise ("Condition handler recursion too deep for tag " + cond.tag)
		end
	
end
