
note
	
	description: "[
		Developer exceptions that affect the flow of control
		in an application.
		]"
	author: "David Hollenberg"
	date: "March 19, 2003"

class CONTROL_FLOW_EXCEPTIONS
inherit
	ANY
	EXCEPTIONS_ACCESS
		export
			{NONE} all
		end

feature -- Properties

	is_retry_exception: BOOLEAN
			-- Is last exception originally due to
			-- a "retry" developer exception?
		do
			Result := exc.is_developer_exception_of_name (retry_exception_name) or exc.is_developer_exception_of_name (retry_vision2_exception_name)
		end

	is_abort_exception: BOOLEAN
			-- Is last exception originally due to
			-- an "abort" developer exception?
		do
			Result := exc.is_developer_exception_of_name (abort_exception_name) or exc.is_developer_exception_of_name (abort_vision2_exception_name)
		end

feature -- Operations

	raise_retry_exception
			-- Raise a "retry" developer exception
		do
			exc.raise (retry_exception_name)
		end

	raise_abort_exception
			-- Raise an "abort" developer exception
		do
			exc.raise (abort_exception_name)
		end

feature {NONE} -- Implementation

	retry_exception_name: STRING = "Retry"
			-- Name of developer exception that indicates
			-- operation should be retried

	abort_exception_name: STRING = "Abort"
			-- Name of developer exception that indicates
			-- operation should be aborted

	retry_vision2_exception_name: STRING = "Vision2 Exception: Retry Code: 24"
			-- Name of developer exception in Vision2 that 
			-- indicates operation should be retried

	abort_vision2_exception_name: STRING = "Vision2 Exception: Abort Code: 24"
			-- Name of developer exception in Vision2 that 
			-- indicates operation should be aborted

end
