
note
	
	description: "[
		Default Object that can handle a condition (error,
		warning, information, etc).
		]"
	author: "David Hollenberg"
	date: "October 30, 2003"

class DEFAULT_CONDITION_HANDLER
inherit
	CONDITION_HANDLER
	EXCEPTIONS
		export 
			{NONE} all
		undefine
			default_create
		end

feature -- Operations

	handle (cond: APPLICATION_CONDITION)
			-- Handle condition `cond'
		do
			raise (condition_description (cond))
		end

feature {NONE} -- Implementation

	condition_description (cond: APPLICATION_CONDITION): STRING
			-- Text describing `cond'
		local
			tried: BOOLEAN
		do
			if not tried then
				Result := cond.text_description
			else
				Result := "Cannot get text description for error condition"
			end
		rescue
			if not tried then
				tried := True
				retry
			end
		end

end
