
note
	
	description: "[
		An operation (piece of application logic) that
		includes error handling and which can be set at run-time.
		]"
	author: "David Hollenberg"
	date: "March 19, 2003"

deferred class DYNAMIC_OPERATION
inherit
	OPERATION
		redefine
			is_implementation_available
		end

feature -- Properties

	implementation: PROCEDURE [ANY, TUPLE]
			-- Implementation to be executed

	is_implementation_available: BOOLEAN
			-- Is the actual application logic available to
			-- be executed?
		do
			Result := implementation /= Void
		end

feature {NONE} -- Implementation

	set_implementation (i: like implementation)
			-- Set `implementation' to `i'
		do
			implementation := i
		ensure
			implementation_set: implementation = i
		end

	try_operation
			-- Try to execute operation and handle error, if any
		do
			implementation.call ([])
		end

end
