
note
	
	description: "Set of two parameters"
	author: "David Hollenberg"
	date: "March 12, 2003"

class PARAMETERS_2 [A, B]
inherit
	PARAMETER_SET
		redefine
			is_valid
		end


feature -- Properties

	parameter_1: A

	parameter_2: B

feature -- Modification

	set_parameter_1 (p: A)
		require
			argument_valid: is_valid_parameter_1 (p)
		do
			parameter_1 := p
		ensure
			parameter_set: parameter_1 = p
		end

	set_parameter_2 (p: B)
		require
			argument_valid: is_valid_parameter_2 (p)
		do
			parameter_2 := p
		ensure
			parameter_set: parameter_2 = p
		end

feature -- Validity

	is_valid: BOOLEAN
			-- Are all parameters valid?
		do
			Result := is_valid_parameter_1 (parameter_1) and
				is_valid_parameter_2 (parameter_2)
		end

	is_valid_parameter_1 (p: A): BOOLEAN
		do
			Result := p /= Void
		end

	is_valid_parameter_2 (p: B): BOOLEAN
		do
			Result := p /= Void
		end

end
