
note
	
	description: "Access to shared row count checking services"
	author: "David Hollenberg"
	date: "October 26, 2003"

deferred class ROW_COUNT_CHECK_ACCESS

feature {NONE} -- Properties

	check_row_count (list: LIST [DB_ROW] range: ITEM_COUNT_RANGE)
			-- Check that count of rows in `list' falls
			-- within `range'
		require
			list_exists: list /= Void
			range_exists: range /= Void
		do
			row_count_checker.check_count_within_range (list, last_query_text, last_query_bindings, range)
		end

	row_count_checker: ROW_COUNT_CHECK_OP
			-- Used to check that number of fetched rows
			-- matches expected count
		once
			create Result
		end

	last_query_text: STRING
			-- Text of last query used
		deferred
		end

	last_query_bindings: STRING
			-- Description of bindings for last query used
		deferred
		end

end
