
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%DATE, DATE, STRING"

class DB_BIND_DDS

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (d1, d2: DB_DATE; s3: STRING)
			-- Set `value1' to `d1', `value2' to `d2'
		do
			value1 := d1
			value2 := d2
			value3 := s3
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_date (1, value1, false)
			q.bind_num_to_date (2, value2, false)
			q.bind_num_to_string (3, value3, false)
		end

feature -- Properties

	value1: DB_DATE
			-- Value to bind to placeholder :1

	value2: DB_DATE
			-- Value to bind to placeholder :2

	value3: STRING

end
