
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "March 30, 2004"
	description: "Database binder which binds numeric placeholders to %
		%DATE, INTEGER"

class DB_BIND_DI

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (d: DB_DATE i: INTEGER)
			-- Set `value1' to `d', `value2' to `i'
		do
			value1 := d
			value2 := i
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (2)
			q.bind_num_to_date (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
		end

feature -- Properties

	value1: DB_DATE
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

end
