
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%DATE, NUMBER (DOUBLE)"

class DB_BIND_DN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (d: DB_DATE n: DOUBLE)
			-- Set `value1' to `d', `value2' to `n'
		do
			value1 := d
			value2 := n
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (2)
			q.bind_num_to_date (1, value1, false)
			q.bind_num_to_double (2, value2, false)
		end

feature -- Properties

	value1: DB_DATE
			-- Value to bind to placeholder :1

	value2: DOUBLE
			-- Value to bind to placeholder :2

end
