
note
	
	author: "David Hollenberg"
	date: "May 15, 2003"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, BOOLEAN"

class DB_BIND_IB

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i1: INTEGER b1: BOOLEAN)
			-- Set `value1' to `i1', `value2' to `b1'
		do
			value1 := i1
			value2 := b1
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (2)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_boolean (2, value2, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: BOOLEAN
			-- Value to bind to placeholder :2

end
