
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, CHARACTER"

class DB_BIND_IC

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER c: CHARACTER)
			-- Set `value1' to `i', `value2' to `c'
		do
			value1 := i
			value2 := c
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (2)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_character (2, value2, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: CHARACTER
			-- Value to bind to placeholder :2

end
