
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "May 18, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, CHARACTER, CHARACTER"

class DB_BIND_ICC

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER c1, c2: CHARACTER)
			-- Set `value1' to `i', `value2' to `c1',
			--  'value3' to c2
		do
			value1 := i
			value2 := c1
			value3 := c2
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- 'value2', and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_character (2, value2, false)
			q.bind_num_to_character (3, value3, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: CHARACTER
			-- Value to bind to placeholder :2

	value3: CHARACTER
			-- Value to bind to placeholder :3

end
