
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, INTEGER, INTEGER"

class DB_BIND_III

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i1, i2, i3: INTEGER)
			-- Set `value1' to `i1', `value2' to `i2' and
			-- `value3' to `i3'
		do
			value1 := i1
			value2 := i2
			value3 := i3
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_integer (3, value3, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: INTEGER
			-- Value to bind to placeholder :3

end
