
note
	
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, INTEGER, STRING"

class DB_BIND_IIS

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i1, i2: INTEGER s1: STRING)
			-- Set `value1' to `i1', `value2' to `i2',
			-- `value3' to `s1'
		do
			value1 := i1
			value2 := i2
			value3 := s1
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_string (3, value3, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

end
