
note
	
	author: "David Hollenberg"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, STRING, BOOLEAN"

class DB_BIND_ISB

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i1: INTEGER s1: STRING b1: BOOLEAN)
			-- Set `value1' to `i1', `value2' to `s1',
			-- `value3' to `b1'
		do
			value1 := i1
			value2 := s1
			value3 := b1
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_integer (1, value1, False)
			q.bind_num_to_string (2, value2, False)
			q.bind_num_to_boolean (3, value3, False)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: BOOLEAN
			-- Value to bind to placeholder :3

end
