
note
	
	author: "David Hollenberg"
	date: "February 29, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, STRING, INTEGER, NUMBER (DOUBLE)"

class DB_BIND_ISDN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER s: STRING d: DB_DATE n: DOUBLE)
			-- Set `value1' to `i', `value2' to `s',
			-- `value3' to `d', `value4' to `n'
		do
			value1 := i
			value2 := s
			value3 := d
			value4 := n
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (4)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_date (3, value3, false)
			q.bind_num_to_double (4, value4, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: DB_DATE
			-- Value to bind to placeholder :3

	value4: DOUBLE
			-- Value to bind to placeholder :4

end
