
note
	
	author: "David Hollenberg"
	date: "March 3, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, STRING, NUMBER (DOUBLE)"

class DB_BIND_ISN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER s: STRING n: DOUBLE)
			-- Set `value1' to `i', `value2' to `s',
			-- 'value3' to `n'
		do
			value1 := i
			value2 := s
			value3 := n
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_double (3, value3, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: DOUBLE
			-- Value to bind to placeholder :3

end
