
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, STRING, NUMBER (DOUBLE), NUMBER, NUMBER"

class DB_BIND_ISNNN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER s: STRING n1, n2, n3: DOUBLE)
			-- Set `value1' to `i', `value2' to `s',
			-- 'value3' to `n1', `value4' to `n2' and
			-- `value5' to `n3'
		do
			value1 := i
			value2 := s
			value3 := n1
			value4 := n2
			value5 := n3
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3', `value4' and `value5'
		do
			q.set_numeric_bind_capacity (5)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_double (3, value3, false)
			q.bind_num_to_double (4, value4, false)
			q.bind_num_to_double (5, value5, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: DOUBLE
			-- Value to bind to placeholder :3

	value4: DOUBLE
			-- Value to bind to placeholder :4

	value5: DOUBLE
			-- Value to bind to placeholder :5

end
