
note
	
	author: "David Hollenberg"
	date: "March 28, 2002"
	description: "Database binder which binds numeric placeholders to %
		%INTEGER, STRING, STRING, STRING"

class DB_BIND_ISSS

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (i: INTEGER s1, s2, s3: STRING)
			-- Set `value1' to `i', `value2' to `s1',
			-- `value3' to `s2', `value4' to `s3'
		do
			value1 := i
			value2 := s1
			value3 := s2
			value4 := s3
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3' and `value4'
		do
			q.set_numeric_bind_capacity (4)
			q.bind_num_to_integer (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_string (3, value3, false)
			q.bind_num_to_string (4, value4, false)
		end

feature -- Properties

	value1: INTEGER
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

	value4: STRING
			-- Value to bind to placeholder :4

end
