
note
	
	author: "David Hollenberg"
	date: "April 25, 2000"
	description: "Database binder which binds numeric placeholders to %
		%NUMBER (DOUBLE), NUMBER (DOUBLE)"

class DB_BIND_NN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (n1: DOUBLE n2: DOUBLE)
			-- Set `value1' to `n1', `value2' to `n2'
		do
			value1 := n1
			value2 := n2
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1'
			-- and `value2'
		do
			q.set_numeric_bind_capacity (2)
			q.bind_num_to_double (1, value1, false)
			q.bind_num_to_double (2, value2, false)
		end

feature -- Properties

	value1: DOUBLE
			-- Value to bind to placeholder :1

	value2: DOUBLE
			-- Value to bind to placeholder :2

end
