
note
	
	author: "David Hollenberg"
	date: "May 14, 2003"
	description: "Database binder which binds numeric placeholders to %
		%STRING, BOOLEAN, BOOLEAN"

class DB_BIND_SBB

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s1: STRING s2, s3: BOOLEAN)
			-- Set `value1' to `s1', `value2' to `s2',
			-- `value3' to `s3'
		do
			value1 := s1
			value2 := s2
			value3 := s3
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_boolean (2, value2, false)
			q.bind_num_to_boolean (3, value3, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: BOOLEAN
			-- Value to bind to placeholder :2

	value3: BOOLEAN
			-- Value to bind to placeholder :3

end
