
note
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 20, 2000"
	description: "Database binder which binds numeric placeholders to %
		%STRING, INTEGER, DATE"

class DB_BIND_SID

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s: STRING i: INTEGER d: DB_DATE)
			-- Set `value1' to `s', `value2' to `i',
			-- `value3' to `d'
		do
			value1 := s
			value2 := i
			value3 := d
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_date (3, value3, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: DB_DATE
			-- Value to bind to placeholder :3

end
