
note
	
	author: "David Hollenberg"
	date: "March 29, 2001"
	description: "Database binder which binds numeric placeholders to %
		%STRING, INTEGER, INTEGER, NUMBER (DOUBLE)"

class DB_BIND_SIIN

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s: STRING i1, i2: INTEGER n: DOUBLE)
			-- Set `value1' to `s', `value2' to `i1',
			-- `value3' to `i2' and `value4' to `n'
		do
			value1 := s
			value2 := i1
			value3 := i2
			value4 := n
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3' and `value4'
		do
			q.set_numeric_bind_capacity (4)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_integer (3, value3, false)
			q.bind_num_to_double (4, value4, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: INTEGER
			-- Value to bind to placeholder :3

	value4: DOUBLE
			-- Value to bind to placeholder :4

end
