
note
	
	author: "David Hollenberg"
	date: "March 26, 2002"
	description: "Database binder which binds numeric placeholders to %
		%STRING, INTEGER, STRING"

class DB_BIND_SIS

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s1: STRING i: INTEGER s2: STRING)
			-- Set `value1' to `s1', `value2' to `i',
			-- `value3' to `s2'
		do
			value1 := s1
			value2 := i
			value3 := s2
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2' and `value3'
		do
			q.set_numeric_bind_capacity (3)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_string (3, value3, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

end
