
note
	
	author: "David Hollenberg"
	date: "March 29, 2002"
	description: "Database binder which binds numeric placeholders to %
		%STRING, INTEGER, STRING, INTEGER"

class DB_BIND_SISI

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s1: STRING i1: INTEGER s2: STRING i2: INTEGER)
			-- Set `value1' to `s1', `value2' to `i1',
			-- `value3' to `s2', `value4' to `i2'
		do
			value1 := s1
			value2 := i1
			value3 := s2
			value4 := i2
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3' and `value4'
		do
			q.set_numeric_bind_capacity (4)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_integer (2, value2, false)
			q.bind_num_to_string (3, value3, false)
			q.bind_num_to_integer (4, value4, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: INTEGER
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

	value4: INTEGER
			-- Value to bind to placeholder :4

end
