
note
	
	author: "Lee Richardson"
	date: "January 17, 2003"
	description: "Database binder which binds numeric placeholders to %
		%STRING, STRING, STRING, DATE"

class DB_BIND_SSSD

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s1, s2, s3: STRING d: DB_DATE)
			-- Set `value1' to `s1', `value2' to `s2',
			-- `value3' to `s3', `value4' to `d'
		do
			value1 := s1
			value2 := s2
			value3 := s3
			value4 := d
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3', and `value4'
		do
			q.set_numeric_bind_capacity (4)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_string (3, value3, false)
			q.bind_num_to_date (4, value4, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

	value4: DB_DATE
			-- Value to bind to placeholder :4

end
