
note
	
	author: "David Hollenberg"
	description: "Database binder which binds numeric placeholders to %
		%STRING, STRING, STRING, INTEGER, INTEGER"

class DB_BIND_SSSII

inherit
	DB_BINDER

create
	make

feature -- Creation

	make (s1, s2, s3: STRING i4, i5: INTEGER)
			-- Set `value1' to `s1', `value2' to `s2',
			-- `value3' to `s3', `value4' to `i4' and
			-- `value5' to `i5'
		do
			value1 := s1
			value2 := s2
			value3 := s3
			value4 := i4
			value5 := i5
		end
	
feature -- Operations

	bind (q: SQL_STATEMENT)
			-- Bind numeric placeholders in `q' to `value1',
			-- `value2', `value3', `value4' and `value5'
		do
			q.set_numeric_bind_capacity (5)
			q.bind_num_to_string (1, value1, false)
			q.bind_num_to_string (2, value2, false)
			q.bind_num_to_string (3, value3, false)
			q.bind_num_to_integer (4, value4, false)
			q.bind_num_to_integer (5, value5, false)
		end

feature -- Properties

	value1: STRING
			-- Value to bind to placeholder :1

	value2: STRING
			-- Value to bind to placeholder :2

	value3: STRING
			-- Value to bind to placeholder :3

	value4: INTEGER
			-- Value to bind to placeholder :4

	value5: INTEGER
			-- Value to bind to placeholder :5

end
