
note
	
	author: "David Hollenberg"
	date:	"December 18, 1995"
	description: "Access to the default database connection"

class DB_ACCESS

feature -- Access

	db: DB_CONNECTION
			-- Default database connection
		do
		ensure
			result_not_void: result /= Void
		end
			
feature -- Modification

	set_db (conn: DB_CONNECTION)
			-- Set `db' to `conn'
		require
			conn_not_void: conn /= Void
		do
			db_cell.put (conn)
		ensure
			db_set: db = conn
		end
			
feature {NONE} -- Implementation

	db_cell: CELL [DB_CONNECTION]
			-- Cell to hold current default database connection
		once
			create Result.put (Void)
		ensure
			result_exists: result /= Void
		end
			
end
