
note
	
	author: "David Hollenberg"
	date:	"August 25, 1997"
	description: "A row or subset of a row from one database table %
		%which corresponds exactly to one specific database row %
		%and which can be locked, updated, inserted and deleted"

deferred class DB_DELETABLE_ROW

inherit
	DB_CHANGEABLE_ROW

feature -- Operations

feature -- Deletion
	
	delete
			-- Mark `Current' as deleted
		do
			raw_delete
		end
	
	delete_immediate
			-- Mark `Current' as deleted and delete it
			-- now in database, leaving it unregistered
		do
			if is_corrupted then
				handle_corrupted_access_error ("delete immediate")
			end
			if not is_registered then
				register_implicit
			end
			is_changed := False
			is_deleted := True
			if is_old then
				post_delete
			else
				is_deleted := False
			end
			connection.deregister (Current)
			is_registered := False
		end
	
end

