
note
	
	author: "David Hollenberg"
	date:	"November 1, 2006"
	description: "A row which can be detached from a database connection %
		%and which can executed some actions when it is detached"

deferred class DB_DETACHABLE_ROW

inherit
	DB_CHANGEABLE_ROW


feature -- Properties

	detach_actions: ACTION_SEQUENCE [TUPLE [like Current, like Current]]
			-- Actions to be executed when `detached_twin' is
			-- called
		do
			if detach_actions_internal = Void then
				create detach_actions_internal
			end
			Result := detach_actions_internal
		end

feature {NONE} -- Implementation

	call_detach_actions (a_detached_row: like Current)
			-- Execute `detach_actions' for `a_detached_row'
			-- which is detached version of `Current'
		do
			detach_actions.call ([Current, a_detached_row])
		end

	detach_actions_internal: like detach_actions
			-- Actions to be executed when `detached_twin' is
			-- called

end
