
note
	
	author: "David Hollenberg"
	date:	"December 18, 1995"
	description: "A handler for database-related errors"

deferred class DB_ERROR_HANDLER

feature

	handle_db_error (connection: DB_CONNECTION stmt: SQL_STATEMENT)
			-- Handle a database call interface error which
			-- occurred on connection `connection' and which
			-- involves statement `stmt' if non-void
		require
			connection_exists: connection /= Void
		deferred
		end

	handle_db_user_error (connection: DB_CONNECTION stmt: SQL_STATEMENT except, message: STRING)
			-- Handle a database error which is detected by
			-- us rather than by the database call interface.
			-- The error occurred on connection `connection' and
			-- involves cursor `cursor' if non-void.
			-- `except' is the exception tag to use if
			-- an exception is raised and `message' is the
			-- message to display.
		require
			connection_exists: connection /= Void
			exception_tag_exists: except /= Void
			message_exists: message /= Void
		deferred
		end

	set_error_display_suppressed (b: BOOLEAN)
			-- Set `error_display_suppressed' to `b'
		deferred
		ensure
			suppressed_set: error_display_suppressed = b
		end

	error_display_suppressed: BOOLEAN
			-- Should handler suppress display of error messages?
			-- If true, suppresses display of error messages.
			-- If false, error messages are displayed at
			-- handler's discretion.
		deferred
		end

end
