
note
	
	author: "David Hollenberg"
	date:	"February 26, 1996"
	description: "A query which returns DB_IDENTIFED_ROW objects from %
		%a relational database"

deferred class DB_IDENTIFIED_QUERY [reference G -> DB_IDENTIFIED_ROW]

inherit
	DB_ROWS_QUERY [G]

feature -- Properties

	distinct: BOOLEAN = False
			-- Should execution of `Current' return distinct rows?
			-- (Answer: no)
	
	frozen group_by: STRING
			-- Group by clause for query (none)
		do
		end
	
	frozen having: STRING
			-- Having clause for query (none)
		do
		end
	
	frozen set_operators: STRING
			-- Set operators clause for query (none)
		do
		end
	
	for_update: BOOLEAN
			-- Should execution of `Current' select rows for
			-- update, thereby locking the fetched rows?
			-- (Default: no)
		do
		end
	
	wait: BOOLEAN
			-- Should execution of `Current' wait
			-- if `for_update' is true and any
			-- rows are locked by another connection?
			-- (Default: connection default)
		do
			Result := connection.wait_for_locks
		end
	
feature {NONE} -- Properties

	busy_status_only: BOOLEAN
			-- Should execution of `Current' return and
			-- set `is_busy' if any selected rows are
			-- locked by another session?
			-- (Answer: no)
		do
			Result := False
		end
	
end
