
note
	
	author: "David Hollenberg"
	date:	"February 20, 2004"
	description: "An option that specifies what to do if a database row %
		%to be locked is busy (locked by another session)"

class DB_LOCK_BUSY_OPTION
inherit
	DB_LOCK_BUSY_CONST

create
	make_block, make_retry, make_return, make_default

feature {NONE} -- Creation

	make_block
			-- Create option that requests blocking until busy
			-- row is unlocked
		do
			value := Block
		end

	make_retry
			-- Create option that will try to lock row again
		do
			value := Try_again
		end

	make_return
			-- Create option that will return immediately and
			-- set busy indication
		do
			value := Return
		end

	make_default
			-- Create option that will take database connection
			-- default action (wait or try again)
		do
			value := Connection_default
		end

feature -- Properties

	value: INTEGER
			-- Value of option
end
