
note
	
	author: "David Hollenberg"
	date:	"February 20, 2004"
	description: "Options that specify what to do if a database row to be %
		%locked is busy (locked by another session)"

class DB_LOCK_BUSY_OPTIONS

feature -- Properties

	block: DB_LOCK_BUSY_OPTION
			-- Option that requests blocking until busy
			-- row is unlocked
		once
			create Result.make_block
		end

	try_again: DB_LOCK_BUSY_OPTION
			-- Option that will try to lock row again
		once
			create Result.make_retry
		end

	return: DB_LOCK_BUSY_OPTION
			-- Option that will return immediately and
			-- set busy indication
		once
			create Result.make_return
		end

	connection_default: DB_LOCK_BUSY_OPTION
			-- Option that will take database connection
			-- default action (wait or try again)
		once
			create Result.make_default
		end

end
