
note
	
	author: "David Hollenberg"
	date:	"March 26, 1996"
	description: "A set of options for a database query by key"

class DB_QUERY_OPTION

inherit
	DB_QUERY_OPTION_CONST

feature -- Modification

	set_old_row
			-- Set "row must exist in database"
		do
			require_old_row := True
			require_new_row := False
		ensure
			row_must_exist: require_old_row
		end

	set_new_row
			-- Set "row must not exist in database"
		do
			require_old_row := False
			require_new_row := True
		ensure
			row_cant_exist: require_new_row
		end

	set_old_or_new_row
			-- Set "row may or may not exist in database"
		do
			require_old_row := False
			require_new_row := False
		ensure
			old_or_new_allowed: allow_old_or_new_row
		end

	set_new_rows_checked (b: BOOLEAN)
			-- Set `new_rows_checked' to `b'
		do
			new_rows_checked := b
		ensure
			new_rows_checked_set: new_rows_checked = b
		end

	set_lock (b: BOOLEAN)
			-- Set `lock' to `b'
		do
			lock := b
		ensure
			lock_set: lock = b
		end

	set_wait (b: BOOLEAN)
			-- Set `wait' to `b'
		do
			wait := b
			override_connection_wait := True
		ensure
			wait_set: wait = b
			local_wait_set: override_connection_wait
		end

	set_no_exception (b: BOOLEAN)
			-- Set `no_exception' to `b'
		do
			no_exception := b
		ensure
			no_exception_set: no_exception = b
		end

end
