
note
	
	author: "David Hollenberg"
	date:	"March 26, 1996"
	description: "A constant set of options for a database query by key"

class DB_QUERY_OPTION_CONST


feature -- Properties

	allow_old_or_new_row: BOOLEAN
			-- Is it OK for row with specified key to
			-- either exist or not exist in database?
		do
			Result := not require_old_row and not require_new_row
		end

	require_old_row: BOOLEAN
			-- Must row with specified key exist in database?
			-- If so, it is an error if no such row exists.

	require_new_row: BOOLEAN
			-- Must row with specified key not exist in database?
			-- If so, it is an error if row with key exists.

	new_rows_checked: BOOLEAN
			-- Should the database be checked for rows which
			-- are required to be new to see whether a row
			-- with specified key exists in database?

	lock: BOOLEAN
			-- Should the row with specified key be locked if
			-- it exists in database?

	override_connection_wait: BOOLEAN
			-- Does the `wait' option override the connection
			-- default specified by `wait_for_locks'?  If not,
			-- then `wait' is ignored

	wait: BOOLEAN
			-- Should the query wait (if necessary) if row with
			-- specified key exists in database and `lock' is true?

	no_exception: BOOLEAN
			-- Should raising of exception be suppressed
			-- if an error is detected (e.g., row with
			-- specified key must exist in database, but
			-- does not)?  If so, row is marked `is_empty'
			-- if there is an error.

end
