
note
	
	author: "David Hollenberg"
	date:	"November 16, 2005"
	description: "A pair of database row sets"

class DB_ROW_SET_PAIR [G -> DB_HASHABLE_ROW]

create
	make_from_lists

feature {NONE} -- Creation

	make_from_lists (list1, list2: LIST [G] eq_tester: KL_EQUALITY_TESTER [G])
			-- Create from `list1' and `list2'
		do
			create {DS_HASH_SET [G]} set1.make (list1.count)
			create {DS_HASH_SET [G]} set2.make (list2.count)
			set1.set_equality_tester (eq_tester)
			set2.set_equality_tester (eq_tester)
			append_to_set (set1, list1)
			append_to_set (set2, list2)
		end

feature -- Properties

	set1: DS_SET [G]
			-- First row set

	set2: like set1
			-- Second row set

	is_identical: BOOLEAN
			-- Are `set1' and `set2' identical?
		do
			Result := set1.is_equal (set2)
		end

	subtraction: LIST [G]
			-- `set1' minus `set2'
		local
			list: like set1
		do
			list := set1.subtraction (set2)
			create {ARRAYED_LIST [G]} Result.make (list.count)
			from
				list.start
			until
				list.after
			loop
				Result.extend (list.item_for_iteration)
				list.forth
			end
		end

feature {NONE} -- Implementation

	append_to_set (s: DS_SET [G] a_list: LIST [G])
		local
			list: LIST [G]
		do
			list := a_list.twin
			from
				list.start
			until
				list.after
			loop
				s.put (list.item)
				list.forth
			end
		end

end
