

note
	
	author: "David Hollenberg"
	date:	"January 16, 2002"
	description: "A database signal (alert) sent from one session to another"

class DB_SIGNAL
inherit
	COMPARABLE
		redefine
			is_equal
		end
	STRING_UTILITIES_ACCESS
		redefine
			is_equal
		end
create
	make

feature {NONE} -- Creation

	make (the_name, the_msg: STRING)
			-- Create new database signal object with
			-- signal name `the_name' and associated message
			-- `the_msg'
		require
			name_exists: the_name /= Void
			name_long_enough: the_name.count > 0
			name_upper_case: su.is_upper_case (the_name)
		do
			name := the_name
			message := the_msg
		end

feature -- Properties

	name: STRING
			-- Name of signal

	message: STRING
			-- Message associated with signal or Void if none

feature -- Comparison

	is_less alias "<" (other: like Current): BOOLEAN
			-- Is current object less than `other'?
		do
			Result := name < other.name
		end

feature -- Equality

	is_equal (other: like Current): BOOLEAN
			-- Is `other' attached to an object considered
			-- equal to current object?
		do
			Result := name.is_equal (other.name) and equal (message, other.message)
		end

invariant
	name_exists: name /= Void
end
