
note
	
	author: "David Hollenberg"
	date:	"February 21, 1996"
	description: "An item which can be posted to a relational database. %
		%The item may represent either a single row or a group of %
		%rows."

deferred class POSTABLE

feature -- Operations

	post
			-- Post `Current' to database
		deferred
		end

	set_corrupted
			-- Mark `Current' as corrupt (invalidated by rollback)
		deferred
		end

feature -- Properties

	is_registered: BOOLEAN
			-- Has item been registered with transaction
			-- manager for its connection?
		deferred
		end

	transaction_number: INTEGER
			-- Number of transaction of which `Current' is
			-- a part or zero if not part of any specific
			-- transaction
		deferred
		ensure
			nonnegative_result: Result >= 0
		end

	rowid: DB_ROWID
			-- Rowid of row `Current' represents.  If void,
			-- then `Current' either represents more than one row
			-- (e.g., a bulk delete) or represents a new row
			-- to be inserted which does not yet have a rowid
		deferred
		end

	connection: DB_CONNECTION
			-- Database connection with which `Current' is
			-- associated.  Used to catch error of posting
			-- something associated with one connection to
			-- a different connection.
		deferred
		end

end
