
note
	
	author: "David Hollenberg"
	date:	"April 2, 2001"
	description: "A SQL query select item and its properties"

deferred class QUERY_SELECT_ITEM

feature -- Properties

	position: INTEGER
			-- Position of select item for which `Current'
			-- is a description
		deferred
		ensure
			nonnegative_result: Result > 0
		end
	
	max_dict_size: INTEGER
			-- Maximum size of select item as stored in
			-- data dictionary (zero for LONG columns,
			-- same as `max_display_size' for functions
			-- returning CHAR)
		deferred
		ensure
			nonnegative_result: Result >= 0
		end
	
	max_display_size: INTEGER
			-- Maximum display size of select item if it is
			-- returned as a character string
		deferred
		ensure
			nonnegative_result: Result >= 0
		end
	
	precision: INTEGER
			-- Precision of numeric select item
		require
			is_number: is_number
		deferred
		ensure
			nonnegative_result: Result >= 0
		end
	
	scale: INTEGER
			-- Scale of numeric select item
		require
			is_number: is_number
		deferred
		end
	
	null_allowed: BOOLEAN
			-- Is null possible for select item?
		deferred
		end
	
	name: STRING
			-- Select item name
		deferred
		ensure
			valid_result: Result /= Void
		end

	is_number: BOOLEAN
			-- Is item internal datatype NUMBER?
		deferred
		end
	
	is_date: BOOLEAN
			-- Is item internal datatype DATE?
		deferred
		end
	
	is_rowid: BOOLEAN
			-- Is item internal datatype ROWID?
		deferred
		end
	
	is_mlslabel: BOOLEAN
			-- Is item internal datatype MLSLABEL?
		deferred
		end
	
	is_varchar2: BOOLEAN
			-- Is item internal datatype VARCHAR2?
		deferred
		end
	
	is_long: BOOLEAN
			-- Is item internal datatype LONG?
		deferred
		end
	
	is_raw: BOOLEAN
			-- Is item internal datatype RAW?
		deferred
		end
	
	is_long_raw: BOOLEAN
			-- Is item internal datatype LONG RAW?
		deferred
		end
	
	is_char: BOOLEAN
			-- Is item internal datatype CHAR?
		deferred
		end
	
	is_string_type: BOOLEAN
			-- Is item internal datatype a "string" datatype
			-- (fixed length or variable length, long or not long,
			-- character or raw)?
		deferred
		end

	is_long_type: BOOLEAN
			-- Is item internal datatype a "long string" datatype
			-- (character or raw)?
		deferred
		end

	is_raw_type: BOOLEAN
			-- Is item internal datatype a "raw string" datatype
			-- (long or not long)?
		deferred
		end

feature -- Operations

	display
			-- Display select item (for debugging purposes)
		deferred
		end

end
