
note

	date: "Mon Nov 22 15:36:17 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application WEB_SERVICES, database user ALLMOSIS"
	database_tables: 
		"CONTENT_TYPES (MOSIS.CONTENT_TYPES)"
			-- Included columns
			-- 	CONTENT_TYPE_ID
			-- 	DESCR
			-- 	FILENAME_SUFFIX
			-- 	ICON_FILENAME
			-- 	MIME_CONTENT_SUBTYPE
			-- 	MIME_CONTENT_TYPE
			-- Excluded columns
			-- 	(none)

class CONTENT_TYPES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_content_type_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_content_type_id_exists: the_content_type_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			content_type_id := the_content_type_id
			is_null_content_type_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  content_type_id, descr, filename_suffix, icon_filename,%N  mime_content_subtype, mime_content_type"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "content_types ct"

	join_condition: STRING = ""

	table_name: STRING = "content_types"

	key_where_clause: STRING = "content_type_id = :1"

feature -- Values

	content_type_id: STRING
			-- DB: VARCHAR2(10) not null

	descr: STRING
			-- DB: VARCHAR2(255)

	filename_suffix: STRING
			-- DB: VARCHAR2(25)

	icon_filename: STRING
			-- DB: VARCHAR2(255)

	mime_content_subtype: STRING
			-- DB: VARCHAR2(25) not null

	mime_content_type: STRING
			-- DB: VARCHAR2(12) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_filename_suffix: BOOLEAN
	is_null_icon_filename: BOOLEAN

feature -- Nullness for non-null columns

	is_null_content_type_id: BOOLEAN
	is_null_mime_content_subtype: BOOLEAN
	is_null_mime_content_type: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (content_type_id, r.content_type_id)
			Result := Result
				and is_null_content_type_id = r.is_null_content_type_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (descr, r.descr)
				and equal (filename_suffix, r.filename_suffix)
				and equal (icon_filename, r.icon_filename)
				and equal (mime_content_subtype, r.mime_content_subtype)
				and equal (mime_content_type, r.mime_content_type)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_filename_suffix = r.is_null_filename_suffix
				and is_null_icon_filename = r.is_null_icon_filename
				and is_null_mime_content_subtype = r.is_null_mime_content_subtype
				and is_null_mime_content_type = r.is_null_mime_content_type
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 10)
			q.select_string (2, 255)
			q.select_string (3, 25)
			q.select_string (4, 255)
			q.select_string (5, 25)
			q.select_string (6, 12)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
		end

	fill_in_references (q: SQL_QUERY)
		do
			content_type_id := q.string_value (1)
			descr := q.string_value (2)
			filename_suffix := q.string_value (3)
			icon_filename := q.string_value (4)
			mime_content_subtype := q.string_value (5)
			mime_content_type := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, content_type_id)
			q.get_string_value (2, descr)
			q.get_string_value (3, filename_suffix)
			q.get_string_value (4, icon_filename)
			q.get_string_value (5, mime_content_subtype)
			q.get_string_value (6, mime_content_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_content_type_id := q.is_null (1)
			is_null_descr := q.is_null (2)
			is_null_filename_suffix := q.is_null (3)
			is_null_icon_filename := q.is_null (4)
			is_null_mime_content_subtype := q.is_null (5)
			is_null_mime_content_type := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_content_type_id := True
			create content_type_id.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_filename_suffix := True
			is_null_icon_filename := True
			is_null_mime_content_subtype := True
			is_null_mime_content_type := True
			create descr.make (0)
			create filename_suffix.make (0)
			create icon_filename.make (0)
			create mime_content_subtype.make (0)
			create mime_content_type.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, content_type_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			q.get_string_value (1, s)
			Result := Result and equal (content_type_id, s)
			q.get_string_value (2, s)
			Result := Result and equal (descr, s)
			q.get_string_value (3, s)
			Result := Result and equal (filename_suffix, s)
			q.get_string_value (4, s)
			Result := Result and equal (icon_filename, s)
			q.get_string_value (5, s)
			Result := Result and equal (mime_content_subtype, s)
			q.get_string_value (6, s)
			Result := Result and equal (mime_content_type, s)
			Result := Result
				and is_null_content_type_id = q.is_null (1)
				and is_null_descr = q.is_null (2)
				and is_null_filename_suffix = q.is_null (3)
				and is_null_icon_filename = q.is_null (4)
				and is_null_mime_content_subtype = q.is_null (5)
				and is_null_mime_content_type = q.is_null (6)
		end

end
