
note

	date: "Thu Jan 21 12:59:40 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_IC_DESIGN_FILE_LAYERS (MOSIS.CUST_IC_DESIGN_FILE_LAYERS)"
			-- Included columns
			-- 	DENSITY
			-- 	DESIGN_NO
			-- 	FILE_NO
			-- 	LAYER_NAME
			-- Excluded columns
			-- 	(none)

class CUST_IC_DESIGN_FILE_LAYERS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_no: INTEGER; the_file_no: INTEGER; the_layer_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_layer_name_exists: the_layer_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_no := the_design_no
			file_no := the_file_no
			layer_name := the_layer_name
			is_null_design_no := False
			is_null_file_no := False
			is_null_layer_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  density, design_no, file_no, layer_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_ic_design_file_layers cidfl"

	join_condition: STRING = ""

	table_name: STRING = "cust_ic_design_file_layers"

	key_where_clause: STRING = "design_no = :1 and file_no = :2 and layer_name = :3"

feature -- Values

	density: DOUBLE
			-- DB: NUMBER(*,*)

	design_no: INTEGER
			-- DB: NUMBER(6,0) not null

	file_no: INTEGER
			-- DB: NUMBER(4,0) not null

	layer_name: STRING
			-- DB: VARCHAR2(255) not null

feature -- Nullness for null allowed columns

	is_null_density: BOOLEAN

feature -- Nullness for non-null columns

	is_null_design_no: BOOLEAN
	is_null_file_no: BOOLEAN
	is_null_layer_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
				and file_no = r.file_no
			Result := Result
				and equal (layer_name, r.layer_name)
			Result := Result
				and is_null_design_no = r.is_null_design_no
				and is_null_file_no = r.is_null_file_no
				and is_null_layer_name = r.is_null_layer_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and density = r.density
			Result := Result
				and is_null_density = r.is_null_density
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_integer (2)
			q.select_integer (3)
			q.select_string (4, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			density := q.double_value (1)
			design_no := q.integer_value (2)
			file_no := q.integer_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			layer_name := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, layer_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_density := q.is_null (1)
			is_null_design_no := q.is_null (2)
			is_null_file_no := q.is_null (3)
			is_null_layer_name := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_no := True
			is_null_file_no := True
			is_null_layer_name := True
			create layer_name.make (0)
		end

	set_null_nonkey
		do
			is_null_density := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, design_no, False)
			q.bind_num_to_integer (2, file_no, False)
			q.bind_num_to_string (3, layer_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and density = q.double_value (1)
				and design_no = q.integer_value (2)
				and file_no = q.integer_value (3)
			q.get_string_value (4, s)
			Result := Result and equal (layer_name, s)
			Result := Result
				and is_null_density = q.is_null (1)
				and is_null_design_no = q.is_null (2)
				and is_null_file_no = q.is_null (3)
				and is_null_layer_name = q.is_null (4)
		end

end
