
note

	date: "Thu Jan 21 12:59:41 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_IC_DESIGN_MEASUREMENTS (MOSIS.CUST_IC_DESIGN_MEASUREMENTS)"
			-- Included columns
			-- 	DESIGN_NO
			-- 	ITEM_NAME
			-- 	NUMERIC_VALUE
			-- Excluded columns
			-- 	(none)

class CUST_IC_DESIGN_MEASUREMENTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_no: INTEGER; the_item_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_item_name_exists: the_item_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_no := the_design_no
			item_name := the_item_name
			is_null_design_no := False
			is_null_item_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 3

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  design_no, item_name, numeric_value"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_ic_design_measurements cidm"

	join_condition: STRING = ""

	table_name: STRING = "cust_ic_design_measurements"

	key_where_clause: STRING = "design_no = :1 and item_name = :2"

feature -- Values

	design_no: INTEGER
			-- DB: NUMBER(6,0) not null

	item_name: STRING
			-- DB: VARCHAR2(15) not null

	numeric_value: DOUBLE
			-- DB: NUMBER(*,*)

feature -- Nullness for null allowed columns

	is_null_numeric_value: BOOLEAN

feature -- Nullness for non-null columns

	is_null_design_no: BOOLEAN
	is_null_item_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
			Result := Result
				and equal (item_name, r.item_name)
			Result := Result
				and is_null_design_no = r.is_null_design_no
				and is_null_item_name = r.is_null_item_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and numeric_value = r.numeric_value
			Result := Result
				and is_null_numeric_value = r.is_null_numeric_value
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 15)
			q.select_double (3)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			design_no := q.integer_value (1)
			numeric_value := q.double_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			item_name := q.string_value (2)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, item_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_design_no := q.is_null (1)
			is_null_item_name := q.is_null (2)
			is_null_numeric_value := q.is_null (3)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_no := True
			is_null_item_name := True
			create item_name.make (0)
		end

	set_null_nonkey
		do
			is_null_numeric_value := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, design_no, False)
			q.bind_num_to_string (2, item_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and design_no = q.integer_value (1)
				and numeric_value = q.double_value (3)
			q.get_string_value (2, s)
			Result := Result and equal (item_name, s)
			Result := Result
				and is_null_design_no = q.is_null (1)
				and is_null_item_name = q.is_null (2)
				and is_null_numeric_value = q.is_null (3)
		end

end
