
note

	date: "Thu Jan 21 12:59:41 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_IC_DESIGN_PADS (MOSIS.CUST_IC_DESIGN_PADS)"
			-- Included columns
			-- 	BONDED
			-- 	CENTER_X
			-- 	CENTER_Y
			-- 	DESIGN_NO
			-- 	NET_NAME
			-- 	PAD_NAME
			-- 	PAD_TYPE
			-- 	SIZE_X
			-- 	SIZE_Y
			-- Excluded columns
			-- 	(none)

class CUST_IC_DESIGN_PADS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_no: INTEGER; the_pad_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_pad_name_exists: the_pad_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_no := the_design_no
			pad_name := the_pad_name
			is_null_design_no := False
			is_null_pad_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 9

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  bonded, center_x, center_y, design_no, net_name, pad_name, pad_type,%N  size_x, size_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_ic_design_pads cidp"

	join_condition: STRING = ""

	table_name: STRING = "cust_ic_design_pads"

	key_where_clause: STRING = "design_no = :1 and pad_name = :2"

feature -- Values

	bonded: BOOLEAN
			-- DB: CHAR(1) not null

	center_x: DOUBLE
			-- DB: NUMBER(9,3) not null

	center_y: DOUBLE
			-- DB: NUMBER(9,3) not null

	design_no: INTEGER
			-- DB: NUMBER(6,0) not null

	net_name: STRING
			-- DB: VARCHAR2(25)

	pad_name: STRING
			-- DB: VARCHAR2(6) not null

	pad_type: STRING
			-- DB: VARCHAR2(10)

	size_x: DOUBLE
			-- DB: NUMBER(9,3) not null

	size_y: DOUBLE
			-- DB: NUMBER(9,3) not null

feature -- Nullness for null allowed columns

	is_null_net_name: BOOLEAN
	is_null_pad_type: BOOLEAN

feature -- Nullness for non-null columns

	is_null_bonded: BOOLEAN
	is_null_center_x: BOOLEAN
	is_null_center_y: BOOLEAN
	is_null_design_no: BOOLEAN
	is_null_pad_name: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
			Result := Result
				and equal (pad_name, r.pad_name)
			Result := Result
				and is_null_design_no = r.is_null_design_no
				and is_null_pad_name = r.is_null_pad_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and bonded = r.bonded
				and center_x = r.center_x
				and center_y = r.center_y
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (net_name, r.net_name)
				and equal (pad_type, r.pad_type)
			Result := Result
				and is_null_bonded = r.is_null_bonded
				and is_null_center_x = r.is_null_center_x
				and is_null_center_y = r.is_null_center_y
				and is_null_net_name = r.is_null_net_name
				and is_null_pad_type = r.is_null_pad_type
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_double (2)
			q.select_double (3)
			q.select_integer (4)
			q.select_string (5, 25)
			q.select_string (6, 6)
			q.select_string (7, 10)
			q.select_double (8)
			q.select_double (9)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			bonded := q.boolean_value (1)
			center_x := q.double_value (2)
			center_y := q.double_value (3)
			design_no := q.integer_value (4)
			size_x := q.double_value (8)
			size_y := q.double_value (9)
		end

	fill_in_references (q: SQL_QUERY)
		do
			net_name := q.string_value (5)
			pad_name := q.string_value (6)
			pad_type := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (5, net_name)
			q.get_string_value (6, pad_name)
			q.get_string_value (7, pad_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_bonded := q.is_null (1)
			is_null_center_x := q.is_null (2)
			is_null_center_y := q.is_null (3)
			is_null_design_no := q.is_null (4)
			is_null_net_name := q.is_null (5)
			is_null_pad_name := q.is_null (6)
			is_null_pad_type := q.is_null (7)
			is_null_size_x := q.is_null (8)
			is_null_size_y := q.is_null (9)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_no := True
			is_null_pad_name := True
			create pad_name.make (0)
		end

	set_null_nonkey
		do
			is_null_bonded := True
			is_null_center_x := True
			is_null_center_y := True
			is_null_net_name := True
			is_null_pad_type := True
			is_null_size_x := True
			is_null_size_y := True
			create net_name.make (0)
			create pad_type.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, design_no, False)
			q.bind_num_to_string (2, pad_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and bonded = q.boolean_value (1)
				and center_x = q.double_value (2)
				and center_y = q.double_value (3)
				and design_no = q.integer_value (4)
				and size_x = q.double_value (8)
				and size_y = q.double_value (9)
			q.get_string_value (5, s)
			Result := Result and equal (net_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (pad_name, s)
			q.get_string_value (7, s)
			Result := Result and equal (pad_type, s)
			Result := Result
				and is_null_bonded = q.is_null (1)
				and is_null_center_x = q.is_null (2)
				and is_null_center_y = q.is_null (3)
				and is_null_design_no = q.is_null (4)
				and is_null_net_name = q.is_null (5)
				and is_null_pad_name = q.is_null (6)
				and is_null_pad_type = q.is_null (7)
				and is_null_size_x = q.is_null (8)
				and is_null_size_y = q.is_null (9)
		end

end
