
note

	date: "Thu Sep 15 12:46:46 2011"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user BSMITH"
	database_tables: 
		"CUST_IC_DESIGN_YN_ANSWERS (MOSIS.CUST_IC_DESIGN_YN_ANSWERS)"
			-- Included columns
			-- 	ANSWER
			-- 	DESIGN_NO
			-- 	PARAGRAPH_ID
			-- 	SUBMISSION_NO
			-- 	VERSION_NO
			-- Excluded columns
			-- 	IS_QUESTION

class CUST_IC_DESIGN_YN_ANSWERS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_no: INTEGER; the_submission_no: INTEGER; the_paragraph_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_paragraph_id_exists: the_paragraph_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_no := the_design_no
			submission_no := the_submission_no
			paragraph_id := the_paragraph_id
			is_null_design_no := False
			is_null_submission_no := False
			is_null_paragraph_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  answer, design_no, paragraph_id, submission_no, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_ic_design_yn_answers cwea"

	join_condition: STRING = ""

	table_name: STRING = "cust_ic_design_yn_answers"

	key_where_clause: STRING = "design_no = :1 and submission_no = :2 and paragraph_id = :3"

feature -- Values

	answer: BOOLEAN
			-- DB: CHAR(1) not null

	design_no: INTEGER
			-- DB: NUMBER(6,0) not null

	paragraph_id: STRING
			-- DB: VARCHAR2(20) not null

	submission_no: INTEGER
			-- DB: NUMBER(3,0) not null

	version_no: INTEGER
			-- DB: NUMBER(3,0) not null

feature -- Nullness for non-null columns

	is_null_answer: BOOLEAN
	is_null_design_no: BOOLEAN
	is_null_paragraph_id: BOOLEAN
	is_null_submission_no: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
				and submission_no = r.submission_no
			Result := Result
				and equal (paragraph_id, r.paragraph_id)
			Result := Result
				and is_null_design_no = r.is_null_design_no
				and is_null_paragraph_id = r.is_null_paragraph_id
				and is_null_submission_no = r.is_null_submission_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and answer = r.answer
				and version_no = r.version_no
			Result := Result
				and is_null_answer = r.is_null_answer
				and is_null_version_no = r.is_null_version_no
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_integer (2)
			q.select_string (3, 20)
			q.select_integer (4)
			q.select_integer (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			answer := q.boolean_value (1)
			design_no := q.integer_value (2)
			submission_no := q.integer_value (4)
			version_no := q.integer_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			paragraph_id := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, paragraph_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_answer := q.is_null (1)
			is_null_design_no := q.is_null (2)
			is_null_paragraph_id := q.is_null (3)
			is_null_submission_no := q.is_null (4)
			is_null_version_no := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_no := True
			is_null_submission_no := True
			is_null_paragraph_id := True
			create paragraph_id.make (0)
		end

	set_null_nonkey
		do
			is_null_answer := True
			is_null_version_no := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, design_no, False)
			q.bind_num_to_integer (2, submission_no, False)
			q.bind_num_to_string (3, paragraph_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and answer = q.boolean_value (1)
				and design_no = q.integer_value (2)
				and submission_no = q.integer_value (4)
				and version_no = q.integer_value (5)
			q.get_string_value (3, s)
			Result := Result and equal (paragraph_id, s)
			Result := Result
				and is_null_answer = q.is_null (1)
				and is_null_design_no = q.is_null (2)
				and is_null_paragraph_id = q.is_null (3)
				and is_null_submission_no = q.is_null (4)
				and is_null_version_no = q.is_null (5)
		end

end
