
note

	date: "Mon Dec  6 14:37:49 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_QUOTES (MOSIS.CUST_QUOTES)"
			-- Included columns
			-- 	APPROVED_BY
			-- 	APPROVED_BY_TITLE
			-- 	CUST_ACCT_NO
			-- 	CUST_QUOTE_ID
			-- 	DATE_DOCUMENT
			-- 	DATE_EFFECTIVE
			-- 	DATE_EXPIRES
			-- 	DATE_NOTIFY_SENT
			-- 	DATE_REPLACED
			-- 	DELIVERABLE
			-- 	DIV_NO
			-- 	MAILING_LABEL
			-- 	M_COMMENTS
			-- 	M_CUST_QUOTE_NO
			-- 	NET_ADDRESS_BCC
			-- 	NET_ADDRESS_TO
			-- 	OLD_QUOTE_CUST_ACCT_NO
			-- 	ORG_NO
			-- 	PREPARED_BY
			-- 	REVISION
			-- 	TERMS_PAYMENT
			-- Excluded columns
			-- 	(none)

class CUST_QUOTES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_cust_quote_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_cust_quote_no := the_m_cust_quote_no
			is_null_m_cust_quote_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 21

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  approved_by, approved_by_title, cust_acct_no, cust_quote_id,%N  date_document, date_effective, date_expires, date_notify_sent,%N  date_replaced, deliverable, div_no, mailing_label, m_comments,%N  m_cust_quote_no, net_address_bcc, net_address_to, old_quote_cust_acct_no,%N  org_no, prepared_by, revision, terms_payment"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_quotes cq"

	join_condition: STRING = ""

	table_name: STRING = "cust_quotes"

	key_where_clause: STRING = "m_cust_quote_no = :1"

feature -- Values

	approved_by: STRING
			-- DB: VARCHAR2(30)

	approved_by_title: STRING
			-- DB: VARCHAR2(30)

	cust_acct_no: INTEGER
			-- DB: NUMBER(6,0)

	cust_quote_id: STRING
			-- DB: VARCHAR2(15) not null

	date_document: DB_DATE
			-- DB: DATE not null

	date_effective: DB_DATE
			-- DB: DATE not null

	date_expires: DB_DATE
			-- DB: DATE

	date_notify_sent: DB_DATE
			-- DB: DATE

	date_replaced: DB_DATE
			-- DB: DATE

	deliverable: BOOLEAN
			-- DB: CHAR(1) not null

	div_no: INTEGER
			-- DB: NUMBER(6,0)

	mailing_label: STRING
			-- DB: VARCHAR2(1000)

	m_comments: STRING
			-- DB: VARCHAR2(300)

	m_cust_quote_no: INTEGER
			-- DB: NUMBER(8,0) not null

	net_address_bcc: STRING
			-- DB: VARCHAR2(300)

	net_address_to: STRING
			-- DB: VARCHAR2(300)

	old_quote_cust_acct_no: INTEGER
			-- DB: NUMBER(6,0)

	org_no: INTEGER
			-- DB: NUMBER(6,0)

	prepared_by: STRING
			-- DB: VARCHAR2(30)

	revision: STRING
			-- DB: CHAR(1) not null
			-- Eiffel type specified explicitly

	terms_payment: STRING
			-- DB: VARCHAR2(20)

feature -- Maximum database lengths for character columns

	maxlen_approved_by: INTEGER = 30
	maxlen_approved_by_title: INTEGER = 30
	maxlen_cust_quote_id: INTEGER = 15
	maxlen_mailing_label: INTEGER = 1000
	maxlen_m_comments: INTEGER = 300
	maxlen_net_address_bcc: INTEGER = 300
	maxlen_net_address_to: INTEGER = 300
	maxlen_prepared_by: INTEGER = 30
	maxlen_revision: INTEGER = 1
	maxlen_terms_payment: INTEGER = 20

feature -- Precisions for number columns

	precision_cust_acct_no: INTEGER = 6
	precision_div_no: INTEGER = 6
	precision_m_cust_quote_no: INTEGER = 8
	precision_old_quote_cust_acct_no: INTEGER = 6
	precision_org_no: INTEGER = 6

feature -- Scales for number columns

	scale_cust_acct_no: INTEGER = 0
	scale_div_no: INTEGER = 0
	scale_m_cust_quote_no: INTEGER = 0
	scale_old_quote_cust_acct_no: INTEGER = 0
	scale_org_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_approved_by: BOOLEAN
	is_null_approved_by_title: BOOLEAN
	is_null_cust_acct_no: BOOLEAN
	is_null_date_expires: BOOLEAN
	is_null_date_notify_sent: BOOLEAN
	is_null_date_replaced: BOOLEAN
	is_null_div_no: BOOLEAN
	is_null_mailing_label: BOOLEAN
	is_null_m_comments: BOOLEAN
	is_null_net_address_bcc: BOOLEAN
	is_null_net_address_to: BOOLEAN
	is_null_old_quote_cust_acct_no: BOOLEAN
	is_null_org_no: BOOLEAN
	is_null_prepared_by: BOOLEAN
	is_null_terms_payment: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cust_quote_id: BOOLEAN
	is_null_date_document: BOOLEAN
	is_null_date_effective: BOOLEAN
	is_null_deliverable: BOOLEAN
	is_null_m_cust_quote_no: BOOLEAN
	is_null_revision: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_cust_quote_no = r.m_cust_quote_no
			Result := Result
				and is_null_m_cust_quote_no = r.is_null_m_cust_quote_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cust_acct_no = r.cust_acct_no
				and deliverable = r.deliverable
				and div_no = r.div_no
				and old_quote_cust_acct_no = r.old_quote_cust_acct_no
				and org_no = r.org_no
			Result := Result
				and equal (approved_by, r.approved_by)
				and equal (approved_by_title, r.approved_by_title)
				and equal (cust_quote_id, r.cust_quote_id)
				and equal (date_document, r.date_document)
				and equal (date_effective, r.date_effective)
				and equal (date_expires, r.date_expires)
				and equal (date_notify_sent, r.date_notify_sent)
				and equal (date_replaced, r.date_replaced)
				and equal (mailing_label, r.mailing_label)
				and equal (m_comments, r.m_comments)
				and equal (net_address_bcc, r.net_address_bcc)
				and equal (net_address_to, r.net_address_to)
				and equal (prepared_by, r.prepared_by)
				and equal (revision, r.revision)
				and equal (terms_payment, r.terms_payment)
			Result := Result
				and is_null_approved_by = r.is_null_approved_by
				and is_null_approved_by_title = r.is_null_approved_by_title
				and is_null_cust_acct_no = r.is_null_cust_acct_no
				and is_null_cust_quote_id = r.is_null_cust_quote_id
				and is_null_date_document = r.is_null_date_document
				and is_null_date_effective = r.is_null_date_effective
				and is_null_date_expires = r.is_null_date_expires
				and is_null_date_notify_sent = r.is_null_date_notify_sent
				and is_null_date_replaced = r.is_null_date_replaced
				and is_null_deliverable = r.is_null_deliverable
				and is_null_div_no = r.is_null_div_no
				and is_null_mailing_label = r.is_null_mailing_label
				and is_null_m_comments = r.is_null_m_comments
				and is_null_net_address_bcc = r.is_null_net_address_bcc
				and is_null_net_address_to = r.is_null_net_address_to
				and is_null_old_quote_cust_acct_no = r.is_null_old_quote_cust_acct_no
				and is_null_org_no = r.is_null_org_no
				and is_null_prepared_by = r.is_null_prepared_by
				and is_null_revision = r.is_null_revision
				and is_null_terms_payment = r.is_null_terms_payment
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_string (2, 30)
			q.select_integer (3)
			q.select_string (4, 15)
			q.select_date (5)
			q.select_date (6)
			q.select_date (7)
			q.select_date (8)
			q.select_date (9)
			q.select_boolean (10)
			q.select_integer (11)
			q.select_string (12, 1000)
			q.select_string (13, 300)
			q.select_integer (14)
			q.select_string (15, 300)
			q.select_string (16, 300)
			q.select_integer (17)
			q.select_integer (18)
			q.select_string (19, 30)
			q.select_string (20, 1)
			q.select_string (21, 20)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cust_acct_no := q.integer_value (3)
			deliverable := q.boolean_value (10)
			div_no := q.integer_value (11)
			m_cust_quote_no := q.integer_value (14)
			old_quote_cust_acct_no := q.integer_value (17)
			org_no := q.integer_value (18)
		end

	fill_in_references (q: SQL_QUERY)
		do
			approved_by := q.string_value (1)
			approved_by_title := q.string_value (2)
			cust_quote_id := q.string_value (4)
			date_document := q.date_value (5)
			date_effective := q.date_value (6)
			date_expires := q.date_value (7)
			date_notify_sent := q.date_value (8)
			date_replaced := q.date_value (9)
			mailing_label := q.string_value (12)
			m_comments := q.string_value (13)
			net_address_bcc := q.string_value (15)
			net_address_to := q.string_value (16)
			prepared_by := q.string_value (19)
			revision := q.string_value (20)
			terms_payment := q.string_value (21)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, approved_by)
			q.get_string_value (2, approved_by_title)
			q.get_string_value (4, cust_quote_id)
			q.get_date_value (5, date_document)
			q.get_date_value (6, date_effective)
			q.get_date_value (7, date_expires)
			q.get_date_value (8, date_notify_sent)
			q.get_date_value (9, date_replaced)
			q.get_string_value (12, mailing_label)
			q.get_string_value (13, m_comments)
			q.get_string_value (15, net_address_bcc)
			q.get_string_value (16, net_address_to)
			q.get_string_value (19, prepared_by)
			q.get_string_value (20, revision)
			q.get_string_value (21, terms_payment)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_approved_by := q.is_null (1)
			is_null_approved_by_title := q.is_null (2)
			is_null_cust_acct_no := q.is_null (3)
			is_null_cust_quote_id := q.is_null (4)
			is_null_date_document := q.is_null (5)
			is_null_date_effective := q.is_null (6)
			is_null_date_expires := q.is_null (7)
			is_null_date_notify_sent := q.is_null (8)
			is_null_date_replaced := q.is_null (9)
			is_null_deliverable := q.is_null (10)
			is_null_div_no := q.is_null (11)
			is_null_mailing_label := q.is_null (12)
			is_null_m_comments := q.is_null (13)
			is_null_m_cust_quote_no := q.is_null (14)
			is_null_net_address_bcc := q.is_null (15)
			is_null_net_address_to := q.is_null (16)
			is_null_old_quote_cust_acct_no := q.is_null (17)
			is_null_org_no := q.is_null (18)
			is_null_prepared_by := q.is_null (19)
			is_null_revision := q.is_null (20)
			is_null_terms_payment := q.is_null (21)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_cust_quote_no := True
		end

	set_null_nonkey
		do
			is_null_approved_by := True
			is_null_approved_by_title := True
			is_null_cust_acct_no := True
			is_null_cust_quote_id := True
			is_null_date_document := True
			is_null_date_effective := True
			is_null_date_expires := True
			is_null_date_notify_sent := True
			is_null_date_replaced := True
			is_null_deliverable := True
			is_null_div_no := True
			is_null_mailing_label := True
			is_null_m_comments := True
			is_null_net_address_bcc := True
			is_null_net_address_to := True
			is_null_old_quote_cust_acct_no := True
			is_null_org_no := True
			is_null_prepared_by := True
			is_null_revision := True
			is_null_terms_payment := True
			create approved_by.make (0)
			create approved_by_title.make (0)
			create cust_quote_id.make (0)
			create {ORACLE_DATE} date_document.set_null
			create {ORACLE_DATE} date_effective.set_null
			create {ORACLE_DATE} date_expires.set_null
			create {ORACLE_DATE} date_notify_sent.set_null
			create {ORACLE_DATE} date_replaced.set_null
			create mailing_label.make (0)
			create m_comments.make (0)
			create net_address_bcc.make (0)
			create net_address_to.make (0)
			create prepared_by.make (0)
			create revision.make (0)
			create terms_payment.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_cust_quote_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and cust_acct_no = q.integer_value (3)
				and deliverable = q.boolean_value (10)
				and div_no = q.integer_value (11)
				and m_cust_quote_no = q.integer_value (14)
				and old_quote_cust_acct_no = q.integer_value (17)
				and org_no = q.integer_value (18)
			q.get_string_value (1, s)
			Result := Result and equal (approved_by, s)
			q.get_string_value (2, s)
			Result := Result and equal (approved_by_title, s)
			q.get_string_value (4, s)
			Result := Result and equal (cust_quote_id, s)
			q.get_date_value (5, d)
			Result := Result and equal (date_document, d)
			q.get_date_value (6, d)
			Result := Result and equal (date_effective, d)
			q.get_date_value (7, d)
			Result := Result and equal (date_expires, d)
			q.get_date_value (8, d)
			Result := Result and equal (date_notify_sent, d)
			q.get_date_value (9, d)
			Result := Result and equal (date_replaced, d)
			q.get_string_value (12, s)
			Result := Result and equal (mailing_label, s)
			q.get_string_value (13, s)
			Result := Result and equal (m_comments, s)
			q.get_string_value (15, s)
			Result := Result and equal (net_address_bcc, s)
			q.get_string_value (16, s)
			Result := Result and equal (net_address_to, s)
			q.get_string_value (19, s)
			Result := Result and equal (prepared_by, s)
			q.get_string_value (20, s)
			Result := Result and equal (revision, s)
			q.get_string_value (21, s)
			Result := Result and equal (terms_payment, s)
			Result := Result
				and is_null_approved_by = q.is_null (1)
				and is_null_approved_by_title = q.is_null (2)
				and is_null_cust_acct_no = q.is_null (3)
				and is_null_cust_quote_id = q.is_null (4)
				and is_null_date_document = q.is_null (5)
				and is_null_date_effective = q.is_null (6)
				and is_null_date_expires = q.is_null (7)
				and is_null_date_notify_sent = q.is_null (8)
				and is_null_date_replaced = q.is_null (9)
				and is_null_deliverable = q.is_null (10)
				and is_null_div_no = q.is_null (11)
				and is_null_mailing_label = q.is_null (12)
				and is_null_m_comments = q.is_null (13)
				and is_null_m_cust_quote_no = q.is_null (14)
				and is_null_net_address_bcc = q.is_null (15)
				and is_null_net_address_to = q.is_null (16)
				and is_null_old_quote_cust_acct_no = q.is_null (17)
				and is_null_org_no = q.is_null (18)
				and is_null_prepared_by = q.is_null (19)
				and is_null_revision = q.is_null (20)
				and is_null_terms_payment = q.is_null (21)
		end

end
