
note

	date: "Thu Jan 21 12:59:41 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"CUT_DIE_SITES (MOSIS.CUT_DIE_SITES)"
			-- Included columns
			-- 	CUT_PATTERN_NO
			-- 	DIE_SIZE_CUT_X
			-- 	DIE_SIZE_CUT_Y
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- 	MASK_SITE_NO
			-- 	RUN_ID
			-- Excluded columns
			-- 	(none)

class CUT_DIE_SITES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_cut_pattern_no: INTEGER; the_mask_site_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			cut_pattern_no := the_cut_pattern_no
			mask_site_no := the_mask_site_no
			is_null_run_id := False
			is_null_cut_pattern_no := False
			is_null_mask_site_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_pattern_no, die_size_cut_x, die_size_cut_y, location_x, location_y,%N  mask_site_no, run_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cut_die_sites cds"

	join_condition: STRING = ""

	table_name: STRING = "cut_die_sites"

	key_where_clause: STRING = "run_id = :1 and cut_pattern_no = :2 and mask_site_no = :3"

feature -- Values

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	die_size_cut_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	die_size_cut_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	mask_site_no: INTEGER
			-- DB: NUMBER(4,0) not null

	run_id: STRING
			-- DB: CHAR(4) not null

feature -- Maximum database lengths for character columns

	maxlen_run_id: INTEGER = 4

feature -- Precisions for number columns

	precision_cut_pattern_no: INTEGER = 2
	precision_die_size_cut_x: INTEGER = 12
	precision_die_size_cut_y: INTEGER = 12
	precision_location_x: INTEGER = 12
	precision_location_y: INTEGER = 12
	precision_mask_site_no: INTEGER = 4

feature -- Scales for number columns

	scale_cut_pattern_no: INTEGER = 0
	scale_die_size_cut_x: INTEGER = 6
	scale_die_size_cut_y: INTEGER = 6
	scale_location_x: INTEGER = 6
	scale_location_y: INTEGER = 6
	scale_mask_site_no: INTEGER = 0

feature -- Nullness for non-null columns

	is_null_cut_pattern_no: BOOLEAN
	is_null_die_size_cut_x: BOOLEAN
	is_null_die_size_cut_y: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN
	is_null_mask_site_no: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no = r.cut_pattern_no
				and mask_site_no = r.mask_site_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_mask_site_no = r.is_null_mask_site_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_size_cut_x = r.die_size_cut_x
				and die_size_cut_y = r.die_size_cut_y
				and location_x = r.location_x
				and location_y = r.location_y
			Result := Result
				and is_null_die_size_cut_x = r.is_null_die_size_cut_x
				and is_null_die_size_cut_y = r.is_null_die_size_cut_y
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_double (2)
			q.select_double (3)
			q.select_double (4)
			q.select_double (5)
			q.select_integer (6)
			q.select_string (7, 4)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_pattern_no := q.integer_value (1)
			die_size_cut_x := q.double_value (2)
			die_size_cut_y := q.double_value (3)
			location_x := q.double_value (4)
			location_y := q.double_value (5)
			mask_site_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			run_id := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (7, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_pattern_no := q.is_null (1)
			is_null_die_size_cut_x := q.is_null (2)
			is_null_die_size_cut_y := q.is_null (3)
			is_null_location_x := q.is_null (4)
			is_null_location_y := q.is_null (5)
			is_null_mask_site_no := q.is_null (6)
			is_null_run_id := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_cut_pattern_no := True
			is_null_mask_site_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_die_size_cut_x := True
			is_null_die_size_cut_y := True
			is_null_location_x := True
			is_null_location_y := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, cut_pattern_no, False)
			q.bind_num_to_integer (3, mask_site_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_pattern_no = q.integer_value (1)
				and die_size_cut_x = q.double_value (2)
				and die_size_cut_y = q.double_value (3)
				and location_x = q.double_value (4)
				and location_y = q.double_value (5)
				and mask_site_no = q.integer_value (6)
			q.get_string_value (7, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_cut_pattern_no = q.is_null (1)
				and is_null_die_size_cut_x = q.is_null (2)
				and is_null_die_size_cut_y = q.is_null (3)
				and is_null_location_x = q.is_null (4)
				and is_null_location_y = q.is_null (5)
				and is_null_mask_site_no = q.is_null (6)
				and is_null_run_id = q.is_null (7)
		end

end
