
note

	date: "Thu Jan 21 12:59:41 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"CUT_LOCATIONS (MOSIS.CUT_LOCATIONS)"
			-- Included columns
			-- 	CUT_NO
			-- 	CUT_PATTERN_NO
			-- 	LOCATION
			-- 	ORIENTATION
			-- 	RUN_ID
			-- Excluded columns
			-- 	(none)

class CUT_LOCATIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_cut_pattern_no: INTEGER; the_cut_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			cut_pattern_no := the_cut_pattern_no
			cut_no := the_cut_no
			is_null_run_id := False
			is_null_cut_pattern_no := False
			is_null_cut_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_no, cut_pattern_no, location, orientation, run_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cut_locations cl"

	join_condition: STRING = ""

	table_name: STRING = "cut_locations"

	key_where_clause: STRING = "run_id = :1 and cut_pattern_no = :2 and cut_no = :3"

feature -- Values

	cut_no: INTEGER
			-- DB: NUMBER(2,0) not null

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	location: DOUBLE
			-- DB: NUMBER(12,6) not null

	orientation: STRING
			-- DB: VARCHAR2(10) not null

	run_id: STRING
			-- DB: CHAR(4) not null

feature -- Maximum database lengths for character columns

	maxlen_orientation: INTEGER = 10
	maxlen_run_id: INTEGER = 4

feature -- Precisions for number columns

	precision_cut_no: INTEGER = 2
	precision_cut_pattern_no: INTEGER = 2
	precision_location: INTEGER = 12

feature -- Scales for number columns

	scale_cut_no: INTEGER = 0
	scale_cut_pattern_no: INTEGER = 0
	scale_location: INTEGER = 6

feature -- Nullness for non-null columns

	is_null_cut_no: BOOLEAN
	is_null_cut_pattern_no: BOOLEAN
	is_null_location: BOOLEAN
	is_null_orientation: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_no = r.cut_no
				and cut_pattern_no = r.cut_pattern_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_cut_no = r.is_null_cut_no
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and location = r.location
			Result := Result
				and equal (orientation, r.orientation)
			Result := Result
				and is_null_location = r.is_null_location
				and is_null_orientation = r.is_null_orientation
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_double (3)
			q.select_string (4, 10)
			q.select_string (5, 4)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_no := q.integer_value (1)
			cut_pattern_no := q.integer_value (2)
			location := q.double_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			orientation := q.string_value (4)
			run_id := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, orientation)
			q.get_string_value (5, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_no := q.is_null (1)
			is_null_cut_pattern_no := q.is_null (2)
			is_null_location := q.is_null (3)
			is_null_orientation := q.is_null (4)
			is_null_run_id := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_cut_pattern_no := True
			is_null_cut_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_location := True
			is_null_orientation := True
			create orientation.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, cut_pattern_no, False)
			q.bind_num_to_integer (3, cut_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_no = q.integer_value (1)
				and cut_pattern_no = q.integer_value (2)
				and location = q.double_value (3)
			q.get_string_value (4, s)
			Result := Result and equal (orientation, s)
			q.get_string_value (5, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_cut_no = q.is_null (1)
				and is_null_cut_pattern_no = q.is_null (2)
				and is_null_location = q.is_null (3)
				and is_null_orientation = q.is_null (4)
				and is_null_run_id = q.is_null (5)
		end

end
