
note

	date: "Thu Jan 21 12:59:42 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"DESIGN_TECHN_IDS (MOSIS.DESIGN_TECHN_IDS)"
			-- Included columns
			-- 	DESCR
			-- 	DESIGN_TECHN_ID
			-- 	DESIGN_TYPE
			-- 	IS_SCALABLE
			-- 	LAYER_MAP_URL
			-- 	ORG_NO
			-- Excluded columns
			-- 	(none)

class DESIGN_TECHN_IDS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_techn_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_design_techn_id_exists: the_design_techn_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_techn_id := the_design_techn_id
			is_null_design_techn_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, design_techn_id, design_type, is_scalable, layer_map_url, org_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "design_techn_ids dti"

	join_condition: STRING = ""

	table_name: STRING = "design_techn_ids"

	key_where_clause: STRING = "design_techn_id = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	design_techn_id: STRING
			-- DB: VARCHAR2(50) not null

	design_type: STRING
			-- DB: VARCHAR2(10) not null

	is_scalable: BOOLEAN
			-- DB: CHAR(1) not null

	layer_map_url: STRING
			-- DB: VARCHAR2(100)

	org_no: INTEGER
			-- DB: NUMBER(6,0) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_layer_map_url: BOOLEAN

feature -- Nullness for non-null columns

	is_null_design_techn_id: BOOLEAN
	is_null_design_type: BOOLEAN
	is_null_is_scalable: BOOLEAN
	is_null_org_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (design_techn_id, r.design_techn_id)
			Result := Result
				and is_null_design_techn_id = r.is_null_design_techn_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_scalable = r.is_scalable
				and org_no = r.org_no
			Result := Result
				and equal (descr, r.descr)
				and equal (design_type, r.design_type)
				and equal (layer_map_url, r.layer_map_url)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_design_type = r.is_null_design_type
				and is_null_is_scalable = r.is_null_is_scalable
				and is_null_layer_map_url = r.is_null_layer_map_url
				and is_null_org_no = r.is_null_org_no
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 50)
			q.select_string (3, 10)
			q.select_boolean (4)
			q.select_string (5, 100)
			q.select_integer (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_scalable := q.boolean_value (4)
			org_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			design_techn_id := q.string_value (2)
			design_type := q.string_value (3)
			layer_map_url := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, design_techn_id)
			q.get_string_value (3, design_type)
			q.get_string_value (5, layer_map_url)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_design_techn_id := q.is_null (2)
			is_null_design_type := q.is_null (3)
			is_null_is_scalable := q.is_null (4)
			is_null_layer_map_url := q.is_null (5)
			is_null_org_no := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_techn_id := True
			create design_techn_id.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_design_type := True
			is_null_is_scalable := True
			is_null_layer_map_url := True
			is_null_org_no := True
			create descr.make (0)
			create design_type.make (0)
			create layer_map_url.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, design_techn_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_scalable = q.boolean_value (4)
				and org_no = q.integer_value (6)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (design_techn_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (design_type, s)
			q.get_string_value (5, s)
			Result := Result and equal (layer_map_url, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_design_techn_id = q.is_null (2)
				and is_null_design_type = q.is_null (3)
				and is_null_is_scalable = q.is_null (4)
				and is_null_layer_map_url = q.is_null (5)
				and is_null_org_no = q.is_null (6)
		end

end
