
note

	date: "Thu May 12 13:52:41 2011"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"DESIGN_TYPES (MOSIS.DESIGN_TYPES)"
			-- Included columns
			-- 	DESCR
			-- 	DESIGN_TYPE
			-- 	IS_TIERED
			-- Excluded columns
			-- 	(none)

class DESIGN_TYPES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_design_type_exists: the_design_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_type := the_design_type
			is_null_design_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 3

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, design_type, is_tiered"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "design_types detyp"

	join_condition: STRING = ""

	table_name: STRING = "design_types"

	key_where_clause: STRING = "design_type = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	design_type: STRING
			-- DB: VARCHAR2(10) not null

	is_tiered: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_design_type: BOOLEAN
	is_null_is_tiered: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (design_type, r.design_type)
			Result := Result
				and is_null_design_type = r.is_null_design_type
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_tiered = r.is_tiered
			Result := Result
				and equal (descr, r.descr)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_is_tiered = r.is_null_is_tiered
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 10)
			q.select_boolean (3)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_tiered := q.boolean_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			design_type := q.string_value (2)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, design_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_design_type := q.is_null (2)
			is_null_is_tiered := q.is_null (3)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_type := True
			create design_type.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_is_tiered := True
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, design_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_tiered = q.boolean_value (3)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (design_type, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_design_type = q.is_null (2)
				and is_null_is_tiered = q.is_null (3)
		end

end
