
note

	date: "Thu Jan 21 12:59:43 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"DIE_LOCATIONS (MOSIS.DIE_LOCATIONS)"
			-- Included columns
			-- 	CATS_STATUS
			-- 	DIE_ID
			-- 	FIELD_NAME
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- 	MASK_SITE_NO
			-- 	RUN_ID
			-- 	WAFER_VENDOR_PART_ID
			-- Excluded columns
			-- 	(none)

class DIE_LOCATIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_mask_site_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			mask_site_no := the_mask_site_no
			is_null_run_id := False
			is_null_mask_site_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cats_status, die_id, field_name, location_x, location_y, mask_site_no,%N  run_id, wafer_vendor_part_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "die_locations d"

	join_condition: STRING = ""

	table_name: STRING = "die_locations"

	key_where_clause: STRING = "run_id = :1 and mask_site_no = :2"

feature -- Values

	cats_status: STRING
			-- DB: VARCHAR2(15)

	die_id: STRING
			-- DB: CHAR(2) not null

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	mask_site_no: INTEGER
			-- DB: NUMBER(4,0) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	wafer_vendor_part_id: STRING
			-- DB: VARCHAR2(50)

feature -- Nullness for null allowed columns

	is_null_cats_status: BOOLEAN
	is_null_wafer_vendor_part_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_die_id: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN
	is_null_mask_site_no: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and mask_site_no = r.mask_site_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_mask_site_no = r.is_null_mask_site_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and location_x = r.location_x
				and location_y = r.location_y
			Result := Result
				and equal (cats_status, r.cats_status)
				and equal (die_id, r.die_id)
				and equal (field_name, r.field_name)
				and equal (wafer_vendor_part_id, r.wafer_vendor_part_id)
			Result := Result
				and is_null_cats_status = r.is_null_cats_status
				and is_null_die_id = r.is_null_die_id
				and is_null_field_name = r.is_null_field_name
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
				and is_null_wafer_vendor_part_id = r.is_null_wafer_vendor_part_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 15)
			q.select_string (2, 2)
			q.select_string (3, 20)
			q.select_double (4)
			q.select_double (5)
			q.select_integer (6)
			q.select_string (7, 4)
			q.select_string (8, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			location_x := q.double_value (4)
			location_y := q.double_value (5)
			mask_site_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cats_status := q.string_value (1)
			die_id := q.string_value (2)
			field_name := q.string_value (3)
			run_id := q.string_value (7)
			wafer_vendor_part_id := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, cats_status)
			q.get_string_value (2, die_id)
			q.get_string_value (3, field_name)
			q.get_string_value (7, run_id)
			q.get_string_value (8, wafer_vendor_part_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cats_status := q.is_null (1)
			is_null_die_id := q.is_null (2)
			is_null_field_name := q.is_null (3)
			is_null_location_x := q.is_null (4)
			is_null_location_y := q.is_null (5)
			is_null_mask_site_no := q.is_null (6)
			is_null_run_id := q.is_null (7)
			is_null_wafer_vendor_part_id := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_mask_site_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_cats_status := True
			is_null_die_id := True
			is_null_field_name := True
			is_null_location_x := True
			is_null_location_y := True
			is_null_wafer_vendor_part_id := True
			create cats_status.make (0)
			create die_id.make (0)
			create field_name.make (0)
			create wafer_vendor_part_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, mask_site_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and location_x = q.double_value (4)
				and location_y = q.double_value (5)
				and mask_site_no = q.integer_value (6)
			q.get_string_value (1, s)
			Result := Result and equal (cats_status, s)
			q.get_string_value (2, s)
			Result := Result and equal (die_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (7, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (8, s)
			Result := Result and equal (wafer_vendor_part_id, s)
			Result := Result
				and is_null_cats_status = q.is_null (1)
				and is_null_die_id = q.is_null (2)
				and is_null_field_name = q.is_null (3)
				and is_null_location_x = q.is_null (4)
				and is_null_location_y = q.is_null (5)
				and is_null_mask_site_no = q.is_null (6)
				and is_null_run_id = q.is_null (7)
				and is_null_wafer_vendor_part_id = q.is_null (8)
		end

end
