
note

	date: "Tue Jun 19 09:40:56 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"DIES (MOSIS.DIES)"
			-- Included columns
			-- 	BATCH_JOB_NO
			-- 	CATS_STATUS
			-- 	DATE_JOB_ENDED
			-- 	DATE_JOB_STARTED
			-- 	DESIGN_NO (test_vehicle_design_no)
			-- 	DIE_ID
			-- 	DIE_SIZE_PRINTED_X
			-- 	DIE_SIZE_PRINTED_Y
			-- 	DIE_TYPE
			-- 	DIE_WAFER_ROTATION
			-- 	ERROR_EXPLANATION
			-- 	FILLER_NAME
			-- 	FILLER_TYPE
			-- 	GEOMETRY_ID
			-- 	RUN_ID
			-- 	SCRIBE_ORIENTATION
			-- 	TIER_NO_3DIC
			-- 	WAFER_VENDOR_PART_ID
			-- Excluded columns
			-- 	(none)

class DIES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_die_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
			the_die_id_exists: the_die_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			die_id := the_die_id
			is_null_run_id := False
			is_null_die_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 18

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  batch_job_no, cats_status, date_job_ended, date_job_started, design_no,%N  die_id, die_size_printed_x, die_size_printed_y, die_type,%N  die_wafer_rotation, error_explanation, filler_name, filler_type,%N  geometry_id, run_id, scribe_orientation, tier_no_3dic,%N  wafer_vendor_part_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "dies d"

	join_condition: STRING = ""

	table_name: STRING = "dies"

	key_where_clause: STRING = "run_id = :1 and die_id = :2"

feature -- Values

	batch_job_no: INTEGER
			-- DB: NUMBER(9,0)

	cats_status: STRING
			-- DB: VARCHAR2(15) not null

	date_job_ended: DB_DATE
			-- DB: DATE

	date_job_started: DB_DATE
			-- DB: DATE

	test_vehicle_design_no: INTEGER
			-- DB: design_no NUMBER(6,0)

	die_id: STRING
			-- DB: CHAR(2) not null

	die_size_printed_x: DOUBLE
			-- DB: NUMBER(12,6)

	die_size_printed_y: DOUBLE
			-- DB: NUMBER(12,6)

	die_type: STRING
			-- DB: VARCHAR2(20) not null

	die_wafer_rotation: INTEGER
			-- DB: NUMBER(3,0)

	error_explanation: STRING
			-- DB: VARCHAR2(4000)

	filler_name: STRING
			-- DB: VARCHAR2(50)

	filler_type: STRING
			-- DB: VARCHAR2(20)

	geometry_id: STRING
			-- DB: VARCHAR2(50)

	run_id: STRING
			-- DB: CHAR(4) not null

	scribe_orientation: STRING
			-- DB: VARCHAR2(10)

	tier_no_3dic: INTEGER
			-- DB: NUMBER(3,0)

	wafer_vendor_part_id: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_cats_status: INTEGER = 15
	maxlen_die_id: INTEGER = 2
	maxlen_die_type: INTEGER = 20
	maxlen_error_explanation: INTEGER = 4000
	maxlen_filler_name: INTEGER = 50
	maxlen_filler_type: INTEGER = 20
	maxlen_geometry_id: INTEGER = 50
	maxlen_run_id: INTEGER = 4
	maxlen_scribe_orientation: INTEGER = 10
	maxlen_wafer_vendor_part_id: INTEGER = 50

feature -- Precisions for number columns

	precision_batch_job_no: INTEGER = 9
	precision_test_vehicle_design_no: INTEGER = 6
	precision_die_size_printed_x: INTEGER = 12
	precision_die_size_printed_y: INTEGER = 12
	precision_die_wafer_rotation: INTEGER = 3
	precision_tier_no_3dic: INTEGER = 3

feature -- Scales for number columns

	scale_batch_job_no: INTEGER = 0
	scale_test_vehicle_design_no: INTEGER = 0
	scale_die_size_printed_x: INTEGER = 6
	scale_die_size_printed_y: INTEGER = 6
	scale_die_wafer_rotation: INTEGER = 0
	scale_tier_no_3dic: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_batch_job_no: BOOLEAN
	is_null_date_job_ended: BOOLEAN
	is_null_date_job_started: BOOLEAN
	is_null_test_vehicle_design_no: BOOLEAN
	is_null_die_size_printed_x: BOOLEAN
	is_null_die_size_printed_y: BOOLEAN
	is_null_die_wafer_rotation: BOOLEAN
	is_null_error_explanation: BOOLEAN
	is_null_filler_name: BOOLEAN
	is_null_filler_type: BOOLEAN
	is_null_geometry_id: BOOLEAN
	is_null_scribe_orientation: BOOLEAN
	is_null_tier_no_3dic: BOOLEAN
	is_null_wafer_vendor_part_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cats_status: BOOLEAN
	is_null_die_id: BOOLEAN
	is_null_die_type: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (die_id, r.die_id)
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_die_id = r.is_null_die_id
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and batch_job_no = r.batch_job_no
				and test_vehicle_design_no = r.test_vehicle_design_no
				and die_size_printed_x = r.die_size_printed_x
				and die_size_printed_y = r.die_size_printed_y
				and die_wafer_rotation = r.die_wafer_rotation
				and tier_no_3dic = r.tier_no_3dic
			Result := Result
				and equal (cats_status, r.cats_status)
				and equal (date_job_ended, r.date_job_ended)
				and equal (date_job_started, r.date_job_started)
				and equal (die_type, r.die_type)
				and equal (error_explanation, r.error_explanation)
				and equal (filler_name, r.filler_name)
				and equal (filler_type, r.filler_type)
				and equal (geometry_id, r.geometry_id)
				and equal (scribe_orientation, r.scribe_orientation)
				and equal (wafer_vendor_part_id, r.wafer_vendor_part_id)
			Result := Result
				and is_null_batch_job_no = r.is_null_batch_job_no
				and is_null_cats_status = r.is_null_cats_status
				and is_null_date_job_ended = r.is_null_date_job_ended
				and is_null_date_job_started = r.is_null_date_job_started
				and is_null_test_vehicle_design_no = r.is_null_test_vehicle_design_no
				and is_null_die_size_printed_x = r.is_null_die_size_printed_x
				and is_null_die_size_printed_y = r.is_null_die_size_printed_y
				and is_null_die_type = r.is_null_die_type
				and is_null_die_wafer_rotation = r.is_null_die_wafer_rotation
				and is_null_error_explanation = r.is_null_error_explanation
				and is_null_filler_name = r.is_null_filler_name
				and is_null_filler_type = r.is_null_filler_type
				and is_null_geometry_id = r.is_null_geometry_id
				and is_null_scribe_orientation = r.is_null_scribe_orientation
				and is_null_tier_no_3dic = r.is_null_tier_no_3dic
				and is_null_wafer_vendor_part_id = r.is_null_wafer_vendor_part_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 15)
			q.select_date (3)
			q.select_date (4)
			q.select_integer (5)
			q.select_string (6, 2)
			q.select_double (7)
			q.select_double (8)
			q.select_string (9, 20)
			q.select_integer (10)
			q.select_string (11, 4000)
			q.select_string (12, 50)
			q.select_string (13, 20)
			q.select_string (14, 50)
			q.select_string (15, 4)
			q.select_string (16, 10)
			q.select_integer (17)
			q.select_string (18, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			batch_job_no := q.integer_value (1)
			test_vehicle_design_no := q.integer_value (5)
			die_size_printed_x := q.double_value (7)
			die_size_printed_y := q.double_value (8)
			die_wafer_rotation := q.integer_value (10)
			tier_no_3dic := q.integer_value (17)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cats_status := q.string_value (2)
			date_job_ended := q.date_value (3)
			date_job_started := q.date_value (4)
			die_id := q.string_value (6)
			die_type := q.string_value (9)
			error_explanation := q.string_value (11)
			filler_name := q.string_value (12)
			filler_type := q.string_value (13)
			geometry_id := q.string_value (14)
			run_id := q.string_value (15)
			scribe_orientation := q.string_value (16)
			wafer_vendor_part_id := q.string_value (18)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, cats_status)
			q.get_date_value (3, date_job_ended)
			q.get_date_value (4, date_job_started)
			q.get_string_value (6, die_id)
			q.get_string_value (9, die_type)
			q.get_string_value (11, error_explanation)
			q.get_string_value (12, filler_name)
			q.get_string_value (13, filler_type)
			q.get_string_value (14, geometry_id)
			q.get_string_value (15, run_id)
			q.get_string_value (16, scribe_orientation)
			q.get_string_value (18, wafer_vendor_part_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_batch_job_no := q.is_null (1)
			is_null_cats_status := q.is_null (2)
			is_null_date_job_ended := q.is_null (3)
			is_null_date_job_started := q.is_null (4)
			is_null_test_vehicle_design_no := q.is_null (5)
			is_null_die_id := q.is_null (6)
			is_null_die_size_printed_x := q.is_null (7)
			is_null_die_size_printed_y := q.is_null (8)
			is_null_die_type := q.is_null (9)
			is_null_die_wafer_rotation := q.is_null (10)
			is_null_error_explanation := q.is_null (11)
			is_null_filler_name := q.is_null (12)
			is_null_filler_type := q.is_null (13)
			is_null_geometry_id := q.is_null (14)
			is_null_run_id := q.is_null (15)
			is_null_scribe_orientation := q.is_null (16)
			is_null_tier_no_3dic := q.is_null (17)
			is_null_wafer_vendor_part_id := q.is_null (18)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_die_id := True
			create run_id.make (0)
			create die_id.make (0)
		end

	set_null_nonkey
		do
			is_null_batch_job_no := True
			is_null_cats_status := True
			is_null_date_job_ended := True
			is_null_date_job_started := True
			is_null_test_vehicle_design_no := True
			is_null_die_size_printed_x := True
			is_null_die_size_printed_y := True
			is_null_die_type := True
			is_null_die_wafer_rotation := True
			is_null_error_explanation := True
			is_null_filler_name := True
			is_null_filler_type := True
			is_null_geometry_id := True
			is_null_scribe_orientation := True
			is_null_tier_no_3dic := True
			is_null_wafer_vendor_part_id := True
			create cats_status.make (0)
			create {ORACLE_DATE} date_job_ended.set_null
			create {ORACLE_DATE} date_job_started.set_null
			create die_type.make (0)
			create error_explanation.make (0)
			create filler_name.make (0)
			create filler_type.make (0)
			create geometry_id.make (0)
			create scribe_orientation.make (0)
			create wafer_vendor_part_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_string (2, die_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and batch_job_no = q.integer_value (1)
				and test_vehicle_design_no = q.integer_value (5)
				and die_size_printed_x = q.double_value (7)
				and die_size_printed_y = q.double_value (8)
				and die_wafer_rotation = q.integer_value (10)
				and tier_no_3dic = q.integer_value (17)
			q.get_string_value (2, s)
			Result := Result and equal (cats_status, s)
			q.get_date_value (3, d)
			Result := Result and equal (date_job_ended, d)
			q.get_date_value (4, d)
			Result := Result and equal (date_job_started, d)
			q.get_string_value (6, s)
			Result := Result and equal (die_id, s)
			q.get_string_value (9, s)
			Result := Result and equal (die_type, s)
			q.get_string_value (11, s)
			Result := Result and equal (error_explanation, s)
			q.get_string_value (12, s)
			Result := Result and equal (filler_name, s)
			q.get_string_value (13, s)
			Result := Result and equal (filler_type, s)
			q.get_string_value (14, s)
			Result := Result and equal (geometry_id, s)
			q.get_string_value (15, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (16, s)
			Result := Result and equal (scribe_orientation, s)
			q.get_string_value (18, s)
			Result := Result and equal (wafer_vendor_part_id, s)
			Result := Result
				and is_null_batch_job_no = q.is_null (1)
				and is_null_cats_status = q.is_null (2)
				and is_null_date_job_ended = q.is_null (3)
				and is_null_date_job_started = q.is_null (4)
				and is_null_test_vehicle_design_no = q.is_null (5)
				and is_null_die_id = q.is_null (6)
				and is_null_die_size_printed_x = q.is_null (7)
				and is_null_die_size_printed_y = q.is_null (8)
				and is_null_die_type = q.is_null (9)
				and is_null_die_wafer_rotation = q.is_null (10)
				and is_null_error_explanation = q.is_null (11)
				and is_null_filler_name = q.is_null (12)
				and is_null_filler_type = q.is_null (13)
				and is_null_geometry_id = q.is_null (14)
				and is_null_run_id = q.is_null (15)
				and is_null_scribe_orientation = q.is_null (16)
				and is_null_tier_no_3dic = q.is_null (17)
				and is_null_wafer_vendor_part_id = q.is_null (18)
		end

end
