
note

	date: "Wed Feb 22 15:48:42 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user BSMITH"
	database_tables: 
		"ECC_QUESTIONNAIRE_TEXT (MOSIS.ECC_QUESTIONNAIRE_TEXT)"
			-- Included columns
			-- 	ECC_QUESTIONNAIRE_ID
			-- 	IS_QUESTION
			-- 	PARAGRAPH_ID
			-- 	PARAGRAPH_PREFIX
			-- 	PARAGRAPH_STYLE
			-- 	PARAGRAPH_TEXT
			-- 	SUPPLEMENTARY_QUESTION_ID
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class ECC_QUESTIONNAIRE_TEXT_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_paragraph_id: STRING; the_version_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_paragraph_id_exists: the_paragraph_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			paragraph_id := the_paragraph_id
			version_no := the_version_no
			is_null_paragraph_id := False
			is_null_version_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  ecc_questionnaire_id, is_question, paragraph_id, paragraph_prefix,%N  paragraph_style, paragraph_text, supplementary_question_id, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "ecc_questionnaire_text eccqt"

	join_condition: STRING = ""

	table_name: STRING = "ecc_questionnaire_text"

	key_where_clause: STRING = "paragraph_id = :1 and version_no = :2"

feature -- Values

	ecc_questionnaire_id: STRING
			-- DB: VARCHAR2(15) not null

	is_question: BOOLEAN
			-- DB: CHAR(1) not null

	paragraph_id: STRING
			-- DB: VARCHAR2(20) not null

	paragraph_prefix: STRING
			-- DB: VARCHAR2(30)

	paragraph_style: STRING
			-- DB: VARCHAR2(30)

	paragraph_text: STRING
			-- DB: VARCHAR2(4000)

	supplementary_question_id: STRING
			-- DB: VARCHAR2(30)

	version_no: INTEGER
			-- DB: NUMBER(3,0) not null

feature -- Maximum database lengths for character columns

	maxlen_ecc_questionnaire_id: INTEGER = 15
	maxlen_paragraph_id: INTEGER = 20
	maxlen_paragraph_prefix: INTEGER = 30
	maxlen_paragraph_style: INTEGER = 30
	maxlen_paragraph_text: INTEGER = 4000
	maxlen_supplementary_question_id: INTEGER = 30

feature -- Precisions for number columns

	precision_version_no: INTEGER = 3

feature -- Scales for number columns

	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_paragraph_prefix: BOOLEAN
	is_null_paragraph_style: BOOLEAN
	is_null_paragraph_text: BOOLEAN
	is_null_supplementary_question_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_ecc_questionnaire_id: BOOLEAN
	is_null_is_question: BOOLEAN
	is_null_paragraph_id: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and version_no = r.version_no
			Result := Result
				and equal (paragraph_id, r.paragraph_id)
			Result := Result
				and is_null_paragraph_id = r.is_null_paragraph_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_question = r.is_question
			Result := Result
				and equal (ecc_questionnaire_id, r.ecc_questionnaire_id)
				and equal (paragraph_prefix, r.paragraph_prefix)
				and equal (paragraph_style, r.paragraph_style)
				and equal (paragraph_text, r.paragraph_text)
				and equal (supplementary_question_id, r.supplementary_question_id)
			Result := Result
				and is_null_ecc_questionnaire_id = r.is_null_ecc_questionnaire_id
				and is_null_is_question = r.is_null_is_question
				and is_null_paragraph_prefix = r.is_null_paragraph_prefix
				and is_null_paragraph_style = r.is_null_paragraph_style
				and is_null_paragraph_text = r.is_null_paragraph_text
				and is_null_supplementary_question_id = r.is_null_supplementary_question_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 15)
			q.select_boolean (2)
			q.select_string (3, 20)
			q.select_string (4, 30)
			q.select_string (5, 30)
			q.select_string (6, 4000)
			q.select_string (7, 30)
			q.select_integer (8)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_question := q.boolean_value (2)
			version_no := q.integer_value (8)
		end

	fill_in_references (q: SQL_QUERY)
		do
			ecc_questionnaire_id := q.string_value (1)
			paragraph_id := q.string_value (3)
			paragraph_prefix := q.string_value (4)
			paragraph_style := q.string_value (5)
			paragraph_text := q.string_value (6)
			supplementary_question_id := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, ecc_questionnaire_id)
			q.get_string_value (3, paragraph_id)
			q.get_string_value (4, paragraph_prefix)
			q.get_string_value (5, paragraph_style)
			q.get_string_value (6, paragraph_text)
			q.get_string_value (7, supplementary_question_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_ecc_questionnaire_id := q.is_null (1)
			is_null_is_question := q.is_null (2)
			is_null_paragraph_id := q.is_null (3)
			is_null_paragraph_prefix := q.is_null (4)
			is_null_paragraph_style := q.is_null (5)
			is_null_paragraph_text := q.is_null (6)
			is_null_supplementary_question_id := q.is_null (7)
			is_null_version_no := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_paragraph_id := True
			is_null_version_no := True
			create paragraph_id.make (0)
		end

	set_null_nonkey
		do
			is_null_ecc_questionnaire_id := True
			is_null_is_question := True
			is_null_paragraph_prefix := True
			is_null_paragraph_style := True
			is_null_paragraph_text := True
			is_null_supplementary_question_id := True
			create ecc_questionnaire_id.make (0)
			create paragraph_prefix.make (0)
			create paragraph_style.make (0)
			create paragraph_text.make (0)
			create supplementary_question_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, paragraph_id, False)
			q.bind_num_to_integer (2, version_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_question = q.boolean_value (2)
				and version_no = q.integer_value (8)
			q.get_string_value (1, s)
			Result := Result and equal (ecc_questionnaire_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (paragraph_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (paragraph_prefix, s)
			q.get_string_value (5, s)
			Result := Result and equal (paragraph_style, s)
			q.get_string_value (6, s)
			Result := Result and equal (paragraph_text, s)
			q.get_string_value (7, s)
			Result := Result and equal (supplementary_question_id, s)
			Result := Result
				and is_null_ecc_questionnaire_id = q.is_null (1)
				and is_null_is_question = q.is_null (2)
				and is_null_paragraph_id = q.is_null (3)
				and is_null_paragraph_prefix = q.is_null (4)
				and is_null_paragraph_style = q.is_null (5)
				and is_null_paragraph_text = q.is_null (6)
				and is_null_supplementary_question_id = q.is_null (7)
				and is_null_version_no = q.is_null (8)
		end

end
