
note

	date: "Thu Jan 21 12:59:43 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"FIELD_SETS (MOSIS.FIELD_SETS)"
			-- Included columns
			-- 	DESCR
			-- 	FAB_LOCATION
			-- 	FIELD_SET_NAME
			-- 	LITHO_SIZE_ID
			-- Excluded columns
			-- 	(none)

class FIELD_SETS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_field_set_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_field_set_name_exists: the_field_set_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			field_set_name := the_field_set_name
			is_null_field_set_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, fab_location, field_set_name, litho_size_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "field_sets fs"

	join_condition: STRING = ""

	table_name: STRING = "field_sets"

	key_where_clause: STRING = "field_set_name = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	fab_location: STRING
			-- DB: VARCHAR2(80)

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	litho_size_id: STRING
			-- DB: VARCHAR2(30) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_fab_location: BOOLEAN

feature -- Nullness for non-null columns

	is_null_field_set_name: BOOLEAN
	is_null_litho_size_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (field_set_name, r.field_set_name)
			Result := Result
				and is_null_field_set_name = r.is_null_field_set_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (descr, r.descr)
				and equal (fab_location, r.fab_location)
				and equal (litho_size_id, r.litho_size_id)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_fab_location = r.is_null_fab_location
				and is_null_litho_size_id = r.is_null_litho_size_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 80)
			q.select_string (3, 30)
			q.select_string (4, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			fab_location := q.string_value (2)
			field_set_name := q.string_value (3)
			litho_size_id := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, fab_location)
			q.get_string_value (3, field_set_name)
			q.get_string_value (4, litho_size_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_fab_location := q.is_null (2)
			is_null_field_set_name := q.is_null (3)
			is_null_litho_size_id := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_field_set_name := True
			create field_set_name.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_fab_location := True
			is_null_litho_size_id := True
			create descr.make (0)
			create fab_location.make (0)
			create litho_size_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, field_set_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (fab_location, s)
			q.get_string_value (3, s)
			Result := Result and equal (field_set_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (litho_size_id, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_fab_location = q.is_null (2)
				and is_null_field_set_name = q.is_null (3)
				and is_null_litho_size_id = q.is_null (4)
		end

end
