
note

	date: "Thu Jan 21 12:59:43 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"FIELD_STEP_PATTERNS (MOSIS.FIELD_STEP_PATTERNS)"
			-- Included columns
			-- 	AVAILABLE
			-- 	DESCR
			-- 	FIELD_SET_NAME
			-- 	FIELD_STEP_PATTERN
			-- 	IS_PRELIMINARY
			-- 	VENDOR_PART_ID
			-- Excluded columns
			-- 	(none)

class FIELD_STEP_PATTERNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_field_step_pattern: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_field_step_pattern_exists: the_field_step_pattern /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			field_step_pattern := the_field_step_pattern
			is_null_field_step_pattern := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  available, descr, field_set_name, field_step_pattern, is_preliminary,%N  vendor_part_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "field_step_patterns fsp"

	join_condition: STRING = ""

	table_name: STRING = "field_step_patterns"

	key_where_clause: STRING = "field_step_pattern = :1"

feature -- Values

	available: BOOLEAN
			-- DB: CHAR(1) not null

	descr: STRING
			-- DB: VARCHAR2(255)

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	field_step_pattern: STRING
			-- DB: VARCHAR2(30) not null

	is_preliminary: BOOLEAN
			-- DB: CHAR(1) not null

	vendor_part_id: STRING
			-- DB: VARCHAR2(50)

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_vendor_part_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_available: BOOLEAN
	is_null_field_set_name: BOOLEAN
	is_null_field_step_pattern: BOOLEAN
	is_null_is_preliminary: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (field_step_pattern, r.field_step_pattern)
			Result := Result
				and is_null_field_step_pattern = r.is_null_field_step_pattern
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and available = r.available
				and is_preliminary = r.is_preliminary
			Result := Result
				and equal (descr, r.descr)
				and equal (field_set_name, r.field_set_name)
				and equal (vendor_part_id, r.vendor_part_id)
			Result := Result
				and is_null_available = r.is_null_available
				and is_null_descr = r.is_null_descr
				and is_null_field_set_name = r.is_null_field_set_name
				and is_null_is_preliminary = r.is_null_is_preliminary
				and is_null_vendor_part_id = r.is_null_vendor_part_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_string (2, 255)
			q.select_string (3, 30)
			q.select_string (4, 30)
			q.select_boolean (5)
			q.select_string (6, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			available := q.boolean_value (1)
			is_preliminary := q.boolean_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (2)
			field_set_name := q.string_value (3)
			field_step_pattern := q.string_value (4)
			vendor_part_id := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, descr)
			q.get_string_value (3, field_set_name)
			q.get_string_value (4, field_step_pattern)
			q.get_string_value (6, vendor_part_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_available := q.is_null (1)
			is_null_descr := q.is_null (2)
			is_null_field_set_name := q.is_null (3)
			is_null_field_step_pattern := q.is_null (4)
			is_null_is_preliminary := q.is_null (5)
			is_null_vendor_part_id := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_field_step_pattern := True
			create field_step_pattern.make (0)
		end

	set_null_nonkey
		do
			is_null_available := True
			is_null_descr := True
			is_null_field_set_name := True
			is_null_is_preliminary := True
			is_null_vendor_part_id := True
			create descr.make (0)
			create field_set_name.make (0)
			create vendor_part_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, field_step_pattern, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and available = q.boolean_value (1)
				and is_preliminary = q.boolean_value (5)
			q.get_string_value (2, s)
			Result := Result and equal (descr, s)
			q.get_string_value (3, s)
			Result := Result and equal (field_set_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (field_step_pattern, s)
			q.get_string_value (6, s)
			Result := Result and equal (vendor_part_id, s)
			Result := Result
				and is_null_available = q.is_null (1)
				and is_null_descr = q.is_null (2)
				and is_null_field_set_name = q.is_null (3)
				and is_null_field_step_pattern = q.is_null (4)
				and is_null_is_preliminary = q.is_null (5)
				and is_null_vendor_part_id = q.is_null (6)
		end

end
