
note

	date: "Wed Mar 13 10:16:58 2013"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user PAI"
	database_tables: 
		"FILE_ROLES (MOSIS.FILE_ROLES)"
			-- Included columns
			-- 	ARCHIVEABLE
			-- 	DELIVERABLE
			-- 	DELIVER_PRIOR
			-- 	DESCR
			-- 	FILE_ROLE
			-- 	IS_LAYOUT
			-- 	MESSAGE_APPLICATION
			-- 	NEEDS_MOSIS_AGREEMENT
			-- 	PROLOG_MESSAGE_ID
			-- 	ROLE_ORDER
			-- 	ROLE_TEXT
			-- Excluded columns
			-- 	(none)

class FILE_ROLES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_file_role: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_file_role_exists: the_file_role /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			file_role := the_file_role
			is_null_file_role := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 11

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  archiveable, deliverable, deliver_prior, descr, file_role, is_layout,%N  message_application, needs_mosis_agreement, prolog_message_id,%N  role_order, role_text"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "file_roles fir"

	join_condition: STRING = ""

	table_name: STRING = "file_roles"

	key_where_clause: STRING = "file_role = :1"

feature -- Values

	archiveable: BOOLEAN
			-- DB: CHAR(1) not null

	deliverable: BOOLEAN
			-- DB: CHAR(1) not null

	deliver_prior: BOOLEAN
			-- DB: CHAR(1) not null

	descr: STRING
			-- DB: VARCHAR2(100)

	file_role: STRING
			-- DB: VARCHAR2(20) not null

	is_layout: BOOLEAN
			-- DB: CHAR(1) not null

	message_application: STRING
			-- DB: VARCHAR2(50)

	needs_mosis_agreement: BOOLEAN
			-- DB: CHAR(1) not null

	prolog_message_id: STRING
			-- DB: VARCHAR2(20)

	role_order: INTEGER
			-- DB: NUMBER(3,0)

	role_text: STRING
			-- DB: VARCHAR2(100)

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_message_application: BOOLEAN
	is_null_prolog_message_id: BOOLEAN
	is_null_role_order: BOOLEAN
	is_null_role_text: BOOLEAN

feature -- Nullness for non-null columns

	is_null_archiveable: BOOLEAN
	is_null_deliverable: BOOLEAN
	is_null_deliver_prior: BOOLEAN
	is_null_file_role: BOOLEAN
	is_null_is_layout: BOOLEAN
	is_null_needs_mosis_agreement: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (file_role, r.file_role)
			Result := Result
				and is_null_file_role = r.is_null_file_role
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and archiveable = r.archiveable
				and deliverable = r.deliverable
				and deliver_prior = r.deliver_prior
				and is_layout = r.is_layout
				and needs_mosis_agreement = r.needs_mosis_agreement
				and role_order = r.role_order
			Result := Result
				and equal (descr, r.descr)
				and equal (message_application, r.message_application)
				and equal (prolog_message_id, r.prolog_message_id)
				and equal (role_text, r.role_text)
			Result := Result
				and is_null_archiveable = r.is_null_archiveable
				and is_null_deliverable = r.is_null_deliverable
				and is_null_deliver_prior = r.is_null_deliver_prior
				and is_null_descr = r.is_null_descr
				and is_null_is_layout = r.is_null_is_layout
				and is_null_message_application = r.is_null_message_application
				and is_null_needs_mosis_agreement = r.is_null_needs_mosis_agreement
				and is_null_prolog_message_id = r.is_null_prolog_message_id
				and is_null_role_order = r.is_null_role_order
				and is_null_role_text = r.is_null_role_text
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_boolean (2)
			q.select_boolean (3)
			q.select_string (4, 100)
			q.select_string (5, 20)
			q.select_boolean (6)
			q.select_string (7, 50)
			q.select_boolean (8)
			q.select_string (9, 20)
			q.select_integer (10)
			q.select_string (11, 100)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			archiveable := q.boolean_value (1)
			deliverable := q.boolean_value (2)
			deliver_prior := q.boolean_value (3)
			is_layout := q.boolean_value (6)
			needs_mosis_agreement := q.boolean_value (8)
			role_order := q.integer_value (10)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (4)
			file_role := q.string_value (5)
			message_application := q.string_value (7)
			prolog_message_id := q.string_value (9)
			role_text := q.string_value (11)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, descr)
			q.get_string_value (5, file_role)
			q.get_string_value (7, message_application)
			q.get_string_value (9, prolog_message_id)
			q.get_string_value (11, role_text)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_archiveable := q.is_null (1)
			is_null_deliverable := q.is_null (2)
			is_null_deliver_prior := q.is_null (3)
			is_null_descr := q.is_null (4)
			is_null_file_role := q.is_null (5)
			is_null_is_layout := q.is_null (6)
			is_null_message_application := q.is_null (7)
			is_null_needs_mosis_agreement := q.is_null (8)
			is_null_prolog_message_id := q.is_null (9)
			is_null_role_order := q.is_null (10)
			is_null_role_text := q.is_null (11)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_file_role := True
			create file_role.make (0)
		end

	set_null_nonkey
		do
			is_null_archiveable := True
			is_null_deliverable := True
			is_null_deliver_prior := True
			is_null_descr := True
			is_null_is_layout := True
			is_null_message_application := True
			is_null_needs_mosis_agreement := True
			is_null_prolog_message_id := True
			is_null_role_order := True
			is_null_role_text := True
			create descr.make (0)
			create message_application.make (0)
			create prolog_message_id.make (0)
			create role_text.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, file_role, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and archiveable = q.boolean_value (1)
				and deliverable = q.boolean_value (2)
				and deliver_prior = q.boolean_value (3)
				and is_layout = q.boolean_value (6)
				and needs_mosis_agreement = q.boolean_value (8)
				and role_order = q.integer_value (10)
			q.get_string_value (4, s)
			Result := Result and equal (descr, s)
			q.get_string_value (5, s)
			Result := Result and equal (file_role, s)
			q.get_string_value (7, s)
			Result := Result and equal (message_application, s)
			q.get_string_value (9, s)
			Result := Result and equal (prolog_message_id, s)
			q.get_string_value (11, s)
			Result := Result and equal (role_text, s)
			Result := Result
				and is_null_archiveable = q.is_null (1)
				and is_null_deliverable = q.is_null (2)
				and is_null_deliver_prior = q.is_null (3)
				and is_null_descr = q.is_null (4)
				and is_null_file_role = q.is_null (5)
				and is_null_is_layout = q.is_null (6)
				and is_null_message_application = q.is_null (7)
				and is_null_needs_mosis_agreement = q.is_null (8)
				and is_null_prolog_message_id = q.is_null (9)
				and is_null_role_order = q.is_null (10)
				and is_null_role_text = q.is_null (11)
		end

end
