
note

	date: "Fri Dec  9 16:50:22 2011"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"FILLER_ELEMENTS (MOSIS.FILLER_ELEMENTS)"
			-- Included columns
			-- 	CENTER_X
			-- 	CENTER_Y
			-- 	ELEMENT_NO
			-- 	ELEMENT_SHAPE
			-- 	FILLER_ID
			-- 	LAYER_NAME
			-- 	SIZE_X
			-- 	SIZE_Y
			-- Excluded columns
			-- 	(none)

class FILLER_ELEMENTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_filler_id: STRING; the_element_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_filler_id_exists: the_filler_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			filler_id := the_filler_id
			element_no := the_element_no
			is_null_filler_id := False
			is_null_element_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  center_x, center_y, element_no, element_shape, filler_id, layer_name,%N  size_x, size_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "filler_elements fe"

	join_condition: STRING = ""

	table_name: STRING = "filler_elements"

	key_where_clause: STRING = "filler_id = :1 and element_no = :2"

feature -- Values

	center_x: DOUBLE
			-- DB: NUMBER(9,6) not null

	center_y: DOUBLE
			-- DB: NUMBER(9,6) not null

	element_no: INTEGER
			-- DB: NUMBER(3,0) not null

	element_shape: STRING
			-- DB: VARCHAR2(30) not null

	filler_id: STRING
			-- DB: VARCHAR2(50) not null

	layer_name: STRING
			-- DB: VARCHAR2(255) not null

	size_x: DOUBLE
			-- DB: NUMBER(9,6) not null

	size_y: DOUBLE
			-- DB: NUMBER(9,6) not null

feature -- Nullness for non-null columns

	is_null_center_x: BOOLEAN
	is_null_center_y: BOOLEAN
	is_null_element_no: BOOLEAN
	is_null_element_shape: BOOLEAN
	is_null_filler_id: BOOLEAN
	is_null_layer_name: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and element_no = r.element_no
			Result := Result
				and equal (filler_id, r.filler_id)
			Result := Result
				and is_null_element_no = r.is_null_element_no
				and is_null_filler_id = r.is_null_filler_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and center_x = r.center_x
				and center_y = r.center_y
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (element_shape, r.element_shape)
				and equal (layer_name, r.layer_name)
			Result := Result
				and is_null_center_x = r.is_null_center_x
				and is_null_center_y = r.is_null_center_y
				and is_null_element_shape = r.is_null_element_shape
				and is_null_layer_name = r.is_null_layer_name
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_integer (3)
			q.select_string (4, 30)
			q.select_string (5, 50)
			q.select_string (6, 255)
			q.select_double (7)
			q.select_double (8)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			center_x := q.double_value (1)
			center_y := q.double_value (2)
			element_no := q.integer_value (3)
			size_x := q.double_value (7)
			size_y := q.double_value (8)
		end

	fill_in_references (q: SQL_QUERY)
		do
			element_shape := q.string_value (4)
			filler_id := q.string_value (5)
			layer_name := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, element_shape)
			q.get_string_value (5, filler_id)
			q.get_string_value (6, layer_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_center_x := q.is_null (1)
			is_null_center_y := q.is_null (2)
			is_null_element_no := q.is_null (3)
			is_null_element_shape := q.is_null (4)
			is_null_filler_id := q.is_null (5)
			is_null_layer_name := q.is_null (6)
			is_null_size_x := q.is_null (7)
			is_null_size_y := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_filler_id := True
			is_null_element_no := True
			create filler_id.make (0)
		end

	set_null_nonkey
		do
			is_null_center_x := True
			is_null_center_y := True
			is_null_element_shape := True
			is_null_layer_name := True
			is_null_size_x := True
			is_null_size_y := True
			create element_shape.make (0)
			create layer_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, filler_id, False)
			q.bind_num_to_integer (2, element_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and center_x = q.double_value (1)
				and center_y = q.double_value (2)
				and element_no = q.integer_value (3)
				and size_x = q.double_value (7)
				and size_y = q.double_value (8)
			q.get_string_value (4, s)
			Result := Result and equal (element_shape, s)
			q.get_string_value (5, s)
			Result := Result and equal (filler_id, s)
			q.get_string_value (6, s)
			Result := Result and equal (layer_name, s)
			Result := Result
				and is_null_center_x = q.is_null (1)
				and is_null_center_y = q.is_null (2)
				and is_null_element_no = q.is_null (3)
				and is_null_element_shape = q.is_null (4)
				and is_null_filler_id = q.is_null (5)
				and is_null_layer_name = q.is_null (6)
				and is_null_size_x = q.is_null (7)
				and is_null_size_y = q.is_null (8)
		end

end
