
note

	date: "Fri Dec  9 16:50:14 2011"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"FILLERS (MOSIS.FILLERS)"
			-- Included columns
			-- 	COMMENTS
			-- 	FILLER_ID
			-- 	STEP_MODULARITY
			-- 	STEP_X
			-- 	STEP_Y
			-- Excluded columns
			-- 	(none)

class FILLERS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_filler_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_filler_id_exists: the_filler_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			filler_id := the_filler_id
			is_null_filler_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, filler_id, step_modularity, step_x, step_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "fillers f"

	join_condition: STRING = ""

	table_name: STRING = "fillers"

	key_where_clause: STRING = "filler_id = :1"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(500)

	filler_id: STRING
			-- DB: VARCHAR2(50) not null

	step_modularity: INTEGER
			-- DB: NUMBER(3,0) not null

	step_x: DOUBLE
			-- DB: NUMBER(9,6) not null

	step_y: DOUBLE
			-- DB: NUMBER(9,6) not null

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN

feature -- Nullness for non-null columns

	is_null_filler_id: BOOLEAN
	is_null_step_modularity: BOOLEAN
	is_null_step_x: BOOLEAN
	is_null_step_y: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (filler_id, r.filler_id)
			Result := Result
				and is_null_filler_id = r.is_null_filler_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and step_modularity = r.step_modularity
				and step_x = r.step_x
				and step_y = r.step_y
			Result := Result
				and equal (comments, r.comments)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_step_modularity = r.is_null_step_modularity
				and is_null_step_x = r.is_null_step_x
				and is_null_step_y = r.is_null_step_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 500)
			q.select_string (2, 50)
			q.select_integer (3)
			q.select_double (4)
			q.select_double (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			step_modularity := q.integer_value (3)
			step_x := q.double_value (4)
			step_y := q.double_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			filler_id := q.string_value (2)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (2, filler_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_filler_id := q.is_null (2)
			is_null_step_modularity := q.is_null (3)
			is_null_step_x := q.is_null (4)
			is_null_step_y := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_filler_id := True
			create filler_id.make (0)
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_step_modularity := True
			is_null_step_x := True
			is_null_step_y := True
			create comments.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, filler_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and step_modularity = q.integer_value (3)
				and step_x = q.double_value (4)
				and step_y = q.double_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (2, s)
			Result := Result and equal (filler_id, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_filler_id = q.is_null (2)
				and is_null_step_modularity = q.is_null (3)
				and is_null_step_x = q.is_null (4)
				and is_null_step_y = q.is_null (5)
		end

end
