
note

	date: "Thu Jan 21 12:59:44 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"GEOMETRY_QUANTITIES (MOSIS.GEOMETRY_QUANTITIES)"
			-- Included columns
			-- 	FIELD_SET_NAME
			-- 	GEOMETRY_ID
			-- 	INSTRUCTIONS
			-- 	IS_ROTATABLE
			-- 	QUANTITY_SITES
			-- Excluded columns
			-- 	(none)

class GEOMETRY_QUANTITIES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_geometry_id: STRING; the_field_set_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_geometry_id_exists: the_geometry_id /= Void
			the_field_set_name_exists: the_field_set_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			geometry_id := the_geometry_id
			field_set_name := the_field_set_name
			is_null_geometry_id := False
			is_null_field_set_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  field_set_name, geometry_id, instructions, is_rotatable, quantity_sites"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "geometry_quantities gq"

	join_condition: STRING = ""

	table_name: STRING = "geometry_quantities"

	key_where_clause: STRING = "geometry_id = :1 and field_set_name = :2"

feature -- Values

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	geometry_id: STRING
			-- DB: VARCHAR2(50) not null

	instructions: STRING
			-- DB: VARCHAR2(250)

	is_rotatable: BOOLEAN
			-- DB: CHAR(1) not null

	quantity_sites: INTEGER
			-- DB: NUMBER(2,0)

feature -- Nullness for null allowed columns

	is_null_instructions: BOOLEAN
	is_null_quantity_sites: BOOLEAN

feature -- Nullness for non-null columns

	is_null_field_set_name: BOOLEAN
	is_null_geometry_id: BOOLEAN
	is_null_is_rotatable: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (field_set_name, r.field_set_name)
				and equal (geometry_id, r.geometry_id)
			Result := Result
				and is_null_field_set_name = r.is_null_field_set_name
				and is_null_geometry_id = r.is_null_geometry_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_rotatable = r.is_rotatable
				and quantity_sites = r.quantity_sites
			Result := Result
				and equal (instructions, r.instructions)
			Result := Result
				and is_null_instructions = r.is_null_instructions
				and is_null_is_rotatable = r.is_null_is_rotatable
				and is_null_quantity_sites = r.is_null_quantity_sites
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_string (2, 50)
			q.select_string (3, 250)
			q.select_boolean (4)
			q.select_integer (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_rotatable := q.boolean_value (4)
			quantity_sites := q.integer_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_set_name := q.string_value (1)
			geometry_id := q.string_value (2)
			instructions := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, field_set_name)
			q.get_string_value (2, geometry_id)
			q.get_string_value (3, instructions)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_field_set_name := q.is_null (1)
			is_null_geometry_id := q.is_null (2)
			is_null_instructions := q.is_null (3)
			is_null_is_rotatable := q.is_null (4)
			is_null_quantity_sites := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_geometry_id := True
			is_null_field_set_name := True
			create geometry_id.make (0)
			create field_set_name.make (0)
		end

	set_null_nonkey
		do
			is_null_instructions := True
			is_null_is_rotatable := True
			is_null_quantity_sites := True
			create instructions.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, geometry_id, False)
			q.bind_num_to_string (2, field_set_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_rotatable = q.boolean_value (4)
				and quantity_sites = q.integer_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (field_set_name, s)
			q.get_string_value (2, s)
			Result := Result and equal (geometry_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (instructions, s)
			Result := Result
				and is_null_field_set_name = q.is_null (1)
				and is_null_geometry_id = q.is_null (2)
				and is_null_instructions = q.is_null (3)
				and is_null_is_rotatable = q.is_null (4)
				and is_null_quantity_sites = q.is_null (5)
		end

end
