
note

	date: "Mon Mar  8 15:14:15 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"GEOMETRY_STRUCTURES (MOSIS.GEOMETRY_STRUCTURES)"
			-- Included columns
			-- 	DRAWN_ORIENTATION
			-- 	GEOMETRY_ID
			-- 	GEOMETRY_ROLE
			-- 	STRUCTURE_NAME
			-- Excluded columns
			-- 	(none)

class GEOMETRY_STRUCTURES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_geometry_id: STRING; the_geometry_role: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_geometry_id_exists: the_geometry_id /= Void
			the_geometry_role_exists: the_geometry_role /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			geometry_id := the_geometry_id
			geometry_role := the_geometry_role
			is_null_geometry_id := False
			is_null_geometry_role := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  drawn_orientation, geometry_id, geometry_role, structure_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "geometry_structures gs"

	join_condition: STRING = ""

	table_name: STRING = "geometry_structures"

	key_where_clause: STRING = "geometry_id = :1 and geometry_role = :2"

feature -- Values

	drawn_orientation: INTEGER
			-- DB: NUMBER(3,0)

	geometry_id: STRING
			-- DB: VARCHAR2(50) not null

	geometry_role: STRING
			-- DB: VARCHAR2(20) not null

	structure_name: STRING
			-- DB: VARCHAR2(255) not null

feature -- Maximum database lengths for character columns

	maxlen_geometry_id: INTEGER = 50
	maxlen_geometry_role: INTEGER = 20
	maxlen_structure_name: INTEGER = 255

feature -- Precisions for number columns

	precision_drawn_orientation: INTEGER = 3

feature -- Scales for number columns

	scale_drawn_orientation: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_drawn_orientation: BOOLEAN

feature -- Nullness for non-null columns

	is_null_geometry_id: BOOLEAN
	is_null_geometry_role: BOOLEAN
	is_null_structure_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (geometry_id, r.geometry_id)
				and equal (geometry_role, r.geometry_role)
			Result := Result
				and is_null_geometry_id = r.is_null_geometry_id
				and is_null_geometry_role = r.is_null_geometry_role
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and drawn_orientation = r.drawn_orientation
			Result := Result
				and equal (structure_name, r.structure_name)
			Result := Result
				and is_null_drawn_orientation = r.is_null_drawn_orientation
				and is_null_structure_name = r.is_null_structure_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 50)
			q.select_string (3, 20)
			q.select_string (4, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			drawn_orientation := q.integer_value (1)
		end

	fill_in_references (q: SQL_QUERY)
		do
			geometry_id := q.string_value (2)
			geometry_role := q.string_value (3)
			structure_name := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, geometry_id)
			q.get_string_value (3, geometry_role)
			q.get_string_value (4, structure_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_drawn_orientation := q.is_null (1)
			is_null_geometry_id := q.is_null (2)
			is_null_geometry_role := q.is_null (3)
			is_null_structure_name := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_geometry_id := True
			is_null_geometry_role := True
			create geometry_id.make (0)
			create geometry_role.make (0)
		end

	set_null_nonkey
		do
			is_null_drawn_orientation := True
			is_null_structure_name := True
			create structure_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, geometry_id, False)
			q.bind_num_to_string (2, geometry_role, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and drawn_orientation = q.integer_value (1)
			q.get_string_value (2, s)
			Result := Result and equal (geometry_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (geometry_role, s)
			q.get_string_value (4, s)
			Result := Result and equal (structure_name, s)
			Result := Result
				and is_null_drawn_orientation = q.is_null (1)
				and is_null_geometry_id = q.is_null (2)
				and is_null_geometry_role = q.is_null (3)
				and is_null_structure_name = q.is_null (4)
		end

end
