
note

	date: "Thu Jan 21 12:59:44 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"GEOMETRY#FIXED_LOCATIONS (MOSIS.GEOMETRY#FIXED_LOCATIONS)"
			-- Included columns
			-- 	COMMENTS
			-- 	FIELD_NAME
			-- 	FIELD_SET_NAME
			-- 	GEOMETRY_ID
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- Excluded columns
			-- 	(none)

class GEOMETRYXFIXED_LOCATIONS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_geometry_id: STRING; the_field_set_name: STRING; the_field_name: STRING; the_location_x: DOUBLE; the_location_y: DOUBLE)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_geometry_id_exists: the_geometry_id /= Void
			the_field_set_name_exists: the_field_set_name /= Void
			the_field_name_exists: the_field_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			geometry_id := the_geometry_id
			field_set_name := the_field_set_name
			field_name := the_field_name
			location_x := the_location_x
			location_y := the_location_y
			is_null_geometry_id := False
			is_null_field_set_name := False
			is_null_field_name := False
			is_null_location_x := False
			is_null_location_y := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, field_name, field_set_name, geometry_id, location_x, location_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "geometry#fixed_locations gl"

	join_condition: STRING = ""

	table_name: STRING = "geometry#fixed_locations"

	key_where_clause: STRING = "geometry_id = :1 and field_set_name = :2 and field_name = :3 and location_x = :4 and location_y = :5"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(255)

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	geometry_id: STRING
			-- DB: VARCHAR2(50) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN

feature -- Nullness for non-null columns

	is_null_field_name: BOOLEAN
	is_null_field_set_name: BOOLEAN
	is_null_geometry_id: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and location_x = r.location_x
				and location_y = r.location_y
			Result := Result
				and equal (field_name, r.field_name)
				and equal (field_set_name, r.field_set_name)
				and equal (geometry_id, r.geometry_id)
			Result := Result
				and is_null_field_name = r.is_null_field_name
				and is_null_field_set_name = r.is_null_field_set_name
				and is_null_geometry_id = r.is_null_geometry_id
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (comments, r.comments)
			Result := Result
				and is_null_comments = r.is_null_comments
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 20)
			q.select_string (3, 30)
			q.select_string (4, 50)
			q.select_double (5)
			q.select_double (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			location_x := q.double_value (5)
			location_y := q.double_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			field_name := q.string_value (2)
			field_set_name := q.string_value (3)
			geometry_id := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (2, field_name)
			q.get_string_value (3, field_set_name)
			q.get_string_value (4, geometry_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_field_name := q.is_null (2)
			is_null_field_set_name := q.is_null (3)
			is_null_geometry_id := q.is_null (4)
			is_null_location_x := q.is_null (5)
			is_null_location_y := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_geometry_id := True
			is_null_field_set_name := True
			is_null_field_name := True
			is_null_location_x := True
			is_null_location_y := True
			create geometry_id.make (0)
			create field_set_name.make (0)
			create field_name.make (0)
		end

	set_null_nonkey
		do
			is_null_comments := True
			create comments.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, geometry_id, False)
			q.bind_num_to_string (2, field_set_name, False)
			q.bind_num_to_string (3, field_name, False)
			q.bind_num_to_double (4, location_x, False)
			q.bind_num_to_double (5, location_y, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and location_x = q.double_value (5)
				and location_y = q.double_value (6)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (2, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (3, s)
			Result := Result and equal (field_set_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (geometry_id, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_field_name = q.is_null (2)
				and is_null_field_set_name = q.is_null (3)
				and is_null_geometry_id = q.is_null (4)
				and is_null_location_x = q.is_null (5)
				and is_null_location_y = q.is_null (6)
		end

end
