
note

	date: "Thu Jan 21 12:59:44 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"IC_PACKAGING_WIRES (MOSIS.IC_PACKAGING_WIRES)"
			-- Included columns
			-- 	BONDING_FINGER_ID
			-- 	DESIGN_NO
			-- 	DOWNBOND
			-- 	IC_PACKAGING_NO
			-- 	PACKAGE_ID
			-- 	PAD_NAME
			-- 	WIRE_NO
			-- Excluded columns
			-- 	(none)

class IC_PACKAGING_WIRES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_ic_packaging_no: INTEGER; the_wire_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			ic_packaging_no := the_ic_packaging_no
			wire_no := the_wire_no
			is_null_ic_packaging_no := False
			is_null_wire_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  bonding_finger_id, design_no, downbond, ic_packaging_no, package_id,%N  pad_name, wire_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "ic_packaging_wires icpw"

	join_condition: STRING = ""

	table_name: STRING = "ic_packaging_wires"

	key_where_clause: STRING = "ic_packaging_no = :1 and wire_no = :2"

feature -- Values

	bonding_finger_id: STRING
			-- DB: VARCHAR2(6)

	design_no: INTEGER
			-- DB: NUMBER(6,0)

	downbond: BOOLEAN
			-- DB: CHAR(1) not null

	ic_packaging_no: INTEGER
			-- DB: NUMBER(6,0) not null

	package_id: STRING
			-- DB: VARCHAR2(25)

	pad_name: STRING
			-- DB: VARCHAR2(6)

	wire_no: INTEGER
			-- DB: NUMBER(3,0) not null

feature -- Maximum database lengths for character columns

	maxlen_bonding_finger_id: INTEGER = 6
	maxlen_package_id: INTEGER = 25
	maxlen_pad_name: INTEGER = 6

feature -- Precisions for number columns

	precision_design_no: INTEGER = 6
	precision_ic_packaging_no: INTEGER = 6
	precision_wire_no: INTEGER = 3

feature -- Scales for number columns

	scale_design_no: INTEGER = 0
	scale_ic_packaging_no: INTEGER = 0
	scale_wire_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_bonding_finger_id: BOOLEAN
	is_null_design_no: BOOLEAN
	is_null_package_id: BOOLEAN
	is_null_pad_name: BOOLEAN

feature -- Nullness for non-null columns

	is_null_downbond: BOOLEAN
	is_null_ic_packaging_no: BOOLEAN
	is_null_wire_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and ic_packaging_no = r.ic_packaging_no
				and wire_no = r.wire_no
			Result := Result
				and is_null_ic_packaging_no = r.is_null_ic_packaging_no
				and is_null_wire_no = r.is_null_wire_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
				and downbond = r.downbond
			Result := Result
				and equal (bonding_finger_id, r.bonding_finger_id)
				and equal (package_id, r.package_id)
				and equal (pad_name, r.pad_name)
			Result := Result
				and is_null_bonding_finger_id = r.is_null_bonding_finger_id
				and is_null_design_no = r.is_null_design_no
				and is_null_downbond = r.is_null_downbond
				and is_null_package_id = r.is_null_package_id
				and is_null_pad_name = r.is_null_pad_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 6)
			q.select_integer (2)
			q.select_boolean (3)
			q.select_integer (4)
			q.select_string (5, 25)
			q.select_string (6, 6)
			q.select_integer (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			design_no := q.integer_value (2)
			downbond := q.boolean_value (3)
			ic_packaging_no := q.integer_value (4)
			wire_no := q.integer_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			bonding_finger_id := q.string_value (1)
			package_id := q.string_value (5)
			pad_name := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, bonding_finger_id)
			q.get_string_value (5, package_id)
			q.get_string_value (6, pad_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_bonding_finger_id := q.is_null (1)
			is_null_design_no := q.is_null (2)
			is_null_downbond := q.is_null (3)
			is_null_ic_packaging_no := q.is_null (4)
			is_null_package_id := q.is_null (5)
			is_null_pad_name := q.is_null (6)
			is_null_wire_no := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_ic_packaging_no := True
			is_null_wire_no := True
		end

	set_null_nonkey
		do
			is_null_bonding_finger_id := True
			is_null_design_no := True
			is_null_downbond := True
			is_null_package_id := True
			is_null_pad_name := True
			create bonding_finger_id.make (0)
			create package_id.make (0)
			create pad_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, ic_packaging_no, False)
			q.bind_num_to_integer (2, wire_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and design_no = q.integer_value (2)
				and downbond = q.boolean_value (3)
				and ic_packaging_no = q.integer_value (4)
				and wire_no = q.integer_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (bonding_finger_id, s)
			q.get_string_value (5, s)
			Result := Result and equal (package_id, s)
			q.get_string_value (6, s)
			Result := Result and equal (pad_name, s)
			Result := Result
				and is_null_bonding_finger_id = q.is_null (1)
				and is_null_design_no = q.is_null (2)
				and is_null_downbond = q.is_null (3)
				and is_null_ic_packaging_no = q.is_null (4)
				and is_null_package_id = q.is_null (5)
				and is_null_pad_name = q.is_null (6)
				and is_null_wire_no = q.is_null (7)
		end

end
