
note

	date: "Wed Aug 21 13:44:38 2013"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"IC_PACKAGINGS (MOSIS.IC_PACKAGINGS)"
			-- Included columns
			-- 	ARTWORK_FILENAME
			-- 	BAKE_AND_BAG
			-- 	BONDING_ID
			-- 	CUSTOMER_PROVIDING_DIAGRAM
			-- 	DATE_BOND_DIAGRAM_NOTICE_SENT
			-- 	DATE_DIAGRAM_APPROVED
			-- 	DATE_DIAGRAM_RECEIVED
			-- 	DATE_DRAFT_DIAGRAM_APPROVED
			-- 	DATE_DRAFT_DIAGRAM_RECEIVED
			-- 	DESIGN_PACKAGE_ROTATION
			-- 	DESIGN_PACKAGE_ROTATION_REQD
			-- 	DIAGRAM_APPROVED_BY
			-- 	DIE_THICKNESS_MILS
			-- 	DOWNBOND_LOCATION_REQD
			-- 	IC_PACKAGING_NO
			-- 	IS_CUSTOM_WIRING
			-- 	LID_ATTACHMENT
			-- 	MOISTURE_SENSITIVE_LEVEL
			-- 	M_FAB_NO
			-- 	PACKAGE_ID
			-- 	PACKAGE_REQUESTED
			-- 	QUANTITY_PACKAGED_REQUESTED
			-- Excluded columns
			-- 	(none)

class IC_PACKAGINGS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_ic_packaging_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			ic_packaging_no := the_ic_packaging_no
			is_null_ic_packaging_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 22

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  artwork_filename, bake_and_bag, bonding_id, customer_providing_diagram,%N  date_bond_diagram_notice_sent, date_diagram_approved,%N  date_diagram_received, date_draft_diagram_approved,%N  date_draft_diagram_received, design_package_rotation,%N  design_package_rotation_reqd, diagram_approved_by, die_thickness_mils,%N  downbond_location_reqd, ic_packaging_no, is_custom_wiring,%N  lid_attachment, moisture_sensitive_level, m_fab_no, package_id,%N  package_requested, quantity_packaged_requested"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "ic_packagings icp"

	join_condition: STRING = ""

	table_name: STRING = "ic_packagings"

	key_where_clause: STRING = "ic_packaging_no = :1"

feature -- Values

	artwork_filename: STRING
			-- DB: VARCHAR2(255)

	bake_and_bag: BOOLEAN
			-- DB: CHAR(1) not null

	bonding_id: STRING
			-- DB: VARCHAR2(6)

	customer_providing_diagram: BOOLEAN
			-- DB: CHAR(1) not null

	date_bond_diagram_notice_sent: DB_DATE
			-- DB: DATE

	date_diagram_approved: DB_DATE
			-- DB: DATE

	date_diagram_received: DB_DATE
			-- DB: DATE

	date_draft_diagram_approved: DB_DATE
			-- DB: DATE

	date_draft_diagram_received: DB_DATE
			-- DB: DATE

	design_package_rotation: INTEGER
			-- DB: NUMBER(3,0)

	design_package_rotation_reqd: INTEGER
			-- DB: NUMBER(3,0)

	diagram_approved_by: STRING
			-- DB: VARCHAR2(40)

	die_thickness_mils: DOUBLE
			-- DB: NUMBER(*,*)

	downbond_location_reqd: STRING
			-- DB: VARCHAR2(8)

	ic_packaging_no: INTEGER
			-- DB: NUMBER(6,0) not null

	is_custom_wiring: BOOLEAN
			-- DB: CHAR(1)

	lid_attachment: STRING
			-- DB: VARCHAR2(10)

	moisture_sensitive_level: INTEGER
			-- DB: NUMBER(2,0)

	m_fab_no: INTEGER
			-- DB: NUMBER(6,0) not null

	package_id: STRING
			-- DB: VARCHAR2(25)

	package_requested: STRING
			-- DB: VARCHAR2(255)

	quantity_packaged_requested: INTEGER
			-- DB: NUMBER(6,0)

feature -- Maximum database lengths for character columns

	maxlen_artwork_filename: INTEGER = 255
	maxlen_bonding_id: INTEGER = 6
	maxlen_diagram_approved_by: INTEGER = 40
	maxlen_downbond_location_reqd: INTEGER = 8
	maxlen_lid_attachment: INTEGER = 10
	maxlen_package_id: INTEGER = 25
	maxlen_package_requested: INTEGER = 255

feature -- Precisions for number columns

	precision_design_package_rotation: INTEGER = 3
	precision_design_package_rotation_reqd: INTEGER = 3
	precision_die_thickness_mils: INTEGER = 38
	precision_ic_packaging_no: INTEGER = 6
	precision_moisture_sensitive_level: INTEGER = 2
	precision_m_fab_no: INTEGER = 6
	precision_quantity_packaged_requested: INTEGER = 6

feature -- Scales for number columns

	scale_design_package_rotation: INTEGER = 0
	scale_design_package_rotation_reqd: INTEGER = 0
	scale_ic_packaging_no: INTEGER = 0
	scale_moisture_sensitive_level: INTEGER = 0
	scale_m_fab_no: INTEGER = 0
	scale_quantity_packaged_requested: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_artwork_filename: BOOLEAN
	is_null_bonding_id: BOOLEAN
	is_null_date_bond_diagram_notice_sent: BOOLEAN
	is_null_date_diagram_approved: BOOLEAN
	is_null_date_diagram_received: BOOLEAN
	is_null_date_draft_diagram_approved: BOOLEAN
	is_null_date_draft_diagram_received: BOOLEAN
	is_null_design_package_rotation: BOOLEAN
	is_null_design_package_rotation_reqd: BOOLEAN
	is_null_diagram_approved_by: BOOLEAN
	is_null_die_thickness_mils: BOOLEAN
	is_null_downbond_location_reqd: BOOLEAN
	is_null_is_custom_wiring: BOOLEAN
	is_null_lid_attachment: BOOLEAN
	is_null_moisture_sensitive_level: BOOLEAN
	is_null_package_id: BOOLEAN
	is_null_package_requested: BOOLEAN
	is_null_quantity_packaged_requested: BOOLEAN

feature -- Nullness for non-null columns

	is_null_bake_and_bag: BOOLEAN
	is_null_customer_providing_diagram: BOOLEAN
	is_null_ic_packaging_no: BOOLEAN
	is_null_m_fab_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and ic_packaging_no = r.ic_packaging_no
			Result := Result
				and is_null_ic_packaging_no = r.is_null_ic_packaging_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and bake_and_bag = r.bake_and_bag
				and customer_providing_diagram = r.customer_providing_diagram
				and design_package_rotation = r.design_package_rotation
				and design_package_rotation_reqd = r.design_package_rotation_reqd
				and die_thickness_mils = r.die_thickness_mils
				and is_custom_wiring = r.is_custom_wiring
				and moisture_sensitive_level = r.moisture_sensitive_level
				and m_fab_no = r.m_fab_no
				and quantity_packaged_requested = r.quantity_packaged_requested
			Result := Result
				and equal (artwork_filename, r.artwork_filename)
				and equal (bonding_id, r.bonding_id)
				and equal (date_bond_diagram_notice_sent, r.date_bond_diagram_notice_sent)
				and equal (date_diagram_approved, r.date_diagram_approved)
				and equal (date_diagram_received, r.date_diagram_received)
				and equal (date_draft_diagram_approved, r.date_draft_diagram_approved)
				and equal (date_draft_diagram_received, r.date_draft_diagram_received)
				and equal (diagram_approved_by, r.diagram_approved_by)
				and equal (downbond_location_reqd, r.downbond_location_reqd)
				and equal (lid_attachment, r.lid_attachment)
				and equal (package_id, r.package_id)
				and equal (package_requested, r.package_requested)
			Result := Result
				and is_null_artwork_filename = r.is_null_artwork_filename
				and is_null_bake_and_bag = r.is_null_bake_and_bag
				and is_null_bonding_id = r.is_null_bonding_id
				and is_null_customer_providing_diagram = r.is_null_customer_providing_diagram
				and is_null_date_bond_diagram_notice_sent = r.is_null_date_bond_diagram_notice_sent
				and is_null_date_diagram_approved = r.is_null_date_diagram_approved
				and is_null_date_diagram_received = r.is_null_date_diagram_received
				and is_null_date_draft_diagram_approved = r.is_null_date_draft_diagram_approved
				and is_null_date_draft_diagram_received = r.is_null_date_draft_diagram_received
				and is_null_design_package_rotation = r.is_null_design_package_rotation
				and is_null_design_package_rotation_reqd = r.is_null_design_package_rotation_reqd
				and is_null_diagram_approved_by = r.is_null_diagram_approved_by
				and is_null_die_thickness_mils = r.is_null_die_thickness_mils
				and is_null_downbond_location_reqd = r.is_null_downbond_location_reqd
				and is_null_is_custom_wiring = r.is_null_is_custom_wiring
				and is_null_lid_attachment = r.is_null_lid_attachment
				and is_null_moisture_sensitive_level = r.is_null_moisture_sensitive_level
				and is_null_m_fab_no = r.is_null_m_fab_no
				and is_null_package_id = r.is_null_package_id
				and is_null_package_requested = r.is_null_package_requested
				and is_null_quantity_packaged_requested = r.is_null_quantity_packaged_requested
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_boolean (2)
			q.select_string (3, 6)
			q.select_boolean (4)
			q.select_date (5)
			q.select_date (6)
			q.select_date (7)
			q.select_date (8)
			q.select_date (9)
			q.select_integer (10)
			q.select_integer (11)
			q.select_string (12, 40)
			q.select_double (13)
			q.select_string (14, 8)
			q.select_integer (15)
			q.select_boolean (16)
			q.select_string (17, 10)
			q.select_integer (18)
			q.select_integer (19)
			q.select_string (20, 25)
			q.select_string (21, 255)
			q.select_integer (22)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			bake_and_bag := q.boolean_value (2)
			customer_providing_diagram := q.boolean_value (4)
			design_package_rotation := q.integer_value (10)
			design_package_rotation_reqd := q.integer_value (11)
			die_thickness_mils := q.double_value (13)
			ic_packaging_no := q.integer_value (15)
			is_custom_wiring := q.boolean_value (16)
			moisture_sensitive_level := q.integer_value (18)
			m_fab_no := q.integer_value (19)
			quantity_packaged_requested := q.integer_value (22)
		end

	fill_in_references (q: SQL_QUERY)
		do
			artwork_filename := q.string_value (1)
			bonding_id := q.string_value (3)
			date_bond_diagram_notice_sent := q.date_value (5)
			date_diagram_approved := q.date_value (6)
			date_diagram_received := q.date_value (7)
			date_draft_diagram_approved := q.date_value (8)
			date_draft_diagram_received := q.date_value (9)
			diagram_approved_by := q.string_value (12)
			downbond_location_reqd := q.string_value (14)
			lid_attachment := q.string_value (17)
			package_id := q.string_value (20)
			package_requested := q.string_value (21)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, artwork_filename)
			q.get_string_value (3, bonding_id)
			q.get_date_value (5, date_bond_diagram_notice_sent)
			q.get_date_value (6, date_diagram_approved)
			q.get_date_value (7, date_diagram_received)
			q.get_date_value (8, date_draft_diagram_approved)
			q.get_date_value (9, date_draft_diagram_received)
			q.get_string_value (12, diagram_approved_by)
			q.get_string_value (14, downbond_location_reqd)
			q.get_string_value (17, lid_attachment)
			q.get_string_value (20, package_id)
			q.get_string_value (21, package_requested)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_artwork_filename := q.is_null (1)
			is_null_bake_and_bag := q.is_null (2)
			is_null_bonding_id := q.is_null (3)
			is_null_customer_providing_diagram := q.is_null (4)
			is_null_date_bond_diagram_notice_sent := q.is_null (5)
			is_null_date_diagram_approved := q.is_null (6)
			is_null_date_diagram_received := q.is_null (7)
			is_null_date_draft_diagram_approved := q.is_null (8)
			is_null_date_draft_diagram_received := q.is_null (9)
			is_null_design_package_rotation := q.is_null (10)
			is_null_design_package_rotation_reqd := q.is_null (11)
			is_null_diagram_approved_by := q.is_null (12)
			is_null_die_thickness_mils := q.is_null (13)
			is_null_downbond_location_reqd := q.is_null (14)
			is_null_ic_packaging_no := q.is_null (15)
			is_null_is_custom_wiring := q.is_null (16)
			is_null_lid_attachment := q.is_null (17)
			is_null_moisture_sensitive_level := q.is_null (18)
			is_null_m_fab_no := q.is_null (19)
			is_null_package_id := q.is_null (20)
			is_null_package_requested := q.is_null (21)
			is_null_quantity_packaged_requested := q.is_null (22)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_ic_packaging_no := True
		end

	set_null_nonkey
		do
			is_null_artwork_filename := True
			is_null_bake_and_bag := True
			is_null_bonding_id := True
			is_null_customer_providing_diagram := True
			is_null_date_bond_diagram_notice_sent := True
			is_null_date_diagram_approved := True
			is_null_date_diagram_received := True
			is_null_date_draft_diagram_approved := True
			is_null_date_draft_diagram_received := True
			is_null_design_package_rotation := True
			is_null_design_package_rotation_reqd := True
			is_null_diagram_approved_by := True
			is_null_die_thickness_mils := True
			is_null_downbond_location_reqd := True
			is_null_is_custom_wiring := True
			is_null_lid_attachment := True
			is_null_moisture_sensitive_level := True
			is_null_m_fab_no := True
			is_null_package_id := True
			is_null_package_requested := True
			is_null_quantity_packaged_requested := True
			create artwork_filename.make (0)
			create bonding_id.make (0)
			create {ORACLE_DATE} date_bond_diagram_notice_sent.set_null
			create {ORACLE_DATE} date_diagram_approved.set_null
			create {ORACLE_DATE} date_diagram_received.set_null
			create {ORACLE_DATE} date_draft_diagram_approved.set_null
			create {ORACLE_DATE} date_draft_diagram_received.set_null
			create diagram_approved_by.make (0)
			create downbond_location_reqd.make (0)
			create lid_attachment.make (0)
			create package_id.make (0)
			create package_requested.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, ic_packaging_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and bake_and_bag = q.boolean_value (2)
				and customer_providing_diagram = q.boolean_value (4)
				and design_package_rotation = q.integer_value (10)
				and design_package_rotation_reqd = q.integer_value (11)
				and die_thickness_mils = q.double_value (13)
				and ic_packaging_no = q.integer_value (15)
				and is_custom_wiring = q.boolean_value (16)
				and moisture_sensitive_level = q.integer_value (18)
				and m_fab_no = q.integer_value (19)
				and quantity_packaged_requested = q.integer_value (22)
			q.get_string_value (1, s)
			Result := Result and equal (artwork_filename, s)
			q.get_string_value (3, s)
			Result := Result and equal (bonding_id, s)
			q.get_date_value (5, d)
			Result := Result and equal (date_bond_diagram_notice_sent, d)
			q.get_date_value (6, d)
			Result := Result and equal (date_diagram_approved, d)
			q.get_date_value (7, d)
			Result := Result and equal (date_diagram_received, d)
			q.get_date_value (8, d)
			Result := Result and equal (date_draft_diagram_approved, d)
			q.get_date_value (9, d)
			Result := Result and equal (date_draft_diagram_received, d)
			q.get_string_value (12, s)
			Result := Result and equal (diagram_approved_by, s)
			q.get_string_value (14, s)
			Result := Result and equal (downbond_location_reqd, s)
			q.get_string_value (17, s)
			Result := Result and equal (lid_attachment, s)
			q.get_string_value (20, s)
			Result := Result and equal (package_id, s)
			q.get_string_value (21, s)
			Result := Result and equal (package_requested, s)
			Result := Result
				and is_null_artwork_filename = q.is_null (1)
				and is_null_bake_and_bag = q.is_null (2)
				and is_null_bonding_id = q.is_null (3)
				and is_null_customer_providing_diagram = q.is_null (4)
				and is_null_date_bond_diagram_notice_sent = q.is_null (5)
				and is_null_date_diagram_approved = q.is_null (6)
				and is_null_date_diagram_received = q.is_null (7)
				and is_null_date_draft_diagram_approved = q.is_null (8)
				and is_null_date_draft_diagram_received = q.is_null (9)
				and is_null_design_package_rotation = q.is_null (10)
				and is_null_design_package_rotation_reqd = q.is_null (11)
				and is_null_diagram_approved_by = q.is_null (12)
				and is_null_die_thickness_mils = q.is_null (13)
				and is_null_downbond_location_reqd = q.is_null (14)
				and is_null_ic_packaging_no = q.is_null (15)
				and is_null_is_custom_wiring = q.is_null (16)
				and is_null_lid_attachment = q.is_null (17)
				and is_null_moisture_sensitive_level = q.is_null (18)
				and is_null_m_fab_no = q.is_null (19)
				and is_null_package_id = q.is_null (20)
				and is_null_package_requested = q.is_null (21)
				and is_null_quantity_packaged_requested = q.is_null (22)
		end

end
