
note

	date: "Wed Jul 25 06:01:08 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"M_PARTS (MOSIS.M_PARTS)"
			-- Included columns
			-- 	COMMENTS
			-- 	CUST_ORDERABLE
			-- 	DESCR
			-- 	DISCOUNTABLE
			-- 	FAB_REVENUE
			-- 	FE_REPORTABLE
			-- 	INITIALLY_INVOICED
			-- 	M_PART_NO
			-- 	PACKAGED
			-- 	PACKAGE_GROUP
			-- 	PACKAGE_ID
			-- 	PART_INCREMENT
			-- 	PART_TYPE
			-- 	PART_UNIT
			-- 	QUANTITY_IN_PART
			-- 	QUOTE_DEFAULT_DESCR
			-- 	SHIPPABLE
			-- 	TECHN_GROUP_FAMILY
			-- 	TG_FAMILY_TIER_NO
			-- 	WAFER_TECHN
			-- Excluded columns
			-- 	(none)

class M_PARTS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_part_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_part_no := the_m_part_no
			is_null_m_part_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 20

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, cust_orderable, descr, discountable, fab_revenue,%N  fe_reportable, initially_invoiced, m_part_no, packaged, package_group,%N  package_id, part_increment, part_type, part_unit, quantity_in_part,%N  quote_default_descr, shippable, techn_group_family, tg_family_tier_no,%N  wafer_techn"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_parts mp"

	join_condition: STRING = ""

	table_name: STRING = "m_parts"

	key_where_clause: STRING = "m_part_no = :1"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(255)

	cust_orderable: BOOLEAN
			-- DB: CHAR(1) not null

	descr: STRING
			-- DB: VARCHAR2(80) not null

	discountable: BOOLEAN
			-- DB: CHAR(1)

	fab_revenue: BOOLEAN
			-- DB: CHAR(1)

	fe_reportable: BOOLEAN
			-- DB: CHAR(1)

	initially_invoiced: BOOLEAN
			-- DB: CHAR(1)

	m_part_no: INTEGER
			-- DB: NUMBER(6,0) not null

	packaged: BOOLEAN
			-- DB: CHAR(1)

	package_group: STRING
			-- DB: VARCHAR2(30)

	package_id: STRING
			-- DB: VARCHAR2(25)

	part_increment: STRING
			-- DB: VARCHAR2(10)

	part_type: STRING
			-- DB: VARCHAR2(10) not null

	part_unit: STRING
			-- DB: VARCHAR2(20) not null

	quantity_in_part: INTEGER
			-- DB: NUMBER(6,0) not null

	quote_default_descr: STRING
			-- DB: VARCHAR2(2000)

	shippable: BOOLEAN
			-- DB: CHAR(1)

	techn_group_family: STRING
			-- DB: VARCHAR2(20)

	tg_family_tier_no: INTEGER
			-- DB: NUMBER(2,0)

	wafer_techn: STRING
			-- DB: VARCHAR2(50)

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_discountable: BOOLEAN
	is_null_fab_revenue: BOOLEAN
	is_null_fe_reportable: BOOLEAN
	is_null_initially_invoiced: BOOLEAN
	is_null_packaged: BOOLEAN
	is_null_package_group: BOOLEAN
	is_null_package_id: BOOLEAN
	is_null_part_increment: BOOLEAN
	is_null_quote_default_descr: BOOLEAN
	is_null_shippable: BOOLEAN
	is_null_techn_group_family: BOOLEAN
	is_null_tg_family_tier_no: BOOLEAN
	is_null_wafer_techn: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cust_orderable: BOOLEAN
	is_null_descr: BOOLEAN
	is_null_m_part_no: BOOLEAN
	is_null_part_type: BOOLEAN
	is_null_part_unit: BOOLEAN
	is_null_quantity_in_part: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_part_no = r.m_part_no
			Result := Result
				and is_null_m_part_no = r.is_null_m_part_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cust_orderable = r.cust_orderable
				and discountable = r.discountable
				and fab_revenue = r.fab_revenue
				and fe_reportable = r.fe_reportable
				and initially_invoiced = r.initially_invoiced
				and packaged = r.packaged
				and quantity_in_part = r.quantity_in_part
				and shippable = r.shippable
				and tg_family_tier_no = r.tg_family_tier_no
			Result := Result
				and equal (comments, r.comments)
				and equal (descr, r.descr)
				and equal (package_group, r.package_group)
				and equal (package_id, r.package_id)
				and equal (part_increment, r.part_increment)
				and equal (part_type, r.part_type)
				and equal (part_unit, r.part_unit)
				and equal (quote_default_descr, r.quote_default_descr)
				and equal (techn_group_family, r.techn_group_family)
				and equal (wafer_techn, r.wafer_techn)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_cust_orderable = r.is_null_cust_orderable
				and is_null_descr = r.is_null_descr
				and is_null_discountable = r.is_null_discountable
				and is_null_fab_revenue = r.is_null_fab_revenue
				and is_null_fe_reportable = r.is_null_fe_reportable
				and is_null_initially_invoiced = r.is_null_initially_invoiced
				and is_null_packaged = r.is_null_packaged
				and is_null_package_group = r.is_null_package_group
				and is_null_package_id = r.is_null_package_id
				and is_null_part_increment = r.is_null_part_increment
				and is_null_part_type = r.is_null_part_type
				and is_null_part_unit = r.is_null_part_unit
				and is_null_quantity_in_part = r.is_null_quantity_in_part
				and is_null_quote_default_descr = r.is_null_quote_default_descr
				and is_null_shippable = r.is_null_shippable
				and is_null_techn_group_family = r.is_null_techn_group_family
				and is_null_tg_family_tier_no = r.is_null_tg_family_tier_no
				and is_null_wafer_techn = r.is_null_wafer_techn
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_boolean (2)
			q.select_string (3, 80)
			q.select_boolean (4)
			q.select_boolean (5)
			q.select_boolean (6)
			q.select_boolean (7)
			q.select_integer (8)
			q.select_boolean (9)
			q.select_string (10, 30)
			q.select_string (11, 25)
			q.select_string (12, 10)
			q.select_string (13, 10)
			q.select_string (14, 20)
			q.select_integer (15)
			q.select_string (16, 2000)
			q.select_boolean (17)
			q.select_string (18, 20)
			q.select_integer (19)
			q.select_string (20, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cust_orderable := q.boolean_value (2)
			discountable := q.boolean_value (4)
			fab_revenue := q.boolean_value (5)
			fe_reportable := q.boolean_value (6)
			initially_invoiced := q.boolean_value (7)
			m_part_no := q.integer_value (8)
			packaged := q.boolean_value (9)
			quantity_in_part := q.integer_value (15)
			shippable := q.boolean_value (17)
			tg_family_tier_no := q.integer_value (19)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			descr := q.string_value (3)
			package_group := q.string_value (10)
			package_id := q.string_value (11)
			part_increment := q.string_value (12)
			part_type := q.string_value (13)
			part_unit := q.string_value (14)
			quote_default_descr := q.string_value (16)
			techn_group_family := q.string_value (18)
			wafer_techn := q.string_value (20)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (3, descr)
			q.get_string_value (10, package_group)
			q.get_string_value (11, package_id)
			q.get_string_value (12, part_increment)
			q.get_string_value (13, part_type)
			q.get_string_value (14, part_unit)
			q.get_string_value (16, quote_default_descr)
			q.get_string_value (18, techn_group_family)
			q.get_string_value (20, wafer_techn)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_cust_orderable := q.is_null (2)
			is_null_descr := q.is_null (3)
			is_null_discountable := q.is_null (4)
			is_null_fab_revenue := q.is_null (5)
			is_null_fe_reportable := q.is_null (6)
			is_null_initially_invoiced := q.is_null (7)
			is_null_m_part_no := q.is_null (8)
			is_null_packaged := q.is_null (9)
			is_null_package_group := q.is_null (10)
			is_null_package_id := q.is_null (11)
			is_null_part_increment := q.is_null (12)
			is_null_part_type := q.is_null (13)
			is_null_part_unit := q.is_null (14)
			is_null_quantity_in_part := q.is_null (15)
			is_null_quote_default_descr := q.is_null (16)
			is_null_shippable := q.is_null (17)
			is_null_techn_group_family := q.is_null (18)
			is_null_tg_family_tier_no := q.is_null (19)
			is_null_wafer_techn := q.is_null (20)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_part_no := True
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_cust_orderable := True
			is_null_descr := True
			is_null_discountable := True
			is_null_fab_revenue := True
			is_null_fe_reportable := True
			is_null_initially_invoiced := True
			is_null_packaged := True
			is_null_package_group := True
			is_null_package_id := True
			is_null_part_increment := True
			is_null_part_type := True
			is_null_part_unit := True
			is_null_quantity_in_part := True
			is_null_quote_default_descr := True
			is_null_shippable := True
			is_null_techn_group_family := True
			is_null_tg_family_tier_no := True
			is_null_wafer_techn := True
			create comments.make (0)
			create descr.make (0)
			create package_group.make (0)
			create package_id.make (0)
			create part_increment.make (0)
			create part_type.make (0)
			create part_unit.make (0)
			create quote_default_descr.make (0)
			create techn_group_family.make (0)
			create wafer_techn.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_part_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cust_orderable = q.boolean_value (2)
				and discountable = q.boolean_value (4)
				and fab_revenue = q.boolean_value (5)
				and fe_reportable = q.boolean_value (6)
				and initially_invoiced = q.boolean_value (7)
				and m_part_no = q.integer_value (8)
				and packaged = q.boolean_value (9)
				and quantity_in_part = q.integer_value (15)
				and shippable = q.boolean_value (17)
				and tg_family_tier_no = q.integer_value (19)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (3, s)
			Result := Result and equal (descr, s)
			q.get_string_value (10, s)
			Result := Result and equal (package_group, s)
			q.get_string_value (11, s)
			Result := Result and equal (package_id, s)
			q.get_string_value (12, s)
			Result := Result and equal (part_increment, s)
			q.get_string_value (13, s)
			Result := Result and equal (part_type, s)
			q.get_string_value (14, s)
			Result := Result and equal (part_unit, s)
			q.get_string_value (16, s)
			Result := Result and equal (quote_default_descr, s)
			q.get_string_value (18, s)
			Result := Result and equal (techn_group_family, s)
			q.get_string_value (20, s)
			Result := Result and equal (wafer_techn, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_cust_orderable = q.is_null (2)
				and is_null_descr = q.is_null (3)
				and is_null_discountable = q.is_null (4)
				and is_null_fab_revenue = q.is_null (5)
				and is_null_fe_reportable = q.is_null (6)
				and is_null_initially_invoiced = q.is_null (7)
				and is_null_m_part_no = q.is_null (8)
				and is_null_packaged = q.is_null (9)
				and is_null_package_group = q.is_null (10)
				and is_null_package_id = q.is_null (11)
				and is_null_part_increment = q.is_null (12)
				and is_null_part_type = q.is_null (13)
				and is_null_part_unit = q.is_null (14)
				and is_null_quantity_in_part = q.is_null (15)
				and is_null_quote_default_descr = q.is_null (16)
				and is_null_shippable = q.is_null (17)
				and is_null_techn_group_family = q.is_null (18)
				and is_null_tg_family_tier_no = q.is_null (19)
				and is_null_wafer_techn = q.is_null (20)
		end

end
