
note

	date: "Thu Jan 21 12:59:45 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"M_REPLIES (MOSIS.M_REPLIES)"
			-- Included columns
			-- 	COMMUNICATION_MEDIUM
			-- 	CONTENT_TYPE_ID
			-- 	DATE_PROCESSED
			-- 	DESIGN_STATE
			-- 	FIRST_RESPONSE_LINE
			-- 	HEADER_SUBJECT
			-- 	M_COMMUNICATION_NO
			-- 	M_SHIPMENT_NO
			-- 	REPLY_MODE
			-- 	REPLY_NO
			-- 	REQUEST_NO
			-- 	SECURITY_TYPE
			-- 	SENT_TO
			-- 	SEVERITY
			-- 	STORAGE_FILENAME
			-- 	STORAGE_SEGMENT_LENGTH
			-- 	STORAGE_SEGMENT_OFFSET
			-- Excluded columns
			-- 	(none)

class M_REPLIES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_communication_no: INTEGER; the_request_no: INTEGER; the_reply_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_communication_no := the_m_communication_no
			request_no := the_request_no
			reply_no := the_reply_no
			is_null_m_communication_no := False
			is_null_request_no := False
			is_null_reply_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 17

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  communication_medium, content_type_id, date_processed, design_state,%N  first_response_line, header_subject, m_communication_no, m_shipment_no,%N  reply_mode, reply_no, request_no, security_type, sent_to, severity,%N  storage_filename, storage_segment_length, storage_segment_offset"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_replies mr"

	join_condition: STRING = ""

	table_name: STRING = "m_replies"

	key_where_clause: STRING = "m_communication_no = :1 and request_no = :2 and reply_no = :3"

feature -- Values

	communication_medium: STRING
			-- DB: VARCHAR2(10)

	content_type_id: STRING
			-- DB: VARCHAR2(10)

	date_processed: DB_DATE
			-- DB: DATE

	design_state: STRING
			-- DB: VARCHAR2(30)

	first_response_line: STRING
			-- DB: VARCHAR2(255)

	header_subject: STRING
			-- DB: VARCHAR2(255)

	m_communication_no: INTEGER
			-- DB: NUMBER(9,0) not null

	m_shipment_no: INTEGER
			-- DB: NUMBER(6,0)

	reply_mode: STRING
			-- DB: VARCHAR2(15) not null

	reply_no: INTEGER
			-- DB: NUMBER(3,0) not null

	request_no: INTEGER
			-- DB: NUMBER(3,0) not null

	security_type: STRING
			-- DB: VARCHAR2(10)

	sent_to: STRING
			-- DB: VARCHAR2(255)

	severity: CHARACTER
			-- DB: CHAR(1) not null
			-- Eiffel type specified explicitly

	storage_filename: STRING
			-- DB: VARCHAR2(255)

	storage_segment_length: INTEGER
			-- DB: NUMBER(9,0)

	storage_segment_offset: INTEGER
			-- DB: NUMBER(9,0)

feature -- Maximum database lengths for character columns

	maxlen_communication_medium: INTEGER = 10
	maxlen_content_type_id: INTEGER = 10
	maxlen_design_state: INTEGER = 30
	maxlen_first_response_line: INTEGER = 255
	maxlen_header_subject: INTEGER = 255
	maxlen_reply_mode: INTEGER = 15
	maxlen_security_type: INTEGER = 10
	maxlen_sent_to: INTEGER = 255
	maxlen_storage_filename: INTEGER = 255

feature -- Precisions for number columns

	precision_m_communication_no: INTEGER = 9
	precision_m_shipment_no: INTEGER = 6
	precision_reply_no: INTEGER = 3
	precision_request_no: INTEGER = 3
	precision_storage_segment_length: INTEGER = 9
	precision_storage_segment_offset: INTEGER = 9

feature -- Scales for number columns

	scale_m_communication_no: INTEGER = 0
	scale_m_shipment_no: INTEGER = 0
	scale_reply_no: INTEGER = 0
	scale_request_no: INTEGER = 0
	scale_storage_segment_length: INTEGER = 0
	scale_storage_segment_offset: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_communication_medium: BOOLEAN
	is_null_content_type_id: BOOLEAN
	is_null_date_processed: BOOLEAN
	is_null_design_state: BOOLEAN
	is_null_first_response_line: BOOLEAN
	is_null_header_subject: BOOLEAN
	is_null_m_shipment_no: BOOLEAN
	is_null_security_type: BOOLEAN
	is_null_sent_to: BOOLEAN
	is_null_storage_filename: BOOLEAN
	is_null_storage_segment_length: BOOLEAN
	is_null_storage_segment_offset: BOOLEAN

feature -- Nullness for non-null columns

	is_null_m_communication_no: BOOLEAN
	is_null_reply_mode: BOOLEAN
	is_null_reply_no: BOOLEAN
	is_null_request_no: BOOLEAN
	is_null_severity: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_communication_no = r.m_communication_no
				and reply_no = r.reply_no
				and request_no = r.request_no
			Result := Result
				and is_null_m_communication_no = r.is_null_m_communication_no
				and is_null_reply_no = r.is_null_reply_no
				and is_null_request_no = r.is_null_request_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_shipment_no = r.m_shipment_no
				and severity = r.severity
				and storage_segment_length = r.storage_segment_length
				and storage_segment_offset = r.storage_segment_offset
			Result := Result
				and equal (communication_medium, r.communication_medium)
				and equal (content_type_id, r.content_type_id)
				and equal (date_processed, r.date_processed)
				and equal (design_state, r.design_state)
				and equal (first_response_line, r.first_response_line)
				and equal (header_subject, r.header_subject)
				and equal (reply_mode, r.reply_mode)
				and equal (security_type, r.security_type)
				and equal (sent_to, r.sent_to)
				and equal (storage_filename, r.storage_filename)
			Result := Result
				and is_null_communication_medium = r.is_null_communication_medium
				and is_null_content_type_id = r.is_null_content_type_id
				and is_null_date_processed = r.is_null_date_processed
				and is_null_design_state = r.is_null_design_state
				and is_null_first_response_line = r.is_null_first_response_line
				and is_null_header_subject = r.is_null_header_subject
				and is_null_m_shipment_no = r.is_null_m_shipment_no
				and is_null_reply_mode = r.is_null_reply_mode
				and is_null_security_type = r.is_null_security_type
				and is_null_sent_to = r.is_null_sent_to
				and is_null_severity = r.is_null_severity
				and is_null_storage_filename = r.is_null_storage_filename
				and is_null_storage_segment_length = r.is_null_storage_segment_length
				and is_null_storage_segment_offset = r.is_null_storage_segment_offset
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 10)
			q.select_string (2, 10)
			q.select_date (3)
			q.select_string (4, 30)
			q.select_string (5, 255)
			q.select_string (6, 255)
			q.select_integer (7)
			q.select_integer (8)
			q.select_string (9, 15)
			q.select_integer (10)
			q.select_integer (11)
			q.select_string (12, 10)
			q.select_string (13, 255)
			q.select_character (14)
			q.select_string (15, 255)
			q.select_integer (16)
			q.select_integer (17)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			m_communication_no := q.integer_value (7)
			m_shipment_no := q.integer_value (8)
			reply_no := q.integer_value (10)
			request_no := q.integer_value (11)
			severity := q.character_value (14)
			storage_segment_length := q.integer_value (16)
			storage_segment_offset := q.integer_value (17)
		end

	fill_in_references (q: SQL_QUERY)
		do
			communication_medium := q.string_value (1)
			content_type_id := q.string_value (2)
			date_processed := q.date_value (3)
			design_state := q.string_value (4)
			first_response_line := q.string_value (5)
			header_subject := q.string_value (6)
			reply_mode := q.string_value (9)
			security_type := q.string_value (12)
			sent_to := q.string_value (13)
			storage_filename := q.string_value (15)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, communication_medium)
			q.get_string_value (2, content_type_id)
			q.get_date_value (3, date_processed)
			q.get_string_value (4, design_state)
			q.get_string_value (5, first_response_line)
			q.get_string_value (6, header_subject)
			q.get_string_value (9, reply_mode)
			q.get_string_value (12, security_type)
			q.get_string_value (13, sent_to)
			q.get_string_value (15, storage_filename)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_communication_medium := q.is_null (1)
			is_null_content_type_id := q.is_null (2)
			is_null_date_processed := q.is_null (3)
			is_null_design_state := q.is_null (4)
			is_null_first_response_line := q.is_null (5)
			is_null_header_subject := q.is_null (6)
			is_null_m_communication_no := q.is_null (7)
			is_null_m_shipment_no := q.is_null (8)
			is_null_reply_mode := q.is_null (9)
			is_null_reply_no := q.is_null (10)
			is_null_request_no := q.is_null (11)
			is_null_security_type := q.is_null (12)
			is_null_sent_to := q.is_null (13)
			is_null_severity := q.is_null (14)
			is_null_storage_filename := q.is_null (15)
			is_null_storage_segment_length := q.is_null (16)
			is_null_storage_segment_offset := q.is_null (17)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_communication_no := True
			is_null_request_no := True
			is_null_reply_no := True
		end

	set_null_nonkey
		do
			is_null_communication_medium := True
			is_null_content_type_id := True
			is_null_date_processed := True
			is_null_design_state := True
			is_null_first_response_line := True
			is_null_header_subject := True
			is_null_m_shipment_no := True
			is_null_reply_mode := True
			is_null_security_type := True
			is_null_sent_to := True
			is_null_severity := True
			is_null_storage_filename := True
			is_null_storage_segment_length := True
			is_null_storage_segment_offset := True
			create communication_medium.make (0)
			create content_type_id.make (0)
			create {ORACLE_DATE} date_processed.set_null
			create design_state.make (0)
			create first_response_line.make (0)
			create header_subject.make (0)
			create reply_mode.make (0)
			create security_type.make (0)
			create sent_to.make (0)
			create storage_filename.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_communication_no, False)
			q.bind_num_to_integer (2, request_no, False)
			q.bind_num_to_integer (3, reply_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and m_communication_no = q.integer_value (7)
				and m_shipment_no = q.integer_value (8)
				and reply_no = q.integer_value (10)
				and request_no = q.integer_value (11)
				and severity = q.character_value (14)
				and storage_segment_length = q.integer_value (16)
				and storage_segment_offset = q.integer_value (17)
			q.get_string_value (1, s)
			Result := Result and equal (communication_medium, s)
			q.get_string_value (2, s)
			Result := Result and equal (content_type_id, s)
			q.get_date_value (3, d)
			Result := Result and equal (date_processed, d)
			q.get_string_value (4, s)
			Result := Result and equal (design_state, s)
			q.get_string_value (5, s)
			Result := Result and equal (first_response_line, s)
			q.get_string_value (6, s)
			Result := Result and equal (header_subject, s)
			q.get_string_value (9, s)
			Result := Result and equal (reply_mode, s)
			q.get_string_value (12, s)
			Result := Result and equal (security_type, s)
			q.get_string_value (13, s)
			Result := Result and equal (sent_to, s)
			q.get_string_value (15, s)
			Result := Result and equal (storage_filename, s)
			Result := Result
				and is_null_communication_medium = q.is_null (1)
				and is_null_content_type_id = q.is_null (2)
				and is_null_date_processed = q.is_null (3)
				and is_null_design_state = q.is_null (4)
				and is_null_first_response_line = q.is_null (5)
				and is_null_header_subject = q.is_null (6)
				and is_null_m_communication_no = q.is_null (7)
				and is_null_m_shipment_no = q.is_null (8)
				and is_null_reply_mode = q.is_null (9)
				and is_null_reply_no = q.is_null (10)
				and is_null_request_no = q.is_null (11)
				and is_null_security_type = q.is_null (12)
				and is_null_sent_to = q.is_null (13)
				and is_null_severity = q.is_null (14)
				and is_null_storage_filename = q.is_null (15)
				and is_null_storage_segment_length = q.is_null (16)
				and is_null_storage_segment_offset = q.is_null (17)
		end

end
