
note

	date: "Thu Jan 21 12:59:45 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"MASK_SIZES (MOSIS.MASK_SIZES)"
			-- Included columns
			-- 	DESCR
			-- 	MASK_SIZE_ID
			-- 	MASK_SIZE_X
			-- 	MASK_SIZE_Y
			-- 	MASK_THICKNESS
			-- Excluded columns
			-- 	(none)

class MASK_SIZES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_mask_size_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_mask_size_id_exists: the_mask_size_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			mask_size_id := the_mask_size_id
			is_null_mask_size_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, mask_size_id, mask_size_x, mask_size_y, mask_thickness"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "mask_sizes ms"

	join_condition: STRING = ""

	table_name: STRING = "mask_sizes"

	key_where_clause: STRING = "mask_size_id = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	mask_size_id: STRING
			-- DB: VARCHAR2(20) not null

	mask_size_x: DOUBLE
			-- DB: NUMBER(*,*) not null

	mask_size_y: DOUBLE
			-- DB: NUMBER(*,*) not null

	mask_thickness: DOUBLE
			-- DB: NUMBER(*,*) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_mask_size_id: BOOLEAN
	is_null_mask_size_x: BOOLEAN
	is_null_mask_size_y: BOOLEAN
	is_null_mask_thickness: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (mask_size_id, r.mask_size_id)
			Result := Result
				and is_null_mask_size_id = r.is_null_mask_size_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and mask_size_x = r.mask_size_x
				and mask_size_y = r.mask_size_y
				and mask_thickness = r.mask_thickness
			Result := Result
				and equal (descr, r.descr)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_mask_size_x = r.is_null_mask_size_x
				and is_null_mask_size_y = r.is_null_mask_size_y
				and is_null_mask_thickness = r.is_null_mask_thickness
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 20)
			q.select_double (3)
			q.select_double (4)
			q.select_double (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			mask_size_x := q.double_value (3)
			mask_size_y := q.double_value (4)
			mask_thickness := q.double_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			mask_size_id := q.string_value (2)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, mask_size_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_mask_size_id := q.is_null (2)
			is_null_mask_size_x := q.is_null (3)
			is_null_mask_size_y := q.is_null (4)
			is_null_mask_thickness := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_mask_size_id := True
			create mask_size_id.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_mask_size_x := True
			is_null_mask_size_y := True
			is_null_mask_thickness := True
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, mask_size_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and mask_size_x = q.double_value (3)
				and mask_size_y = q.double_value (4)
				and mask_thickness = q.double_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (mask_size_id, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_mask_size_id = q.is_null (2)
				and is_null_mask_size_x = q.is_null (3)
				and is_null_mask_size_y = q.is_null (4)
				and is_null_mask_thickness = q.is_null (5)
		end

end
