
note

	date: "Thu Oct 28 09:30:08 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"OPTION_IDS (MOSIS.OPTION_IDS)"
			-- Included columns
			-- 	OPTION_CATEGORY
			-- 	OPTION_ID
			-- 	OPTION_NAME
			-- Excluded columns
			-- 	(none)

class OPTION_IDS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_option_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_option_id_exists: the_option_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			option_id := the_option_id
			is_null_option_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 3

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  option_category, option_id, option_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "option_ids oid"

	join_condition: STRING = ""

	table_name: STRING = "option_ids"

	key_where_clause: STRING = "option_id = :1"

feature -- Values

	option_category: STRING
			-- DB: VARCHAR2(20)

	option_id: STRING
			-- DB: VARCHAR2(10) not null

	option_name: STRING
			-- DB: VARCHAR2(30) not null

feature -- Nullness for null allowed columns

	is_null_option_category: BOOLEAN

feature -- Nullness for non-null columns

	is_null_option_id: BOOLEAN
	is_null_option_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (option_id, r.option_id)
			Result := Result
				and is_null_option_id = r.is_null_option_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (option_category, r.option_category)
				and equal (option_name, r.option_name)
			Result := Result
				and is_null_option_category = r.is_null_option_category
				and is_null_option_name = r.is_null_option_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 20)
			q.select_string (2, 10)
			q.select_string (3, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
		end

	fill_in_references (q: SQL_QUERY)
		do
			option_category := q.string_value (1)
			option_id := q.string_value (2)
			option_name := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, option_category)
			q.get_string_value (2, option_id)
			q.get_string_value (3, option_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_option_category := q.is_null (1)
			is_null_option_id := q.is_null (2)
			is_null_option_name := q.is_null (3)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_option_id := True
			create option_id.make (0)
		end

	set_null_nonkey
		do
			is_null_option_category := True
			is_null_option_name := True
			create option_category.make (0)
			create option_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, option_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			q.get_string_value (1, s)
			Result := Result and equal (option_category, s)
			q.get_string_value (2, s)
			Result := Result and equal (option_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (option_name, s)
			Result := Result
				and is_null_option_category = q.is_null (1)
				and is_null_option_id = q.is_null (2)
				and is_null_option_name = q.is_null (3)
		end

end
