
note

	date: "Thu Jan 21 12:59:46 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"ORGANIZATIONS (MOSIS.ORGANIZATIONS)"
			-- Included columns
			-- 	COMMENTS
			-- 	FULL_NAME
			-- 	ORG_NO
			-- 	SHORT_ID
			-- 	VENDOR
			-- 	VENDOR_CODE
			-- 	VENDOR_CODE_ACTIVE
			-- 	WAFER_VENDOR_CONSTRAINT_CODE
			-- Excluded columns
			-- 	(none)

class ORGANIZATIONS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_org_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			org_no := the_org_no
			is_null_org_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, full_name, org_no, short_id, vendor, vendor_code,%N  vendor_code_active, wafer_vendor_constraint_code"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "organizations o"

	join_condition: STRING = ""

	table_name: STRING = "organizations"

	key_where_clause: STRING = "org_no = :1"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(255)

	full_name: STRING
			-- DB: VARCHAR2(40) not null

	org_no: INTEGER
			-- DB: NUMBER(6,0) not null

	short_id: STRING
			-- DB: VARCHAR2(15) not null

	vendor: BOOLEAN
			-- DB: CHAR(1) not null

	vendor_code: STRING
			-- DB: VARCHAR2(3)

	vendor_code_active: BOOLEAN
			-- DB: CHAR(1)

	wafer_vendor_constraint_code: STRING
			-- DB: VARCHAR2(10)

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_vendor_code: BOOLEAN
	is_null_vendor_code_active: BOOLEAN
	is_null_wafer_vendor_constraint_code: BOOLEAN

feature -- Nullness for non-null columns

	is_null_full_name: BOOLEAN
	is_null_org_no: BOOLEAN
	is_null_short_id: BOOLEAN
	is_null_vendor: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and org_no = r.org_no
			Result := Result
				and is_null_org_no = r.is_null_org_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and vendor = r.vendor
				and vendor_code_active = r.vendor_code_active
			Result := Result
				and equal (comments, r.comments)
				and equal (full_name, r.full_name)
				and equal (short_id, r.short_id)
				and equal (vendor_code, r.vendor_code)
				and equal (wafer_vendor_constraint_code, r.wafer_vendor_constraint_code)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_full_name = r.is_null_full_name
				and is_null_short_id = r.is_null_short_id
				and is_null_vendor = r.is_null_vendor
				and is_null_vendor_code = r.is_null_vendor_code
				and is_null_vendor_code_active = r.is_null_vendor_code_active
				and is_null_wafer_vendor_constraint_code = r.is_null_wafer_vendor_constraint_code
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 40)
			q.select_integer (3)
			q.select_string (4, 15)
			q.select_boolean (5)
			q.select_string (6, 3)
			q.select_boolean (7)
			q.select_string (8, 10)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			org_no := q.integer_value (3)
			vendor := q.boolean_value (5)
			vendor_code_active := q.boolean_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			full_name := q.string_value (2)
			short_id := q.string_value (4)
			vendor_code := q.string_value (6)
			wafer_vendor_constraint_code := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (2, full_name)
			q.get_string_value (4, short_id)
			q.get_string_value (6, vendor_code)
			q.get_string_value (8, wafer_vendor_constraint_code)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_full_name := q.is_null (2)
			is_null_org_no := q.is_null (3)
			is_null_short_id := q.is_null (4)
			is_null_vendor := q.is_null (5)
			is_null_vendor_code := q.is_null (6)
			is_null_vendor_code_active := q.is_null (7)
			is_null_wafer_vendor_constraint_code := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_org_no := True
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_full_name := True
			is_null_short_id := True
			is_null_vendor := True
			is_null_vendor_code := True
			is_null_vendor_code_active := True
			is_null_wafer_vendor_constraint_code := True
			create comments.make (0)
			create full_name.make (0)
			create short_id.make (0)
			create vendor_code.make (0)
			create wafer_vendor_constraint_code.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, org_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and org_no = q.integer_value (3)
				and vendor = q.boolean_value (5)
				and vendor_code_active = q.boolean_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (2, s)
			Result := Result and equal (full_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (short_id, s)
			q.get_string_value (6, s)
			Result := Result and equal (vendor_code, s)
			q.get_string_value (8, s)
			Result := Result and equal (wafer_vendor_constraint_code, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_full_name = q.is_null (2)
				and is_null_org_no = q.is_null (3)
				and is_null_short_id = q.is_null (4)
				and is_null_vendor = q.is_null (5)
				and is_null_vendor_code = q.is_null (6)
				and is_null_vendor_code_active = q.is_null (7)
				and is_null_wafer_vendor_constraint_code = q.is_null (8)
		end

end
