
note

	date: "Thu Jan 21 12:59:46 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"PACKAGE_CONNECTIONS (MOSIS.PACKAGE_CONNECTIONS)"
			-- Included columns
			-- 	BONDING_FINGER_ID
			-- 	BONDING_FINGER_LAYOUT_NO
			-- 	BONDING_FINGER_LOCATION_X
			-- 	BONDING_FINGER_LOCATION_Y
			-- 	CONNECTION_NO
			-- 	IS_LAYOUT_MIRRORED_IN_X
			-- 	IS_LAYOUT_MIRRORED_IN_Y
			-- 	IS_LAYOUT_ROTATED_90CCW
			-- 	PACKAGE_ID
			-- 	PIN_ID
			-- Excluded columns
			-- 	(none)

class PACKAGE_CONNECTIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_package_id: STRING; the_connection_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_package_id_exists: the_package_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			package_id := the_package_id
			connection_no := the_connection_no
			is_null_package_id := False
			is_null_connection_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 10

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  bonding_finger_id, bonding_finger_layout_no, bonding_finger_location_x,%N  bonding_finger_location_y, connection_no, is_layout_mirrored_in_x,%N  is_layout_mirrored_in_y, is_layout_rotated_90ccw, package_id, pin_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "package_connections pkgc"

	join_condition: STRING = ""

	table_name: STRING = "package_connections"

	key_where_clause: STRING = "package_id = :1 and connection_no = :2"

feature -- Values

	bonding_finger_id: STRING
			-- DB: VARCHAR2(6) not null

	bonding_finger_layout_no: INTEGER
			-- DB: NUMBER(6,0) not null

	bonding_finger_location_x: DOUBLE
			-- DB: NUMBER(9,3) not null

	bonding_finger_location_y: DOUBLE
			-- DB: NUMBER(9,3) not null

	connection_no: INTEGER
			-- DB: NUMBER(3,0) not null

	is_layout_mirrored_in_x: BOOLEAN
			-- DB: CHAR(1) not null

	is_layout_mirrored_in_y: BOOLEAN
			-- DB: CHAR(1) not null

	is_layout_rotated_90ccw: BOOLEAN
			-- DB: CHAR(1) not null

	package_id: STRING
			-- DB: VARCHAR2(25) not null

	pin_id: STRING
			-- DB: VARCHAR2(8)

feature -- Nullness for null allowed columns

	is_null_pin_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_bonding_finger_id: BOOLEAN
	is_null_bonding_finger_layout_no: BOOLEAN
	is_null_bonding_finger_location_x: BOOLEAN
	is_null_bonding_finger_location_y: BOOLEAN
	is_null_connection_no: BOOLEAN
	is_null_is_layout_mirrored_in_x: BOOLEAN
	is_null_is_layout_mirrored_in_y: BOOLEAN
	is_null_is_layout_rotated_90ccw: BOOLEAN
	is_null_package_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and connection_no = r.connection_no
			Result := Result
				and equal (package_id, r.package_id)
			Result := Result
				and is_null_connection_no = r.is_null_connection_no
				and is_null_package_id = r.is_null_package_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and bonding_finger_layout_no = r.bonding_finger_layout_no
				and bonding_finger_location_x = r.bonding_finger_location_x
				and bonding_finger_location_y = r.bonding_finger_location_y
				and is_layout_mirrored_in_x = r.is_layout_mirrored_in_x
				and is_layout_mirrored_in_y = r.is_layout_mirrored_in_y
				and is_layout_rotated_90ccw = r.is_layout_rotated_90ccw
			Result := Result
				and equal (bonding_finger_id, r.bonding_finger_id)
				and equal (pin_id, r.pin_id)
			Result := Result
				and is_null_bonding_finger_id = r.is_null_bonding_finger_id
				and is_null_bonding_finger_layout_no = r.is_null_bonding_finger_layout_no
				and is_null_bonding_finger_location_x = r.is_null_bonding_finger_location_x
				and is_null_bonding_finger_location_y = r.is_null_bonding_finger_location_y
				and is_null_is_layout_mirrored_in_x = r.is_null_is_layout_mirrored_in_x
				and is_null_is_layout_mirrored_in_y = r.is_null_is_layout_mirrored_in_y
				and is_null_is_layout_rotated_90ccw = r.is_null_is_layout_rotated_90ccw
				and is_null_pin_id = r.is_null_pin_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 6)
			q.select_integer (2)
			q.select_double (3)
			q.select_double (4)
			q.select_integer (5)
			q.select_boolean (6)
			q.select_boolean (7)
			q.select_boolean (8)
			q.select_string (9, 25)
			q.select_string (10, 8)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			bonding_finger_layout_no := q.integer_value (2)
			bonding_finger_location_x := q.double_value (3)
			bonding_finger_location_y := q.double_value (4)
			connection_no := q.integer_value (5)
			is_layout_mirrored_in_x := q.boolean_value (6)
			is_layout_mirrored_in_y := q.boolean_value (7)
			is_layout_rotated_90ccw := q.boolean_value (8)
		end

	fill_in_references (q: SQL_QUERY)
		do
			bonding_finger_id := q.string_value (1)
			package_id := q.string_value (9)
			pin_id := q.string_value (10)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, bonding_finger_id)
			q.get_string_value (9, package_id)
			q.get_string_value (10, pin_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_bonding_finger_id := q.is_null (1)
			is_null_bonding_finger_layout_no := q.is_null (2)
			is_null_bonding_finger_location_x := q.is_null (3)
			is_null_bonding_finger_location_y := q.is_null (4)
			is_null_connection_no := q.is_null (5)
			is_null_is_layout_mirrored_in_x := q.is_null (6)
			is_null_is_layout_mirrored_in_y := q.is_null (7)
			is_null_is_layout_rotated_90ccw := q.is_null (8)
			is_null_package_id := q.is_null (9)
			is_null_pin_id := q.is_null (10)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_package_id := True
			is_null_connection_no := True
			create package_id.make (0)
		end

	set_null_nonkey
		do
			is_null_bonding_finger_id := True
			is_null_bonding_finger_layout_no := True
			is_null_bonding_finger_location_x := True
			is_null_bonding_finger_location_y := True
			is_null_is_layout_mirrored_in_x := True
			is_null_is_layout_mirrored_in_y := True
			is_null_is_layout_rotated_90ccw := True
			is_null_pin_id := True
			create bonding_finger_id.make (0)
			create pin_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, package_id, False)
			q.bind_num_to_integer (2, connection_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and bonding_finger_layout_no = q.integer_value (2)
				and bonding_finger_location_x = q.double_value (3)
				and bonding_finger_location_y = q.double_value (4)
				and connection_no = q.integer_value (5)
				and is_layout_mirrored_in_x = q.boolean_value (6)
				and is_layout_mirrored_in_y = q.boolean_value (7)
				and is_layout_rotated_90ccw = q.boolean_value (8)
			q.get_string_value (1, s)
			Result := Result and equal (bonding_finger_id, s)
			q.get_string_value (9, s)
			Result := Result and equal (package_id, s)
			q.get_string_value (10, s)
			Result := Result and equal (pin_id, s)
			Result := Result
				and is_null_bonding_finger_id = q.is_null (1)
				and is_null_bonding_finger_layout_no = q.is_null (2)
				and is_null_bonding_finger_location_x = q.is_null (3)
				and is_null_bonding_finger_location_y = q.is_null (4)
				and is_null_connection_no = q.is_null (5)
				and is_null_is_layout_mirrored_in_x = q.is_null (6)
				and is_null_is_layout_mirrored_in_y = q.is_null (7)
				and is_null_is_layout_rotated_90ccw = q.is_null (8)
				and is_null_package_id = q.is_null (9)
				and is_null_pin_id = q.is_null (10)
		end

end
