
note

	date: "Thu Jan 21 12:59:46 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PACKING_CUT_DIE_SITES (MOSIS.PACKING_CUT_DIE_SITES)"
			-- Included columns
			-- 	CUT_PATTERN_NO
			-- 	DIE_NO
			-- 	DIE_SIZE_CUT_X
			-- 	DIE_SIZE_CUT_Y
			-- 	ISOLATED
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- 	PACKING_ID
			-- 	SITE_NO
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_CUT_DIE_SITES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_cut_pattern_no: INTEGER; the_die_no: INTEGER; the_site_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			cut_pattern_no := the_cut_pattern_no
			die_no := the_die_no
			site_no := the_site_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_cut_pattern_no := False
			is_null_die_no := False
			is_null_site_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 10

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_pattern_no, die_no, die_size_cut_x, die_size_cut_y, isolated,%N  location_x, location_y, packing_id, site_no, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_cut_die_sites pckcds"

	join_condition: STRING = ""

	table_name: STRING = "packing_cut_die_sites"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and cut_pattern_no = :3 and die_no = :4 and site_no = :5"

feature -- Values

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	die_no: INTEGER
			-- DB: NUMBER(4,0) not null

	die_size_cut_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	die_size_cut_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	isolated: BOOLEAN
			-- DB: CHAR(1) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	site_no: INTEGER
			-- DB: NUMBER(4,0) not null

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Nullness for non-null columns

	is_null_cut_pattern_no: BOOLEAN
	is_null_die_no: BOOLEAN
	is_null_die_size_cut_x: BOOLEAN
	is_null_die_size_cut_y: BOOLEAN
	is_null_isolated: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_site_no: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no = r.cut_pattern_no
				and die_no = r.die_no
				and site_no = r.site_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_die_no = r.is_null_die_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_site_no = r.is_null_site_no
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_size_cut_x = r.die_size_cut_x
				and die_size_cut_y = r.die_size_cut_y
				and isolated = r.isolated
				and location_x = r.location_x
				and location_y = r.location_y
			Result := Result
				and is_null_die_size_cut_x = r.is_null_die_size_cut_x
				and is_null_die_size_cut_y = r.is_null_die_size_cut_y
				and is_null_isolated = r.is_null_isolated
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_double (3)
			q.select_double (4)
			q.select_boolean (5)
			q.select_double (6)
			q.select_double (7)
			q.select_string (8, 30)
			q.select_integer (9)
			q.select_integer (10)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_pattern_no := q.integer_value (1)
			die_no := q.integer_value (2)
			die_size_cut_x := q.double_value (3)
			die_size_cut_y := q.double_value (4)
			isolated := q.boolean_value (5)
			location_x := q.double_value (6)
			location_y := q.double_value (7)
			site_no := q.integer_value (9)
			version_no := q.integer_value (10)
		end

	fill_in_references (q: SQL_QUERY)
		do
			packing_id := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (8, packing_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_pattern_no := q.is_null (1)
			is_null_die_no := q.is_null (2)
			is_null_die_size_cut_x := q.is_null (3)
			is_null_die_size_cut_y := q.is_null (4)
			is_null_isolated := q.is_null (5)
			is_null_location_x := q.is_null (6)
			is_null_location_y := q.is_null (7)
			is_null_packing_id := q.is_null (8)
			is_null_site_no := q.is_null (9)
			is_null_version_no := q.is_null (10)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_cut_pattern_no := True
			is_null_die_no := True
			is_null_site_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_die_size_cut_x := True
			is_null_die_size_cut_y := True
			is_null_isolated := True
			is_null_location_x := True
			is_null_location_y := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, cut_pattern_no, False)
			q.bind_num_to_integer (4, die_no, False)
			q.bind_num_to_integer (5, site_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_pattern_no = q.integer_value (1)
				and die_no = q.integer_value (2)
				and die_size_cut_x = q.double_value (3)
				and die_size_cut_y = q.double_value (4)
				and isolated = q.boolean_value (5)
				and location_x = q.double_value (6)
				and location_y = q.double_value (7)
				and site_no = q.integer_value (9)
				and version_no = q.integer_value (10)
			q.get_string_value (8, s)
			Result := Result and equal (packing_id, s)
			Result := Result
				and is_null_cut_pattern_no = q.is_null (1)
				and is_null_die_no = q.is_null (2)
				and is_null_die_size_cut_x = q.is_null (3)
				and is_null_die_size_cut_y = q.is_null (4)
				and is_null_isolated = q.is_null (5)
				and is_null_location_x = q.is_null (6)
				and is_null_location_y = q.is_null (7)
				and is_null_packing_id = q.is_null (8)
				and is_null_site_no = q.is_null (9)
				and is_null_version_no = q.is_null (10)
		end

end
