
note

	date: "Thu Jan 21 12:59:46 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PACKING_CUT_LOCATIONS (MOSIS.PACKING_CUT_LOCATIONS)"
			-- Included columns
			-- 	CUT_NO
			-- 	CUT_PATTERN_NO
			-- 	CUT_TYPE
			-- 	LOCATION
			-- 	ORIENTATION
			-- 	PACKING_ID
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_CUT_LOCATIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_cut_pattern_no: INTEGER; the_cut_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			cut_pattern_no := the_cut_pattern_no
			cut_no := the_cut_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_cut_pattern_no := False
			is_null_cut_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_no, cut_pattern_no, cut_type, location, orientation, packing_id,%N  version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_cut_locations pckcl"

	join_condition: STRING = ""

	table_name: STRING = "packing_cut_locations"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and cut_pattern_no = :3 and cut_no = :4"

feature -- Values

	cut_no: INTEGER
			-- DB: NUMBER(2,0) not null

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	cut_type: STRING
			-- DB: VARCHAR2(20) not null

	location: DOUBLE
			-- DB: NUMBER(12,6) not null

	orientation: STRING
			-- DB: VARCHAR2(10) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Nullness for non-null columns

	is_null_cut_no: BOOLEAN
	is_null_cut_pattern_no: BOOLEAN
	is_null_cut_type: BOOLEAN
	is_null_location: BOOLEAN
	is_null_orientation: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_no = r.cut_no
				and cut_pattern_no = r.cut_pattern_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_cut_no = r.is_null_cut_no
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and location = r.location
			Result := Result
				and equal (cut_type, r.cut_type)
				and equal (orientation, r.orientation)
			Result := Result
				and is_null_cut_type = r.is_null_cut_type
				and is_null_location = r.is_null_location
				and is_null_orientation = r.is_null_orientation
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_string (3, 20)
			q.select_double (4)
			q.select_string (5, 10)
			q.select_string (6, 30)
			q.select_integer (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_no := q.integer_value (1)
			cut_pattern_no := q.integer_value (2)
			location := q.double_value (4)
			version_no := q.integer_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cut_type := q.string_value (3)
			orientation := q.string_value (5)
			packing_id := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, cut_type)
			q.get_string_value (5, orientation)
			q.get_string_value (6, packing_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_no := q.is_null (1)
			is_null_cut_pattern_no := q.is_null (2)
			is_null_cut_type := q.is_null (3)
			is_null_location := q.is_null (4)
			is_null_orientation := q.is_null (5)
			is_null_packing_id := q.is_null (6)
			is_null_version_no := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_cut_pattern_no := True
			is_null_cut_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_cut_type := True
			is_null_location := True
			is_null_orientation := True
			create cut_type.make (0)
			create orientation.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, cut_pattern_no, False)
			q.bind_num_to_integer (4, cut_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_no = q.integer_value (1)
				and cut_pattern_no = q.integer_value (2)
				and location = q.double_value (4)
				and version_no = q.integer_value (7)
			q.get_string_value (3, s)
			Result := Result and equal (cut_type, s)
			q.get_string_value (5, s)
			Result := Result and equal (orientation, s)
			q.get_string_value (6, s)
			Result := Result and equal (packing_id, s)
			Result := Result
				and is_null_cut_no = q.is_null (1)
				and is_null_cut_pattern_no = q.is_null (2)
				and is_null_cut_type = q.is_null (3)
				and is_null_location = q.is_null (4)
				and is_null_orientation = q.is_null (5)
				and is_null_packing_id = q.is_null (6)
				and is_null_version_no = q.is_null (7)
		end

end
