
note

	date: "Thu Jan 21 12:59:46 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PACKING_DIE_LOCATIONS (MOSIS.PACKING_DIE_LOCATIONS)"
			-- Included columns
			-- 	DIE_NO
			-- 	FIELD_NAME
			-- 	IS_DELETABLE
			-- 	IS_DUPLICATABLE
			-- 	IS_FIXED_IN_X
			-- 	IS_FIXED_IN_Y
			-- 	IS_MOVABLE_IN_X
			-- 	IS_MOVABLE_IN_Y
			-- 	IS_ROTATABLE
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- 	MASK_SITE_NO
			-- 	PACKING_ID
			-- 	SITE_NO
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_DIE_LOCATIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_die_no: INTEGER; the_site_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			die_no := the_die_no
			site_no := the_site_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_die_no := False
			is_null_site_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 15

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  die_no, field_name, is_deletable, is_duplicatable, is_fixed_in_x,%N  is_fixed_in_y, is_movable_in_x, is_movable_in_y, is_rotatable,%N  location_x, location_y, mask_site_no, packing_id, site_no, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_die_locations pckdl"

	join_condition: STRING = ""

	table_name: STRING = "packing_die_locations"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and die_no = :3 and site_no = :4"

feature -- Values

	die_no: INTEGER
			-- DB: NUMBER(4,0) not null

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	is_deletable: BOOLEAN
			-- DB: CHAR(1) not null

	is_duplicatable: BOOLEAN
			-- DB: CHAR(1) not null

	is_fixed_in_x: BOOLEAN
			-- DB: CHAR(1) not null

	is_fixed_in_y: BOOLEAN
			-- DB: CHAR(1) not null

	is_movable_in_x: BOOLEAN
			-- DB: CHAR(1) not null

	is_movable_in_y: BOOLEAN
			-- DB: CHAR(1) not null

	is_rotatable: BOOLEAN
			-- DB: CHAR(1) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	mask_site_no: INTEGER
			-- DB: NUMBER(4,0)

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	site_no: INTEGER
			-- DB: NUMBER(4,0) not null

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Maximum database lengths for character columns

	maxlen_field_name: INTEGER = 20
	maxlen_packing_id: INTEGER = 30

feature -- Precisions for number columns

	precision_die_no: INTEGER = 4
	precision_location_x: INTEGER = 12
	precision_location_y: INTEGER = 12
	precision_mask_site_no: INTEGER = 4
	precision_site_no: INTEGER = 4
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_die_no: INTEGER = 0
	scale_location_x: INTEGER = 6
	scale_location_y: INTEGER = 6
	scale_mask_site_no: INTEGER = 0
	scale_site_no: INTEGER = 0
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_mask_site_no: BOOLEAN

feature -- Nullness for non-null columns

	is_null_die_no: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_is_deletable: BOOLEAN
	is_null_is_duplicatable: BOOLEAN
	is_null_is_fixed_in_x: BOOLEAN
	is_null_is_fixed_in_y: BOOLEAN
	is_null_is_movable_in_x: BOOLEAN
	is_null_is_movable_in_y: BOOLEAN
	is_null_is_rotatable: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_site_no: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_no = r.die_no
				and site_no = r.site_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_die_no = r.is_null_die_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_site_no = r.is_null_site_no
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_deletable = r.is_deletable
				and is_duplicatable = r.is_duplicatable
				and is_fixed_in_x = r.is_fixed_in_x
				and is_fixed_in_y = r.is_fixed_in_y
				and is_movable_in_x = r.is_movable_in_x
				and is_movable_in_y = r.is_movable_in_y
				and is_rotatable = r.is_rotatable
				and location_x = r.location_x
				and location_y = r.location_y
				and mask_site_no = r.mask_site_no
			Result := Result
				and equal (field_name, r.field_name)
			Result := Result
				and is_null_field_name = r.is_null_field_name
				and is_null_is_deletable = r.is_null_is_deletable
				and is_null_is_duplicatable = r.is_null_is_duplicatable
				and is_null_is_fixed_in_x = r.is_null_is_fixed_in_x
				and is_null_is_fixed_in_y = r.is_null_is_fixed_in_y
				and is_null_is_movable_in_x = r.is_null_is_movable_in_x
				and is_null_is_movable_in_y = r.is_null_is_movable_in_y
				and is_null_is_rotatable = r.is_null_is_rotatable
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
				and is_null_mask_site_no = r.is_null_mask_site_no
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 20)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_boolean (5)
			q.select_boolean (6)
			q.select_boolean (7)
			q.select_boolean (8)
			q.select_boolean (9)
			q.select_double (10)
			q.select_double (11)
			q.select_integer (12)
			q.select_string (13, 30)
			q.select_integer (14)
			q.select_integer (15)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			die_no := q.integer_value (1)
			is_deletable := q.boolean_value (3)
			is_duplicatable := q.boolean_value (4)
			is_fixed_in_x := q.boolean_value (5)
			is_fixed_in_y := q.boolean_value (6)
			is_movable_in_x := q.boolean_value (7)
			is_movable_in_y := q.boolean_value (8)
			is_rotatable := q.boolean_value (9)
			location_x := q.double_value (10)
			location_y := q.double_value (11)
			mask_site_no := q.integer_value (12)
			site_no := q.integer_value (14)
			version_no := q.integer_value (15)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_name := q.string_value (2)
			packing_id := q.string_value (13)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, field_name)
			q.get_string_value (13, packing_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_die_no := q.is_null (1)
			is_null_field_name := q.is_null (2)
			is_null_is_deletable := q.is_null (3)
			is_null_is_duplicatable := q.is_null (4)
			is_null_is_fixed_in_x := q.is_null (5)
			is_null_is_fixed_in_y := q.is_null (6)
			is_null_is_movable_in_x := q.is_null (7)
			is_null_is_movable_in_y := q.is_null (8)
			is_null_is_rotatable := q.is_null (9)
			is_null_location_x := q.is_null (10)
			is_null_location_y := q.is_null (11)
			is_null_mask_site_no := q.is_null (12)
			is_null_packing_id := q.is_null (13)
			is_null_site_no := q.is_null (14)
			is_null_version_no := q.is_null (15)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_die_no := True
			is_null_site_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_field_name := True
			is_null_is_deletable := True
			is_null_is_duplicatable := True
			is_null_is_fixed_in_x := True
			is_null_is_fixed_in_y := True
			is_null_is_movable_in_x := True
			is_null_is_movable_in_y := True
			is_null_is_rotatable := True
			is_null_location_x := True
			is_null_location_y := True
			is_null_mask_site_no := True
			create field_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, die_no, False)
			q.bind_num_to_integer (4, site_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and die_no = q.integer_value (1)
				and is_deletable = q.boolean_value (3)
				and is_duplicatable = q.boolean_value (4)
				and is_fixed_in_x = q.boolean_value (5)
				and is_fixed_in_y = q.boolean_value (6)
				and is_movable_in_x = q.boolean_value (7)
				and is_movable_in_y = q.boolean_value (8)
				and is_rotatable = q.boolean_value (9)
				and location_x = q.double_value (10)
				and location_y = q.double_value (11)
				and mask_site_no = q.integer_value (12)
				and site_no = q.integer_value (14)
				and version_no = q.integer_value (15)
			q.get_string_value (2, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (13, s)
			Result := Result and equal (packing_id, s)
			Result := Result
				and is_null_die_no = q.is_null (1)
				and is_null_field_name = q.is_null (2)
				and is_null_is_deletable = q.is_null (3)
				and is_null_is_duplicatable = q.is_null (4)
				and is_null_is_fixed_in_x = q.is_null (5)
				and is_null_is_fixed_in_y = q.is_null (6)
				and is_null_is_movable_in_x = q.is_null (7)
				and is_null_is_movable_in_y = q.is_null (8)
				and is_null_is_rotatable = q.is_null (9)
				and is_null_location_x = q.is_null (10)
				and is_null_location_y = q.is_null (11)
				and is_null_mask_site_no = q.is_null (12)
				and is_null_packing_id = q.is_null (13)
				and is_null_site_no = q.is_null (14)
				and is_null_version_no = q.is_null (15)
		end

end
