
note

	date: "Tue Jun 19 09:41:03 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_DIES (MOSIS.PACKING_DIES)"
			-- Included columns
			-- 	DIE_ID
			-- 	DIE_NO
			-- 	DIE_SIZE_PRINTED_X
			-- 	DIE_SIZE_PRINTED_Y
			-- 	DIE_TYPE
			-- 	DIE_WAFER_ROTATION
			-- 	FILLER_NAME
			-- 	FILLER_TYPE
			-- 	GEOMETRY_ID
			-- 	PACKING_ID
			-- 	PROJECT_NO
			-- 	PROJECT_VERSION_NO
			-- 	SCRIBE_ORIENTATION
			-- 	VERSION_NO
			-- 	WAFER_ETEST_NAME
			-- Excluded columns
			-- 	(none)

class PACKING_DIES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_die_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			die_no := the_die_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_die_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 15

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  die_id, die_no, die_size_printed_x, die_size_printed_y, die_type,%N  die_wafer_rotation, filler_name, filler_type, geometry_id, packing_id,%N  project_no, project_version_no, scribe_orientation, version_no,%N  wafer_etest_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_dies pckd"

	join_condition: STRING = ""

	table_name: STRING = "packing_dies"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and die_no = :3"

feature -- Values

	die_id: STRING
			-- DB: CHAR(2)

	die_no: INTEGER
			-- DB: NUMBER(4,0) not null

	die_size_printed_x: DOUBLE
			-- DB: NUMBER(12,6)

	die_size_printed_y: DOUBLE
			-- DB: NUMBER(12,6)

	die_type: STRING
			-- DB: VARCHAR2(20) not null

	die_wafer_rotation: INTEGER
			-- DB: NUMBER(3,0)

	filler_name: STRING
			-- DB: VARCHAR2(50)

	filler_type: STRING
			-- DB: VARCHAR2(20)

	geometry_id: STRING
			-- DB: VARCHAR2(50)

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	project_no: INTEGER
			-- DB: NUMBER(4,0)

	project_version_no: INTEGER
			-- DB: NUMBER(4,0)

	scribe_orientation: STRING
			-- DB: VARCHAR2(10)

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

	wafer_etest_name: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_die_id: INTEGER = 2
	maxlen_die_type: INTEGER = 20
	maxlen_filler_name: INTEGER = 50
	maxlen_filler_type: INTEGER = 20
	maxlen_geometry_id: INTEGER = 50
	maxlen_packing_id: INTEGER = 30
	maxlen_scribe_orientation: INTEGER = 10
	maxlen_wafer_etest_name: INTEGER = 50

feature -- Precisions for number columns

	precision_die_no: INTEGER = 4
	precision_die_size_printed_x: INTEGER = 12
	precision_die_size_printed_y: INTEGER = 12
	precision_die_wafer_rotation: INTEGER = 3
	precision_project_no: INTEGER = 4
	precision_project_version_no: INTEGER = 4
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_die_no: INTEGER = 0
	scale_die_size_printed_x: INTEGER = 6
	scale_die_size_printed_y: INTEGER = 6
	scale_die_wafer_rotation: INTEGER = 0
	scale_project_no: INTEGER = 0
	scale_project_version_no: INTEGER = 0
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_die_id: BOOLEAN
	is_null_die_size_printed_x: BOOLEAN
	is_null_die_size_printed_y: BOOLEAN
	is_null_die_wafer_rotation: BOOLEAN
	is_null_filler_name: BOOLEAN
	is_null_filler_type: BOOLEAN
	is_null_geometry_id: BOOLEAN
	is_null_project_no: BOOLEAN
	is_null_project_version_no: BOOLEAN
	is_null_scribe_orientation: BOOLEAN
	is_null_wafer_etest_name: BOOLEAN

feature -- Nullness for non-null columns

	is_null_die_no: BOOLEAN
	is_null_die_type: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_no = r.die_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_die_no = r.is_null_die_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_size_printed_x = r.die_size_printed_x
				and die_size_printed_y = r.die_size_printed_y
				and die_wafer_rotation = r.die_wafer_rotation
				and project_no = r.project_no
				and project_version_no = r.project_version_no
			Result := Result
				and equal (die_id, r.die_id)
				and equal (die_type, r.die_type)
				and equal (filler_name, r.filler_name)
				and equal (filler_type, r.filler_type)
				and equal (geometry_id, r.geometry_id)
				and equal (scribe_orientation, r.scribe_orientation)
				and equal (wafer_etest_name, r.wafer_etest_name)
			Result := Result
				and is_null_die_id = r.is_null_die_id
				and is_null_die_size_printed_x = r.is_null_die_size_printed_x
				and is_null_die_size_printed_y = r.is_null_die_size_printed_y
				and is_null_die_type = r.is_null_die_type
				and is_null_die_wafer_rotation = r.is_null_die_wafer_rotation
				and is_null_filler_name = r.is_null_filler_name
				and is_null_filler_type = r.is_null_filler_type
				and is_null_geometry_id = r.is_null_geometry_id
				and is_null_project_no = r.is_null_project_no
				and is_null_project_version_no = r.is_null_project_version_no
				and is_null_scribe_orientation = r.is_null_scribe_orientation
				and is_null_wafer_etest_name = r.is_null_wafer_etest_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 2)
			q.select_integer (2)
			q.select_double (3)
			q.select_double (4)
			q.select_string (5, 20)
			q.select_integer (6)
			q.select_string (7, 50)
			q.select_string (8, 20)
			q.select_string (9, 50)
			q.select_string (10, 30)
			q.select_integer (11)
			q.select_integer (12)
			q.select_string (13, 10)
			q.select_integer (14)
			q.select_string (15, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			die_no := q.integer_value (2)
			die_size_printed_x := q.double_value (3)
			die_size_printed_y := q.double_value (4)
			die_wafer_rotation := q.integer_value (6)
			project_no := q.integer_value (11)
			project_version_no := q.integer_value (12)
			version_no := q.integer_value (14)
		end

	fill_in_references (q: SQL_QUERY)
		do
			die_id := q.string_value (1)
			die_type := q.string_value (5)
			filler_name := q.string_value (7)
			filler_type := q.string_value (8)
			geometry_id := q.string_value (9)
			packing_id := q.string_value (10)
			scribe_orientation := q.string_value (13)
			wafer_etest_name := q.string_value (15)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, die_id)
			q.get_string_value (5, die_type)
			q.get_string_value (7, filler_name)
			q.get_string_value (8, filler_type)
			q.get_string_value (9, geometry_id)
			q.get_string_value (10, packing_id)
			q.get_string_value (13, scribe_orientation)
			q.get_string_value (15, wafer_etest_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_die_id := q.is_null (1)
			is_null_die_no := q.is_null (2)
			is_null_die_size_printed_x := q.is_null (3)
			is_null_die_size_printed_y := q.is_null (4)
			is_null_die_type := q.is_null (5)
			is_null_die_wafer_rotation := q.is_null (6)
			is_null_filler_name := q.is_null (7)
			is_null_filler_type := q.is_null (8)
			is_null_geometry_id := q.is_null (9)
			is_null_packing_id := q.is_null (10)
			is_null_project_no := q.is_null (11)
			is_null_project_version_no := q.is_null (12)
			is_null_scribe_orientation := q.is_null (13)
			is_null_version_no := q.is_null (14)
			is_null_wafer_etest_name := q.is_null (15)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_die_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_die_id := True
			is_null_die_size_printed_x := True
			is_null_die_size_printed_y := True
			is_null_die_type := True
			is_null_die_wafer_rotation := True
			is_null_filler_name := True
			is_null_filler_type := True
			is_null_geometry_id := True
			is_null_project_no := True
			is_null_project_version_no := True
			is_null_scribe_orientation := True
			is_null_wafer_etest_name := True
			create die_id.make (0)
			create die_type.make (0)
			create filler_name.make (0)
			create filler_type.make (0)
			create geometry_id.make (0)
			create scribe_orientation.make (0)
			create wafer_etest_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, die_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and die_no = q.integer_value (2)
				and die_size_printed_x = q.double_value (3)
				and die_size_printed_y = q.double_value (4)
				and die_wafer_rotation = q.integer_value (6)
				and project_no = q.integer_value (11)
				and project_version_no = q.integer_value (12)
				and version_no = q.integer_value (14)
			q.get_string_value (1, s)
			Result := Result and equal (die_id, s)
			q.get_string_value (5, s)
			Result := Result and equal (die_type, s)
			q.get_string_value (7, s)
			Result := Result and equal (filler_name, s)
			q.get_string_value (8, s)
			Result := Result and equal (filler_type, s)
			q.get_string_value (9, s)
			Result := Result and equal (geometry_id, s)
			q.get_string_value (10, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (13, s)
			Result := Result and equal (scribe_orientation, s)
			q.get_string_value (15, s)
			Result := Result and equal (wafer_etest_name, s)
			Result := Result
				and is_null_die_id = q.is_null (1)
				and is_null_die_no = q.is_null (2)
				and is_null_die_size_printed_x = q.is_null (3)
				and is_null_die_size_printed_y = q.is_null (4)
				and is_null_die_type = q.is_null (5)
				and is_null_die_wafer_rotation = q.is_null (6)
				and is_null_filler_name = q.is_null (7)
				and is_null_filler_type = q.is_null (8)
				and is_null_geometry_id = q.is_null (9)
				and is_null_packing_id = q.is_null (10)
				and is_null_project_no = q.is_null (11)
				and is_null_project_version_no = q.is_null (12)
				and is_null_scribe_orientation = q.is_null (13)
				and is_null_version_no = q.is_null (14)
				and is_null_wafer_etest_name = q.is_null (15)
		end

end
