
note

	date: "Thu Jan 21 12:59:47 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PACKING_PARTITIONS (MOSIS.PACKING_PARTITIONS)"
			-- Included columns
			-- 	FIELD_NAME
			-- 	IS_DELETABLE
			-- 	IS_MOVABLE_IN_X
			-- 	IS_MOVABLE_IN_Y
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- 	PACKING_ID
			-- 	PARTITION_NO
			-- 	PARTITION_SIZE_X
			-- 	PARTITION_SIZE_Y
			-- 	VERSION_NO
			-- 	WAFER_ETEST_NAME
			-- Excluded columns
			-- 	(none)

class PACKING_PARTITIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_partition_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			partition_no := the_partition_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_partition_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 12

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  field_name, is_deletable, is_movable_in_x, is_movable_in_y, location_x,%N  location_y, packing_id, partition_no, partition_size_x, partition_size_y,%N  version_no, wafer_etest_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_partitions pckpt"

	join_condition: STRING = ""

	table_name: STRING = "packing_partitions"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and partition_no = :3"

feature -- Values

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	is_deletable: BOOLEAN
			-- DB: CHAR(1) not null

	is_movable_in_x: BOOLEAN
			-- DB: CHAR(1) not null

	is_movable_in_y: BOOLEAN
			-- DB: CHAR(1) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	location_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	partition_no: INTEGER
			-- DB: NUMBER(2,0) not null

	partition_size_x: DOUBLE
			-- DB: NUMBER(12,6) not null

	partition_size_y: DOUBLE
			-- DB: NUMBER(12,6) not null

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

	wafer_etest_name: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_field_name: INTEGER = 20
	maxlen_packing_id: INTEGER = 30
	maxlen_wafer_etest_name: INTEGER = 50

feature -- Precisions for number columns

	precision_location_x: INTEGER = 12
	precision_location_y: INTEGER = 12
	precision_partition_no: INTEGER = 2
	precision_partition_size_x: INTEGER = 12
	precision_partition_size_y: INTEGER = 12
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_location_x: INTEGER = 6
	scale_location_y: INTEGER = 6
	scale_partition_no: INTEGER = 0
	scale_partition_size_x: INTEGER = 6
	scale_partition_size_y: INTEGER = 6
	scale_version_no: INTEGER = 0

feature -- Nullness for non-null columns

	is_null_field_name: BOOLEAN
	is_null_is_deletable: BOOLEAN
	is_null_is_movable_in_x: BOOLEAN
	is_null_is_movable_in_y: BOOLEAN
	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_partition_no: BOOLEAN
	is_null_partition_size_x: BOOLEAN
	is_null_partition_size_y: BOOLEAN
	is_null_version_no: BOOLEAN
	is_null_wafer_etest_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and partition_no = r.partition_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_packing_id = r.is_null_packing_id
				and is_null_partition_no = r.is_null_partition_no
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_deletable = r.is_deletable
				and is_movable_in_x = r.is_movable_in_x
				and is_movable_in_y = r.is_movable_in_y
				and location_x = r.location_x
				and location_y = r.location_y
				and partition_size_x = r.partition_size_x
				and partition_size_y = r.partition_size_y
			Result := Result
				and equal (field_name, r.field_name)
				and equal (wafer_etest_name, r.wafer_etest_name)
			Result := Result
				and is_null_field_name = r.is_null_field_name
				and is_null_is_deletable = r.is_null_is_deletable
				and is_null_is_movable_in_x = r.is_null_is_movable_in_x
				and is_null_is_movable_in_y = r.is_null_is_movable_in_y
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
				and is_null_partition_size_x = r.is_null_partition_size_x
				and is_null_partition_size_y = r.is_null_partition_size_y
				and is_null_wafer_etest_name = r.is_null_wafer_etest_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 20)
			q.select_boolean (2)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_double (5)
			q.select_double (6)
			q.select_string (7, 30)
			q.select_integer (8)
			q.select_double (9)
			q.select_double (10)
			q.select_integer (11)
			q.select_string (12, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_deletable := q.boolean_value (2)
			is_movable_in_x := q.boolean_value (3)
			is_movable_in_y := q.boolean_value (4)
			location_x := q.double_value (5)
			location_y := q.double_value (6)
			partition_no := q.integer_value (8)
			partition_size_x := q.double_value (9)
			partition_size_y := q.double_value (10)
			version_no := q.integer_value (11)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_name := q.string_value (1)
			packing_id := q.string_value (7)
			wafer_etest_name := q.string_value (12)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, field_name)
			q.get_string_value (7, packing_id)
			q.get_string_value (12, wafer_etest_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_field_name := q.is_null (1)
			is_null_is_deletable := q.is_null (2)
			is_null_is_movable_in_x := q.is_null (3)
			is_null_is_movable_in_y := q.is_null (4)
			is_null_location_x := q.is_null (5)
			is_null_location_y := q.is_null (6)
			is_null_packing_id := q.is_null (7)
			is_null_partition_no := q.is_null (8)
			is_null_partition_size_x := q.is_null (9)
			is_null_partition_size_y := q.is_null (10)
			is_null_version_no := q.is_null (11)
			is_null_wafer_etest_name := q.is_null (12)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_partition_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_field_name := True
			is_null_is_deletable := True
			is_null_is_movable_in_x := True
			is_null_is_movable_in_y := True
			is_null_location_x := True
			is_null_location_y := True
			is_null_partition_size_x := True
			is_null_partition_size_y := True
			is_null_wafer_etest_name := True
			create field_name.make (0)
			create wafer_etest_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, partition_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_deletable = q.boolean_value (2)
				and is_movable_in_x = q.boolean_value (3)
				and is_movable_in_y = q.boolean_value (4)
				and location_x = q.double_value (5)
				and location_y = q.double_value (6)
				and partition_no = q.integer_value (8)
				and partition_size_x = q.double_value (9)
				and partition_size_y = q.double_value (10)
				and version_no = q.integer_value (11)
			q.get_string_value (1, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (7, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (12, s)
			Result := Result and equal (wafer_etest_name, s)
			Result := Result
				and is_null_field_name = q.is_null (1)
				and is_null_is_deletable = q.is_null (2)
				and is_null_is_movable_in_x = q.is_null (3)
				and is_null_is_movable_in_y = q.is_null (4)
				and is_null_location_x = q.is_null (5)
				and is_null_location_y = q.is_null (6)
				and is_null_packing_id = q.is_null (7)
				and is_null_partition_no = q.is_null (8)
				and is_null_partition_size_x = q.is_null (9)
				and is_null_partition_size_y = q.is_null (10)
				and is_null_version_no = q.is_null (11)
				and is_null_wafer_etest_name = q.is_null (12)
		end

end
