
note

	date: "Mon Jun 25 09:31:27 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_PROJECT_OPTIONS (MOSIS.PACKING_PROJECT_OPTIONS)"
			-- Included columns
			-- 	IS_EXPLICIT
			-- 	OPTION_ID
			-- 	OPTION_IN_PROCESS
			-- 	PACKING_ID
			-- 	PROJECT_NO
			-- 	PROJECT_VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_PROJECT_OPTIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_project_no: INTEGER; the_project_version_no: INTEGER; the_option_id: STRING; the_is_explicit: BOOLEAN)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
			the_option_id_exists: the_option_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			project_no := the_project_no
			project_version_no := the_project_version_no
			option_id := the_option_id
			is_explicit := the_is_explicit
			is_null_packing_id := False
			is_null_project_no := False
			is_null_project_version_no := False
			is_null_option_id := False
			is_null_is_explicit := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  is_explicit, option_id, option_in_process, packing_id, project_no,%N  project_version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_project_options pckpo"

	join_condition: STRING = ""

	table_name: STRING = "packing_project_options"

	key_where_clause: STRING = "packing_id = :1 and project_no = :2 and project_version_no = :3 and option_id = :4 and is_explicit = :5"

feature -- Values

	is_explicit: BOOLEAN
			-- DB: CHAR(1) not null

	option_id: STRING
			-- DB: VARCHAR2(10) not null

	option_in_process: BOOLEAN
			-- DB: CHAR(1) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	project_no: INTEGER
			-- DB: NUMBER(4,0) not null

	project_version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Maximum database lengths for character columns

	maxlen_option_id: INTEGER = 10
	maxlen_packing_id: INTEGER = 30

feature -- Precisions for number columns

	precision_project_no: INTEGER = 4
	precision_project_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_project_no: INTEGER = 0
	scale_project_version_no: INTEGER = 0

feature -- Nullness for non-null columns

	is_null_is_explicit: BOOLEAN
	is_null_option_id: BOOLEAN
	is_null_option_in_process: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_project_no: BOOLEAN
	is_null_project_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_explicit = r.is_explicit
				and project_no = r.project_no
				and project_version_no = r.project_version_no
			Result := Result
				and equal (option_id, r.option_id)
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_is_explicit = r.is_null_is_explicit
				and is_null_option_id = r.is_null_option_id
				and is_null_packing_id = r.is_null_packing_id
				and is_null_project_no = r.is_null_project_no
				and is_null_project_version_no = r.is_null_project_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and option_in_process = r.option_in_process
			Result := Result
				and is_null_option_in_process = r.is_null_option_in_process
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_string (2, 10)
			q.select_boolean (3)
			q.select_string (4, 30)
			q.select_integer (5)
			q.select_integer (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_explicit := q.boolean_value (1)
			option_in_process := q.boolean_value (3)
			project_no := q.integer_value (5)
			project_version_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			option_id := q.string_value (2)
			packing_id := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, option_id)
			q.get_string_value (4, packing_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_is_explicit := q.is_null (1)
			is_null_option_id := q.is_null (2)
			is_null_option_in_process := q.is_null (3)
			is_null_packing_id := q.is_null (4)
			is_null_project_no := q.is_null (5)
			is_null_project_version_no := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_project_no := True
			is_null_project_version_no := True
			is_null_option_id := True
			is_null_is_explicit := True
			create packing_id.make (0)
			create option_id.make (0)
		end

	set_null_nonkey
		do
			is_null_option_in_process := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, project_no, False)
			q.bind_num_to_integer (3, project_version_no, False)
			q.bind_num_to_string (4, option_id, False)
			q.bind_num_to_boolean (5, is_explicit, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_explicit = q.boolean_value (1)
				and option_in_process = q.boolean_value (3)
				and project_no = q.integer_value (5)
				and project_version_no = q.integer_value (6)
			q.get_string_value (2, s)
			Result := Result and equal (option_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (packing_id, s)
			Result := Result
				and is_null_is_explicit = q.is_null (1)
				and is_null_option_id = q.is_null (2)
				and is_null_option_in_process = q.is_null (3)
				and is_null_packing_id = q.is_null (4)
				and is_null_project_no = q.is_null (5)
				and is_null_project_version_no = q.is_null (6)
		end

end
