
note

	date: "Mon Jun 25 09:31:27 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_PROJECT_PACKAGINGS (MOSIS.PACKING_PROJECT_PACKAGINGS)"
			-- Included columns
			-- 	DESIGN_PACKAGE_ROTATION
			-- 	DESIGN_PACKAGE_ROTATION_REQD
			-- 	DIE_THICKNESS_MILS
			-- 	DOWNBOND_LOCATION_REQD
			-- 	LINE_NO
			-- 	PACKAGED
			-- 	PACKAGE_ID
			-- 	PACKAGE_REQUESTED
			-- 	PACKING_ID
			-- 	PROJECT_NO
			-- 	PROJECT_VERSION_NO
			-- 	QUANTITY_ORDERED
			-- 	QUANTITY_PACKAGED_REQUESTED
			-- Excluded columns
			-- 	(none)

class PACKING_PROJECT_PACKAGINGS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_project_no: INTEGER; the_project_version_no: INTEGER; the_line_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			project_no := the_project_no
			project_version_no := the_project_version_no
			line_no := the_line_no
			is_null_packing_id := False
			is_null_project_no := False
			is_null_project_version_no := False
			is_null_line_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 13

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  design_package_rotation, design_package_rotation_reqd,%N  die_thickness_mils, downbond_location_reqd, line_no, packaged,%N  package_id, package_requested, packing_id, project_no,%N  project_version_no, quantity_ordered, quantity_packaged_requested"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_project_packagings pckpp"

	join_condition: STRING = ""

	table_name: STRING = "packing_project_packagings"

	key_where_clause: STRING = "packing_id = :1 and project_no = :2 and project_version_no = :3 and line_no = :4"

feature -- Values

	design_package_rotation: INTEGER
			-- DB: NUMBER(3,0)

	design_package_rotation_reqd: INTEGER
			-- DB: NUMBER(3,0)

	die_thickness_mils: DOUBLE
			-- DB: NUMBER(*,*)

	downbond_location_reqd: STRING
			-- DB: VARCHAR2(8)

	line_no: INTEGER
			-- DB: NUMBER(6,0) not null

	packaged: BOOLEAN
			-- DB: CHAR(1)

	package_id: STRING
			-- DB: VARCHAR2(25)

	package_requested: STRING
			-- DB: VARCHAR2(255)

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	project_no: INTEGER
			-- DB: NUMBER(4,0) not null

	project_version_no: INTEGER
			-- DB: NUMBER(4,0) not null

	quantity_ordered: INTEGER
			-- DB: NUMBER(6,0)

	quantity_packaged_requested: INTEGER
			-- DB: NUMBER(6,0)

feature -- Maximum database lengths for character columns

	maxlen_downbond_location_reqd: INTEGER = 8
	maxlen_package_id: INTEGER = 25
	maxlen_package_requested: INTEGER = 255
	maxlen_packing_id: INTEGER = 30

feature -- Precisions for number columns

	precision_design_package_rotation: INTEGER = 3
	precision_design_package_rotation_reqd: INTEGER = 3
	precision_die_thickness_mils: INTEGER = 38
	precision_line_no: INTEGER = 6
	precision_project_no: INTEGER = 4
	precision_project_version_no: INTEGER = 4
	precision_quantity_ordered: INTEGER = 6
	precision_quantity_packaged_requested: INTEGER = 6

feature -- Scales for number columns

	scale_design_package_rotation: INTEGER = 0
	scale_design_package_rotation_reqd: INTEGER = 0
	scale_line_no: INTEGER = 0
	scale_project_no: INTEGER = 0
	scale_project_version_no: INTEGER = 0
	scale_quantity_ordered: INTEGER = 0
	scale_quantity_packaged_requested: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_design_package_rotation: BOOLEAN
	is_null_design_package_rotation_reqd: BOOLEAN
	is_null_die_thickness_mils: BOOLEAN
	is_null_downbond_location_reqd: BOOLEAN
	is_null_packaged: BOOLEAN
	is_null_package_id: BOOLEAN
	is_null_package_requested: BOOLEAN
	is_null_quantity_ordered: BOOLEAN
	is_null_quantity_packaged_requested: BOOLEAN

feature -- Nullness for non-null columns

	is_null_line_no: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_project_no: BOOLEAN
	is_null_project_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and line_no = r.line_no
				and project_no = r.project_no
				and project_version_no = r.project_version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_line_no = r.is_null_line_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_project_no = r.is_null_project_no
				and is_null_project_version_no = r.is_null_project_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_package_rotation = r.design_package_rotation
				and design_package_rotation_reqd = r.design_package_rotation_reqd
				and die_thickness_mils = r.die_thickness_mils
				and packaged = r.packaged
				and quantity_ordered = r.quantity_ordered
				and quantity_packaged_requested = r.quantity_packaged_requested
			Result := Result
				and equal (downbond_location_reqd, r.downbond_location_reqd)
				and equal (package_id, r.package_id)
				and equal (package_requested, r.package_requested)
			Result := Result
				and is_null_design_package_rotation = r.is_null_design_package_rotation
				and is_null_design_package_rotation_reqd = r.is_null_design_package_rotation_reqd
				and is_null_die_thickness_mils = r.is_null_die_thickness_mils
				and is_null_downbond_location_reqd = r.is_null_downbond_location_reqd
				and is_null_packaged = r.is_null_packaged
				and is_null_package_id = r.is_null_package_id
				and is_null_package_requested = r.is_null_package_requested
				and is_null_quantity_ordered = r.is_null_quantity_ordered
				and is_null_quantity_packaged_requested = r.is_null_quantity_packaged_requested
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_double (3)
			q.select_string (4, 8)
			q.select_integer (5)
			q.select_boolean (6)
			q.select_string (7, 25)
			q.select_string (8, 255)
			q.select_string (9, 30)
			q.select_integer (10)
			q.select_integer (11)
			q.select_integer (12)
			q.select_integer (13)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			design_package_rotation := q.integer_value (1)
			design_package_rotation_reqd := q.integer_value (2)
			die_thickness_mils := q.double_value (3)
			line_no := q.integer_value (5)
			packaged := q.boolean_value (6)
			project_no := q.integer_value (10)
			project_version_no := q.integer_value (11)
			quantity_ordered := q.integer_value (12)
			quantity_packaged_requested := q.integer_value (13)
		end

	fill_in_references (q: SQL_QUERY)
		do
			downbond_location_reqd := q.string_value (4)
			package_id := q.string_value (7)
			package_requested := q.string_value (8)
			packing_id := q.string_value (9)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, downbond_location_reqd)
			q.get_string_value (7, package_id)
			q.get_string_value (8, package_requested)
			q.get_string_value (9, packing_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_design_package_rotation := q.is_null (1)
			is_null_design_package_rotation_reqd := q.is_null (2)
			is_null_die_thickness_mils := q.is_null (3)
			is_null_downbond_location_reqd := q.is_null (4)
			is_null_line_no := q.is_null (5)
			is_null_packaged := q.is_null (6)
			is_null_package_id := q.is_null (7)
			is_null_package_requested := q.is_null (8)
			is_null_packing_id := q.is_null (9)
			is_null_project_no := q.is_null (10)
			is_null_project_version_no := q.is_null (11)
			is_null_quantity_ordered := q.is_null (12)
			is_null_quantity_packaged_requested := q.is_null (13)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_project_no := True
			is_null_project_version_no := True
			is_null_line_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_design_package_rotation := True
			is_null_design_package_rotation_reqd := True
			is_null_die_thickness_mils := True
			is_null_downbond_location_reqd := True
			is_null_packaged := True
			is_null_package_id := True
			is_null_package_requested := True
			is_null_quantity_ordered := True
			is_null_quantity_packaged_requested := True
			create downbond_location_reqd.make (0)
			create package_id.make (0)
			create package_requested.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, project_no, False)
			q.bind_num_to_integer (3, project_version_no, False)
			q.bind_num_to_integer (4, line_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and design_package_rotation = q.integer_value (1)
				and design_package_rotation_reqd = q.integer_value (2)
				and die_thickness_mils = q.double_value (3)
				and line_no = q.integer_value (5)
				and packaged = q.boolean_value (6)
				and project_no = q.integer_value (10)
				and project_version_no = q.integer_value (11)
				and quantity_ordered = q.integer_value (12)
				and quantity_packaged_requested = q.integer_value (13)
			q.get_string_value (4, s)
			Result := Result and equal (downbond_location_reqd, s)
			q.get_string_value (7, s)
			Result := Result and equal (package_id, s)
			q.get_string_value (8, s)
			Result := Result and equal (package_requested, s)
			q.get_string_value (9, s)
			Result := Result and equal (packing_id, s)
			Result := Result
				and is_null_design_package_rotation = q.is_null (1)
				and is_null_design_package_rotation_reqd = q.is_null (2)
				and is_null_die_thickness_mils = q.is_null (3)
				and is_null_downbond_location_reqd = q.is_null (4)
				and is_null_line_no = q.is_null (5)
				and is_null_packaged = q.is_null (6)
				and is_null_package_id = q.is_null (7)
				and is_null_package_requested = q.is_null (8)
				and is_null_packing_id = q.is_null (9)
				and is_null_project_no = q.is_null (10)
				and is_null_project_version_no = q.is_null (11)
				and is_null_quantity_ordered = q.is_null (12)
				and is_null_quantity_packaged_requested = q.is_null (13)
		end

end
