
note

	date: "Tue May  1 10:38:29 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_VERSIONS (MOSIS.PACKING_VERSIONS)"
			-- Included columns
			-- 	CREATOR
			-- 	DATE_CREATED
			-- 	EXTERNAL_CUT_DISTANCE_BOTTOM
			-- 	EXTERNAL_CUT_DISTANCE_LEFT
			-- 	EXTERNAL_CUT_DISTANCE_RIGHT
			-- 	EXTERNAL_CUT_DISTANCE_TOP
			-- 	FIELD_SIZE_X
			-- 	FIELD_SIZE_Y
			-- 	PACKING_ID
			-- 	PACKING_NAME
			-- 	PARENT_VERSION_NO
			-- 	PAYLOAD_SIZE_X
			-- 	PAYLOAD_SIZE_Y
			-- 	SAW_BLADE_WIDTH
			-- 	VERSION_ID
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_VERSIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			is_null_packing_id := False
			is_null_version_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 16

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  creator, date_created, external_cut_distance_bottom,%N  external_cut_distance_left, external_cut_distance_right,%N  external_cut_distance_top, field_size_x, field_size_y, packing_id,%N  packing_name, parent_version_no, payload_size_x, payload_size_y,%N  saw_blade_width, version_id, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_versions pckv"

	join_condition: STRING = ""

	table_name: STRING = "packing_versions"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2"

feature -- Values

	creator: STRING
			-- DB: VARCHAR2(30) not null

	date_created: DB_DATE
			-- DB: DATE not null

	external_cut_distance_bottom: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_left: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_right: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_top: DOUBLE
			-- DB: NUMBER(12,6)

	field_size_x: DOUBLE
			-- DB: NUMBER(12,6)

	field_size_y: DOUBLE
			-- DB: NUMBER(12,6)

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	packing_name: STRING
			-- DB: VARCHAR2(30)

	parent_version_no: INTEGER
			-- DB: NUMBER(4,0)

	payload_size_x: DOUBLE
			-- DB: NUMBER(12,6)

	payload_size_y: DOUBLE
			-- DB: NUMBER(12,6)

	saw_blade_width: DOUBLE
			-- DB: NUMBER(6,3) not null
			-- Eiffel type specified explicitly

	version_id: STRING
			-- DB: VARCHAR2(50)

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Maximum database lengths for character columns

	maxlen_creator: INTEGER = 30
	maxlen_packing_id: INTEGER = 30
	maxlen_packing_name: INTEGER = 30
	maxlen_version_id: INTEGER = 50

feature -- Precisions for number columns

	precision_external_cut_distance_bottom: INTEGER = 12
	precision_external_cut_distance_left: INTEGER = 12
	precision_external_cut_distance_right: INTEGER = 12
	precision_external_cut_distance_top: INTEGER = 12
	precision_field_size_x: INTEGER = 12
	precision_field_size_y: INTEGER = 12
	precision_parent_version_no: INTEGER = 4
	precision_payload_size_x: INTEGER = 12
	precision_payload_size_y: INTEGER = 12
	precision_saw_blade_width: INTEGER = 6
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_external_cut_distance_bottom: INTEGER = 6
	scale_external_cut_distance_left: INTEGER = 6
	scale_external_cut_distance_right: INTEGER = 6
	scale_external_cut_distance_top: INTEGER = 6
	scale_field_size_x: INTEGER = 6
	scale_field_size_y: INTEGER = 6
	scale_parent_version_no: INTEGER = 0
	scale_payload_size_x: INTEGER = 6
	scale_payload_size_y: INTEGER = 6
	scale_saw_blade_width: INTEGER = 3
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_external_cut_distance_bottom: BOOLEAN
	is_null_external_cut_distance_left: BOOLEAN
	is_null_external_cut_distance_right: BOOLEAN
	is_null_external_cut_distance_top: BOOLEAN
	is_null_field_size_x: BOOLEAN
	is_null_field_size_y: BOOLEAN
	is_null_packing_name: BOOLEAN
	is_null_parent_version_no: BOOLEAN
	is_null_payload_size_x: BOOLEAN
	is_null_payload_size_y: BOOLEAN
	is_null_version_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_creator: BOOLEAN
	is_null_date_created: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_saw_blade_width: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and external_cut_distance_bottom = r.external_cut_distance_bottom
				and external_cut_distance_left = r.external_cut_distance_left
				and external_cut_distance_right = r.external_cut_distance_right
				and external_cut_distance_top = r.external_cut_distance_top
				and field_size_x = r.field_size_x
				and field_size_y = r.field_size_y
				and parent_version_no = r.parent_version_no
				and payload_size_x = r.payload_size_x
				and payload_size_y = r.payload_size_y
				and saw_blade_width = r.saw_blade_width
			Result := Result
				and equal (creator, r.creator)
				and equal (date_created, r.date_created)
				and equal (packing_name, r.packing_name)
				and equal (version_id, r.version_id)
			Result := Result
				and is_null_creator = r.is_null_creator
				and is_null_date_created = r.is_null_date_created
				and is_null_external_cut_distance_bottom = r.is_null_external_cut_distance_bottom
				and is_null_external_cut_distance_left = r.is_null_external_cut_distance_left
				and is_null_external_cut_distance_right = r.is_null_external_cut_distance_right
				and is_null_external_cut_distance_top = r.is_null_external_cut_distance_top
				and is_null_field_size_x = r.is_null_field_size_x
				and is_null_field_size_y = r.is_null_field_size_y
				and is_null_packing_name = r.is_null_packing_name
				and is_null_parent_version_no = r.is_null_parent_version_no
				and is_null_payload_size_x = r.is_null_payload_size_x
				and is_null_payload_size_y = r.is_null_payload_size_y
				and is_null_saw_blade_width = r.is_null_saw_blade_width
				and is_null_version_id = r.is_null_version_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_date (2)
			q.select_double (3)
			q.select_double (4)
			q.select_double (5)
			q.select_double (6)
			q.select_double (7)
			q.select_double (8)
			q.select_string (9, 30)
			q.select_string (10, 30)
			q.select_integer (11)
			q.select_double (12)
			q.select_double (13)
			q.select_double (14)
			q.select_string (15, 50)
			q.select_integer (16)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			external_cut_distance_bottom := q.double_value (3)
			external_cut_distance_left := q.double_value (4)
			external_cut_distance_right := q.double_value (5)
			external_cut_distance_top := q.double_value (6)
			field_size_x := q.double_value (7)
			field_size_y := q.double_value (8)
			parent_version_no := q.integer_value (11)
			payload_size_x := q.double_value (12)
			payload_size_y := q.double_value (13)
			saw_blade_width := q.double_value (14)
			version_no := q.integer_value (16)
		end

	fill_in_references (q: SQL_QUERY)
		do
			creator := q.string_value (1)
			date_created := q.date_value (2)
			packing_id := q.string_value (9)
			packing_name := q.string_value (10)
			version_id := q.string_value (15)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, creator)
			q.get_date_value (2, date_created)
			q.get_string_value (9, packing_id)
			q.get_string_value (10, packing_name)
			q.get_string_value (15, version_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_creator := q.is_null (1)
			is_null_date_created := q.is_null (2)
			is_null_external_cut_distance_bottom := q.is_null (3)
			is_null_external_cut_distance_left := q.is_null (4)
			is_null_external_cut_distance_right := q.is_null (5)
			is_null_external_cut_distance_top := q.is_null (6)
			is_null_field_size_x := q.is_null (7)
			is_null_field_size_y := q.is_null (8)
			is_null_packing_id := q.is_null (9)
			is_null_packing_name := q.is_null (10)
			is_null_parent_version_no := q.is_null (11)
			is_null_payload_size_x := q.is_null (12)
			is_null_payload_size_y := q.is_null (13)
			is_null_saw_blade_width := q.is_null (14)
			is_null_version_id := q.is_null (15)
			is_null_version_no := q.is_null (16)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_creator := True
			is_null_date_created := True
			is_null_external_cut_distance_bottom := True
			is_null_external_cut_distance_left := True
			is_null_external_cut_distance_right := True
			is_null_external_cut_distance_top := True
			is_null_field_size_x := True
			is_null_field_size_y := True
			is_null_packing_name := True
			is_null_parent_version_no := True
			is_null_payload_size_x := True
			is_null_payload_size_y := True
			is_null_saw_blade_width := True
			is_null_version_id := True
			create creator.make (0)
			create {ORACLE_DATE} date_created.set_null
			create packing_name.make (0)
			create version_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and external_cut_distance_bottom = q.double_value (3)
				and external_cut_distance_left = q.double_value (4)
				and external_cut_distance_right = q.double_value (5)
				and external_cut_distance_top = q.double_value (6)
				and field_size_x = q.double_value (7)
				and field_size_y = q.double_value (8)
				and parent_version_no = q.integer_value (11)
				and payload_size_x = q.double_value (12)
				and payload_size_y = q.double_value (13)
				and saw_blade_width = q.double_value (14)
				and version_no = q.integer_value (16)
			q.get_string_value (1, s)
			Result := Result and equal (creator, s)
			q.get_date_value (2, d)
			Result := Result and equal (date_created, d)
			q.get_string_value (9, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (10, s)
			Result := Result and equal (packing_name, s)
			q.get_string_value (15, s)
			Result := Result and equal (version_id, s)
			Result := Result
				and is_null_creator = q.is_null (1)
				and is_null_date_created = q.is_null (2)
				and is_null_external_cut_distance_bottom = q.is_null (3)
				and is_null_external_cut_distance_left = q.is_null (4)
				and is_null_external_cut_distance_right = q.is_null (5)
				and is_null_external_cut_distance_top = q.is_null (6)
				and is_null_field_size_x = q.is_null (7)
				and is_null_field_size_y = q.is_null (8)
				and is_null_packing_id = q.is_null (9)
				and is_null_packing_name = q.is_null (10)
				and is_null_parent_version_no = q.is_null (11)
				and is_null_payload_size_x = q.is_null (12)
				and is_null_payload_size_y = q.is_null (13)
				and is_null_saw_blade_width = q.is_null (14)
				and is_null_version_id = q.is_null (15)
				and is_null_version_no = q.is_null (16)
		end

end
