
note

	date: "Thu Jan 21 12:59:47 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PACKING_WAFER_PROCESSES (MOSIS.PACKING_WAFER_PROCESSES)"
			-- Included columns
			-- 	PACKING_ID
			-- 	QUANTITY_WAFERS_ORDERED
			-- 	VERSION_NO
			-- 	WAFER_PROCESS
			-- Excluded columns
			-- 	(none)

class PACKING_WAFER_PROCESSES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_wafer_process: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
			the_wafer_process_exists: the_wafer_process /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			wafer_process := the_wafer_process
			is_null_packing_id := False
			is_null_version_no := False
			is_null_wafer_process := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  packing_id, quantity_wafers_ordered, version_no, wafer_process"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_wafer_processes pckpl"

	join_condition: STRING = ""

	table_name: STRING = "packing_wafer_processes"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and wafer_process = :3"

feature -- Values

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	quantity_wafers_ordered: INTEGER
			-- DB: NUMBER(6,0)

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

	wafer_process: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_packing_id: INTEGER = 30
	maxlen_wafer_process: INTEGER = 50

feature -- Precisions for number columns

	precision_quantity_wafers_ordered: INTEGER = 6
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_quantity_wafers_ordered: INTEGER = 0
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_quantity_wafers_ordered: BOOLEAN

feature -- Nullness for non-null columns

	is_null_packing_id: BOOLEAN
	is_null_version_no: BOOLEAN
	is_null_wafer_process: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
				and equal (wafer_process, r.wafer_process)
			Result := Result
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
				and is_null_wafer_process = r.is_null_wafer_process
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and quantity_wafers_ordered = r.quantity_wafers_ordered
			Result := Result
				and is_null_quantity_wafers_ordered = r.is_null_quantity_wafers_ordered
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_integer (2)
			q.select_integer (3)
			q.select_string (4, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			quantity_wafers_ordered := q.integer_value (2)
			version_no := q.integer_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			packing_id := q.string_value (1)
			wafer_process := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, packing_id)
			q.get_string_value (4, wafer_process)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_packing_id := q.is_null (1)
			is_null_quantity_wafers_ordered := q.is_null (2)
			is_null_version_no := q.is_null (3)
			is_null_wafer_process := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_wafer_process := True
			create packing_id.make (0)
			create wafer_process.make (0)
		end

	set_null_nonkey
		do
			is_null_quantity_wafers_ordered := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_string (3, wafer_process, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and quantity_wafers_ordered = q.integer_value (2)
				and version_no = q.integer_value (3)
			q.get_string_value (1, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (wafer_process, s)
			Result := Result
				and is_null_packing_id = q.is_null (1)
				and is_null_quantity_wafers_ordered = q.is_null (2)
				and is_null_version_no = q.is_null (3)
				and is_null_wafer_process = q.is_null (4)
		end

end
