
note

	date: "Mon Jun 25 09:31:26 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKINGS (MOSIS.PACKINGS)"
			-- Included columns
			-- 	ASSIGNED_RUN_ID
			-- 	CREATOR
			-- 	CUST_ACCT_ACCESS_PREDICATE
			-- 	DATE_CREATED
			-- 	DEDICATED_CUST_ACCT_NO
			-- 	DESCR
			-- 	FIELD_SET_NAME
			-- 	HORIZONTAL_SCRIBE_WIDTH
			-- 	INTENDED_RUN
			-- 	IS_EDUCATIONAL
			-- 	IS_TAXI
			-- 	OTHER_BORDER
			-- 	OVERHEAD_STYLE
			-- 	PACKED_WITH_NEW_PACKER
			-- 	PACKING_ID
			-- 	RUN_TYPE
			-- 	SCHED_RUN_NO
			-- 	UNIFORM_OVERRIDE_BORDER
			-- 	VERTICAL_SCRIBE_WIDTH
			-- 	WAFER_TECHN
			-- 	WAFER_TECHN_FAMILY
			-- Excluded columns
			-- 	(none)

class PACKINGS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			is_null_packing_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 21

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  assigned_run_id, creator, cust_acct_access_predicate, date_created,%N  dedicated_cust_acct_no, descr, field_set_name, horizontal_scribe_width,%N  intended_run, is_educational, is_taxi, other_border, overhead_style,%N  packed_with_new_packer, packing_id, run_type, sched_run_no,%N  uniform_override_border, vertical_scribe_width, wafer_techn,%N  wafer_techn_family"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packings pck"

	join_condition: STRING = ""

	table_name: STRING = "packings"

	key_where_clause: STRING = "packing_id = :1"

feature -- Values

	assigned_run_id: STRING
			-- DB: CHAR(4)

	creator: STRING
			-- DB: VARCHAR2(30) not null

	cust_acct_access_predicate: STRING
			-- DB: VARCHAR2(25)

	date_created: DB_DATE
			-- DB: DATE not null

	dedicated_cust_acct_no: INTEGER
			-- DB: NUMBER(6,0)

	descr: STRING
			-- DB: VARCHAR2(255)

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	horizontal_scribe_width: DOUBLE
			-- DB: NUMBER(12,6)

	intended_run: STRING
			-- DB: VARCHAR2(50)

	is_educational: BOOLEAN
			-- DB: CHAR(1) not null

	is_taxi: BOOLEAN
			-- DB: CHAR(1) not null

	other_border: DOUBLE
			-- DB: NUMBER(12,6) not null

	overhead_style: STRING
			-- DB: VARCHAR2(12)

	packed_with_new_packer: BOOLEAN
			-- DB: CHAR(1) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	run_type: STRING
			-- DB: VARCHAR2(5) not null

	sched_run_no: INTEGER
			-- DB: NUMBER(6,0) not null

	uniform_override_border: DOUBLE
			-- DB: NUMBER(*,*)

	vertical_scribe_width: DOUBLE
			-- DB: NUMBER(12,6)

	wafer_techn: STRING
			-- DB: VARCHAR2(50) not null

	wafer_techn_family: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_assigned_run_id: INTEGER = 4
	maxlen_creator: INTEGER = 30
	maxlen_cust_acct_access_predicate: INTEGER = 25
	maxlen_descr: INTEGER = 255
	maxlen_field_set_name: INTEGER = 30
	maxlen_intended_run: INTEGER = 50
	maxlen_overhead_style: INTEGER = 12
	maxlen_packing_id: INTEGER = 30
	maxlen_run_type: INTEGER = 5
	maxlen_wafer_techn: INTEGER = 50
	maxlen_wafer_techn_family: INTEGER = 50

feature -- Precisions for number columns

	precision_dedicated_cust_acct_no: INTEGER = 6
	precision_horizontal_scribe_width: INTEGER = 12
	precision_other_border: INTEGER = 12
	precision_sched_run_no: INTEGER = 6
	precision_uniform_override_border: INTEGER = 38
	precision_vertical_scribe_width: INTEGER = 12

feature -- Scales for number columns

	scale_dedicated_cust_acct_no: INTEGER = 0
	scale_horizontal_scribe_width: INTEGER = 6
	scale_other_border: INTEGER = 6
	scale_sched_run_no: INTEGER = 0
	scale_vertical_scribe_width: INTEGER = 6

feature -- Nullness for null allowed columns

	is_null_assigned_run_id: BOOLEAN
	is_null_cust_acct_access_predicate: BOOLEAN
	is_null_dedicated_cust_acct_no: BOOLEAN
	is_null_descr: BOOLEAN
	is_null_horizontal_scribe_width: BOOLEAN
	is_null_intended_run: BOOLEAN
	is_null_overhead_style: BOOLEAN
	is_null_uniform_override_border: BOOLEAN
	is_null_vertical_scribe_width: BOOLEAN

feature -- Nullness for non-null columns

	is_null_creator: BOOLEAN
	is_null_date_created: BOOLEAN
	is_null_field_set_name: BOOLEAN
	is_null_is_educational: BOOLEAN
	is_null_is_taxi: BOOLEAN
	is_null_other_border: BOOLEAN
	is_null_packed_with_new_packer: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_run_type: BOOLEAN
	is_null_sched_run_no: BOOLEAN
	is_null_wafer_techn: BOOLEAN
	is_null_wafer_techn_family: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_packing_id = r.is_null_packing_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and dedicated_cust_acct_no = r.dedicated_cust_acct_no
				and horizontal_scribe_width = r.horizontal_scribe_width
				and is_educational = r.is_educational
				and is_taxi = r.is_taxi
				and other_border = r.other_border
				and packed_with_new_packer = r.packed_with_new_packer
				and sched_run_no = r.sched_run_no
				and uniform_override_border = r.uniform_override_border
				and vertical_scribe_width = r.vertical_scribe_width
			Result := Result
				and equal (assigned_run_id, r.assigned_run_id)
				and equal (creator, r.creator)
				and equal (cust_acct_access_predicate, r.cust_acct_access_predicate)
				and equal (date_created, r.date_created)
				and equal (descr, r.descr)
				and equal (field_set_name, r.field_set_name)
				and equal (intended_run, r.intended_run)
				and equal (overhead_style, r.overhead_style)
				and equal (run_type, r.run_type)
				and equal (wafer_techn, r.wafer_techn)
				and equal (wafer_techn_family, r.wafer_techn_family)
			Result := Result
				and is_null_assigned_run_id = r.is_null_assigned_run_id
				and is_null_creator = r.is_null_creator
				and is_null_cust_acct_access_predicate = r.is_null_cust_acct_access_predicate
				and is_null_date_created = r.is_null_date_created
				and is_null_dedicated_cust_acct_no = r.is_null_dedicated_cust_acct_no
				and is_null_descr = r.is_null_descr
				and is_null_field_set_name = r.is_null_field_set_name
				and is_null_horizontal_scribe_width = r.is_null_horizontal_scribe_width
				and is_null_intended_run = r.is_null_intended_run
				and is_null_is_educational = r.is_null_is_educational
				and is_null_is_taxi = r.is_null_is_taxi
				and is_null_other_border = r.is_null_other_border
				and is_null_overhead_style = r.is_null_overhead_style
				and is_null_packed_with_new_packer = r.is_null_packed_with_new_packer
				and is_null_run_type = r.is_null_run_type
				and is_null_sched_run_no = r.is_null_sched_run_no
				and is_null_uniform_override_border = r.is_null_uniform_override_border
				and is_null_vertical_scribe_width = r.is_null_vertical_scribe_width
				and is_null_wafer_techn = r.is_null_wafer_techn
				and is_null_wafer_techn_family = r.is_null_wafer_techn_family
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 4)
			q.select_string (2, 30)
			q.select_string (3, 25)
			q.select_date (4)
			q.select_integer (5)
			q.select_string (6, 255)
			q.select_string (7, 30)
			q.select_double (8)
			q.select_string (9, 50)
			q.select_boolean (10)
			q.select_boolean (11)
			q.select_double (12)
			q.select_string (13, 12)
			q.select_boolean (14)
			q.select_string (15, 30)
			q.select_string (16, 5)
			q.select_integer (17)
			q.select_double (18)
			q.select_double (19)
			q.select_string (20, 50)
			q.select_string (21, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			dedicated_cust_acct_no := q.integer_value (5)
			horizontal_scribe_width := q.double_value (8)
			is_educational := q.boolean_value (10)
			is_taxi := q.boolean_value (11)
			other_border := q.double_value (12)
			packed_with_new_packer := q.boolean_value (14)
			sched_run_no := q.integer_value (17)
			uniform_override_border := q.double_value (18)
			vertical_scribe_width := q.double_value (19)
		end

	fill_in_references (q: SQL_QUERY)
		do
			assigned_run_id := q.string_value (1)
			creator := q.string_value (2)
			cust_acct_access_predicate := q.string_value (3)
			date_created := q.date_value (4)
			descr := q.string_value (6)
			field_set_name := q.string_value (7)
			intended_run := q.string_value (9)
			overhead_style := q.string_value (13)
			packing_id := q.string_value (15)
			run_type := q.string_value (16)
			wafer_techn := q.string_value (20)
			wafer_techn_family := q.string_value (21)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, assigned_run_id)
			q.get_string_value (2, creator)
			q.get_string_value (3, cust_acct_access_predicate)
			q.get_date_value (4, date_created)
			q.get_string_value (6, descr)
			q.get_string_value (7, field_set_name)
			q.get_string_value (9, intended_run)
			q.get_string_value (13, overhead_style)
			q.get_string_value (15, packing_id)
			q.get_string_value (16, run_type)
			q.get_string_value (20, wafer_techn)
			q.get_string_value (21, wafer_techn_family)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_assigned_run_id := q.is_null (1)
			is_null_creator := q.is_null (2)
			is_null_cust_acct_access_predicate := q.is_null (3)
			is_null_date_created := q.is_null (4)
			is_null_dedicated_cust_acct_no := q.is_null (5)
			is_null_descr := q.is_null (6)
			is_null_field_set_name := q.is_null (7)
			is_null_horizontal_scribe_width := q.is_null (8)
			is_null_intended_run := q.is_null (9)
			is_null_is_educational := q.is_null (10)
			is_null_is_taxi := q.is_null (11)
			is_null_other_border := q.is_null (12)
			is_null_overhead_style := q.is_null (13)
			is_null_packed_with_new_packer := q.is_null (14)
			is_null_packing_id := q.is_null (15)
			is_null_run_type := q.is_null (16)
			is_null_sched_run_no := q.is_null (17)
			is_null_uniform_override_border := q.is_null (18)
			is_null_vertical_scribe_width := q.is_null (19)
			is_null_wafer_techn := q.is_null (20)
			is_null_wafer_techn_family := q.is_null (21)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_assigned_run_id := True
			is_null_creator := True
			is_null_cust_acct_access_predicate := True
			is_null_date_created := True
			is_null_dedicated_cust_acct_no := True
			is_null_descr := True
			is_null_field_set_name := True
			is_null_horizontal_scribe_width := True
			is_null_intended_run := True
			is_null_is_educational := True
			is_null_is_taxi := True
			is_null_other_border := True
			is_null_overhead_style := True
			is_null_packed_with_new_packer := True
			is_null_run_type := True
			is_null_sched_run_no := True
			is_null_uniform_override_border := True
			is_null_vertical_scribe_width := True
			is_null_wafer_techn := True
			is_null_wafer_techn_family := True
			create assigned_run_id.make (0)
			create creator.make (0)
			create cust_acct_access_predicate.make (0)
			create {ORACLE_DATE} date_created.set_null
			create descr.make (0)
			create field_set_name.make (0)
			create intended_run.make (0)
			create overhead_style.make (0)
			create run_type.make (0)
			create wafer_techn.make (0)
			create wafer_techn_family.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and dedicated_cust_acct_no = q.integer_value (5)
				and horizontal_scribe_width = q.double_value (8)
				and is_educational = q.boolean_value (10)
				and is_taxi = q.boolean_value (11)
				and other_border = q.double_value (12)
				and packed_with_new_packer = q.boolean_value (14)
				and sched_run_no = q.integer_value (17)
				and uniform_override_border = q.double_value (18)
				and vertical_scribe_width = q.double_value (19)
			q.get_string_value (1, s)
			Result := Result and equal (assigned_run_id, s)
			q.get_string_value (2, s)
			Result := Result and equal (creator, s)
			q.get_string_value (3, s)
			Result := Result and equal (cust_acct_access_predicate, s)
			q.get_date_value (4, d)
			Result := Result and equal (date_created, d)
			q.get_string_value (6, s)
			Result := Result and equal (descr, s)
			q.get_string_value (7, s)
			Result := Result and equal (field_set_name, s)
			q.get_string_value (9, s)
			Result := Result and equal (intended_run, s)
			q.get_string_value (13, s)
			Result := Result and equal (overhead_style, s)
			q.get_string_value (15, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (16, s)
			Result := Result and equal (run_type, s)
			q.get_string_value (20, s)
			Result := Result and equal (wafer_techn, s)
			q.get_string_value (21, s)
			Result := Result and equal (wafer_techn_family, s)
			Result := Result
				and is_null_assigned_run_id = q.is_null (1)
				and is_null_creator = q.is_null (2)
				and is_null_cust_acct_access_predicate = q.is_null (3)
				and is_null_date_created = q.is_null (4)
				and is_null_dedicated_cust_acct_no = q.is_null (5)
				and is_null_descr = q.is_null (6)
				and is_null_field_set_name = q.is_null (7)
				and is_null_horizontal_scribe_width = q.is_null (8)
				and is_null_intended_run = q.is_null (9)
				and is_null_is_educational = q.is_null (10)
				and is_null_is_taxi = q.is_null (11)
				and is_null_other_border = q.is_null (12)
				and is_null_overhead_style = q.is_null (13)
				and is_null_packed_with_new_packer = q.is_null (14)
				and is_null_packing_id = q.is_null (15)
				and is_null_run_type = q.is_null (16)
				and is_null_sched_run_no = q.is_null (17)
				and is_null_uniform_override_border = q.is_null (18)
				and is_null_vertical_scribe_width = q.is_null (19)
				and is_null_wafer_techn = q.is_null (20)
				and is_null_wafer_techn_family = q.is_null (21)
		end

end
