
note

	date: "Thu Jan 21 12:59:47 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"PART_TYPES (MOSIS.PART_TYPES)"
			-- Included columns
			-- 	DESCR
			-- 	DISCOUNTABLE
			-- 	FAB_REVENUE
			-- 	FE_REPORTABLE
			-- 	INITIALLY_INVOICED
			-- 	PART_TYPE
			-- 	SHIPPABLE
			-- Excluded columns
			-- 	(none)

class PART_TYPES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_part_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_part_type_exists: the_part_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			part_type := the_part_type
			is_null_part_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, discountable, fab_revenue, fe_reportable, initially_invoiced,%N  part_type, shippable"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "part_types pt"

	join_condition: STRING = ""

	table_name: STRING = "part_types"

	key_where_clause: STRING = "part_type = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	discountable: BOOLEAN
			-- DB: CHAR(1) not null

	fab_revenue: BOOLEAN
			-- DB: CHAR(1) not null

	fe_reportable: BOOLEAN
			-- DB: CHAR(1) not null

	initially_invoiced: BOOLEAN
			-- DB: CHAR(1) not null

	part_type: STRING
			-- DB: VARCHAR2(10) not null

	shippable: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_discountable: BOOLEAN
	is_null_fab_revenue: BOOLEAN
	is_null_fe_reportable: BOOLEAN
	is_null_initially_invoiced: BOOLEAN
	is_null_part_type: BOOLEAN
	is_null_shippable: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (part_type, r.part_type)
			Result := Result
				and is_null_part_type = r.is_null_part_type
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and discountable = r.discountable
				and fab_revenue = r.fab_revenue
				and fe_reportable = r.fe_reportable
				and initially_invoiced = r.initially_invoiced
				and shippable = r.shippable
			Result := Result
				and equal (descr, r.descr)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_discountable = r.is_null_discountable
				and is_null_fab_revenue = r.is_null_fab_revenue
				and is_null_fe_reportable = r.is_null_fe_reportable
				and is_null_initially_invoiced = r.is_null_initially_invoiced
				and is_null_shippable = r.is_null_shippable
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_boolean (2)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_boolean (5)
			q.select_string (6, 10)
			q.select_boolean (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			discountable := q.boolean_value (2)
			fab_revenue := q.boolean_value (3)
			fe_reportable := q.boolean_value (4)
			initially_invoiced := q.boolean_value (5)
			shippable := q.boolean_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			part_type := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (6, part_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_discountable := q.is_null (2)
			is_null_fab_revenue := q.is_null (3)
			is_null_fe_reportable := q.is_null (4)
			is_null_initially_invoiced := q.is_null (5)
			is_null_part_type := q.is_null (6)
			is_null_shippable := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_part_type := True
			create part_type.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_discountable := True
			is_null_fab_revenue := True
			is_null_fe_reportable := True
			is_null_initially_invoiced := True
			is_null_shippable := True
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, part_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and discountable = q.boolean_value (2)
				and fab_revenue = q.boolean_value (3)
				and fe_reportable = q.boolean_value (4)
				and initially_invoiced = q.boolean_value (5)
				and shippable = q.boolean_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (6, s)
			Result := Result and equal (part_type, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_discountable = q.is_null (2)
				and is_null_fab_revenue = q.is_null (3)
				and is_null_fe_reportable = q.is_null (4)
				and is_null_initially_invoiced = q.is_null (5)
				and is_null_part_type = q.is_null (6)
				and is_null_shippable = q.is_null (7)
		end

end
