
note

	date: "Fri Oct 22 13:20:18 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"PRODUCTIONS (MOSIS.PRODUCTIONS)"
			-- Included columns
			-- 	DATA_ENTRY_USERNAME
			-- 	DATE_PRODUCTION_CLOSED
			-- 	DATE_TA_DATES_MODIFIED
			-- 	IS_COMPLETED
			-- 	IS_TAXI
			-- 	MASK_REVISION
			-- 	PRODUCTION_CHARGES_LOCKED
			-- 	PRODUCTION_ID
			-- 	PRODUCTION_MANAGER
			-- 	PRODUCTION_TECH
			-- 	PRODUCTION_TYPE
			-- 	RUN_ID
			-- 	TEST_ENGINEER
			-- 	TURN_AROUND_DAYS
			-- 	WAFER_PART_ID
			-- 	WAFER_PART_ID_SOURCE
			-- Excluded columns
			-- 	CHARGE_COMMENTS
			-- 	COST_COMMENTS
			-- 	RUN_REVIEW_COMMENTS

class PRODUCTIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_production_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_production_id_exists: the_production_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			production_id := the_production_id
			is_null_production_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 16

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  data_entry_username, date_production_closed, date_ta_dates_modified,%N  is_completed, is_taxi, mask_revision, production_charges_locked,%N  production_id, production_manager, production_tech, production_type,%N  run_id, test_engineer, turn_around_days, wafer_part_id,%N  wafer_part_id_source"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "productions p"

	join_condition: STRING = ""

	table_name: STRING = "productions"

	key_where_clause: STRING = "production_id = :1"

feature -- Values

	data_entry_username: STRING
			-- DB: VARCHAR2(30)

	date_production_closed: DB_DATE
			-- DB: DATE

	date_ta_dates_modified: DB_DATE
			-- DB: DATE

	is_completed: BOOLEAN
			-- DB: CHAR(1) not null

	is_taxi: BOOLEAN
			-- DB: CHAR(1) not null

	mask_revision: CHARACTER
			-- DB: CHAR(1)
			-- Eiffel type specified explicitly

	production_charges_locked: BOOLEAN
			-- DB: CHAR(1) not null

	production_id: STRING
			-- DB: VARCHAR2(10) not null

	production_manager: STRING
			-- DB: VARCHAR2(30)

	production_tech: STRING
			-- DB: VARCHAR2(30)

	production_type: STRING
			-- DB: VARCHAR2(15) not null

	run_id: STRING
			-- DB: CHAR(4)

	test_engineer: STRING
			-- DB: VARCHAR2(30)

	turn_around_days: INTEGER
			-- DB: NUMBER(3,0)

	wafer_part_id: STRING
			-- DB: VARCHAR2(50)

	wafer_part_id_source: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_data_entry_username: INTEGER = 30
	maxlen_production_id: INTEGER = 10
	maxlen_production_manager: INTEGER = 30
	maxlen_production_tech: INTEGER = 30
	maxlen_production_type: INTEGER = 15
	maxlen_run_id: INTEGER = 4
	maxlen_test_engineer: INTEGER = 30
	maxlen_wafer_part_id: INTEGER = 50
	maxlen_wafer_part_id_source: INTEGER = 50

feature -- Precisions for number columns

	precision_turn_around_days: INTEGER = 3

feature -- Scales for number columns

	scale_turn_around_days: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_data_entry_username: BOOLEAN
	is_null_date_production_closed: BOOLEAN
	is_null_date_ta_dates_modified: BOOLEAN
	is_null_mask_revision: BOOLEAN
	is_null_production_manager: BOOLEAN
	is_null_production_tech: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_test_engineer: BOOLEAN
	is_null_turn_around_days: BOOLEAN
	is_null_wafer_part_id: BOOLEAN
	is_null_wafer_part_id_source: BOOLEAN

feature -- Nullness for non-null columns

	is_null_is_completed: BOOLEAN
	is_null_is_taxi: BOOLEAN
	is_null_production_charges_locked: BOOLEAN
	is_null_production_id: BOOLEAN
	is_null_production_type: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (production_id, r.production_id)
			Result := Result
				and is_null_production_id = r.is_null_production_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_completed = r.is_completed
				and is_taxi = r.is_taxi
				and mask_revision = r.mask_revision
				and production_charges_locked = r.production_charges_locked
				and turn_around_days = r.turn_around_days
			Result := Result
				and equal (data_entry_username, r.data_entry_username)
				and equal (date_production_closed, r.date_production_closed)
				and equal (date_ta_dates_modified, r.date_ta_dates_modified)
				and equal (production_manager, r.production_manager)
				and equal (production_tech, r.production_tech)
				and equal (production_type, r.production_type)
				and equal (run_id, r.run_id)
				and equal (test_engineer, r.test_engineer)
				and equal (wafer_part_id, r.wafer_part_id)
				and equal (wafer_part_id_source, r.wafer_part_id_source)
			Result := Result
				and is_null_data_entry_username = r.is_null_data_entry_username
				and is_null_date_production_closed = r.is_null_date_production_closed
				and is_null_date_ta_dates_modified = r.is_null_date_ta_dates_modified
				and is_null_is_completed = r.is_null_is_completed
				and is_null_is_taxi = r.is_null_is_taxi
				and is_null_mask_revision = r.is_null_mask_revision
				and is_null_production_charges_locked = r.is_null_production_charges_locked
				and is_null_production_manager = r.is_null_production_manager
				and is_null_production_tech = r.is_null_production_tech
				and is_null_production_type = r.is_null_production_type
				and is_null_run_id = r.is_null_run_id
				and is_null_test_engineer = r.is_null_test_engineer
				and is_null_turn_around_days = r.is_null_turn_around_days
				and is_null_wafer_part_id = r.is_null_wafer_part_id
				and is_null_wafer_part_id_source = r.is_null_wafer_part_id_source
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_date (2)
			q.select_date (3)
			q.select_boolean (4)
			q.select_boolean (5)
			q.select_character (6)
			q.select_boolean (7)
			q.select_string (8, 10)
			q.select_string (9, 30)
			q.select_string (10, 30)
			q.select_string (11, 15)
			q.select_string (12, 4)
			q.select_string (13, 30)
			q.select_integer (14)
			q.select_string (15, 50)
			q.select_string (16, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_completed := q.boolean_value (4)
			is_taxi := q.boolean_value (5)
			mask_revision := q.character_value (6)
			production_charges_locked := q.boolean_value (7)
			turn_around_days := q.integer_value (14)
		end

	fill_in_references (q: SQL_QUERY)
		do
			data_entry_username := q.string_value (1)
			date_production_closed := q.date_value (2)
			date_ta_dates_modified := q.date_value (3)
			production_id := q.string_value (8)
			production_manager := q.string_value (9)
			production_tech := q.string_value (10)
			production_type := q.string_value (11)
			run_id := q.string_value (12)
			test_engineer := q.string_value (13)
			wafer_part_id := q.string_value (15)
			wafer_part_id_source := q.string_value (16)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, data_entry_username)
			q.get_date_value (2, date_production_closed)
			q.get_date_value (3, date_ta_dates_modified)
			q.get_string_value (8, production_id)
			q.get_string_value (9, production_manager)
			q.get_string_value (10, production_tech)
			q.get_string_value (11, production_type)
			q.get_string_value (12, run_id)
			q.get_string_value (13, test_engineer)
			q.get_string_value (15, wafer_part_id)
			q.get_string_value (16, wafer_part_id_source)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_data_entry_username := q.is_null (1)
			is_null_date_production_closed := q.is_null (2)
			is_null_date_ta_dates_modified := q.is_null (3)
			is_null_is_completed := q.is_null (4)
			is_null_is_taxi := q.is_null (5)
			is_null_mask_revision := q.is_null (6)
			is_null_production_charges_locked := q.is_null (7)
			is_null_production_id := q.is_null (8)
			is_null_production_manager := q.is_null (9)
			is_null_production_tech := q.is_null (10)
			is_null_production_type := q.is_null (11)
			is_null_run_id := q.is_null (12)
			is_null_test_engineer := q.is_null (13)
			is_null_turn_around_days := q.is_null (14)
			is_null_wafer_part_id := q.is_null (15)
			is_null_wafer_part_id_source := q.is_null (16)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_production_id := True
			create production_id.make (0)
		end

	set_null_nonkey
		do
			is_null_data_entry_username := True
			is_null_date_production_closed := True
			is_null_date_ta_dates_modified := True
			is_null_is_completed := True
			is_null_is_taxi := True
			is_null_mask_revision := True
			is_null_production_charges_locked := True
			is_null_production_manager := True
			is_null_production_tech := True
			is_null_production_type := True
			is_null_run_id := True
			is_null_test_engineer := True
			is_null_turn_around_days := True
			is_null_wafer_part_id := True
			is_null_wafer_part_id_source := True
			create data_entry_username.make (0)
			create {ORACLE_DATE} date_production_closed.set_null
			create {ORACLE_DATE} date_ta_dates_modified.set_null
			create production_manager.make (0)
			create production_tech.make (0)
			create production_type.make (0)
			create run_id.make (0)
			create test_engineer.make (0)
			create wafer_part_id.make (0)
			create wafer_part_id_source.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, production_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and is_completed = q.boolean_value (4)
				and is_taxi = q.boolean_value (5)
				and mask_revision = q.character_value (6)
				and production_charges_locked = q.boolean_value (7)
				and turn_around_days = q.integer_value (14)
			q.get_string_value (1, s)
			Result := Result and equal (data_entry_username, s)
			q.get_date_value (2, d)
			Result := Result and equal (date_production_closed, d)
			q.get_date_value (3, d)
			Result := Result and equal (date_ta_dates_modified, d)
			q.get_string_value (8, s)
			Result := Result and equal (production_id, s)
			q.get_string_value (9, s)
			Result := Result and equal (production_manager, s)
			q.get_string_value (10, s)
			Result := Result and equal (production_tech, s)
			q.get_string_value (11, s)
			Result := Result and equal (production_type, s)
			q.get_string_value (12, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (13, s)
			Result := Result and equal (test_engineer, s)
			q.get_string_value (15, s)
			Result := Result and equal (wafer_part_id, s)
			q.get_string_value (16, s)
			Result := Result and equal (wafer_part_id_source, s)
			Result := Result
				and is_null_data_entry_username = q.is_null (1)
				and is_null_date_production_closed = q.is_null (2)
				and is_null_date_ta_dates_modified = q.is_null (3)
				and is_null_is_completed = q.is_null (4)
				and is_null_is_taxi = q.is_null (5)
				and is_null_mask_revision = q.is_null (6)
				and is_null_production_charges_locked = q.is_null (7)
				and is_null_production_id = q.is_null (8)
				and is_null_production_manager = q.is_null (9)
				and is_null_production_tech = q.is_null (10)
				and is_null_production_type = q.is_null (11)
				and is_null_run_id = q.is_null (12)
				and is_null_test_engineer = q.is_null (13)
				and is_null_turn_around_days = q.is_null (14)
				and is_null_wafer_part_id = q.is_null (15)
				and is_null_wafer_part_id_source = q.is_null (16)
		end

end
