
note

	date: "Tue May  1 10:33:40 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_CUT_PATTERNS (MOSIS.RUN_CUT_PATTERNS)"
			-- Included columns
			-- 	CUT_PATTERN_NO
			-- 	CUT_PATTERN_NO_PARENT
			-- 	CUT_PATTERN_XFORM_TYPE
			-- 	EXTERNAL_CUT_DISTANCE_BOTTOM
			-- 	EXTERNAL_CUT_DISTANCE_LEFT
			-- 	EXTERNAL_CUT_DISTANCE_RIGHT
			-- 	EXTERNAL_CUT_DISTANCE_TOP
			-- 	FIELD_NAME
			-- 	PACKAGING_LOT_NO
			-- 	PRODUCTION_ID
			-- 	QUANTITY_WAFERS_NEEDED
			-- 	RUN_ID
			-- 	SAW_BLADE_WIDTH
			-- 	TIER_NO_3DIC
			-- 	WAFER_ETEST_NAME
			-- Excluded columns
			-- 	(none)

class RUN_CUT_PATTERNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_cut_pattern_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			cut_pattern_no := the_cut_pattern_no
			is_null_run_id := False
			is_null_cut_pattern_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 15

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_pattern_no, cut_pattern_no_parent, cut_pattern_xform_type,%N  external_cut_distance_bottom, external_cut_distance_left,%N  external_cut_distance_right, external_cut_distance_top, field_name,%N  packaging_lot_no, production_id, quantity_wafers_needed, run_id,%N  saw_blade_width, tier_no_3dic, wafer_etest_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_cut_patterns rcp"

	join_condition: STRING = ""

	table_name: STRING = "run_cut_patterns"

	key_where_clause: STRING = "run_id = :1 and cut_pattern_no = :2"

feature -- Values

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	cut_pattern_no_parent: INTEGER
			-- DB: NUMBER(2,0)

	cut_pattern_xform_type: STRING
			-- DB: VARCHAR2(30) not null

	external_cut_distance_bottom: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_left: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_right: DOUBLE
			-- DB: NUMBER(12,6)

	external_cut_distance_top: DOUBLE
			-- DB: NUMBER(12,6)

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	packaging_lot_no: INTEGER
			-- DB: NUMBER(3,0)

	production_id: STRING
			-- DB: VARCHAR2(10) not null

	quantity_wafers_needed: INTEGER
			-- DB: NUMBER(6,0) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	saw_blade_width: DOUBLE
			-- DB: NUMBER(6,3) not null
			-- Eiffel type specified explicitly

	tier_no_3dic: INTEGER
			-- DB: NUMBER(3,0)

	wafer_etest_name: STRING
			-- DB: VARCHAR2(50) not null

feature -- Nullness for null allowed columns

	is_null_cut_pattern_no_parent: BOOLEAN
	is_null_external_cut_distance_bottom: BOOLEAN
	is_null_external_cut_distance_left: BOOLEAN
	is_null_external_cut_distance_right: BOOLEAN
	is_null_external_cut_distance_top: BOOLEAN
	is_null_packaging_lot_no: BOOLEAN
	is_null_tier_no_3dic: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cut_pattern_no: BOOLEAN
	is_null_cut_pattern_xform_type: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_production_id: BOOLEAN
	is_null_quantity_wafers_needed: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_saw_blade_width: BOOLEAN
	is_null_wafer_etest_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no = r.cut_pattern_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no_parent = r.cut_pattern_no_parent
				and external_cut_distance_bottom = r.external_cut_distance_bottom
				and external_cut_distance_left = r.external_cut_distance_left
				and external_cut_distance_right = r.external_cut_distance_right
				and external_cut_distance_top = r.external_cut_distance_top
				and packaging_lot_no = r.packaging_lot_no
				and quantity_wafers_needed = r.quantity_wafers_needed
				and saw_blade_width = r.saw_blade_width
				and tier_no_3dic = r.tier_no_3dic
			Result := Result
				and equal (cut_pattern_xform_type, r.cut_pattern_xform_type)
				and equal (field_name, r.field_name)
				and equal (production_id, r.production_id)
				and equal (wafer_etest_name, r.wafer_etest_name)
			Result := Result
				and is_null_cut_pattern_no_parent = r.is_null_cut_pattern_no_parent
				and is_null_cut_pattern_xform_type = r.is_null_cut_pattern_xform_type
				and is_null_external_cut_distance_bottom = r.is_null_external_cut_distance_bottom
				and is_null_external_cut_distance_left = r.is_null_external_cut_distance_left
				and is_null_external_cut_distance_right = r.is_null_external_cut_distance_right
				and is_null_external_cut_distance_top = r.is_null_external_cut_distance_top
				and is_null_field_name = r.is_null_field_name
				and is_null_packaging_lot_no = r.is_null_packaging_lot_no
				and is_null_production_id = r.is_null_production_id
				and is_null_quantity_wafers_needed = r.is_null_quantity_wafers_needed
				and is_null_saw_blade_width = r.is_null_saw_blade_width
				and is_null_tier_no_3dic = r.is_null_tier_no_3dic
				and is_null_wafer_etest_name = r.is_null_wafer_etest_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_string (3, 30)
			q.select_double (4)
			q.select_double (5)
			q.select_double (6)
			q.select_double (7)
			q.select_string (8, 20)
			q.select_integer (9)
			q.select_string (10, 10)
			q.select_integer (11)
			q.select_string (12, 4)
			q.select_double (13)
			q.select_integer (14)
			q.select_string (15, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_pattern_no := q.integer_value (1)
			cut_pattern_no_parent := q.integer_value (2)
			external_cut_distance_bottom := q.double_value (4)
			external_cut_distance_left := q.double_value (5)
			external_cut_distance_right := q.double_value (6)
			external_cut_distance_top := q.double_value (7)
			packaging_lot_no := q.integer_value (9)
			quantity_wafers_needed := q.integer_value (11)
			saw_blade_width := q.double_value (13)
			tier_no_3dic := q.integer_value (14)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cut_pattern_xform_type := q.string_value (3)
			field_name := q.string_value (8)
			production_id := q.string_value (10)
			run_id := q.string_value (12)
			wafer_etest_name := q.string_value (15)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, cut_pattern_xform_type)
			q.get_string_value (8, field_name)
			q.get_string_value (10, production_id)
			q.get_string_value (12, run_id)
			q.get_string_value (15, wafer_etest_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_pattern_no := q.is_null (1)
			is_null_cut_pattern_no_parent := q.is_null (2)
			is_null_cut_pattern_xform_type := q.is_null (3)
			is_null_external_cut_distance_bottom := q.is_null (4)
			is_null_external_cut_distance_left := q.is_null (5)
			is_null_external_cut_distance_right := q.is_null (6)
			is_null_external_cut_distance_top := q.is_null (7)
			is_null_field_name := q.is_null (8)
			is_null_packaging_lot_no := q.is_null (9)
			is_null_production_id := q.is_null (10)
			is_null_quantity_wafers_needed := q.is_null (11)
			is_null_run_id := q.is_null (12)
			is_null_saw_blade_width := q.is_null (13)
			is_null_tier_no_3dic := q.is_null (14)
			is_null_wafer_etest_name := q.is_null (15)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_cut_pattern_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_cut_pattern_no_parent := True
			is_null_cut_pattern_xform_type := True
			is_null_external_cut_distance_bottom := True
			is_null_external_cut_distance_left := True
			is_null_external_cut_distance_right := True
			is_null_external_cut_distance_top := True
			is_null_field_name := True
			is_null_packaging_lot_no := True
			is_null_production_id := True
			is_null_quantity_wafers_needed := True
			is_null_saw_blade_width := True
			is_null_tier_no_3dic := True
			is_null_wafer_etest_name := True
			create cut_pattern_xform_type.make (0)
			create field_name.make (0)
			create production_id.make (0)
			create wafer_etest_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, cut_pattern_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_pattern_no = q.integer_value (1)
				and cut_pattern_no_parent = q.integer_value (2)
				and external_cut_distance_bottom = q.double_value (4)
				and external_cut_distance_left = q.double_value (5)
				and external_cut_distance_right = q.double_value (6)
				and external_cut_distance_top = q.double_value (7)
				and packaging_lot_no = q.integer_value (9)
				and quantity_wafers_needed = q.integer_value (11)
				and saw_blade_width = q.double_value (13)
				and tier_no_3dic = q.integer_value (14)
			q.get_string_value (3, s)
			Result := Result and equal (cut_pattern_xform_type, s)
			q.get_string_value (8, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (10, s)
			Result := Result and equal (production_id, s)
			q.get_string_value (12, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (15, s)
			Result := Result and equal (wafer_etest_name, s)
			Result := Result
				and is_null_cut_pattern_no = q.is_null (1)
				and is_null_cut_pattern_no_parent = q.is_null (2)
				and is_null_cut_pattern_xform_type = q.is_null (3)
				and is_null_external_cut_distance_bottom = q.is_null (4)
				and is_null_external_cut_distance_left = q.is_null (5)
				and is_null_external_cut_distance_right = q.is_null (6)
				and is_null_external_cut_distance_top = q.is_null (7)
				and is_null_field_name = q.is_null (8)
				and is_null_packaging_lot_no = q.is_null (9)
				and is_null_production_id = q.is_null (10)
				and is_null_quantity_wafers_needed = q.is_null (11)
				and is_null_run_id = q.is_null (12)
				and is_null_saw_blade_width = q.is_null (13)
				and is_null_tier_no_3dic = q.is_null (14)
				and is_null_wafer_etest_name = q.is_null (15)
		end

end
