
note

	date: "Thu Jan 21 12:59:48 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"RUN_EVENTS (MOSIS.RUN_EVENTS)"
			-- Included columns
			-- 	ACTUAL_DATE
			-- 	COMMENTS
			-- 	DATE_EVENT
			-- 	EVENT_NAME
			-- 	RUN_ID
			-- 	SIGNIFICANT
			-- Excluded columns
			-- 	(none)

class RUN_EVENTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_event_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
			the_event_name_exists: the_event_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			event_name := the_event_name
			is_null_run_id := False
			is_null_event_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  actual_date, comments, date_event, event_name, run_id, significant"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_events re"

	join_condition: STRING = ""

	table_name: STRING = "run_events"

	key_where_clause: STRING = "run_id = :1 and event_name = :2"

feature -- Values

	actual_date: BOOLEAN
			-- DB: CHAR(1) not null

	comments: STRING
			-- DB: VARCHAR2(255)

	date_event: DB_DATE
			-- DB: DATE not null

	event_name: STRING
			-- DB: VARCHAR2(30) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	significant: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN

feature -- Nullness for non-null columns

	is_null_actual_date: BOOLEAN
	is_null_date_event: BOOLEAN
	is_null_event_name: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_significant: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (event_name, r.event_name)
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_event_name = r.is_null_event_name
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and actual_date = r.actual_date
				and significant = r.significant
			Result := Result
				and equal (comments, r.comments)
				and equal (date_event, r.date_event)
			Result := Result
				and is_null_actual_date = r.is_null_actual_date
				and is_null_comments = r.is_null_comments
				and is_null_date_event = r.is_null_date_event
				and is_null_significant = r.is_null_significant
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_string (2, 255)
			q.select_date (3)
			q.select_string (4, 30)
			q.select_string (5, 4)
			q.select_boolean (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			actual_date := q.boolean_value (1)
			significant := q.boolean_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (2)
			date_event := q.date_value (3)
			event_name := q.string_value (4)
			run_id := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, comments)
			q.get_date_value (3, date_event)
			q.get_string_value (4, event_name)
			q.get_string_value (5, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_actual_date := q.is_null (1)
			is_null_comments := q.is_null (2)
			is_null_date_event := q.is_null (3)
			is_null_event_name := q.is_null (4)
			is_null_run_id := q.is_null (5)
			is_null_significant := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_event_name := True
			create run_id.make (0)
			create event_name.make (0)
		end

	set_null_nonkey
		do
			is_null_actual_date := True
			is_null_comments := True
			is_null_date_event := True
			is_null_significant := True
			create comments.make (0)
			create {ORACLE_DATE} date_event.set_null
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_string (2, event_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and actual_date = q.boolean_value (1)
				and significant = q.boolean_value (6)
			q.get_string_value (2, s)
			Result := Result and equal (comments, s)
			q.get_date_value (3, d)
			Result := Result and equal (date_event, d)
			q.get_string_value (4, s)
			Result := Result and equal (event_name, s)
			q.get_string_value (5, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_actual_date = q.is_null (1)
				and is_null_comments = q.is_null (2)
				and is_null_date_event = q.is_null (3)
				and is_null_event_name = q.is_null (4)
				and is_null_run_id = q.is_null (5)
				and is_null_significant = q.is_null (6)
		end

end
