
note

	date: "Mon Apr 30 16:01:59 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_PACKAGING_LOTS (MOSIS.RUN_PACKAGING_LOTS)"
			-- Included columns
			-- 	COMMENTS
			-- 	DATE_RECEIVED
			-- 	DATE_RECEIVED_STATUS
			-- 	DATE_SENT
			-- 	DIE_THICKNESS_MILS
			-- 	IS_ACTUAL_DATE_SENT
			-- 	IS_DIE_FORM
			-- 	PACKAGING_LOT_NO
			-- 	PACKAGING_ORDER_TYPE
			-- 	PACKAGING_ORG_NO
			-- 	PRODUCTION_ID
			-- 	QUANTITY_WAFERS_SENT
			-- 	RUN_ID
			-- 	WAFER_PROCESS
			-- Excluded columns
			-- 	(none)

class RUN_PACKAGING_LOTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_packaging_lot_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			packaging_lot_no := the_packaging_lot_no
			is_null_run_id := False
			is_null_packaging_lot_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 14

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, date_received, date_received_status, date_sent,%N  die_thickness_mils, is_actual_date_sent, is_die_form, packaging_lot_no,%N  packaging_order_type, packaging_org_no, production_id,%N  quantity_wafers_sent, run_id, wafer_process"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_packaging_lots rpl"

	join_condition: STRING = ""

	table_name: STRING = "run_packaging_lots"

	key_where_clause: STRING = "run_id = :1 and packaging_lot_no = :2"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(250)

	date_received: DB_DATE
			-- DB: DATE

	date_received_status: STRING
			-- DB: VARCHAR2(20)

	date_sent: DB_DATE
			-- DB: DATE

	die_thickness_mils: REAL
			-- DB: NUMBER(6,3)

	is_actual_date_sent: BOOLEAN
			-- DB: CHAR(1) not null

	is_die_form: BOOLEAN
			-- DB: CHAR(1) not null

	packaging_lot_no: INTEGER
			-- DB: NUMBER(3,0) not null

	packaging_order_type: STRING
			-- DB: VARCHAR2(10) not null

	packaging_org_no: INTEGER
			-- DB: NUMBER(6,0) not null

	production_id: STRING
			-- DB: VARCHAR2(10) not null

	quantity_wafers_sent: INTEGER
			-- DB: NUMBER(6,0)

	run_id: STRING
			-- DB: CHAR(4) not null

	wafer_process: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_comments: INTEGER = 250
	maxlen_date_received_status: INTEGER = 20
	maxlen_packaging_order_type: INTEGER = 10
	maxlen_production_id: INTEGER = 10
	maxlen_run_id: INTEGER = 4
	maxlen_wafer_process: INTEGER = 50

feature -- Precisions for number columns

	precision_die_thickness_mils: INTEGER = 6
	precision_packaging_lot_no: INTEGER = 3
	precision_packaging_org_no: INTEGER = 6
	precision_quantity_wafers_sent: INTEGER = 6

feature -- Scales for number columns

	scale_die_thickness_mils: INTEGER = 3
	scale_packaging_lot_no: INTEGER = 0
	scale_packaging_org_no: INTEGER = 0
	scale_quantity_wafers_sent: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_date_received: BOOLEAN
	is_null_date_received_status: BOOLEAN
	is_null_date_sent: BOOLEAN
	is_null_die_thickness_mils: BOOLEAN
	is_null_quantity_wafers_sent: BOOLEAN
	is_null_wafer_process: BOOLEAN

feature -- Nullness for non-null columns

	is_null_is_actual_date_sent: BOOLEAN
	is_null_is_die_form: BOOLEAN
	is_null_packaging_lot_no: BOOLEAN
	is_null_packaging_order_type: BOOLEAN
	is_null_packaging_org_no: BOOLEAN
	is_null_production_id: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and packaging_lot_no = r.packaging_lot_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_packaging_lot_no = r.is_null_packaging_lot_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and die_thickness_mils = r.die_thickness_mils
				and is_actual_date_sent = r.is_actual_date_sent
				and is_die_form = r.is_die_form
				and packaging_org_no = r.packaging_org_no
				and quantity_wafers_sent = r.quantity_wafers_sent
			Result := Result
				and equal (comments, r.comments)
				and equal (date_received, r.date_received)
				and equal (date_received_status, r.date_received_status)
				and equal (date_sent, r.date_sent)
				and equal (packaging_order_type, r.packaging_order_type)
				and equal (production_id, r.production_id)
				and equal (wafer_process, r.wafer_process)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_date_received = r.is_null_date_received
				and is_null_date_received_status = r.is_null_date_received_status
				and is_null_date_sent = r.is_null_date_sent
				and is_null_die_thickness_mils = r.is_null_die_thickness_mils
				and is_null_is_actual_date_sent = r.is_null_is_actual_date_sent
				and is_null_is_die_form = r.is_null_is_die_form
				and is_null_packaging_order_type = r.is_null_packaging_order_type
				and is_null_packaging_org_no = r.is_null_packaging_org_no
				and is_null_production_id = r.is_null_production_id
				and is_null_quantity_wafers_sent = r.is_null_quantity_wafers_sent
				and is_null_wafer_process = r.is_null_wafer_process
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 250)
			q.select_date (2)
			q.select_string (3, 20)
			q.select_date (4)
			q.select_real (5)
			q.select_boolean (6)
			q.select_boolean (7)
			q.select_integer (8)
			q.select_string (9, 10)
			q.select_integer (10)
			q.select_string (11, 10)
			q.select_integer (12)
			q.select_string (13, 4)
			q.select_string (14, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			die_thickness_mils := q.real_value (5)
			is_actual_date_sent := q.boolean_value (6)
			is_die_form := q.boolean_value (7)
			packaging_lot_no := q.integer_value (8)
			packaging_org_no := q.integer_value (10)
			quantity_wafers_sent := q.integer_value (12)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			date_received := q.date_value (2)
			date_received_status := q.string_value (3)
			date_sent := q.date_value (4)
			packaging_order_type := q.string_value (9)
			production_id := q.string_value (11)
			run_id := q.string_value (13)
			wafer_process := q.string_value (14)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_date_value (2, date_received)
			q.get_string_value (3, date_received_status)
			q.get_date_value (4, date_sent)
			q.get_string_value (9, packaging_order_type)
			q.get_string_value (11, production_id)
			q.get_string_value (13, run_id)
			q.get_string_value (14, wafer_process)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_date_received := q.is_null (2)
			is_null_date_received_status := q.is_null (3)
			is_null_date_sent := q.is_null (4)
			is_null_die_thickness_mils := q.is_null (5)
			is_null_is_actual_date_sent := q.is_null (6)
			is_null_is_die_form := q.is_null (7)
			is_null_packaging_lot_no := q.is_null (8)
			is_null_packaging_order_type := q.is_null (9)
			is_null_packaging_org_no := q.is_null (10)
			is_null_production_id := q.is_null (11)
			is_null_quantity_wafers_sent := q.is_null (12)
			is_null_run_id := q.is_null (13)
			is_null_wafer_process := q.is_null (14)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_packaging_lot_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_date_received := True
			is_null_date_received_status := True
			is_null_date_sent := True
			is_null_die_thickness_mils := True
			is_null_is_actual_date_sent := True
			is_null_is_die_form := True
			is_null_packaging_order_type := True
			is_null_packaging_org_no := True
			is_null_production_id := True
			is_null_quantity_wafers_sent := True
			is_null_wafer_process := True
			create comments.make (0)
			create {ORACLE_DATE} date_received.set_null
			create date_received_status.make (0)
			create {ORACLE_DATE} date_sent.set_null
			create packaging_order_type.make (0)
			create production_id.make (0)
			create wafer_process.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, packaging_lot_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and die_thickness_mils = q.real_value (5)
				and is_actual_date_sent = q.boolean_value (6)
				and is_die_form = q.boolean_value (7)
				and packaging_lot_no = q.integer_value (8)
				and packaging_org_no = q.integer_value (10)
				and quantity_wafers_sent = q.integer_value (12)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_date_value (2, d)
			Result := Result and equal (date_received, d)
			q.get_string_value (3, s)
			Result := Result and equal (date_received_status, s)
			q.get_date_value (4, d)
			Result := Result and equal (date_sent, d)
			q.get_string_value (9, s)
			Result := Result and equal (packaging_order_type, s)
			q.get_string_value (11, s)
			Result := Result and equal (production_id, s)
			q.get_string_value (13, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (14, s)
			Result := Result and equal (wafer_process, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_date_received = q.is_null (2)
				and is_null_date_received_status = q.is_null (3)
				and is_null_date_sent = q.is_null (4)
				and is_null_die_thickness_mils = q.is_null (5)
				and is_null_is_actual_date_sent = q.is_null (6)
				and is_null_is_die_form = q.is_null (7)
				and is_null_packaging_lot_no = q.is_null (8)
				and is_null_packaging_order_type = q.is_null (9)
				and is_null_packaging_org_no = q.is_null (10)
				and is_null_production_id = q.is_null (11)
				and is_null_quantity_wafers_sent = q.is_null (12)
				and is_null_run_id = q.is_null (13)
				and is_null_wafer_process = q.is_null (14)
		end

end
