
note

	date: "Tue Nov 27 13:33:12 2012"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ROGERS"
	database_tables: 
		"RUN_WAFER_LOTS (MOSIS.RUN_WAFER_LOTS)"
			-- Included columns
			-- 	COMMENTS
			-- 	CUST_PART_ID
			-- 	DATE_ACCEPTED
			-- 	DATE_CUST_REQUESTED
			-- 	DATE_PROCESSING_STATUS_UPDATED
			-- 	DATE_RECEIVED
			-- 	DATE_RECEIVED_STATUS
			-- 	DATE_TARGET_ESTABLISHED
			-- 	FIELD_STEP_PATTERN
			-- 	FIELD_STEP_PATTERN_OFFSET_X
			-- 	FIELD_STEP_PATTERN_OFFSET_Y
			-- 	PROCESSING_PERCENT_COMPLETE
			-- 	PROCESSING_STAGE
			-- 	PROCESSING_STAGE_NO
			-- 	PRODUCTION_ID
			-- 	QUANTITY_WAFERS_ORDERED
			-- 	QUANTITY_WAFERS_ORDERED_WO_DFC
			-- 	QUANTITY_WAFERS_RECEIVED
			-- 	RUN_ID
			-- 	VENDOR_ADDITIONAL_LOT_ID
			-- 	VENDOR_PCM_DATA_FILENAME
			-- 	VENDOR_TARGET_DATE
			-- 	WAFER_LOT_NO
			-- 	WAFER_PROCESS
			-- 	WAFER_VENDOR_LOT_ID
			-- Excluded columns
			-- 	WIP_CUSTOMER_UPDATE_SENT
			-- 	WIP_DATE_STATUS_UPDATED
			-- 	WIP_NOT_EXPECTED
			-- 	WIP_PERCENT_COMPLETE
			-- 	WIP_PERFORM_UPDATE
			-- 	WIP_PROCESSING_STAGE
			-- 	WIP_PROCESSING_STAGE_NO
			-- 	WIP_REVIEW_UPDATE

class RUN_WAFER_LOTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_wafer_lot_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			wafer_lot_no := the_wafer_lot_no
			is_null_run_id := False
			is_null_wafer_lot_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 25

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, cust_part_id, date_accepted, date_cust_requested,%N  date_processing_status_updated, date_received, date_received_status,%N  date_target_established, field_step_pattern, field_step_pattern_offset_x,%N  field_step_pattern_offset_y, processing_percent_complete,%N  processing_stage, processing_stage_no, production_id,%N  quantity_wafers_ordered, quantity_wafers_ordered_wo_dfc,%N  quantity_wafers_received, run_id, vendor_additional_lot_id,%N  vendor_pcm_data_filename, vendor_target_date, wafer_lot_no,%N  wafer_process, wafer_vendor_lot_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_wafer_lots rwl"

	join_condition: STRING = ""

	table_name: STRING = "run_wafer_lots"

	key_where_clause: STRING = "run_id = :1 and wafer_lot_no = :2"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(500)

	cust_part_id: STRING
			-- DB: VARCHAR2(20)

	date_accepted: DB_DATE
			-- DB: DATE

	date_cust_requested: DB_DATE
			-- DB: DATE

	date_processing_status_updated: DB_DATE
			-- DB: DATE

	date_received: DB_DATE
			-- DB: DATE

	date_received_status: STRING
			-- DB: VARCHAR2(20)

	date_target_established: DB_DATE
			-- DB: DATE

	field_step_pattern: STRING
			-- DB: VARCHAR2(30)

	field_step_pattern_offset_x: DOUBLE
			-- DB: NUMBER(*,*)

	field_step_pattern_offset_y: DOUBLE
			-- DB: NUMBER(*,*)

	processing_percent_complete: DOUBLE
			-- DB: NUMBER(*,*)

	processing_stage: STRING
			-- DB: VARCHAR2(50)

	processing_stage_no: INTEGER
			-- DB: NUMBER(9,0)

	production_id: STRING
			-- DB: VARCHAR2(10) not null

	quantity_wafers_ordered: INTEGER
			-- DB: NUMBER(6,0)

	quantity_wafers_ordered_wo_dfc: INTEGER
			-- DB: NUMBER(6,0)

	quantity_wafers_received: INTEGER
			-- DB: NUMBER(6,0)

	run_id: STRING
			-- DB: CHAR(4) not null

	vendor_additional_lot_id: STRING
			-- DB: VARCHAR2(50)

	vendor_pcm_data_filename: STRING
			-- DB: VARCHAR2(200)

	vendor_target_date: DB_DATE
			-- DB: DATE

	wafer_lot_no: INTEGER
			-- DB: NUMBER(3,0) not null

	wafer_process: STRING
			-- DB: VARCHAR2(50) not null

	wafer_vendor_lot_id: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_comments: INTEGER = 500
	maxlen_cust_part_id: INTEGER = 20
	maxlen_date_received_status: INTEGER = 20
	maxlen_field_step_pattern: INTEGER = 30
	maxlen_processing_stage: INTEGER = 50
	maxlen_production_id: INTEGER = 10
	maxlen_run_id: INTEGER = 4
	maxlen_vendor_additional_lot_id: INTEGER = 50
	maxlen_vendor_pcm_data_filename: INTEGER = 200
	maxlen_wafer_process: INTEGER = 50
	maxlen_wafer_vendor_lot_id: INTEGER = 50

feature -- Precisions for number columns

	precision_field_step_pattern_offset_x: INTEGER = 38
	precision_field_step_pattern_offset_y: INTEGER = 38
	precision_processing_percent_complete: INTEGER = 38
	precision_processing_stage_no: INTEGER = 9
	precision_quantity_wafers_ordered: INTEGER = 6
	precision_quantity_wafers_ordered_wo_dfc: INTEGER = 6
	precision_quantity_wafers_received: INTEGER = 6
	precision_wafer_lot_no: INTEGER = 3

feature -- Scales for number columns

	scale_processing_stage_no: INTEGER = 0
	scale_quantity_wafers_ordered: INTEGER = 0
	scale_quantity_wafers_ordered_wo_dfc: INTEGER = 0
	scale_quantity_wafers_received: INTEGER = 0
	scale_wafer_lot_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_cust_part_id: BOOLEAN
	is_null_date_accepted: BOOLEAN
	is_null_date_cust_requested: BOOLEAN
	is_null_date_processing_status_updated: BOOLEAN
	is_null_date_received: BOOLEAN
	is_null_date_received_status: BOOLEAN
	is_null_date_target_established: BOOLEAN
	is_null_field_step_pattern: BOOLEAN
	is_null_field_step_pattern_offset_x: BOOLEAN
	is_null_field_step_pattern_offset_y: BOOLEAN
	is_null_processing_percent_complete: BOOLEAN
	is_null_processing_stage: BOOLEAN
	is_null_processing_stage_no: BOOLEAN
	is_null_quantity_wafers_ordered: BOOLEAN
	is_null_quantity_wafers_ordered_wo_dfc: BOOLEAN
	is_null_quantity_wafers_received: BOOLEAN
	is_null_vendor_additional_lot_id: BOOLEAN
	is_null_vendor_pcm_data_filename: BOOLEAN
	is_null_vendor_target_date: BOOLEAN
	is_null_wafer_vendor_lot_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_production_id: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_wafer_lot_no: BOOLEAN
	is_null_wafer_process: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and wafer_lot_no = r.wafer_lot_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_run_id = r.is_null_run_id
				and is_null_wafer_lot_no = r.is_null_wafer_lot_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and field_step_pattern_offset_x = r.field_step_pattern_offset_x
				and field_step_pattern_offset_y = r.field_step_pattern_offset_y
				and processing_percent_complete = r.processing_percent_complete
				and processing_stage_no = r.processing_stage_no
				and quantity_wafers_ordered = r.quantity_wafers_ordered
				and quantity_wafers_ordered_wo_dfc = r.quantity_wafers_ordered_wo_dfc
				and quantity_wafers_received = r.quantity_wafers_received
			Result := Result
				and equal (comments, r.comments)
				and equal (cust_part_id, r.cust_part_id)
				and equal (date_accepted, r.date_accepted)
				and equal (date_cust_requested, r.date_cust_requested)
				and equal (date_processing_status_updated, r.date_processing_status_updated)
				and equal (date_received, r.date_received)
				and equal (date_received_status, r.date_received_status)
				and equal (date_target_established, r.date_target_established)
				and equal (field_step_pattern, r.field_step_pattern)
				and equal (processing_stage, r.processing_stage)
				and equal (production_id, r.production_id)
				and equal (vendor_additional_lot_id, r.vendor_additional_lot_id)
				and equal (vendor_pcm_data_filename, r.vendor_pcm_data_filename)
				and equal (vendor_target_date, r.vendor_target_date)
				and equal (wafer_process, r.wafer_process)
				and equal (wafer_vendor_lot_id, r.wafer_vendor_lot_id)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_cust_part_id = r.is_null_cust_part_id
				and is_null_date_accepted = r.is_null_date_accepted
				and is_null_date_cust_requested = r.is_null_date_cust_requested
				and is_null_date_processing_status_updated = r.is_null_date_processing_status_updated
				and is_null_date_received = r.is_null_date_received
				and is_null_date_received_status = r.is_null_date_received_status
				and is_null_date_target_established = r.is_null_date_target_established
				and is_null_field_step_pattern = r.is_null_field_step_pattern
				and is_null_field_step_pattern_offset_x = r.is_null_field_step_pattern_offset_x
				and is_null_field_step_pattern_offset_y = r.is_null_field_step_pattern_offset_y
				and is_null_processing_percent_complete = r.is_null_processing_percent_complete
				and is_null_processing_stage = r.is_null_processing_stage
				and is_null_processing_stage_no = r.is_null_processing_stage_no
				and is_null_production_id = r.is_null_production_id
				and is_null_quantity_wafers_ordered = r.is_null_quantity_wafers_ordered
				and is_null_quantity_wafers_ordered_wo_dfc = r.is_null_quantity_wafers_ordered_wo_dfc
				and is_null_quantity_wafers_received = r.is_null_quantity_wafers_received
				and is_null_vendor_additional_lot_id = r.is_null_vendor_additional_lot_id
				and is_null_vendor_pcm_data_filename = r.is_null_vendor_pcm_data_filename
				and is_null_vendor_target_date = r.is_null_vendor_target_date
				and is_null_wafer_process = r.is_null_wafer_process
				and is_null_wafer_vendor_lot_id = r.is_null_wafer_vendor_lot_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 500)
			q.select_string (2, 20)
			q.select_date (3)
			q.select_date (4)
			q.select_date (5)
			q.select_date (6)
			q.select_string (7, 20)
			q.select_date (8)
			q.select_string (9, 30)
			q.select_double (10)
			q.select_double (11)
			q.select_double (12)
			q.select_string (13, 50)
			q.select_integer (14)
			q.select_string (15, 10)
			q.select_integer (16)
			q.select_integer (17)
			q.select_integer (18)
			q.select_string (19, 4)
			q.select_string (20, 50)
			q.select_string (21, 200)
			q.select_date (22)
			q.select_integer (23)
			q.select_string (24, 50)
			q.select_string (25, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			field_step_pattern_offset_x := q.double_value (10)
			field_step_pattern_offset_y := q.double_value (11)
			processing_percent_complete := q.double_value (12)
			processing_stage_no := q.integer_value (14)
			quantity_wafers_ordered := q.integer_value (16)
			quantity_wafers_ordered_wo_dfc := q.integer_value (17)
			quantity_wafers_received := q.integer_value (18)
			wafer_lot_no := q.integer_value (23)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			cust_part_id := q.string_value (2)
			date_accepted := q.date_value (3)
			date_cust_requested := q.date_value (4)
			date_processing_status_updated := q.date_value (5)
			date_received := q.date_value (6)
			date_received_status := q.string_value (7)
			date_target_established := q.date_value (8)
			field_step_pattern := q.string_value (9)
			processing_stage := q.string_value (13)
			production_id := q.string_value (15)
			run_id := q.string_value (19)
			vendor_additional_lot_id := q.string_value (20)
			vendor_pcm_data_filename := q.string_value (21)
			vendor_target_date := q.date_value (22)
			wafer_process := q.string_value (24)
			wafer_vendor_lot_id := q.string_value (25)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (2, cust_part_id)
			q.get_date_value (3, date_accepted)
			q.get_date_value (4, date_cust_requested)
			q.get_date_value (5, date_processing_status_updated)
			q.get_date_value (6, date_received)
			q.get_string_value (7, date_received_status)
			q.get_date_value (8, date_target_established)
			q.get_string_value (9, field_step_pattern)
			q.get_string_value (13, processing_stage)
			q.get_string_value (15, production_id)
			q.get_string_value (19, run_id)
			q.get_string_value (20, vendor_additional_lot_id)
			q.get_string_value (21, vendor_pcm_data_filename)
			q.get_date_value (22, vendor_target_date)
			q.get_string_value (24, wafer_process)
			q.get_string_value (25, wafer_vendor_lot_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_cust_part_id := q.is_null (2)
			is_null_date_accepted := q.is_null (3)
			is_null_date_cust_requested := q.is_null (4)
			is_null_date_processing_status_updated := q.is_null (5)
			is_null_date_received := q.is_null (6)
			is_null_date_received_status := q.is_null (7)
			is_null_date_target_established := q.is_null (8)
			is_null_field_step_pattern := q.is_null (9)
			is_null_field_step_pattern_offset_x := q.is_null (10)
			is_null_field_step_pattern_offset_y := q.is_null (11)
			is_null_processing_percent_complete := q.is_null (12)
			is_null_processing_stage := q.is_null (13)
			is_null_processing_stage_no := q.is_null (14)
			is_null_production_id := q.is_null (15)
			is_null_quantity_wafers_ordered := q.is_null (16)
			is_null_quantity_wafers_ordered_wo_dfc := q.is_null (17)
			is_null_quantity_wafers_received := q.is_null (18)
			is_null_run_id := q.is_null (19)
			is_null_vendor_additional_lot_id := q.is_null (20)
			is_null_vendor_pcm_data_filename := q.is_null (21)
			is_null_vendor_target_date := q.is_null (22)
			is_null_wafer_lot_no := q.is_null (23)
			is_null_wafer_process := q.is_null (24)
			is_null_wafer_vendor_lot_id := q.is_null (25)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_wafer_lot_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_cust_part_id := True
			is_null_date_accepted := True
			is_null_date_cust_requested := True
			is_null_date_processing_status_updated := True
			is_null_date_received := True
			is_null_date_received_status := True
			is_null_date_target_established := True
			is_null_field_step_pattern := True
			is_null_field_step_pattern_offset_x := True
			is_null_field_step_pattern_offset_y := True
			is_null_processing_percent_complete := True
			is_null_processing_stage := True
			is_null_processing_stage_no := True
			is_null_production_id := True
			is_null_quantity_wafers_ordered := True
			is_null_quantity_wafers_ordered_wo_dfc := True
			is_null_quantity_wafers_received := True
			is_null_vendor_additional_lot_id := True
			is_null_vendor_pcm_data_filename := True
			is_null_vendor_target_date := True
			is_null_wafer_process := True
			is_null_wafer_vendor_lot_id := True
			create comments.make (0)
			create cust_part_id.make (0)
			create {ORACLE_DATE} date_accepted.set_null
			create {ORACLE_DATE} date_cust_requested.set_null
			create {ORACLE_DATE} date_processing_status_updated.set_null
			create {ORACLE_DATE} date_received.set_null
			create date_received_status.make (0)
			create {ORACLE_DATE} date_target_established.set_null
			create field_step_pattern.make (0)
			create processing_stage.make (0)
			create production_id.make (0)
			create vendor_additional_lot_id.make (0)
			create vendor_pcm_data_filename.make (0)
			create {ORACLE_DATE} vendor_target_date.set_null
			create wafer_process.make (0)
			create wafer_vendor_lot_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, wafer_lot_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and field_step_pattern_offset_x = q.double_value (10)
				and field_step_pattern_offset_y = q.double_value (11)
				and processing_percent_complete = q.double_value (12)
				and processing_stage_no = q.integer_value (14)
				and quantity_wafers_ordered = q.integer_value (16)
				and quantity_wafers_ordered_wo_dfc = q.integer_value (17)
				and quantity_wafers_received = q.integer_value (18)
				and wafer_lot_no = q.integer_value (23)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (2, s)
			Result := Result and equal (cust_part_id, s)
			q.get_date_value (3, d)
			Result := Result and equal (date_accepted, d)
			q.get_date_value (4, d)
			Result := Result and equal (date_cust_requested, d)
			q.get_date_value (5, d)
			Result := Result and equal (date_processing_status_updated, d)
			q.get_date_value (6, d)
			Result := Result and equal (date_received, d)
			q.get_string_value (7, s)
			Result := Result and equal (date_received_status, s)
			q.get_date_value (8, d)
			Result := Result and equal (date_target_established, d)
			q.get_string_value (9, s)
			Result := Result and equal (field_step_pattern, s)
			q.get_string_value (13, s)
			Result := Result and equal (processing_stage, s)
			q.get_string_value (15, s)
			Result := Result and equal (production_id, s)
			q.get_string_value (19, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (20, s)
			Result := Result and equal (vendor_additional_lot_id, s)
			q.get_string_value (21, s)
			Result := Result and equal (vendor_pcm_data_filename, s)
			q.get_date_value (22, d)
			Result := Result and equal (vendor_target_date, d)
			q.get_string_value (24, s)
			Result := Result and equal (wafer_process, s)
			q.get_string_value (25, s)
			Result := Result and equal (wafer_vendor_lot_id, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_cust_part_id = q.is_null (2)
				and is_null_date_accepted = q.is_null (3)
				and is_null_date_cust_requested = q.is_null (4)
				and is_null_date_processing_status_updated = q.is_null (5)
				and is_null_date_received = q.is_null (6)
				and is_null_date_received_status = q.is_null (7)
				and is_null_date_target_established = q.is_null (8)
				and is_null_field_step_pattern = q.is_null (9)
				and is_null_field_step_pattern_offset_x = q.is_null (10)
				and is_null_field_step_pattern_offset_y = q.is_null (11)
				and is_null_processing_percent_complete = q.is_null (12)
				and is_null_processing_stage = q.is_null (13)
				and is_null_processing_stage_no = q.is_null (14)
				and is_null_production_id = q.is_null (15)
				and is_null_quantity_wafers_ordered = q.is_null (16)
				and is_null_quantity_wafers_ordered_wo_dfc = q.is_null (17)
				and is_null_quantity_wafers_received = q.is_null (18)
				and is_null_run_id = q.is_null (19)
				and is_null_vendor_additional_lot_id = q.is_null (20)
				and is_null_vendor_pcm_data_filename = q.is_null (21)
				and is_null_vendor_target_date = q.is_null (22)
				and is_null_wafer_lot_no = q.is_null (23)
				and is_null_wafer_process = q.is_null (24)
				and is_null_wafer_vendor_lot_id = q.is_null (25)
		end

end
