
note

	date: "Fri Apr 22 13:46:33 2011"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user GOLDBERG"
	database_tables: 
		"SCHEDULED_RUNS (MOSIS.SCHEDULED_RUNS)"
			-- Included columns
			-- 	CUST_ACCT_ACCESS_PREDICATE
			-- 	DATE_CANCELLED
			-- 	DATE_CLOSE_TARGETED
			-- 	DATE_FAB_REMINDER_PROCESSED
			-- 	DATE_SCHEDULED
			-- 	DEDICATED_CUST_ACCT_NO
			-- 	DEDICATED_ORG_NO
			-- 	DEDICATED_RUN_NAME
			-- 	DESIGN_ENGINEER
			-- 	IS_ESTIMATE
			-- 	M_CUST_QUOTE_NO
			-- 	NET_ADDRESS
			-- 	PHONE_NUMBER
			-- 	PRODUCTION_MANAGER
			-- 	RUN_TYPE
			-- 	SCHED_RUN_NO
			-- 	VISIBLE_EXTERNALLY
			-- 	VISIBLE_INTERNALLY
			-- 	WAFER_PART_ID
			-- 	WAFER_TECHN
			-- Excluded columns
			-- 	(none)

class SCHEDULED_RUNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_sched_run_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			sched_run_no := the_sched_run_no
			is_null_sched_run_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 20

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cust_acct_access_predicate, date_cancelled, date_close_targeted,%N  date_fab_reminder_processed, date_scheduled, dedicated_cust_acct_no,%N  dedicated_org_no, dedicated_run_name, design_engineer, is_estimate,%N  m_cust_quote_no, net_address, phone_number, production_manager, run_type,%N  sched_run_no, visible_externally, visible_internally, wafer_part_id,%N  wafer_techn"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "scheduled_runs sr"

	join_condition: STRING = ""

	table_name: STRING = "scheduled_runs"

	key_where_clause: STRING = "sched_run_no = :1"

feature -- Values

	cust_acct_access_predicate: STRING
			-- DB: VARCHAR2(25)

	date_cancelled: DB_DATE
			-- DB: DATE

	date_close_targeted: DB_DATE
			-- DB: DATE

	date_fab_reminder_processed: DB_DATE
			-- DB: DATE

	date_scheduled: DB_DATE
			-- DB: DATE not null

	dedicated_cust_acct_no: INTEGER
			-- DB: NUMBER(6,0)

	dedicated_org_no: INTEGER
			-- DB: NUMBER(6,0)

	dedicated_run_name: STRING
			-- DB: VARCHAR2(20)

	design_engineer: STRING
			-- DB: VARCHAR2(30)

	is_estimate: BOOLEAN
			-- DB: CHAR(1) not null

	m_cust_quote_no: INTEGER
			-- DB: NUMBER(8,0)

	net_address: STRING
			-- DB: VARCHAR2(300)

	phone_number: STRING
			-- DB: VARCHAR2(200)

	production_manager: STRING
			-- DB: VARCHAR2(30)

	run_type: STRING
			-- DB: VARCHAR2(5) not null

	sched_run_no: INTEGER
			-- DB: NUMBER(6,0) not null

	visible_externally: BOOLEAN
			-- DB: CHAR(1) not null

	visible_internally: BOOLEAN
			-- DB: CHAR(1) not null

	wafer_part_id: STRING
			-- DB: VARCHAR2(50)

	wafer_techn: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_cust_acct_access_predicate: INTEGER = 25
	maxlen_dedicated_run_name: INTEGER = 20
	maxlen_design_engineer: INTEGER = 30
	maxlen_net_address: INTEGER = 300
	maxlen_phone_number: INTEGER = 200
	maxlen_production_manager: INTEGER = 30
	maxlen_run_type: INTEGER = 5
	maxlen_wafer_part_id: INTEGER = 50
	maxlen_wafer_techn: INTEGER = 50

feature -- Precisions for number columns

	precision_dedicated_cust_acct_no: INTEGER = 6
	precision_dedicated_org_no: INTEGER = 6
	precision_m_cust_quote_no: INTEGER = 8
	precision_sched_run_no: INTEGER = 6

feature -- Scales for number columns

	scale_dedicated_cust_acct_no: INTEGER = 0
	scale_dedicated_org_no: INTEGER = 0
	scale_m_cust_quote_no: INTEGER = 0
	scale_sched_run_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_cust_acct_access_predicate: BOOLEAN
	is_null_date_cancelled: BOOLEAN
	is_null_date_close_targeted: BOOLEAN
	is_null_date_fab_reminder_processed: BOOLEAN
	is_null_dedicated_cust_acct_no: BOOLEAN
	is_null_dedicated_org_no: BOOLEAN
	is_null_dedicated_run_name: BOOLEAN
	is_null_design_engineer: BOOLEAN
	is_null_m_cust_quote_no: BOOLEAN
	is_null_net_address: BOOLEAN
	is_null_phone_number: BOOLEAN
	is_null_production_manager: BOOLEAN
	is_null_wafer_part_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_date_scheduled: BOOLEAN
	is_null_is_estimate: BOOLEAN
	is_null_run_type: BOOLEAN
	is_null_sched_run_no: BOOLEAN
	is_null_visible_externally: BOOLEAN
	is_null_visible_internally: BOOLEAN
	is_null_wafer_techn: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and sched_run_no = r.sched_run_no
			Result := Result
				and is_null_sched_run_no = r.is_null_sched_run_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and dedicated_cust_acct_no = r.dedicated_cust_acct_no
				and dedicated_org_no = r.dedicated_org_no
				and is_estimate = r.is_estimate
				and m_cust_quote_no = r.m_cust_quote_no
				and visible_externally = r.visible_externally
				and visible_internally = r.visible_internally
			Result := Result
				and equal (cust_acct_access_predicate, r.cust_acct_access_predicate)
				and equal (date_cancelled, r.date_cancelled)
				and equal (date_close_targeted, r.date_close_targeted)
				and equal (date_fab_reminder_processed, r.date_fab_reminder_processed)
				and equal (date_scheduled, r.date_scheduled)
				and equal (dedicated_run_name, r.dedicated_run_name)
				and equal (design_engineer, r.design_engineer)
				and equal (net_address, r.net_address)
				and equal (phone_number, r.phone_number)
				and equal (production_manager, r.production_manager)
				and equal (run_type, r.run_type)
				and equal (wafer_part_id, r.wafer_part_id)
				and equal (wafer_techn, r.wafer_techn)
			Result := Result
				and is_null_cust_acct_access_predicate = r.is_null_cust_acct_access_predicate
				and is_null_date_cancelled = r.is_null_date_cancelled
				and is_null_date_close_targeted = r.is_null_date_close_targeted
				and is_null_date_fab_reminder_processed = r.is_null_date_fab_reminder_processed
				and is_null_date_scheduled = r.is_null_date_scheduled
				and is_null_dedicated_cust_acct_no = r.is_null_dedicated_cust_acct_no
				and is_null_dedicated_org_no = r.is_null_dedicated_org_no
				and is_null_dedicated_run_name = r.is_null_dedicated_run_name
				and is_null_design_engineer = r.is_null_design_engineer
				and is_null_is_estimate = r.is_null_is_estimate
				and is_null_m_cust_quote_no = r.is_null_m_cust_quote_no
				and is_null_net_address = r.is_null_net_address
				and is_null_phone_number = r.is_null_phone_number
				and is_null_production_manager = r.is_null_production_manager
				and is_null_run_type = r.is_null_run_type
				and is_null_visible_externally = r.is_null_visible_externally
				and is_null_visible_internally = r.is_null_visible_internally
				and is_null_wafer_part_id = r.is_null_wafer_part_id
				and is_null_wafer_techn = r.is_null_wafer_techn
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 25)
			q.select_date (2)
			q.select_date (3)
			q.select_date (4)
			q.select_date (5)
			q.select_integer (6)
			q.select_integer (7)
			q.select_string (8, 20)
			q.select_string (9, 30)
			q.select_boolean (10)
			q.select_integer (11)
			q.select_string (12, 300)
			q.select_string (13, 200)
			q.select_string (14, 30)
			q.select_string (15, 5)
			q.select_integer (16)
			q.select_boolean (17)
			q.select_boolean (18)
			q.select_string (19, 50)
			q.select_string (20, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			dedicated_cust_acct_no := q.integer_value (6)
			dedicated_org_no := q.integer_value (7)
			is_estimate := q.boolean_value (10)
			m_cust_quote_no := q.integer_value (11)
			sched_run_no := q.integer_value (16)
			visible_externally := q.boolean_value (17)
			visible_internally := q.boolean_value (18)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cust_acct_access_predicate := q.string_value (1)
			date_cancelled := q.date_value (2)
			date_close_targeted := q.date_value (3)
			date_fab_reminder_processed := q.date_value (4)
			date_scheduled := q.date_value (5)
			dedicated_run_name := q.string_value (8)
			design_engineer := q.string_value (9)
			net_address := q.string_value (12)
			phone_number := q.string_value (13)
			production_manager := q.string_value (14)
			run_type := q.string_value (15)
			wafer_part_id := q.string_value (19)
			wafer_techn := q.string_value (20)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, cust_acct_access_predicate)
			q.get_date_value (2, date_cancelled)
			q.get_date_value (3, date_close_targeted)
			q.get_date_value (4, date_fab_reminder_processed)
			q.get_date_value (5, date_scheduled)
			q.get_string_value (8, dedicated_run_name)
			q.get_string_value (9, design_engineer)
			q.get_string_value (12, net_address)
			q.get_string_value (13, phone_number)
			q.get_string_value (14, production_manager)
			q.get_string_value (15, run_type)
			q.get_string_value (19, wafer_part_id)
			q.get_string_value (20, wafer_techn)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cust_acct_access_predicate := q.is_null (1)
			is_null_date_cancelled := q.is_null (2)
			is_null_date_close_targeted := q.is_null (3)
			is_null_date_fab_reminder_processed := q.is_null (4)
			is_null_date_scheduled := q.is_null (5)
			is_null_dedicated_cust_acct_no := q.is_null (6)
			is_null_dedicated_org_no := q.is_null (7)
			is_null_dedicated_run_name := q.is_null (8)
			is_null_design_engineer := q.is_null (9)
			is_null_is_estimate := q.is_null (10)
			is_null_m_cust_quote_no := q.is_null (11)
			is_null_net_address := q.is_null (12)
			is_null_phone_number := q.is_null (13)
			is_null_production_manager := q.is_null (14)
			is_null_run_type := q.is_null (15)
			is_null_sched_run_no := q.is_null (16)
			is_null_visible_externally := q.is_null (17)
			is_null_visible_internally := q.is_null (18)
			is_null_wafer_part_id := q.is_null (19)
			is_null_wafer_techn := q.is_null (20)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_sched_run_no := True
		end

	set_null_nonkey
		do
			is_null_cust_acct_access_predicate := True
			is_null_date_cancelled := True
			is_null_date_close_targeted := True
			is_null_date_fab_reminder_processed := True
			is_null_date_scheduled := True
			is_null_dedicated_cust_acct_no := True
			is_null_dedicated_org_no := True
			is_null_dedicated_run_name := True
			is_null_design_engineer := True
			is_null_is_estimate := True
			is_null_m_cust_quote_no := True
			is_null_net_address := True
			is_null_phone_number := True
			is_null_production_manager := True
			is_null_run_type := True
			is_null_visible_externally := True
			is_null_visible_internally := True
			is_null_wafer_part_id := True
			is_null_wafer_techn := True
			create cust_acct_access_predicate.make (0)
			create {ORACLE_DATE} date_cancelled.set_null
			create {ORACLE_DATE} date_close_targeted.set_null
			create {ORACLE_DATE} date_fab_reminder_processed.set_null
			create {ORACLE_DATE} date_scheduled.set_null
			create dedicated_run_name.make (0)
			create design_engineer.make (0)
			create net_address.make (0)
			create phone_number.make (0)
			create production_manager.make (0)
			create run_type.make (0)
			create wafer_part_id.make (0)
			create wafer_techn.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, sched_run_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and dedicated_cust_acct_no = q.integer_value (6)
				and dedicated_org_no = q.integer_value (7)
				and is_estimate = q.boolean_value (10)
				and m_cust_quote_no = q.integer_value (11)
				and sched_run_no = q.integer_value (16)
				and visible_externally = q.boolean_value (17)
				and visible_internally = q.boolean_value (18)
			q.get_string_value (1, s)
			Result := Result and equal (cust_acct_access_predicate, s)
			q.get_date_value (2, d)
			Result := Result and equal (date_cancelled, d)
			q.get_date_value (3, d)
			Result := Result and equal (date_close_targeted, d)
			q.get_date_value (4, d)
			Result := Result and equal (date_fab_reminder_processed, d)
			q.get_date_value (5, d)
			Result := Result and equal (date_scheduled, d)
			q.get_string_value (8, s)
			Result := Result and equal (dedicated_run_name, s)
			q.get_string_value (9, s)
			Result := Result and equal (design_engineer, s)
			q.get_string_value (12, s)
			Result := Result and equal (net_address, s)
			q.get_string_value (13, s)
			Result := Result and equal (phone_number, s)
			q.get_string_value (14, s)
			Result := Result and equal (production_manager, s)
			q.get_string_value (15, s)
			Result := Result and equal (run_type, s)
			q.get_string_value (19, s)
			Result := Result and equal (wafer_part_id, s)
			q.get_string_value (20, s)
			Result := Result and equal (wafer_techn, s)
			Result := Result
				and is_null_cust_acct_access_predicate = q.is_null (1)
				and is_null_date_cancelled = q.is_null (2)
				and is_null_date_close_targeted = q.is_null (3)
				and is_null_date_fab_reminder_processed = q.is_null (4)
				and is_null_date_scheduled = q.is_null (5)
				and is_null_dedicated_cust_acct_no = q.is_null (6)
				and is_null_dedicated_org_no = q.is_null (7)
				and is_null_dedicated_run_name = q.is_null (8)
				and is_null_design_engineer = q.is_null (9)
				and is_null_is_estimate = q.is_null (10)
				and is_null_m_cust_quote_no = q.is_null (11)
				and is_null_net_address = q.is_null (12)
				and is_null_phone_number = q.is_null (13)
				and is_null_production_manager = q.is_null (14)
				and is_null_run_type = q.is_null (15)
				and is_null_sched_run_no = q.is_null (16)
				and is_null_visible_externally = q.is_null (17)
				and is_null_visible_internally = q.is_null (18)
				and is_null_wafer_part_id = q.is_null (19)
				and is_null_wafer_techn = q.is_null (20)
		end

end
