
note

	date: "Thu Jan 21 12:59:49 2010"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"WAFER_PROCESSES (MOSIS.WAFER_PROCESSES)"
			-- Included columns
			-- 	DESCR
			-- 	ELEC_SPEC_FILE_SPECIFICATION
			-- 	NOMINAL_TURNAROUND_DAYS
			-- 	PROCESS_VDD
			-- 	WAFER_ETEST_ID
			-- 	WAFER_PROCESS
			-- 	WAFER_PROCESS_ID
			-- 	WAFER_TECHN_FAMILY
			-- Excluded columns
			-- 	(none)

class WAFER_PROCESSES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_wafer_process: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_wafer_process_exists: the_wafer_process /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			wafer_process := the_wafer_process
			is_null_wafer_process := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, elec_spec_file_specification, nominal_turnaround_days,%N  process_vdd, wafer_etest_id, wafer_process, wafer_process_id,%N  wafer_techn_family"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "wafer_processes wp"

	join_condition: STRING = ""

	table_name: STRING = "wafer_processes"

	key_where_clause: STRING = "wafer_process = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(255)

	elec_spec_file_specification: STRING
			-- DB: VARCHAR2(255)

	nominal_turnaround_days: INTEGER
			-- DB: NUMBER(4,0)

	process_vdd: REAL
			-- DB: NUMBER(5,2)

	wafer_etest_id: STRING
			-- DB: VARCHAR2(20) not null

	wafer_process: STRING
			-- DB: VARCHAR2(50) not null

	wafer_process_id: STRING
			-- DB: VARCHAR2(20) not null

	wafer_techn_family: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_descr: INTEGER = 255
	maxlen_elec_spec_file_specification: INTEGER = 255
	maxlen_wafer_etest_id: INTEGER = 20
	maxlen_wafer_process: INTEGER = 50
	maxlen_wafer_process_id: INTEGER = 20
	maxlen_wafer_techn_family: INTEGER = 50

feature -- Precisions for number columns

	precision_nominal_turnaround_days: INTEGER = 4
	precision_process_vdd: INTEGER = 5

feature -- Scales for number columns

	scale_nominal_turnaround_days: INTEGER = 0
	scale_process_vdd: INTEGER = 2

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_elec_spec_file_specification: BOOLEAN
	is_null_nominal_turnaround_days: BOOLEAN
	is_null_process_vdd: BOOLEAN

feature -- Nullness for non-null columns

	is_null_wafer_etest_id: BOOLEAN
	is_null_wafer_process: BOOLEAN
	is_null_wafer_process_id: BOOLEAN
	is_null_wafer_techn_family: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (wafer_process, r.wafer_process)
			Result := Result
				and is_null_wafer_process = r.is_null_wafer_process
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and nominal_turnaround_days = r.nominal_turnaround_days
				and process_vdd = r.process_vdd
			Result := Result
				and equal (descr, r.descr)
				and equal (elec_spec_file_specification, r.elec_spec_file_specification)
				and equal (wafer_etest_id, r.wafer_etest_id)
				and equal (wafer_process_id, r.wafer_process_id)
				and equal (wafer_techn_family, r.wafer_techn_family)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_elec_spec_file_specification = r.is_null_elec_spec_file_specification
				and is_null_nominal_turnaround_days = r.is_null_nominal_turnaround_days
				and is_null_process_vdd = r.is_null_process_vdd
				and is_null_wafer_etest_id = r.is_null_wafer_etest_id
				and is_null_wafer_process_id = r.is_null_wafer_process_id
				and is_null_wafer_techn_family = r.is_null_wafer_techn_family
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 255)
			q.select_integer (3)
			q.select_real (4)
			q.select_string (5, 20)
			q.select_string (6, 50)
			q.select_string (7, 20)
			q.select_string (8, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			nominal_turnaround_days := q.integer_value (3)
			process_vdd := q.real_value (4)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			elec_spec_file_specification := q.string_value (2)
			wafer_etest_id := q.string_value (5)
			wafer_process := q.string_value (6)
			wafer_process_id := q.string_value (7)
			wafer_techn_family := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, elec_spec_file_specification)
			q.get_string_value (5, wafer_etest_id)
			q.get_string_value (6, wafer_process)
			q.get_string_value (7, wafer_process_id)
			q.get_string_value (8, wafer_techn_family)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_elec_spec_file_specification := q.is_null (2)
			is_null_nominal_turnaround_days := q.is_null (3)
			is_null_process_vdd := q.is_null (4)
			is_null_wafer_etest_id := q.is_null (5)
			is_null_wafer_process := q.is_null (6)
			is_null_wafer_process_id := q.is_null (7)
			is_null_wafer_techn_family := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_wafer_process := True
			create wafer_process.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_elec_spec_file_specification := True
			is_null_nominal_turnaround_days := True
			is_null_process_vdd := True
			is_null_wafer_etest_id := True
			is_null_wafer_process_id := True
			is_null_wafer_techn_family := True
			create descr.make (0)
			create elec_spec_file_specification.make (0)
			create wafer_etest_id.make (0)
			create wafer_process_id.make (0)
			create wafer_techn_family.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, wafer_process, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and nominal_turnaround_days = q.integer_value (3)
				and process_vdd = q.real_value (4)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (elec_spec_file_specification, s)
			q.get_string_value (5, s)
			Result := Result and equal (wafer_etest_id, s)
			q.get_string_value (6, s)
			Result := Result and equal (wafer_process, s)
			q.get_string_value (7, s)
			Result := Result and equal (wafer_process_id, s)
			q.get_string_value (8, s)
			Result := Result and equal (wafer_techn_family, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_elec_spec_file_specification = q.is_null (2)
				and is_null_nominal_turnaround_days = q.is_null (3)
				and is_null_process_vdd = q.is_null (4)
				and is_null_wafer_etest_id = q.is_null (5)
				and is_null_wafer_process = q.is_null (6)
				and is_null_wafer_process_id = q.is_null (7)
				and is_null_wafer_techn_family = q.is_null (8)
		end

end
