
note
	description:
		"A wafer process option, which determines which wafer %
		%processes a project can go on"
	author: "David Hollenberg"
	date:	"April 26, 2006"

class WAFER_PROCESS_OPTION
inherit
	ABSTRACT_MOD_PROCESS_OPTION

	DB_QUERY_OPTIONS
		export {NONE}	all
		end

feature -- Properties

	option_id: STRING
			-- Unique identifier for option (within wafer
			-- techn family)

	option_in_process: BOOLEAN
			-- If true, then option is required to be in process.
			-- If false, then option is forbidden to be in process.

feature -- Modification

	set_option_id (s: STRING)
			-- Set `option_id' to `s'
		do
			option_id := s
		end
	
	set_option_in_process (b: BOOLEAN)
		do
			option_in_process := b
		end
	
feature	-- the rest of essence_of_option

	option_name: STRING
	do  Result := option_id_row.option_name
	end

	option_category: STRING
	do  Result := option_id_row.option_category
	end

feature	-- my OPTION_IDS_ROW so I can know about myself

	option_id_row: OPTION_IDS_ROW
	do  if cached_option_id = Void
	     then create cached_option_id.make_by_key(db, old_row, option_id)
	    end
	    Result := cached_option_id
	end

feature {NONE} -- cache

	cached_option_id: OPTION_IDS_ROW

end
