note
	description:
		"Package bonding finger layout information."
	author: "Barden E. Smith"
	date:	"August 30, 2004"

class BONDING_FINGER_LAYOUTS_ROW

inherit
	BONDING_FINGER_LAYOUTS_RAW
	ROW_COUNT_CHECK_ACCESS

create
	make_template, make_null, make_by_key

feature

	rows_for_package_id (pkg: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All bonding finger layouts for connections
			-- for package id `pkg'
		require
			pkg_exists: pkg /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (pkg)
			Result := all_rows_filtered (conn, "bonding_finger_layout_no in (select bonding_finger_layout_no from package_connections where package_id = :1)", b)
			check_row_count (Result, range)
		end

end -- class BONDING_FINGER_LAYOUTS_ROW
