class CUST_IC_DESIGN_PADS_ROW

inherit
	CUST_IC_DESIGN_PADS_RAW

	ROW_COUNT_CHECK_ACCESS

	MORE_DOUBLE_MATH

create
	make_template, make_null, make_by_key

feature -- Properties

	size_min: DOUBLE
		-- shorter of x and y
	do  Result := size_x.min (size_y)
	end;

	size_max: DOUBLE
		-- longer of x and y
	do  Result := size_x.max (size_y)
	end;

	distance alias "|-|"(other: CUST_IC_DESIGN_PADS_ROW): DOUBLE
		-- center to center distance between two pads
	require exists: other /= Void
	do  Result := radius(center_x - other.center_x, center_y - other.center_y)
	end;

feature	-- drawn_shape

	drawn_shape: STRING
		-- the drawn_shape for this pad_type (Void if pad_type is null)
	local b: DB_BIND_S
	do  if not is_null_pad_type then
		if cached_shape = Void then
			create b.make(pad_type);
			cached_shape := connection.selected_string
						("drawn_shape", "pad_types",
						 "pad_type = :1", b)
		end
		Result := cached_shape
	    end
	end;

feature {NONE}

	cached_shape: STRING

feature	-- selection

	rows_for_design_no (dno: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for design number `dno'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (dno)
			Result := all_rows_filtered (conn, "design_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end -- CUST_IC_DESIGN_PADS_ROW
