class CUST_IC_DESIGN_YN_ANSWERS_ROW

inherit

	CUST_IC_DESIGN_YN_ANSWERS_RAW

	DB_QUERY_OPTIONS
		export
			{NONE} all
		end

	ROW_COUNT_CHECK_ACCESS

create 
	make_template,
	make_null,
	make_detached,
	make_by_key


feature -- Misc conversions

	paragraph_display_value: STRING
		do
			if paragraph_display_value_0 = Void then
				compute_paragraph_display_value
			end
			Result := paragraph_display_value_0
		end

	ecc_questionnaire_id: STRING
		do
			if paragraph_id /= Void then
				if     eqi /= Void
				   and paragraph_id /= Void
				   and version_no = eqi.version_no
				   and then paragraph_id.is_equal(eqi.paragraph_id) then
				  -- return prior text row
				else
					create eqi.make_by_key (connection, old_row, paragraph_id, version_no)
				end
				Result := eqi.ecc_questionnaire_id
			else
				Result := ""
			end
		end

feature {NONE} -- Conversion implementation

	paragraph_display_value_0: STRING

	compute_paragraph_display_value
		local
			b: SQL_BLOCK
		do
			create paragraph_display_value_0.make (200)
			paragraph_display_value_0.fill_blank
			b := connection.sql_block ("begin :result := m_lookup.eccn_id_to_eccn (:par_id); end;")
			b.set_named_bind_capacity (2)
			b.bind_name_to_string (ph_paragraph_id, paragraph_id, False)
			b.bind_name_to_string (ph_result, paragraph_display_value_0, False)
			b.execute
			paragraph_display_value_0 := b.string_bound_to_name (ph_result)
			b.release
		end

	ph_result: STRING = "result"

	ph_paragraph_id: STRING = "par_id"

	eqi: ECC_QUESTIONNAIRE_TEXT_ROW

feature -- Collections
	
	design_submission_yn_answers (d_no, sub_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All design questionniare YN answers for a specific questionnaire submission
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_II
		do
			create b.make (d_no, sub_no)
			Result := all_rows_filtered_ordered (conn, "design_no = :1 and submission_no = :2", b, "paragraph_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end
	
	design_yn_answers (d_no, sub_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All design questionniare YN answers for a specific design at or below the specifed submission
			-- This should also ignore answers for questions on prior versions of the questionnaire version
			-- that were answered for the specified submissions (to be done)
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_II
		do
			create b.make (d_no, sub_no)
			Result := all_rows_filtered_ordered (conn, "design_no = :1 and submission_no <= :2", b, "submission_no desc, paragraph_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
