
note

	author: "Generated"
	date: "Fri Feb 27 14:00:36 PST 2004"

class CUST_IC_DESIGNS_MROW
inherit
	CUST_IC_DESIGNS_MRAW
	undefine delete		-- inherit from MULTI_LINE_TEXT_ROW
	redefine post
	end;

	CUST_IC_DESIGNS_ROW
		undefine
			initialize_new, initialize_new_by_key
		redefine
			anchored_cidf_row,
			anchored_ic_fab_instance
		end

	MULTI_LINE_TEXT_ROW[CUST_IC_DESIGN_DESCRS_MROW]
	rename the_text as description,
	       set_the_text as set_description
	end;

	DB_UTILITIES
	export	{ANY}	su
		{NONE}	all
	end;

create
	make_template, make_null, make_by_key, make_detached

feature	-- new ic_fab_instance

	make_new_fab_instance
		-- new fab instance for me
	local oifi, nifi: like anchored_ic_fab_instance; b: DB_BIND_II
	do  if not ic_fab_instances.is_empty then
		oifi := ic_fab_instances.last	-- the latest one (if any)
	    end
	    create nifi.make_by_key(db, new_row, db.sequence_next_value("M_FAB_NO"));
	    -- some constants or defaults
	    nifi.set_design_no(design_no)
	    nifi.initialize_default_attributes;
	    ic_fab_instances.extend(nifi);
	    if oifi /= Void
	     then  -- copy some stuff from old ifi to new ifi
		nifi.set_overhead_style(oifi.overhead_style);
		nifi.set_is_standard_stack_declared(oifi.is_standard_stack_declared);
		nifi.set_declared_etest_handle(oifi.declared_etest_handle);
		nifi.set_wafer_etest_name(oifi.wafer_etest_name);
		nifi.insert_immediate;
		create b.make(oifi.m_fab_no, nifi.m_fab_no);
		db.execute_dml_statement(copy_fab_options_stmnt, b);
	    else
		nifi.reregister_first;
	    end;
	    -- put these guys up front (referential integrity vis a vis
	    --  the m_request, whose creation we do not control)
	    if is_new
	     then reregister_first
	    end
	end;

	copy_fab_options_stmnt: STRING =
	"insert into ic_fab_instance_options%
	% select :2, option_id%
	% from ic_fab_instance_options where m_fab_no = :1"

feature -- database coordination

	post
		-- automatic update of date_modified before posting
	do if is_registered and not is_deleted
	    then set_date_modified(connection.transaction_date)
	   end;
	   precursor;
	end;

feature -- Modification

	freeze
			-- If `Current' is not frozen, mark it frozen
		do
			if not design_frozen then
				set_design_frozen (True)
			end
		end

	unfreeze
			-- If `Current' is frozen and does not have
			-- multiple fab instances, mark it unfrozen
		do
			if design_frozen then
				if not has_multiple_fab_instances then
					set_design_frozen (False)
				end
			end
		end

feature	-- compound sets

	set_est_design_size(x, y: DOUBLE)
	do  set_est_design_size_x(x)
	    set_est_design_size_y(y)
	end;

	set_design_size_and_center(sx, sy, cx, cy: DOUBLE)
	do  set_design_size_x(sx);
	    set_design_size_y(sy);
	    set_center_x(cx)
	    set_center_y(cy)
	    if is_3dic_tier then
		-- parent updated from last child that is checked
		parent_cid.set_design_size_and_center(sx, sy, cx, cy)
	    end;
	end;

feature	-- ifi_of_interest sets

	set_net_address(s: STRING)
	do  ifi_of_interest.set_net_address(s)
	end;

	set_phone_number(s: STRING)
	do  ifi_of_interest.set_phone_number(s)
	end;

feature	-- 3dic parent computations

	compute_is_preliminary
		-- parent is preliminary iff (at least) one child is preliminary
	require is_3dic_parent: is_3dic_parent
	do  layout_of_interest.set_is_preliminary
		(tiered_cids.there_exists(agent {like Current}.is_preliminary))
	end;

	compute_design_accept_state
		-- parent is passed iff all children are passed (else null)
		-- NOTE: project.update_3dic_parent can change this to failed
	require is_3dic_parent: is_3dic_parent
	local dasv: DESIGN_ACCEPT_STATE_VALUES
	do  if tiered_cids.there_exists(agent {like Current}.is_not_passed) then
		set_null_design_accept_state
	    else
		set_design_accept_state(dasv.passed)
	    end
	end;

feature	-- cust_ic_design_measurements

	set_measurement_value(iname: STRING; val: DOUBLE)
		-- modify existing or add a new one
	local foo: CUST_IC_DESIGN_MEASUREMENTS_MROW
	do  foo := a_measurement(iname);
	    if foo = Void then
		create foo.make_null(connection)
		foo.set_design_no(design_no);
		foo.set_item_name(iname);
		cached_measurements.extend(foo)
	    end;
	    foo.set_numeric_value(val)
	end;

	remove_measurement(iname: STRING)
		-- remove a measurement (nop if doesn't exist)
	local foo: CUST_IC_DESIGN_MEASUREMENTS_MROW
	do  foo := a_measurement(iname);
	    if foo /= Void then
		foo.delete;
		cached_measurements.remove	-- foo is current!!
	    end
	end;

feature {NONE} -- effectors for description (MULTI_LINE_TEXT_ROW)

	anchored_cidf_row: CUST_IC_DESIGN_FILES_MROW
	do
	end;

	anchored_ic_fab_instance: IC_FAB_INSTANCES_MROW
	do
	end;

	create_numbered_row: CUST_IC_DESIGN_DESCRS_MROW
	do  create Result.make_null(connection);
	    Result.set_design_no(design_no)
	end;

	numbered_rows_filter: STRING = "design_no = :1";

	numbered_rows_binder: DB_BIND_I
	do  create Result.make(design_no);
	end;

end
