
note

	author: "Generated"
	date: "Thu Mar 11 15:52:47 PST 2004"

class CUT_LOCATIONS_ROW
inherit
	CUT_LOCATIONS_RAW
	ROW_COUNT_CHECK_ACCESS
	HAS_POSITION
	
create
	make_template, make_null, make_by_key

feature -- Properties

	rows_for_run (a_run_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for `a_run_id', ordered by cut
			-- pattern number and by cut number within cut
			-- pattern
		require
			a_run_id_exists: a_run_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (a_run_id)
			Result := all_rows_filtered_ordered (conn, "run_id = :1", b, "cut_pattern_no, cut_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_for_run_and_production (a_run_id, a_prod_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for cuts for cut patterns assigned
			-- to run `a_run_id' and production
			-- `a_prod_id', ordered by cut pattern number
			-- and by cut number within cut pattern
		require
			a_run_id_exists: a_run_id /= Void
			a_prod_id_exists: a_prod_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (a_run_id, a_prod_id)
			Result := all_rows_filtered_ordered (conn, "(run_id, cut_pattern_no) in (select run_id, cut_pattern_no from run_cut_patterns where run_id = :1 and production_id = :2)", b, "cut_pattern_no, cut_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_for_run_and_pattern (a_run_id: STRING pat_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for `a_run_id' and `pat_no',
			-- ordered by cut number
		require
			a_run_id_exists: a_run_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SI
		do
			create b.make (a_run_id, pat_no)
			Result := all_rows_filtered_ordered (conn, "run_id = :1 and cut_pattern_no = :2", b, "cut_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	is_horizontal: BOOLEAN
		local
			orient: ORIENTATION_VALUES
		do
			Result := orientation.is_equal (orient.Horizontal)
		end
	
	is_vertical: BOOLEAN
		local
			orient: ORIENTATION_VALUES
		do
			Result := orientation.is_equal (orient.Vertical)
		end

	has_position: BOOLEAN = TRUE
			-- Is there a position?

	position: DOUBLE
			-- Value of position
		do
			Result := location
		end
	
end
