
class CUT_PATTERN_XFORM_TYPES_ROW

inherit
	CUT_PATTERN_XFORM_TYPES_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null, make_by_key

feature -- Collections

	all_xform_types (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		do
			Result := all_rows_ordered (conn, "cut_pattern_xform_type")
			check_row_count (Result, range)
		end

feature -- Properties

	isolates_sites: BOOLEAN
			-- Does this type of cut pattern
			-- isolate site?
		local
			type: CUT_PATTERN_RESULT_TYPE_VALUES
		do
			Result := result_type.is_equal (type.Isolated_sites)
		end

	produces_strips: BOOLEAN
			-- Does this type of cut pattern
			-- produce wafer strips?
		local
			type: CUT_PATTERN_RESULT_TYPE_VALUES
		do
			Result := result_type.is_equal (type.Wafer_strips)
		end

	applies_to_strips: BOOLEAN
			-- Is this type of cut pattern
			-- applied to wafer strips?
		local
			type: CUT_PATTERN_SOURCE_TYPE_VALUES
		do
			Result := source_type.is_equal (type.Wafer_strips)
		end

end
