class DESIGN_TECHN_LAYERS_ROW

inherit
	DESIGN_TECHN_LAYERS_RAW
	ROW_COUNT_CHECK_ACCESS
		export 
			{NONE} all
		end
	NULL_VALUE_CHECK_ACCESS
		export 
			{NONE} all
		end

create
	make_template, make_null

feature -- Collections

	layers_for_dt (dt: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All layers for design techn `dt'.
		require
			dt_not_void: dt /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (dt)
			Result := all_rows_filtered (conn, "design_techn = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

feature -- Properties

	non_null_min_width: like min_width
			-- Value of `min_width', with error check 
			-- for nullness
		do
			check_not_null ("min_width", is_null_min_width, Current)
			Result := min_width
		end

end -- DESIGN_TECHN_LAYERS_ROW
