
note

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class DESIGN_TYPES_ROW
inherit
	DESIGN_TYPES_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature -- Properties

	all_design_types_ordered (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for design types
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		do
			Result := all_rows_ordered (conn, "design_type")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	available_design_types_ordered (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for design types that
			-- are the type for at least one 
			-- wafer techn that is not retired
		require
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_S
			status: WAFER_TECHN_STATUS_VALUES
		do
			create b.make (status.Ret)
			Result := all_rows_filtered_ordered (conn, "design_type in (select design_type from wafer_techns_ wt, run_techns rt where wt.run_techn = rt.run_techn and wafer_techn_status <> :1)", b, "design_type")
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end

	has_design_type (dt: STRING): BOOLEAN
			-- Does this row have design type `dt'?
		require
			dt_not_void: dt /= Void
		do
			Result := design_type.is_equal (dt)
		end

	is_ic: BOOLEAN
			-- Is design type IC?
		local
			type: DESIGN_TYPE_VALUES
		do
			Result := design_type.is_equal (type.Ic)
		end

	is_3dic: BOOLEAN
			-- Is design type 3DIC?
		local
			type: DESIGN_TYPE_VALUES
		do
			Result := design_type.is_equal (type.Three_d_Ic)
		end

end
