
note

	author: "Generated"
	date: "Thu Jun 12 14:26:02 PDT 2003"

class DIE_LOCATIONS_ROW
inherit
	DIE_LOCATIONS_RAW
		rename
			cats_status as job_status,
			is_null_cats_status as is_null_job_status
		end
	ROW_COUNT_CHECK_ACCESS
	DIE_PART_ID_QUERIES
		export
			{NONE} all
		end
create
	make_template, make_null, make_by_key

feature -- Properties

	usage: STRING
			-- How part id is used
		do
			Result := "run " + run_id + ", die " + die_id + ", site " + mask_site_no.out
		end

	site_part_id_usages (seq: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All uses of parts in sequence `seq' by runs
			-- in the DIE_LOCATIONS table
		require
			sequence_exists: seq /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
			labeled_entity: LABELED_ENTITY_VALUES
		do
			create b.make (seq, labeled_entity.Site)
			Result := all_rows_filtered (conn, die_part_id_query (seq), b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	die_locations_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All die locations for run `run', ordered by die id,
			-- X location and Y location
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered_ordered (conn, "run_id = :1", b, "die_id, location_x, location_y")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	center: CONST_POINT
			-- Location of center of die relative to center
			-- of field, at 1X
		do
			create Result.make_xy (location_x, location_y)
		end
	
	is_in_field (fld_name: STRING): BOOLEAN
			-- Is `Current' in field named `fld_name'?
		require
			fld_name_not_void: fld_name /= Void
		do
			Result := field_name.is_equal (fld_name)
		end
end
