note
	description: "Small Class to compute and hold ECC Questionnaire answer counts."
	author: "Barden Smith"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	ECC_QUESTIONNAIRE_ANSWER_SUMMARY

feature -- Access

	question_count: INTEGER
		deferred
		end

	negative_response_count: INTEGER

	positive_response_count: INTEGER

	missing_response_count: INTEGER
		do
			Result := question_count - (negative_response_count + positive_response_count)
		end

feature -- Status setting

	section_id: STRING
		deferred
		end

	version_no: INTEGER
		deferred
		end

	clear_negative_response
		do
			negative_response_count := 0
		end

	increment_count (do_positive: BOOLEAN)
		do
			if do_positive then
				positive_response_count := positive_response_count + 1
			else
				negative_response_count := negative_response_count + 1
			end
		end


	increment_negative_response
		do
			negative_response_count := negative_response_count + 1
		end

	set_negative_response (val: INTEGER)
		do
			negative_response_count := val
		end

	clear_positive_response
		do
			positive_response_count := 0
		end

	increment_positive_response
		do
			positive_response_count := positive_response_count + 1
		end

	set_positive_response (val: INTEGER)
		do
			positive_response_count := val
		end

end
