
note

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class FIELD_STEP_PATTERNXFIELD_LOCS_ROW
inherit
	FIELD_STEP_PATTERNXFIELD_LOCS_RAW
	ROW_COUNT_CHECK_ACCESS
	NULL_VALUE_CHECK_ACCESS
create
	make_template, make_null

feature -- Properties

	locations_for_step_pattern (pat_name: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Field locations for step pattern named `pat_name',
			-- order by field name and by copy number within field
			-- name
		require
			pat_name_exists: pat_name /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (pat_name)
			Result := all_rows_filtered_ordered (conn, "field_step_pattern = :1", b, "field_name, copy_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	custom_step_patterns_locs_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All locations for field step patterns whose
			-- litho size is a custom one for `run'
		require
			run_not_void: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered (conn, "[
				field_step_pattern in    
				   (select field_step_pattern from field_step_patterns fsp, field_sets fs, litho_sizes ls
				    where fsp.field_set_name = fs.field_set_name
				      and fs.litho_size_id = ls.litho_size_id and ls.run_id = :1)
				]", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	center: CONST_POINT
			-- Center of field relative to center of wafer,
			-- in microns
		do
			create Result.make_xy (non_null_location_x, non_null_location_y)
		end

	non_null_location_x: like location_x
			-- Value of `location_x', with error check 
			-- for nullness
		do
			check_not_null ("location_x", is_null_location_x, Current)
			Result := location_x
		end

	non_null_location_y: like location_y
			-- Value of `location_y', with error check 
			-- for nullness
		do
			check_not_null ("location_y", is_null_location_y, Current)
			Result := location_y
		end

end
