
note

	author: "David Hollenberg"

class GEOMETRY_QUANTITIES_ROW
inherit
	GEOMETRY_QUANTITIES_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
	NULL_VALUE_CHECK_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null, make_by_key, make_detached

feature -- Queries

	rows_for_id_and_field_set (gid, fs: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Rows for geometry id `gid' and field set `fs'
		require
			gid_not_void: gid /= Void
			fs_not_void: fs /= Void
			connection_exists: conn /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (gid, fs)
			Result := all_rows_filtered (conn, 
				"geometry_id = :1 and field_set_name = :2", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

feature -- Properties

	non_null_quantity_sites: like quantity_sites
			-- Value of `quantity_sites', with error check 
			-- for nullness
		do
			check_not_null ("quantity_sites", is_null_quantity_sites, Current)
			Result := quantity_sites
		end

end
