
note

	author: "David Hollenberg"

class GEOMETRYXFIXED_LOCATIONS_ROW
inherit
	GEOMETRYXFIXED_LOCATIONS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null, make_by_key, make_detached

feature -- Queries

	rows_for_id_and_field_set (gid, fs: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Rows for geometry id `gid' and field set
			-- `fs', ordered by field_name, then location_x, then
			-- location_y
		require
			gid_not_void: gid /= Void
			fs_not_void: fs /= Void
			connection_exists: conn /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (gid, fs)
			Result := all_rows_filtered_ordered (conn, 
				"geometry_id = :1 and field_set_name = :2", 
				b, "field_name, location_x, location_y")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
