class	IC_FAB_INSTANCE_OPTIONS_ROW

		-- an IC_FAB_INSTANCE_OPTIONS_RAW with its option_id
		-- data to make it an essence_of_option

inherit
	IC_FAB_INSTANCE_OPTIONS_RAW

	DB_ESSENCE_OF_OPTION
	undefine initialize_new, initialize_old, fill_in
	end;
	ABSTRACT_PROCESS_OPTION

	DB_QUERY_OPTIONS
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end


create
	make_template, make_null, make_detached, make_by_key

feature	-- Collections

	options_for_fab_no (mfn: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All explicitly requested options for fab instance
			-- whose m_fab_no is `mfn', order by option ID
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (mfn)
			Result := all_rows_filtered_ordered (conn, "m_fab_no = :1", b, "option_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	

feature	-- Properties

	option_in_process: BOOLEAN = True
			-- Is option required to be in process for
			-- process to be compatible?

feature	-- the rest of my option_ids_row

	option_name: STRING 
	do  Result := my_opt.option_name
	end;

	option_category: STRING 
	do  Result := my_opt.option_category
	end;

feature	-- my OPTION_IDS_ROW so I can know about myself

	my_opt: OPTION_IDS_ROW
	do  if cached_opt = Void
	     then create cached_opt.make_by_key(any_connection, old_row, option_id)
	    end;
	    Result := cached_opt
	end;

feature {NONE} -- cache

	cached_opt: OPTION_IDS_ROW

end -- IC_FAB_INSTANCE_OPTIONS_ROW
