
note

	author: "Generated"
	date: "Fri Feb 27 10:32:55 PST 2004"

class IC_FAB_INSTANCES_MROW
inherit
	IC_FAB_INSTANCES_MRAW
	IC_FAB_INSTANCES_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		redefine
			anchored_cust_ic_design
		end
	ROW_COUNT_CHECK_ACCESS

create
	make_template, make_null, make_detached, make_by_key

feature -- Properties
	
	locked_fab_instances_for_run (run: STRING conn: DB_CONNECTION opt: DB_LOCK_BUSY_OPTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All fab instances on run `run', 
			-- with rows already locked
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			busy_action_exists: opt /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered_locked (conn, "run_id = :1 ", b, opt)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	locked_test_vehicle_fab_instances_for_run (run: STRING conn: DB_CONNECTION opt: DB_LOCK_BUSY_OPTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All fab instances for test vehicles on run `run', 
			-- with rows already locked
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			busy_action_exists: opt /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SS
			fab_instance_type: IC_FAB_INSTANCE_TYPE_VALUES
		do
			create b.make (run, fab_instance_type.Test_vehicle)
			Result := all_rows_filtered_locked (conn, "run_id = :1 and ic_fab_instance_type = :2", b, opt)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

feature	-- initialization

	initialize_default_attributes
		-- initialize some non-null columns
	do  set_is_reworkable(false);
	    set_fill_allowed(false);
	    set_ic_fab_instance_type(type_is_customer_fab);
	    set_run_type_requested(rtype_is_shared)
	end;

feature	-- Modification

	clear_run_id
			-- If `Current' has a non-null run_id,
			-- set it to null
		do
			if not is_null_run_id then
				set_null_run_id
			end
		end

	clear_die_id
			-- Set die ID and project on die to null
		do
			set_null_die_id
			set_null_project_on_die
		end

	freeze
			-- If `Current' is not already frozen
			-- (i.e., is not already locked against customer
			-- updates), freeze it
		do
			if is_null_date_locked then
				set_date_locked (connection.transaction_date)
			end
		end

	unfreeze
			-- If `Current' is frozen, unfreeze it
		do
			if not is_null_date_locked then
				set_null_date_locked
			end
		end

	assign_to_run_if_unassigned (s: STRING)
			-- If `Current' is not already assigned to a run,
			-- assign it to run `s'
		require
			s_not_void: s /= Void
		do
			if is_null_run_id then
				set_run_id (s)
			end
		end

feature {NONE} -- Implementation

	anchored_cust_ic_design: CUST_IC_DESIGNS_MROW
			-- For anchoring only
		do
		end

end
