class IC_PACKAGING_WIRES_ROW

inherit
	IC_PACKAGING_WIRES_RAW
	ROW_COUNT_CHECK_ACCESS

create

	make_template, make_null, make_by_key

feature -- Properties

	rows_for_packaging_no (pno: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Wires for packaging number `pno'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (pno)
			Result := all_rows_filtered (conn, "ic_packaging_no = :1", b)
			check_row_count (Result, range)
		end

	package_connection: PACKAGE_CONNECTIONS_ROW
			-- Package connection for this wire

	design_pad: CUST_IC_DESIGN_PADS_ROW
			-- Chip pad for this wire

feature -- Modification

	set_package_connection (r: like package_connection)
			-- Set `package_connection' to `r'
		do
			package_connection := r
		ensure
			value_set: package_connection = r
		end

	set_design_pad (r: like design_pad)
			-- Set `design_pad' to `r'
		do
			design_pad := r
		ensure
			value_set: design_pad = r
		end

end -- class IC_PACKAGING_WIRES_ROW
