class M_REPLIES_ROW

inherit
	M_REPLIES_RAW

	NUMERIC_SEVERITY_RO

	MOSIS_UMFE_VALUES
	export {NONE} all end;
	
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		undefine
			is_equal
		end

create
	make_template, make_null, make_by_key

feature -- status

	is_mode_aside: BOOLEAN
	    do
		Result := equal(reply_mode,reply_is_aside)
	    end

	is_mode_immediate: BOOLEAN
	    do
		Result := equal(reply_mode,reply_is_immediate)
	    end

	is_mode_asynchronous: BOOLEAN
	    do
		Result := equal(reply_mode,reply_is_asynchronous)
	    end

	is_mode_info: BOOLEAN
	    do
		Result := equal(reply_mode,reply_is_info)
	    end

feature -- Collections

	replies_for_fab_no (fab_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Replies to requests for fab number `fab_no',
			-- in reverse order of date processed
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (fab_no)
			Result := all_rows_filtered_ordered (conn, "(m_communication_no, request_no) in (select m_communication_no, request_no from m_requests where m_fab_no = :1)", b, "date_processed desc")
			check_row_count (Result, range)
		end
	
feature -- Properties

	has_reply_mode (s: STRING): BOOLEAN
			-- Does `Current' have `s' as its reply mode?
		require
			s_not_void: s /= Void
		do
			Result := reply_mode.is_equal (s)
		end

end
