
note

	author: "Generated"
	date: "Tue Nov 18 12:43:41 PST 2003"

class M_TEST_OBJECTS_EROW
inherit
	M_TEST_OBJECTS_ERAW
	ROW_COUNT_CHECK_ACCESS
	NULL_VALUE_CHECK_ACCESS
create
	make_template, make_null

feature

	test_objects_for_design_no (n: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All test objects for design number `n'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (n)
			Result := all_rows_filtered (conn, "design_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	probe_origin: CONST_POINT
			-- Center of lower right probe pad relative to
			-- center of test vehicle MBB
		do
			create Result.make_xy (non_null_probe_x, non_null_probe_y)
		ensure
			result_exists: Result /= Void
		end

	non_null_probe_x: like probe_x
			-- Value of `probe_x', with error check 
			-- for nullness
		do
			check_not_null ("probe_x", is_null_probe_x, Current)
			Result := probe_x
		end
	
	non_null_probe_y: like probe_y
			-- Value of `probe_y', with error check 
			-- for nullness
		do
			check_not_null ("probe_y", is_null_probe_y, Current)
			Result := probe_y
		end
		
	is_parametric: BOOLEAN
			-- Is this a parametric test object?
		local
			type: TEST_OBJECT_TYPE_VALUES
		do
			Result := test_object_type.is_equal (type.Parametric)
		end

	is_functional: BOOLEAN
			-- Is this a functional test object?
		local
			type: TEST_OBJECT_TYPE_VALUES
		do
			Result := test_object_type.is_equal (type.Functional)
		end

	is_development: BOOLEAN
			-- Is this a development test object?
		local
			type: TEST_OBJECT_TYPE_VALUES
		do
			Result := test_object_type.is_equal (type.Development)
		end

end
