
note

	author: "David Hollenberg"
	date: "November 29, 2004"

class MASK_SETS_ROW

inherit
	MASK_SETS_RAW
	ROW_COUNT_CHECK_ACCESS

create
	make_template, make_null, make_by_key

feature

	mask_sets_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for mask sets for `run'
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered (conn, "run_id = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	mask_sets_for_run_and_revision (run: STRING rev: CHARACTER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for mask sets for `run' with revision `rev'
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SC
		do
			create b.make (run, rev)
			Result := all_rows_filtered (conn, "run_id = :1 and mask_revision = :2", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
