
note

	author: "Generated"
	date: "Wed Jun 18 12:57:24 PDT 2003"

class ORGANIZATIONS_ROW
inherit
	ORGANIZATIONS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all	
		end
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all	
		end

create
	make_template, make_null, make_by_key

feature -- Properties

	rows_with_org_no (n: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows with `org_no' as organization number
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (n)
			Result := all_rows_filtered (conn, "org_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_with_short_id (s: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows with `s' as short id
		require
			short_id_exists: s /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (s)
			Result := all_rows_filtered (conn, "short_id = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	packaging_vendor_rows (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for organizations that are package
			-- vendors (or bump vendors or test vendors),
			-- ordered by short_id
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSS
			type: ORG_TYPE_VALUES
		do
			create b.make (type.Pkg_vendor, type.Bump_vendor, type.Test_vendor)
			Result := all_rows_filtered_ordered (conn, "org_no in (select org_no from org#org_types where org_type in (:1, :2, :3))", b, "short_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	itar_approved_rows (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for organizations that are
			-- ITAR approved, ordered by short_id
		require
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_S
			type: ORG_TYPE_VALUES
		do
			create b.make (type.Itar_approved)
			Result := all_rows_filtered_ordered (conn, "org_no in (select org_no from org#org_types where org_type = :1)", b, "short_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	is_itar_approved: BOOLEAN
			-- Is organization approved for handling
			-- ITAR material?
		local
			b: DB_BIND_S
			type: ORG_TYPE_VALUES
			row: ORGXORG_TYPES_ROW
			list: LIST [ORGXORG_TYPES_ROW]
		do
			create b.make (type.Itar_approved)
			create row.make_template
			list := row.rows_with_org_no_and_type (org_no, type.Itar_approved, connection, expected_count.At_most_one)
			Result := not list.is_empty
		end

end
