
class ORGXORG_TYPES_ROW
inherit
	ORGXORG_TYPES_RAW
	ROW_COUNT_CHECK_ACCESS

create
	make_template, make_null

feature -- Properties

	rows_with_org_no (an_org_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All rows with `an_org_no', ordered by org_type
		require
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (an_org_no)
			Result := all_rows_filtered_ordered (conn, "org_no = :1", b, "org_type")
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end

	rows_with_org_no_and_type (an_org_no: INTEGER an_org_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All rows with `an_org_no' and org type `an_org_type'
		require
			an_org_type_not_void: an_org_type /= Void
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_IS
		do
			create b.make (an_org_no, an_org_type)
			Result := all_rows_filtered (conn, "org_no = :1 and org_type = :2", b)
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end

	rows_with_type (an_org_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All rows with org type `an_org_type'
		require
			an_org_type_not_void: an_org_type /= Void
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (an_org_type)
			Result := all_rows_filtered (conn, "org_type = :1", b)
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end

end
