
note

	author: "David Hollenberg"

class PACKING_PROJECT_OPTIONS_MROW
inherit
	PACKING_PROJECT_OPTIONS_MRAW
	PACKING_PROJECT_OPTIONS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		end
	ABSTRACT_MOD_PROCESS_OPTION

create
	make_template, make_null, make_by_key, make_from_explicit_option,
	make_from_layer_option, make_detached

feature {NONE} -- Creation

	make_from_explicit_option (proj: PACKING_PROJECTS_ROW opt: IC_FAB_INSTANCE_OPTIONS_ROW)
			-- Create detached row for option with
			-- attributes determined from `opt' and key
			-- determined from `proj'
		require
			proj_not_void: proj /= Void
			opt_not_void: opt /= Void
		do
			make_detached (proj.any_connection)
			set_key_from_project (proj)
			set_option_id (opt.option_id)
			set_option_in_process (True)
			set_is_explicit (True)
			cached_option := opt.my_opt
		end

	make_from_layer_option (proj: PACKING_PROJECTS_ROW opt: WAFER_PROCESS_OPTION)
			-- Create detached row for option with
			-- attributes determined from `opt' and key
			-- determined from `proj'
		require
			proj_not_void: proj /= Void
			opt_not_void: opt /= Void
		do
			make_detached (proj.any_connection)
			set_key_from_project (proj)
			set_option_id (opt.option_id)
			set_option_in_process (opt.option_in_process)
			set_is_explicit (False)
		end

feature -- Properties

	is_deep_unchanged: BOOLEAN
			-- Are `Current' and all its dependent rows
			-- unchanged from their original versions?
			-- Returns False if no original version
		do
			Result := all_columns_equal_original
		end

feature -- Modification

	set_key_from_project (proj: PACKING_PROJECTS_ROW)
			-- Set key fields from `proj'
		require
			proj_not_void: proj /= Void
		do
			set_packing_id (proj.packing_id)
			set_project_no (proj.project_no)
			set_project_version_no (proj.project_version_no)
		end

feature -- Operations

	register_deep
			-- Register `Current' and all dependent rows
			-- on implicit connection
		do
			register_on_implicit_connection
		end

end
