
note

	author: "David Hollenberg"

class PACKING_PROJECT_PACKAGINGS_MROW
inherit
	PACKING_PROJECT_PACKAGINGS_MRAW
		redefine
			copy_from_row
		end
	PACKING_PROJECT_PACKAGINGS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		end

create
	make_template, make_null, make_by_key, make_detached,
	make_from_line_item

feature {NONE} -- Creation
	
	make_from_line_item (proj: PACKING_PROJECTS_ROW woli: CUST_WO_LINE_ITEMS_ROW)
			-- Create detached row for packaging with
			-- attributes determined from `woli' and with
			-- key fields determined from `proj'
		require
			proj_not_void: proj /= Void
			woli_not_void: woli /= Void
		local
			icp: IC_PACKAGINGS_ROW
			part: M_PARTS_ROW
		do
			icp := woli.ic_packaging
			part := woli.part
			make_detached (woli.connection)
			set_key_from_project (proj)
			set_package_id (icp.package_id)
			set_package_requested (icp.package_requested)
			if not icp.is_null_package_id and not part.is_null_packaged then
				set_packaged (part.packaged)
			else
				set_null_packaged
			end
			set_downbond_location_reqd (icp.downbond_location_reqd)
			if not icp.is_null_design_package_rotation_reqd then
				set_design_package_rotation_reqd (icp.design_package_rotation_reqd)
			else
				set_null_design_package_rotation_reqd
			end
			if not icp.is_null_design_package_rotation then
				set_design_package_rotation (icp.design_package_rotation)
			else
				set_null_design_package_rotation
			end
			if not icp.is_null_die_thickness_mils then
				set_die_thickness_mils (icp.die_thickness_mils)
			else
				set_null_die_thickness_mils
			end
			if not icp.is_null_quantity_packaged_requested then
				set_quantity_packaged_requested (icp.quantity_packaged_requested)
			else
				set_null_quantity_packaged_requested
			end
			set_quantity_ordered (woli.part_quantity_ordered * part.quantity_in_part)
		end

feature -- Properties

	is_deep_unchanged: BOOLEAN
			-- Are `Current' and all its dependent rows
			-- unchanged from their original versions?
			-- Returns False if no original version
		do
			Result := all_columns_equal_original
		end

feature -- Modification

	copy_from_row (r: like original_row)
			-- Initialize `Current' from `r'
		do
			precursor (r)
			cached_max_die_size := r.cached_max_die_size
			is_cached_max_die_size := r.is_cached_max_die_size
		end

	set_key_from_project (p: PACKING_PROJECTS_ROW)
			-- Set key columns from `p' (except line_no,
			-- which is set before rows are inserted into
			-- database)
		do
			set_packing_id (p.packing_id)
			set_project_no (p.project_no)
			set_project_version_no (p.project_version_no)
		end

feature -- Operations

	register_deep
			-- Register `Current' and all dependent rows
			-- on implicit connection
		do
			register_on_implicit_connection
		end

end
