
note

	author: "David Hollenberg"

class PACKING_WAFER_PROCESSES_ROW
inherit
	PACKING_WAFER_PROCESSES_RAW
	PACKING_QUERIES
	DB_HASHABLE_ROW
		undefine
			initialize_new, initialize_old, fill_in
		end
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
create
	make_template, make_null, make_by_key, make_detached

feature -- Queries

	rows_for_packing_version (a_packing_id: STRING a_version_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Wafer processes for `a_packing_id' and
			-- `a_version_no', ordered by wafer process
			-- name
		require
			a_packing_id_not_void: a_packing_id /= Void
			connection_exists: conn /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SI
		do
			create b.make (a_packing_id, a_version_no)
			Result := all_rows_filtered_ordered (conn, "packing_id = :1 and version_no = :2", b, "wafer_process")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

feature -- Properties

	hash_code: INTEGER
		local
			s: STRING
		do
			create s.make (packing_id.count + wafer_process.count + 5)
			s.append (packing_id)
			s.extend ('%U')
			s.append_integer (version_no)
			s.extend ('%U')
			s.append (wafer_process)
			Result := s.hash_code
		end
	
end
