
note

	author: "David Hollenberg"

class PACKINGS_MROW
inherit
	PACKINGS_MRAW
	PACKINGS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		redefine
			anchored_field_set, anchored_litho_size
		end

create
	make_template, make_null, make_by_key, make_detached

feature -- Modification

	initialize_from_run (r: RUNS_ROW)
			-- Initialize from attributes of `r'
		require
			r_not_void: r /= Void
		local
			wt: WAFER_TECHNS_ROW
			def_width: DOUBLE
			sr: SCHEDULED_RUNS_ROW
		do
			wt := r.wafer_techn_row
			sr := r.scheduled_run
			set_date_created (any_connection.transaction_date)
			set_creator (any_connection.user_name)
			set_run_type (r.run_type)
			set_is_taxi (r.initial_run_production.is_taxi)
			set_is_educational (r.is_educational)
			set_wafer_techn (r.wafer_techn)
			set_wafer_techn_family (wt.wafer_techn_family)
			set_sched_run_no (r.sched_run_no)
			if sr.is_null_dedicated_cust_acct_no then
				set_null_dedicated_cust_acct_no
			else
				set_dedicated_cust_acct_no (sr.dedicated_cust_acct_no)
			end
			if sr.is_null_cust_acct_access_predicate then
				set_null_cust_acct_access_predicate
			else
				set_cust_acct_access_predicate (sr.cust_acct_access_predicate)
			end
			set_field_set_name (r.field_set_name)
			if r.is_null_uniform_override_border then
				set_null_uniform_override_border
			else
				set_uniform_override_border (r.uniform_override_border)
			end
			if r.is_null_overhead_style then
				set_null_overhead_style
			else
				set_overhead_style (r.overhead_style)
			end
			set_other_border (r.other_border)
			set_intended_run (r.run_id)
			set_assigned_run_id (r.run_id)
			set_packed_with_new_packer (True)
			def_width := wt.non_null_max_scribe_width
			set_horizontal_scribe_width (def_width)
			set_vertical_scribe_width (def_width)
			set_descr ("Packing created automatically by Delta")
		end

feature {NONE} -- Implementation

	anchored_field_set: FIELD_SETS_MROW
			-- Used for anchoring only
		do
		end

	anchored_litho_size: LITHO_SIZES_MROW
			-- Used for anchoring only
		do
		end

end
