
note

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class RUN_EVENTS_ROW
inherit
	RUN_EVENTS_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature -- Properties

	run_events_with_name (a_run_id, an_event_name: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All run events for `a_run_id' named `an_event_name'
		require
			a_run_id_exists: a_run_id /= Void
			an_event_name_exists: an_event_name /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			a_range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (a_run_id, an_event_name)
			Result := all_rows_filtered (conn, "run_id = :1 and event_name = :2", b)
			check_row_count (Result, range)
		end

	run_closed_events (a_run_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- The "run closed" events for `a_run_id'
		require
			a_run_id_exists: a_run_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			name: EVENT_NAME_VALUES
		do
			Result := run_events_with_name (a_run_id, name.Run_closed, conn, range)
		ensure
			result_exists: Result /= Void
		end

end
