
class SCHEDULED_RUN_CUST_ACCTS_ROW
inherit
	SCHEDULED_RUN_CUST_ACCTS_RAW

	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all
		end


create
	make_template, make_null, make_by_key

feature -- Collections

	rows_for_sched_run_no (sr_no: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All rows for scheduled run number `sr_no'
		require
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (sr_no)
			Result := all_rows_filtered (conn, "sched_run_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end


end
