
note

	author: "David Hollenberg"
	date: "December 15, 2006"

class WAFER_ETEST_NAMES_ROW

inherit
	WAFER_ETEST_NAMES_RAW
	HAS_WAFER_ETEST_ID
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null, make_by_key, make_by_etest_id

feature {NONE} -- Creation

	make_by_etest_id (conn: DB_CONNECTION opt: DB_QUERY_OPTION a_wt_family, an_etest_id: STRING)
			-- Create from `a_wt_family' and `an_etest_id'
			-- (alternate key0
		require
			a_wt_family_not_void: a_wt_family /= Void
			an_etest_id_not_void: an_etest_id /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (a_wt_family, an_etest_id)
			make_by_alternate_key (conn, opt, "wafer_techn_family = :1 and wafer_etest_id = :2", b)
		end

feature -- Collection

	rows_for_wafer_techn (a_wafer_techn: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All wafer etest names for `a_wafer_techn',
			-- ordered by wafer etest ID
		require
			a_wafer_techn_not_void: a_wafer_techn /= Void
			connection_not_void: conn /= Void
			connection_open: conn.is_open
			range_not_void: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (a_wafer_techn)
			Result := all_rows_filtered_ordered (conn, 
				"[
	(wafer_techn_family, wafer_etest_id) in
	(select wp.wafer_techn_family, wp.wafer_etest_id
	from
		wafer_techns_ wt,
		wafer_techn_offered_processes wtop,
		wafer_processes wp
	where
		wt.wafer_techn_family = wtop.wafer_techn_family
   	   and  wt.wafer_techn_id = wtop.wafer_techn_id 
   	   and  wtop.wafer_techn_family = wp.wafer_techn_family
   	   and  wtop.wafer_process_id = wp.wafer_process_id
   	   and  wt.wafer_techn = :1)
				]", 
				b, "wafer_etest_id")
			check_row_count (Result, range)
		ensure
			result_not_void: Result /= Void
		end

feature -- Properties

	has_name (a_name: STRING): BOOLEAN
			-- Does `Current' have wafer_etest_name `a_name'?
		do
			Result := wafer_etest_name.is_equal (a_name)
		end

	has_wafer_etest_id: BOOLEAN = True
			-- Is there an associated wafer etest ID?

end
