
note

	author: "Generated"
	date: "Thu Feb 26 10:39:46 PST 2004"

class WAFER_TECHN_FAMILIES_ROW
inherit
	WAFER_TECHN_FAMILIES_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature

	wafer_techn_families_for_wt (wt: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- All wafer techn families for wafer techn `wt'
		require
			wt_exists: wt /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (wt)
			Result := all_rows_filtered (conn, "wafer_techn_family in (select wafer_techn_family from wafer_techns_ where wafer_techn = :1)", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

feature	-- wafer_techn_family_options

	is_offered_option(oid: STRING): BOOLEAN
			-- is oid one of the offered options of this family?
	require
		have_option: oid /= Void
	local
		wtfo: like wafer_techn_family_options
	do
		wtfo := wafer_techn_family_options;
		from	wtfo.start
		until	wtfo.after or Result
		loop	Result := equal(oid, wtfo.item.option_id)
			wtfo.forth
		end
	end

	wafer_techn_family_options: LIST[WAFER_TECHN_FAMILY_OPTIONS_ROW]
			-- return list of my available options
	local
		r: WAFER_TECHN_FAMILY_OPTIONS_ROW; b: DB_BIND_S
	do
		if cached_options = Void then
			create r.make_template
			create b.make(wafer_techn_family)
			cached_options := r.all_rows_filtered_ordered
						(connection,
						 "wafer_techn_family = :1", b,
						 "option_order")
		end
		Result := cached_options
	ensure
		Result /= Void
	end

feature {NONE} -- implementation of options

	cached_options: LIST[WAFER_TECHN_FAMILY_OPTIONS_ROW]

end
