
note

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class WAFER_TYPES_ROW
inherit
	WAFER_TYPES_RAW
	ROW_COUNT_CHECK_ACCESS
	NULL_VALUE_CHECK_ACCESS
create
	make_template, make_null

feature -- Properties

	wafer_types_with_name (wt_name: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Wafer types with name `wt_name'
		require
			wt_name_exists: wt_name /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (wt_name)
			Result := all_rows_filtered (conn, "wafer_type_id = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	non_null_wafer_shape: like wafer_shape
			-- Value of `wafer_shape', with error check 
			-- for nullness
		do
			check_not_null ("wafer_shape", is_null_wafer_shape, Current)
			Result := wafer_shape
		end

	non_null_wafer_diameter: like wafer_diameter
			-- Value of `wafer_diameter', with error check 
			-- for nullness
		do
			check_not_null ("wafer_diameter", is_null_wafer_diameter, Current)
			Result := wafer_diameter
		end

	non_null_max_primary_flat_indent: like max_primary_flat_indent
			-- Value of `max_primary_flat_indent', with error 
			-- check for nullness
		do
			check_not_null ("max_primary_flat_indent", is_null_max_primary_flat_indent, Current)
			Result := max_primary_flat_indent
		end

	non_null_max_primary_flat_length: like max_primary_flat_length
			-- Value of `max_primary_flat_length', with error 
			-- check for nullness
		do
			check_not_null ("max_primary_flat_length", is_null_max_primary_flat_length, Current)
			Result := max_primary_flat_length
		end

end
