
note
	
	description: "Abstraction for object that may have external cut distances"
	author: "David Hollenberg"

deferred class ABSTRACT_EXT_CUT_DIST_SPEC
inherit
	CONST_ABSTRACT_EXT_CUT_DIST_SPEC

feature -- Modification
	
	set_external_cut_distance_left (d: DOUBLE)
			-- Set `external_cut_distance_left' to `d'
		deferred
		ensure
			value_set: external_cut_distance_left = d
		end

	set_external_cut_distance_right (d: DOUBLE)
			-- Set `external_cut_distance_right' to `d'
		deferred
		ensure
			value_set: external_cut_distance_right = d
		end

	set_external_cut_distance_bottom (d: DOUBLE)
			-- Set `external_cut_distance_bottom' to `d'
		deferred
		ensure
			value_set: external_cut_distance_bottom = d
		end

	set_external_cut_distance_top (d: DOUBLE)
			-- Set `external_cut_distance_top' to `d'
		deferred
		ensure
			value_set: external_cut_distance_top = d
		end

	set_null_external_cut_distance_left
			-- Set `external_cut_distance_left' to null
			-- (floating cut)
		deferred
		ensure
			value_set: is_null_external_cut_distance_left
		end

	set_null_external_cut_distance_right
			-- Set `external_cut_distance_right' to null
			-- (floating cut)
		deferred
		ensure
			value_set: is_null_external_cut_distance_right
		end

	set_null_external_cut_distance_bottom
			-- Set `external_cut_distance_bottom' to null
			-- (floating cut)
		deferred
		ensure
			value_set: is_null_external_cut_distance_bottom
		end

	set_null_external_cut_distance_top
			-- Set `external_cut_distance_top' to null
			-- (floating cut)
		deferred
		ensure
			value_set: is_null_external_cut_distance_top
		end

	set_external_cut_specs (s: CONST_ABSTRACT_EXT_CUT_DIST_SPEC)
			-- Set external cut specifications from `s'
		require
			s_not_void: s /= Void
		do
			if s.has_external_cut_distance_left then
				set_external_cut_distance_left (s.external_cut_distance_left)
			else
				set_null_external_cut_distance_left
			end
			if s.has_external_cut_distance_right then
				set_external_cut_distance_right (s.external_cut_distance_right)
			else
				set_null_external_cut_distance_right
			end
			if s.has_external_cut_distance_bottom then
				set_external_cut_distance_bottom (s.external_cut_distance_bottom)
			else
				set_null_external_cut_distance_bottom
			end
			if s.has_external_cut_distance_top then
				set_external_cut_distance_top (s.external_cut_distance_top)
			else
				set_null_external_cut_distance_top
			end
		end
end
