

note
	description:
		"An abstract wafer process option.  Intended to be used by %
		%inheritance in effective descendants."
	author: "David Hollenberg"
	date:	"April 26, 2006"

deferred class ABSTRACT_PROCESS_OPTION
	-- add option_in_process: BOOLEAN to ESSENCE_OF_OPTION

inherit
	ESSENCE_OF_OPTION

	DB_UTILITIES
		export
			{NONE} all
		end

feature -- Properties

	option_in_process: BOOLEAN
			-- If true, then option is required to be in process.
			-- If false, then option is forbidden to be in process.
		deferred
		end

	to_string (sep: STRING): STRING
			-- Representation of `Current' as a string,
			-- with field values separated by `sep'
		do
			Result := option_id + sep + boolean_to_db_string (option_in_process)
		end

	to_short_string: STRING
			-- Option_id with preceding "-" if not in process
		do
			if option_in_process then
				Result := option_id
			else
				Result := "-" + option_id
			end
		end
end
