deferred class CONTENT_TYPE_CACHE
	-- class to find my content_types_row
	-- based on my content_type_id, and hang on to it.
	-- uses a single shared list of all CONTENT_TYPES_ROW

inherit
	ANY

feature	-- the deferred stuff we need to function

	any_connection: DB_CONNECTION
	deferred
	end;

	content_type_id: STRING
	deferred
	end;

feature	-- fetch and select routines

	content_type: CONTENT_TYPES_ROW
		-- the content_types row for my content_type_id
	local actr: like all_content_types_rows
	do  if cached_content_type = Void or else
	       (not equal(cached_content_type.content_type_id, 
					content_type_id))
	     then -- look it up and cache it
		  from	actr := all_content_types_rows;
			actr.start;
			cached_content_type := Void
		  until actr.after or cached_content_type /= Void
		  loop	if equal(actr.item.content_type_id,
					content_type_id)
			 then cached_content_type := actr.item
			end;
			actr.forth
		  end
	    end
	    Result := cached_content_type
	end;

	all_content_types_rows: LIST[CONTENT_TYPES_ROW]
	local r: CONTENT_TYPES_ROW
	once  create r.make_template
	      Result := r.all_rows(any_connection)
	end;

feature {NONE} -- cached row for this content_type_id

	cached_content_type: CONTENT_TYPES_ROW

end -- CONTENT_TYPE_CACHE
