
note
	
	description: "Queries related to vendor part ids";
	author: "David Hollenberg";
	date: "June 10, 2003"

class DIE_PART_ID_QUERIES

feature -- Properties

	die_part_id_query (seq: STRING): STRING
			-- Query to retrieve runs that reference a part id
			-- from sequence `seq' in the DIES or DIE_LOCATIONS
			-- table
		require
			sequence_exists: seq /= Void
		do
			Result := "run_id in (%N%
  			  %  select run_id from runs r, field_sets fs, wafer_litho_size_part_seq_ids seq %N%
  			  %  where r.field_set_name = fs.field_set_name %N%
        		  %    and r.wafer_techn = seq.wafer_techn %N%
        		  %    and fs.litho_size_id = seq.litho_size_id %N%
			  %    and seq.vendor_part_sequence_id = :1 %N%
			  %    and seq.labelled_entity = :2) %N%
			  %    and wafer_vendor_part_id is not null"
		ensure
			result_exists: Result /= Void
		end
end
