deferred class EFFECTIVE_ON_DATE

	-- supplies effective_on_date(db_date): boolean
	-- to classes with 
	-- a date_effective: db_date and
	-- a (nullable) date_expires

feature	-- the deferred features

	date_effective: DB_DATE
	deferred
	end;

	date_expires: DB_DATE
	deferred
	end;

	is_null_date_expires: BOOLEAN
	deferred
	end;

feature	-- our contribution to the world

	is_effective_on(dat: DB_DATE): BOOLEAN
		-- is dat in my effective date range?
		-- (all dates ignore the time-of-day)
	require exists: dat /= Void
	do  Result :=	(date_effective = Void or else
			  midnight_of(dat) >= midnight_of(date_effective))
			and
			(is_null_date_expires or else
			  midnight_of(date_expires) >= midnight_of(dat))
	end;

feature {NONE} -- details

	midnight_of(dat: DB_DATE): DB_DATE
		-- dat.truncated_to_midnight, unless it already is
	require exists: dat /= Void
	do  if dat.hour = 0 and dat.minute = 0 and dat.second = 0
	     then Result := dat
	     else Result := dat.truncated_to_midnight
	    end
	end;

end -- EFFECTIVE_ON_DATE
