deferred class ESSENCE_OF_DATE_RECEIVED

feature	-- the common features

	connection: DB_CONNECTION
	deferred
	end;

	run_id: STRING 
	deferred
	end;

	production_id: STRING 
	deferred
	end;

	date_received: DB_DATE
	deferred
	end;

	date_received_status: STRING 
	deferred
	end;

	is_null_date_received_status: BOOLEAN
	deferred
	end;

feature	-- classifying the date_received_status

	is_actual: BOOLEAN
	local dsv: DATE_STATUS_VALUES
	do  Result := equal(date_received_status, dsv.actual)
	end;

	is_mosis_projected: BOOLEAN
	local dsv: DATE_STATUS_VALUES
	do  Result := equal(date_received_status, dsv.mosis_projected)
	end;

	is_vendor_projected: BOOLEAN
	local dsv: DATE_STATUS_VALUES
	do  Result := equal(date_received_status, dsv.vendor_projected)
	end;

feature	-- fetching the status publication_text

	publication_text: STRING
	require have_status: not is_null_date_received_status
	local b: DB_BIND_S
	do  create b.make(date_received_status);
	    Result := connection.selected_string
				("publication_text",
				 "date_statuses",
				 "date_status = :1", b)
	end;

end -- ESSENCE_OF_DATE_RECEIVED
