
note
	
	description: "Set of external cut distance specifications"
	author: "David Hollenberg"

class EXT_CUT_DIST_SPEC
inherit
	ABSTRACT_EXT_CUT_DIST_SPEC

create
	default_create, set_external_cut_specs

feature -- Properties
	
	external_cut_distance_left: DOUBLE
			-- <Precursor>
	
	external_cut_distance_right: DOUBLE
			-- <Precursor>
	
	external_cut_distance_top: DOUBLE
			-- <Precursor>
	
	external_cut_distance_bottom: DOUBLE
			-- <Precursor>
	
	is_null_external_cut_distance_left: BOOLEAN
			-- <Precursor>

	is_null_external_cut_distance_right: BOOLEAN
			-- <Precursor>

	is_null_external_cut_distance_bottom: BOOLEAN
			-- <Precursor>

	is_null_external_cut_distance_top: BOOLEAN
			-- <Precursor>

feature -- Modification
	
	set_external_cut_distance_left (d: DOUBLE)
			-- <Precursor>
		do
			external_cut_distance_left := d
			is_null_external_cut_distance_left := False
		end

	set_external_cut_distance_right (d: DOUBLE)
			-- <Precursor>
		do
			external_cut_distance_right := d
			is_null_external_cut_distance_right := False
		end

	set_external_cut_distance_bottom (d: DOUBLE)
			-- <Precursor>
		do
			external_cut_distance_bottom := d
			is_null_external_cut_distance_bottom := False
		end

	set_external_cut_distance_top (d: DOUBLE)
			-- <Precursor>
		do
			external_cut_distance_top := d
			is_null_external_cut_distance_top := False
		end

	set_null_external_cut_distance_left
			-- <Precursor>
		do
			external_cut_distance_left := 0
			is_null_external_cut_distance_left := True
		end

	set_null_external_cut_distance_right
			-- <Precursor>
		do
			external_cut_distance_right := 0
			is_null_external_cut_distance_right := True
		end

	set_null_external_cut_distance_bottom
			-- <Precursor>
		do
			external_cut_distance_bottom := 0
			is_null_external_cut_distance_bottom := True
		end

	set_null_external_cut_distance_top
			-- <Precursor>
		do
			external_cut_distance_top := 0
			is_null_external_cut_distance_top := True
		end


end
