deferred class FILE_ROLE_CACHE
	-- class to find my file_roles_row
	-- based on my file_role, and hang on to it.
	-- uses a single shared list of all FILE_ROLES_ROW
	-- also brings selected attributes to the parent

inherit
	ANY

feature	-- the deferred stuff we need to function

	any_connection: DB_CONNECTION
	deferred
	end;

	file_role: STRING
	deferred
	end;

feature	-- selected FILE_ROLES attributes

	is_layout: BOOLEAN
	do  Result := file_role_row.is_layout
	end;

	needs_mosis_agreement: BOOLEAN
	do  Result := file_role_row.needs_mosis_agreement
	end;

feature	-- fetch and select routines

	file_role_row: FILE_ROLES_ROW
		-- the file_roles row for my file_role
	local afrr: like all_file_roles_rows
	do  if cached_file_role = Void or else
	       (not equal(cached_file_role.file_role, 
					file_role))
	     then -- look it up and cache it
		  from	afrr := all_file_roles_rows;
			afrr.start;
			cached_file_role := Void
		  until afrr.after or cached_file_role /= Void
		  loop	if equal(afrr.item.file_role,
					file_role)
			 then cached_file_role := afrr.item
			end;
			afrr.forth
		  end
	    end
	    Result := cached_file_role
	end;

	all_file_roles_rows: LIST[FILE_ROLES_ROW]
	local r: FILE_ROLES_ROW
	once  create r.make_template
	      Result := r.all_rows(any_connection)
	end;

feature {NONE} -- cached row for this file_role

	cached_file_role: FILE_ROLES_ROW

end -- FILE_ROLE_CACHE
