
note

	author: "David Hollenberg"

deferred class PACKING_QUERIES
inherit
	DB_IDENTIFIED_ROW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
feature -- Queries

	rows_for_run (a_run_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current]
			-- Rows for packing whose intended run is `a_run_id'
		require
			a_run_id_not_void: a_run_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (a_run_id)
			Result := all_rows_filtered (conn, "packing_id in (select packing_id from packings where intended_run = :1)", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
