class MOSIS_UMFE_VALUES
	-- known attribute values with semantic meaning
	-- found primarily in UMFE section tables
	-- They are collected here for ease of use.

feature -- COMMUNICATION_MEDIA and SECURITY_TYPES

	medium_is_email:	STRING = "EMAIL"
	medium_is_web:		STRING = "WEB"
	medium_is_ftp:		STRING = "FTP"
	medium_is_operator:	STRING = "OPERATOR"
	security_is_https:	STRING = "HTTPS"

feature -- REPLY_MODES

	reply_is_immediate:	STRING = "IMMEDIATE"
	reply_is_asynchronous:	STRING = "ASYNCHRONOUS"
	reply_is_info:		STRING = "INFO"
	reply_is_aside:		STRING = "ASIDE"
	reply_is_post:		STRING = "POST"
	reply_is_ship:		STRING = "SHIP"
	reply_is_ftp:		STRING = "FTP"
	reply_is_final_bond:	STRING = "FINAL_BOND"

feature -- CONTENT_TYPE_IDs

	content_is_text:	STRING = "TEXT"
	content_is_html:	STRING = "HTML"

feature -- REQUEST_TYPES (as in M_REQUESTS and the requests themselves)
	-- (request aliases are defined only in the request itself)

	rtype_is_attention:	STRING = "ATTENTION"
	rtype_is_autodrc:	STRING = "AUTODRC"
	rtype_is_canceldedrun:	STRING = "CANCELDEDRUN"
	rtype_is_cancelderived: STRING = "CANCELDERIVED"
	rtype_is_cancelfabrication: STRING = "CANCELFABRICATION"
	rtype_is_cancelproject:	STRING = "CANCELPROJECT"
	rtype_is_creatededrun:	STRING = "CREATEDEDRUN"
	rtype_is_dedrunstatus:	STRING = "DEDRUNSTATUS"
	rtype_is_eccquestionnaire: STRING = "ECCQUESTIONNAIRE"
	rtype_is_fabricate:	STRING = "FABRICATE"
	rtype_is_fab_derived:	STRING = "FABDERIVED"
	rtype_is_force:		STRING = "FORCEINTOQUEUE"
	rtype_is_information:	STRING = "INFORMATION"
	rtype_is_library:	STRING = "LIBRARY"
	rtype_is_mk_fil_avail:	STRING = "MAKEFILEAVAILABLE"
	rtype_is_newproject:	STRING = "NEWPROJECT"
	rtype_is_not_found:	STRING = "NOT_FOUND"
	rtype_is_refab:		STRING = "REFAB"
	rtype_is_replay:	STRING = "REPLAY"
	rtype_is_report:	STRING = "REPORT"
	rtype_is_rework:	STRING = "REWORK"
	rtype_is_sendftp:	STRING = "SENDFTP"
	rtype_is_standardquote:	STRING = "STANDARDQUOTE"
	rtype_is_status:	STRING = "STATUS"
	rtype_is_unknown:	STRING = "UNKNOWN"
	rtype_is_update:	STRING = "UPDATE"
	rtype_is_updatededrun:	STRING = "UPDATEDEDRUN"
	rtype_is_zerocostquote:	STRING = "ZEROCOSTQUOTE"

feature -- MULTILINE_ITEM_TYPES

	ml_item_is_attention:	STRING = "ATTENTION"
	ml_item_is_description:	STRING = "DESCRIPTION"
	ml_item_is_mailing_address: STRING =
		"MAILING_ADDRESS"
	ml_item_is_comments:	STRING =
		"REPORT CHIP COMMENTS"		-- nsf_fab_reports
	ml_item_is_designers:	STRING =
		"REPORT CHIP DESIGNERS"		-- nsf_fab_reports
	ml_item_is_failures:	STRING =
		"REPORT CHIP FAILURE CAUSES"	-- nsf_fab_reports

feature -- MESSAGE_TEMPLATE substitution vars

	key_is_acct:	STRING = "ACCT"
	key_is_actchg:  STRING = "ACTCHG"
	key_is_action:	STRING = "ACTION"
	key_is_actpart:	STRING = "ACTPART"
	key_is_actqty:	STRING = "ACTQTY"
	key_is_addl:	STRING = "ADDL"
	key_is_area:	STRING = "AREA"
	key_is_bdydim:	STRING = "BDYDIM"
	key_is_compval:	STRING = "COMPVAL"
	key_is_count:	STRING = "COUNT"
	key_is_custval:	STRING = "CUSTVAL"
	key_is_date:	STRING = "DATE"
	key_is_descr:	STRING = "DESCR"
	key_is_dieid:	STRING = "DIEID"
	key_is_dno:	STRING = "DNO"
	key_is_estchg:	STRING = "ESTCHG"
	key_is_estpart:	STRING = "ESTPART"
	key_is_estqty:	STRING = "ESTQTY"
	key_is_fabid:	STRING = "FABID"
	key_is_frame:	STRING = "FRAME"
	key_is_handle:	STRING = "HANDLE"
	key_is_hint:	STRING = "HINT"
	key_is_hival:	STRING = "HIVAL"
	key_is_host:	STRING = "HOST"
	key_is_item:	STRING = "ITEM"
	key_is_keep:	STRING = "KEEP"
	key_is_lineno:	STRING = "LINENO"
	key_is_lowval:	STRING = "LOWVAL"
	key_is_name:	STRING = "NAME"
	key_is_oldarg:	STRING = "OLDARG"
	key_is_paramdata: STRING = "PARAMDATA"
	key_is_pkg:	STRING = "PKG"
	key_is_pkslip:	STRING = "PKSLIP"
	key_is_pnam:	STRING = "PNAM"
	key_is_posted:	STRING = "POSTED"
	key_is_priority: STRING = "PRIORITY"
	key_is_prodid:	STRING = "PRODID"
	key_is_pstate:	STRING = "PSTATE"
	key_is_pval:	STRING = "PVAL"
	key_is_reason:	STRING = "REASON"
	key_is_rname:	STRING = "RNAME"
	key_is_rtm:	STRING = "RTM"
	key_is_rtr:	STRING = "RTR"
	key_is_runid:	STRING = "RUNID"
	key_is_shipper:	STRING = "SHIPPER"
	key_is_stage:	STRING = "STAGE"
	key_is_status:  STRING = "STATUS"
	key_is_stru:	STRING = "STRU"
	key_is_support:	STRING = "SUPPORT"
	key_is_tapeout:	STRING = "TAPEOUT"
	key_is_tdno:	STRING = "TDNO"
	key_is_techn:	STRING = "TECHN"
	key_is_text:	STRING = "TEXT"
	key_is_tierno:	STRING = "TIERNO"
	key_is_tname:	STRING = "TNAME"
	key_is_toss:	STRING = "TOSS"
	key_is_time:	STRING = "TIME"
	key_is_total:	STRING = "TOTAL"
	key_is_trkid:	STRING = "TRKID"
	key_is_tsize:	STRING = "TSIZE"
	key_is_upgrade:	STRING = "UPGRADE"
	key_is_url:	STRING = "URL"
	key_is_user:	STRING = "USER"
	key_is_val:	STRING = "VAL"
	key_is_verb:	STRING = "VERB"
	key_is_waftek:	STRING = "WAFTEK"

feature -- some verb values

	verb_is_are:		STRING = "are"
	verb_is_hasbeen:	STRING = "has been"
	verb_is_is:		STRING = "is"
	verb_is_were:		STRING = "were"
	verb_is_willbe:		STRING = "will be"
	verb_is_wouldbe:	STRING = "would be"

feature -- some action values

	action_is_no_fab:       STRING = "may not be fabricated"
	action_is_no_ship:      STRING = "will not be shipped"

feature	-- bonding diagram supplier values

	bdsupp_is_mosis:	STRING = "MOSIS"
	bdsupp_is_customer:	STRING = "CUSTOMER"

end
