
expanded class OVERHEAD_STYLE_VALUES

feature -- Properties

	External_: STRING = "EXTERNAL"
	Internal:  STRING = "INTERNAL"
	None:	   STRING = "NONE"
	Per_project: STRING = ""
	
	Project_specific: STRING = "PROJECT_SPECIFIC"
			-- Not a valid value in database columns,
			-- but useful translation of null to display to users

feature -- Translation

	null_translated (a_style: STRING): STRING
			-- `a_style' with empty string (null) translated to
			-- a value user can understand
		do
			if a_style.is_empty then
				Result := Project_specific
			else
				Result := a_style
			end
		end

	project_specific_translated (a_style: STRING): STRING
			-- `a_style' with Project_specific translated to
			-- empty string
		do
			if a_style.is_equal (Project_specific) then
				Result := ""
			else
				Result := a_style
			end
		end

	is_external (a_style: STRING): BOOLEAN
			-- Is `a_style' an external overhead style?
		do
			Result := a_style.is_equal (External_)
		end

end
