
note
	
	description: "Set of distances of external cuts from payload edge %
		%on all four sides of payload"
	author: "David Hollenberg"

class EXTERNAL_CUT_DISTANCE_SET
create
	make

feature {NONE}

	make (l, r, b, t: DOUBLE a_grid: GRID)
			-- Create set
		require
			a_grid_not_void: a_grid /= Void
		do
			left := l
			right := r
			bottom := b
			top := t
			grid := a_grid
		end

feature
	grid: GRID
			-- Grid used for formatting

	left: DOUBLE
			-- Distance of external cut from left
			-- edge of payload, in microns, if cut
			-- is present on that side

	right: DOUBLE
			-- Distance of external cut from right
			-- edge of payload, in microns, if cut
			-- is present on that side

	bottom: DOUBLE
			-- Distance of external cut from bottom
			-- edge of payload, in microns, if cut
			-- is present on that side

	top: DOUBLE
			-- Distance of external cut from top
			-- edge of payload, in microns, if cut
			-- is present on that side

	formatted_left: STRING
			-- `left' formatted nicely
		do
			Result := grid.formatted_number (left)
		end

	formatted_right: STRING
			-- `right' formatted nicely
		do
			Result := grid.formatted_number (right)
		end

	formatted_bottom: STRING
			-- `bottom' formatted nicely
		do
			Result := grid.formatted_number (bottom)
		end

	formatted_top: STRING
			-- `top' formatted nicely
		do
			Result := grid.formatted_number (top)
		end

end
