
note
	
	description: "Model of some portion of the world"
	author: "David Hollenberg"
	date: "July 15, 2006"

class MODEL
inherit
	GRIDABLE

feature -- Properties

	elements: LIST [like anchored_model_element]
			-- Elements comprising whatever is being modeled

	bounding_box: CONST_RECTANGLE
			-- Bounding box for all elements in model
		local
			box: RECTANGLE
		do
			if not elements.is_empty then
				create box.make_copy (elements.first.bounding_box)
				from
					elements.start
				until
					elements.after
				loop
					box.extend_to_include (elements.item.bounding_box)
					elements.forth
				end
				Result := box
			else
				create Result.make_by_size_and_center (0.0, 0.0, 0.0, 0.0)
			end
		end

	anchored_model_element: MODEL_ELEMENT
			-- Type of elements in model
		do
		ensure
			result_void: Result = Void
		end

end
