
note
	
	description: "Object that is a sub-element of a reticle cut"
	author: "David Hollenberg"
	date: "July 25, 2006"

class RETICLE_CUT_SUB_ELEMENT
inherit
	RETICLE_MODEL_SUB_ELEMENT

feature {NONE} -- Creation

	make (a_size_x, a_size_y, a_center_x, a_center_y: DOUBLE)
			-- Create cut sub-element
		do
			size_x := a_size_x
			size_y := a_size_y
			center_x := a_center_x
			center_y := a_center_y
		end

feature -- Properties

	size_x: DOUBLE
			-- Size of minimum bounding box in X dimension

	size_y: DOUBLE
			-- Size of minimum bounding box in Y dimension

	center_x: DOUBLE
			-- Center of minimum bounding box in X dimension

	center_y: DOUBLE
			-- Center of minimum bounding box in Y dimension

	has_required_rotation: BOOLEAN
			-- Must object have specific rotation?
		do
			Result := False
		end

	required_rotation: INTEGER
			-- Rotation object is required to have in degrees clockwise
		do
			Result := 0
		end

end
