
note
	
	description: "Rectangular area of model of a reticle"
	author: "David Hollenberg"
	date: "July 28, 2006"

class RETICLE_MODEL_AREA

create
	make

feature {NONE} -- Creation

	make (a_rectangle: like rectangle n: INTEGER)
			-- Create with initial space for `n' elements and
			-- area of model covered by `a_rectangle'
		require
			a_rectangle_not_void: a_rectangle /= Void
			initial_capacity_nonnegative: n >= 0
		do
			rectangle := a_rectangle
			create {ARRAYED_LIST [RETICLE_VIEW_ELEMENT]} intersecting_elements.make (n)
		end

feature -- Properties

	rectangle: CONST_RECTANGLE
			-- Rectangle that defines area of model

	intersecting_elements: LIST [RETICLE_VIEW_ELEMENT]
			-- Elements that intersect `rectangle'

end
