
note
	
	description: "Context of reticle model, which can be saved and restored"
	author: "David Hollenberg"
	date: "July 15, 2006"

class RETICLE_MODEL_CONTEXT

feature -- Properties

	elements: LIST [RETICLE_MODEL_ELEMENT]
			-- Elements comprising whatever is being modeled

	copies_table: HASH_TABLE [LIST [RETICLE_MODEL_ELEMENT], PACKING_DIES_MROW]
			-- Table that maps a packing die to the list
			-- of model elements for that die (each
			-- element is one location of die)

feature -- Modification

	set_elements (a_list: like elements)
			-- Set `elements' to `a_list'
		do
			elements := a_list
		ensure
			elements_set: elements = a_list
		end

	set_copies_table (a_table: like copies_table)
			-- Set `copies_table' to `a_table'
		do
			copies_table := a_table
		ensure
			copies_table_set: copies_table = a_table
		end

end

