
note
	
	description: "Object that is an sub-element of a model element that %
		%is comprised of more than one part (each one rectangular) %
		%in reticle model"
	author: "David Hollenberg"
	date: "July 25, 2006"

deferred class RETICLE_MODEL_SUB_ELEMENT
inherit
	MODEL_SUB_ELEMENT
		redefine
			anchored_model, anchored_model_element
		end

feature -- Properties

	identification: STRING
			-- Identifying name of element
		do
			Result := model_element.identification
		end

	is_selectable: BOOLEAN
			-- May object be selected?
		do
			Result := model_element.is_selectable
		end

	rotation: INTEGER
			-- Rotation of object in degrees clockwise
		do
			Result := model_element.rotation
		end

	is_rotated_sideways: BOOLEAN
			-- Is object rotated by 90 degrees clockwise or
			-- 90 degrees counterclockwise?
		do
			Result := model_element.is_rotated_sideways
		end

	is_cut_line: BOOLEAN
			-- Is element a cut line?
		do
			Result := False
		end

	is_cut_handle: BOOLEAN
			-- Is element a cut handle?
		do
			Result := False
		end

	anchored_model: RETICLE_MODEL
			-- Type of model of which sub-element is part
		do
		end

	anchored_model_element: RETICLE_MODEL_ELEMENT
			-- Type of model element of which `Current' is
			-- one part
		do
		end

end
