
note
	
	description: "Simple change applied to reticle during packing, which %
		%cannot be undone or redone individually but can be undone or %
		%redone as part of a group of changes"
	author: "David Hollenberg"
	date: "January 25, 2007"

deferred class RETICLE_SIMPLE_CHANGE

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT)
		require
			an_element_not_void: an_element /= Void
		do
			element := an_element
		end

feature -- Properties

	parent: RETICLE_CHANGE
			-- Change that includes this simple change, if
			-- not Void

feature -- Modification

	set_parent (a_parent: like parent)
		require
			a_parent_not_void: a_parent /= Void
		do
			parent := a_parent
		end

feature -- Operations

	undo
			-- Undo change
		deferred
		end

	redo
			-- Redo change
		deferred
		end

feature {NONE} -- Implementation

	element: RETICLE_VIEW_ELEMENT
			-- View element that was changed

	model_element: RETICLE_MODEL_ELEMENT
			-- Model element for `element'
		do
			Result := element.model_element
		end

	view: RETICLE_VIEW
			-- View to which element belongs
		do
			Result := element.view
		end

	model: RETICLE_MODEL
			-- Model to which model element of `element' belongs
		do
		end

end
