
note
	
	description: "Object that is an element of a view of a reticle"
	author: "David Hollenberg"
	date: "July 25, 2006"

class RETICLE_VIEW_ELEMENT
inherit
	VIEW_ELEMENT
		redefine
			anchored_model_element,anchored_view_sub_element
		end

feature {NONE} -- Creation

	make (a_model_element: like anchored_model_element a_view: ANY)
		require
			a_model_element_not_void: a_model_element /= Void
		do
		end

feature -- Properties

	view: RETICLE_VIEW

	max_db_value: DOUBLE
		do
		end

	grid: GRID
		do
		end

	label_generator: ANY

	is_label_generator_changed: BOOLEAN

	is_color_generator_changed: BOOLEAN

	fill_generator: ANY

	is_fill_generator_changed: BOOLEAN

	opacity_generator: ANY

	is_opacity_generator_changed: BOOLEAN

	is_hidden_element_displayed: BOOLEAN

	is_hidden_element_displayed_changed: BOOLEAN

	line_width: INTEGER
		do
			if is_selected then
			else
			end
		end

	label: STRING
		do
		end

	label_rotation: INTEGER
		do
		end

	is_interior_filled: BOOLEAN
		do
		end

	is_opaque: BOOLEAN
		do
		end

	is_transparent: BOOLEAN
		do
		end

	is_selected: BOOLEAN

	is_selected_changed: BOOLEAN

	included_in_changed_region: BOOLEAN

	matched_last_search: BOOLEAN

	matched_last_search_changed: BOOLEAN

	identification: STRING
		do
		end

	identification_for_message: STRING
		do
		end

	location_description: STRING
		do
		end

	size_description: STRING
		do
		end

	virtual_scribe_cut_size_description: STRING
		do
		end

	actual_scribe_cut_size_description: STRING
		do
		end

	virtual_cut_cut_size_description: STRING
		do
		end

	actual_cut_cut_size_description: STRING
		do
		end

	offset_cut_center_description: STRING
		do
		end

	design_number: INTEGER
		require
			is_project: is_project
		do
		end

	design_name: STRING
		do
		end

	die_id: STRING
		do
		end

	non_scribe_die_id: STRING
		do
		end

	mask_site_number: INTEGER
		require
			has_mask_site_number: has_mask_site_number
		do
		end

	has_mask_site_number: BOOLEAN
		do
		end

	account_number: STRING
		do
		end

	account_type: STRING
		do
		end

	organization_short_id: STRING
		do
		end

	effective_overhead_style: STRING
		do
		end

	effective_overhead_style_description: STRING
		do
		end

	is_layout_preliminary: BOOLEAN
		do
		end

	layout_status_description: STRING
		do
		end

	test_vehicle_priority: STRING
		do
		end

	required_rotation_description: STRING
		do
			if has_required_rotation then
				if rotation /= required_rotation then
					Result.extend ('%N')
					Result.append ("Cur Rot = " + rotation.out)
				end
			else
			end
		end

	wafer_etest_name: STRING
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	alternate_wafer_etest_names: LIST [STRING]
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	alternate_assigned_wafer_etest_names: LIST [WAFER_ETEST_NAMES_ROW]
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	assigned_wafer_etest_id: STRING
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	assigned_wafer_etest_name: WAFER_ETEST_NAMES_ROW
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	unassigned_wafer_etest_ids: LIST [STRING]
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	has_wafer_etest_id: BOOLEAN
		do
		end

	is_wafer_etest_id_assigned: BOOLEAN
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	is_wafer_etest_id_missing: BOOLEAN
		do
		end

	compatible_wafer_etest_ids: LIST [STRING]
		require
			has_wafer_etest_id: has_wafer_etest_id
		do
		end

	compatible_wafer_etest_names: LIST [WAFER_ETEST_NAMES_ROW]
		do
		end

	all_compatible_etest_names_manufacturable: BOOLEAN
		local
			list: like compatible_wafer_etest_names
		do
			from
				list.start
			until
				list.after or not Result
			loop
				list.forth
			end
		end

	any_compatible_etest_name_matches (a_partition: RETICLE_VIEW_ELEMENT): BOOLEAN
		local
			list: like compatible_wafer_etest_names
			lot, required_lot: STRING
		do
			from
				list.start
			until
				list.after or Result
			loop
				list.forth
			end
		end

	has_constraining_wafer_etest_id: BOOLEAN
		do
		end

	constraining_wafer_etest_id: STRING
		require
			has_constraining_wafer_etest_id: has_constraining_wafer_etest_id
		do
		end

	constraining_wafer_etest_name: STRING
		require
			has_constraining_wafer_etest_id: has_constraining_wafer_etest_id
		do
		end

	constraining_wafer_etest_names_row: WAFER_ETEST_NAMES_ROW
		require
			has_constraining_wafer_etest_id: has_constraining_wafer_etest_id
		do
		end

	has_quantity_requested: BOOLEAN
		do
		end

	quantity_requested: INTEGER
		require
			has_quantity_requested: has_quantity_requested
		do
		end

	has_quantity_ordered: BOOLEAN
		do
		end

	quantity_ordered: INTEGER
		require
			has_quantity_ordered: has_quantity_ordered
		do
		end

	packaging_description: STRING
		do
		end

	has_ceramic_packaging: BOOLEAN
		do
		end

	has_plastic_packaging: BOOLEAN
		do
		end

	is_commercial_project: BOOLEAN
		do
		end

	is_mep_project: BOOLEAN
		do
		end

	is_mep_instructional_project: BOOLEAN
		do
		end

	is_mep_research_project: BOOLEAN
		do
		end

	is_mep_other_project: BOOLEAN
		do
		end

	is_other_project: BOOLEAN
		do
		end

	is_die: BOOLEAN
		do
		end

	is_non_filler_die: BOOLEAN
		do
		end

	reticle_die: RETICLE_DIE
		require
			is_die: is_die
		do
		end

	is_non_scribe_die: BOOLEAN
		do
		end

	is_abstract_die: BOOLEAN
		do
		end

	is_cut: BOOLEAN
		do
		end

	is_horizontal_cut: BOOLEAN
		do
		end

	is_vertical_cut: BOOLEAN
		do
		end

	is_external_cut: BOOLEAN
		do
		end

	external_cut_position_for (dist: EXTERNAL_CUT_DISTANCE_SET): DOUBLE
		require
			is_external_cut: is_external_cut
		do
		end

	cut_position: DOUBLE
		require
			is_cut: is_cut
		do
		end

	cut_field_relative_position: DOUBLE
		require
			is_cut: is_cut
		do
		end

	gridded_cut_position: DOUBLE
		require
			is_cut: is_cut
		do
		end

	cut_line: RETICLE_VIEW_SUB_ELEMENT
		require
			is_cut: is_cut
		do
		end

	is_cut_pattern_label: BOOLEAN
		do
		end

	is_field: BOOLEAN
		do
		end

	is_field_label: BOOLEAN
		do
		end

	is_project: BOOLEAN
		do
		end

	is_project_or_placeholder: BOOLEAN
		do
		end

	is_cust_project: BOOLEAN
		do
		end

	is_unlocked_or_unassigned_project: BOOLEAN
		do
		end

	is_unlocked_project: BOOLEAN
		do
		end

	is_unassigned_project: BOOLEAN
		do
		end

	is_uncentered_in_cut_die_project: BOOLEAN
		do
		end

	is_test_vehicle: BOOLEAN
		do
		end

	is_high_priority_test_vehicle: BOOLEAN
		do
		end

	is_partition: BOOLEAN
		do
		end
	
	both_or_neither_are_partitions (other: RETICLE_VIEW_ELEMENT): BOOLEAN
		do
		end
	
	neither_is_partition (other: RETICLE_VIEW_ELEMENT): BOOLEAN
		do
		end
	
	is_scribe: BOOLEAN
		do
		end
	
	is_horizontal_scribe: BOOLEAN
		do
		end

	is_vertical_scribe: BOOLEAN
		do
		end

	is_default_width_scribe: BOOLEAN
		do
		end

	is_custom_width_scribe: BOOLEAN
		do
			
		end

	scribe_width: DOUBLE
		require
			is_scribe: is_scribe
		do
			if is_horizontal_scribe then
			else
			end
		end

	default_scribe_width: DOUBLE
		do
		end

	is_non_scribe: BOOLEAN
		do
		end
	
	is_meetable: BOOLEAN
		do
		end
	
	is_movable_in_length_dimension: BOOLEAN
		require
			is_scribe: is_scribe
		do
			if is_horizontal_scribe then
			else
			end
		end
	
	is_filler: BOOLEAN
		do
		end

	is_normal_filler: BOOLEAN
		do
		end

	is_temporary_filler: BOOLEAN
		do
		end

	is_placeholder_filler: BOOLEAN
		do
		end

	is_non_placeholder_filler: BOOLEAN
		do
		end

	is_vendor_geometry: BOOLEAN
		do
		end

	is_movable_vendor_geometry: BOOLEAN
		do
		end

	is_selectable_by_mouse: BOOLEAN
		do
		end

	is_resizable: BOOLEAN
		do
		end

	is_below_minimum_size: BOOLEAN
		do
		end

	is_small_scribe_or_filler: BOOLEAN
		do
		end

	uniform_white_space_border: DOUBLE
		do
		end

	minimum_separation: DOUBLE
		do
		end

	needs_min_sep_white_space: BOOLEAN
		do
		end

	minimum_gap: DOUBLE
		do
		end

	minimum_separation_from (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
		do
		end

	fields: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	field: RETICLE_VIEW_ELEMENT
		local
			l_fields: like fields
			f: RETICLE_VIEW_ELEMENT
		do
			from
				l_fields.start
			until
				l_fields.after or Result /= Void
			loop
				if f.model_element.field = model_element.field then
				end
				l_fields.forth
			end
		end

	reticle_field: RETICLE_FIELD
		do
		end

	field_name: STRING
		do
		end

	distance_from_associated_field_to_field (a_field_name: STRING): CONST_POINT
		require
			a_field_name_not_void: a_field_name /= Void
		do
		end

	is_center_in_field: BOOLEAN
		do
		end

	is_center_x_in_field: BOOLEAN
		do
		end

	is_center_y_in_field: BOOLEAN
		do
		end

	intersects_field (f: RETICLE_FIELD): BOOLEAN
		do
		end

	intersects_any_field: BOOLEAN
		do
		end

	intersects_more_than_one_field: BOOLEAN
		do
		end

	intersection_with_fields: LIST [RECTANGLE]
		do
		end

	intersecting_fields: LIST [RETICLE_FIELD]
		do
		end

	enclosed_by_one_field: BOOLEAN
		do
		end

	partially_outside_fields: BOOLEAN
		do
		end

	is_too_close_to_field_edge: BOOLEAN
		do
		end

	is_edge_too_close_to_field_edge (dist: DOUBLE): BOOLEAN
		do
		end

	distance_in_x_from (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
		do
		end

	distance_in_y_from (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
		do
		end

	abuts_field_edge_on_length_side: BOOLEAN
		require
			is_scribe: is_scribe
		do
		end

	abuts_left_field_edge: BOOLEAN
		do
		end

	abuts_right_field_edge: BOOLEAN
		do
		end

	abuts_bottom_field_edge: BOOLEAN
		do
		end

	abuts_top_field_edge: BOOLEAN
		do
		end

	left_to_field_edge: DOUBLE
		do
		end

	right_to_field_edge: DOUBLE
		do
		end

	top_to_field_edge: DOUBLE
		do
		end

	bottom_to_field_edge: DOUBLE
		do
		end

	field_containing_top_edge: RETICLE_FIELD
		do
		end

	field_containing_bottom_edge: RETICLE_FIELD
		do
		end

	field_containing_left_edge: RETICLE_FIELD
		do
		end

	field_containing_right_edge: RETICLE_FIELD
		do
		end

	abuts_element_on_both_sides (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		require
			is_scribe: is_scribe
		do
		end

	abuts_bottom_element_edge (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			pos, low, high: DOUBLE
			elem_pos, elem_low, elem_high: DOUBLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				list.forth
			end
		end

	abuts_top_element_edge (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			pos, low, high: DOUBLE
			elem_pos, elem_low, elem_high: DOUBLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				list.forth
			end
		end

	abuts_left_element_edge (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			pos, low, high: DOUBLE
			elem_pos, elem_low, elem_high: DOUBLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				list.forth
			end
		end

	abuts_right_element_edge (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			pos, low, high: DOUBLE
			elem_pos, elem_low, elem_high: DOUBLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				list.forth
			end
		end

	x_outside_all_fields (a_value: DOUBLE): BOOLEAN
		do
		end

	y_outside_all_fields (a_value: DOUBLE): BOOLEAN
		do
		end

	closest_field_edge_above (a_value: DOUBLE): DOUBLE
		do
		end

	closest_field_edge_below (a_value: DOUBLE): DOUBLE
		do
		end

	closest_field_edge_to_left (a_value: DOUBLE): DOUBLE
		do
		end

	closest_field_edge_to_right (a_value: DOUBLE): DOUBLE
		do
		end

	intersects (an_element: like Current): BOOLEAN
		do
		end

	encloses (an_element: like Current): BOOLEAN
		do
		end

	model_bounding_box: CONST_RECTANGLE
		do
		end

	size_x: DOUBLE
		do
		end

	size_y: DOUBLE
		do
		end

	has_zero_size_in_x: BOOLEAN
		do
		end
		
	has_zero_size_in_y: BOOLEAN
		do
		end
		
	has_size_x: BOOLEAN = True

	has_size_y: BOOLEAN = True

	size_x_string: STRING
		do
		end

	size_y_string: STRING
		do
		end

	gridded_size_x: DOUBLE
		do
		end

	gridded_size_y: DOUBLE
		do
		end

	has_gridded_size_x: BOOLEAN = True

	has_gridded_size_y: BOOLEAN = True

	gridded_size_x_string: STRING
		do
		end

	gridded_size_y_string: STRING
		do
		end

	die_area: DOUBLE
		do
		end

	project_area: DOUBLE
		do
		end

	slop_x: DOUBLE
		require
			has_max_die_size: has_max_die_size
		do
		end

	slop_y: DOUBLE
		require
			has_max_die_size: has_max_die_size
		do
		end

	slop_x_alt: DOUBLE
		require
			has_alt_max_die_size: max_die_size_alt /= Void
		do
		end

	slop_y_alt: DOUBLE
		require
			has_alt_max_die_size: max_die_size_alt /= Void
		do
		end

	left_x: DOUBLE
		do
		end

	right_x: DOUBLE
		do
		end

	top_y: DOUBLE
		do
		end

	bottom_y: DOUBLE
		do
		end

	gridded_left_x: DOUBLE
		do
		end

	gridded_right_x: DOUBLE
		do
		end

	gridded_top_y: DOUBLE
		do
		end

	gridded_bottom_y: DOUBLE
		do
		end

	center_x: DOUBLE
		do
		end

	center_y: DOUBLE
		do
		end

	field_relative_center_x: DOUBLE
		do
		end

	field_relative_center_y: DOUBLE
		do
		end

	field_relative_left_x: DOUBLE
		do
		end

	field_relative_right_x: DOUBLE
		do
		end

	field_relative_top_y: DOUBLE
		do
		end

	field_relative_bottom_y: DOUBLE
		do
		end

	has_left_x: BOOLEAN = True

	has_bottom_y: BOOLEAN = True

	has_center_x: BOOLEAN = True

	has_center_y: BOOLEAN = True

	left_x_string: STRING
		do
		end

	bottom_y_string: STRING
		do
		end

	center_x_string: STRING
		do
		end

	center_y_string: STRING
		do
		end

	gridded_center_x: DOUBLE
		do
		end

	gridded_center_y: DOUBLE
		do
		end

	has_gridded_center_x: BOOLEAN = True

	has_gridded_center_y: BOOLEAN = True

	gridded_center_x_string: STRING
		do
		end

	gridded_center_y_string: STRING
		do
		end

	has_fixed_in_x: BOOLEAN = True

	has_fixed_in_y: BOOLEAN = True

	has_max_die_size: BOOLEAN
		do
		end

	has_max_die_size_alt: BOOLEAN
		do
		end

	max_die_size: CONST_POINT
		require
			is_die: is_die
		do
		end

	max_die_size_alt: CONST_POINT
		require
			is_die: is_die
		local
			pkg_max: like packaging_max_die_size_alt
		do
			if pkg_max /= Void then
			end
		end

	packaging_max_die_size_fixed_rotation: CONST_POINT
		require
			is_die: is_die
		do
		end

	packaging_max_die_size_free_rotation: CONST_POINT
		require
			is_die: is_die
		do
		end

	packaging_max_die_size: CONST_POINT
		require
			is_die: is_die
		local
			max_1, max_2: CONST_POINT
		do
			if max_1 = Void and max_2 = Void then
			elseif max_2 = Void then
			elseif max_1 = Void then
			else
				if max_1.is_less_equal (max_2) then
				elseif max_2.is_less_equal (max_1) then
				else
				end
			end
		end

	packaging_max_die_size_alt: CONST_POINT
		require
			is_die: is_die
		local
			max_1, max_2: CONST_POINT
		do
			if max_2 = Void or max_2 = Void or max_1.is_less_equal (max_2) or max_2.is_less_equal (max_1) then
			else
			end
		end

	user_max_die_size: CONST_POINT
		require
			is_die: is_die
		do
		end

	is_oversize_die_always_allowed: BOOLEAN
		require
			is_die: is_die
		do
		end

	is_oversize_die_possibly_allowed: BOOLEAN
		require
			is_die: is_die
		do
		end

	oversize_die_inclusion_short_desc: STRING
		require
			is_die: is_die
		do
			if is_oversize_die_always_allowed then
			elseif is_oversize_die_possibly_allowed then
			else
			end
		end

	oversize_die_inclusion_conditions: STRING
		require
			is_die: is_die
			oversize_die_possibly_allowed: is_oversize_die_possibly_allowed
		do
		end

	has_sub_elements: BOOLEAN
		do
		end

	sub_elements: LIST [like anchored_view_sub_element]

	packing_name: STRING
		do
		end

	has_packing_name: BOOLEAN = True

	die: PACKING_DIES_MROW
		require
			is_die: is_die
		do
		end

	die_location: PACKING_DIE_LOCATIONS_MROW
		require
			is_die: is_die
		do
		end

	project: PACKING_PROJECTS_MROW
		require
			is_project: is_project
		do
		end

	partition: PACKING_PARTITIONS_MROW
		require
			is_partition: is_partition
		do
		end

	all_copies: RETICLE_VIEW_ELEMENT_LIST

	all_copies_selected: BOOLEAN
		do
		end

	any_copies_selected: BOOLEAN
		do
		end

	is_partially_selected: BOOLEAN
		do
		end

	any_copies_stationary_orientation: BOOLEAN
		do
		end

	any_copies_rotation_locked: BOOLEAN
		do
		end

	is_processed: BOOLEAN
		do
		end

	rotation_move_distance: DOUBLE
		do
		end

	participates_in_measure: BOOLEAN
		do
		end

	participates_in_scan: BOOLEAN
		do
		end

	is_misaligned_with (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
		require
			is_scribe: is_scribe
			an_element_is_scribe: an_element.is_scribe
			same_orientation_if_horizontal: is_horizontal_scribe implies an_element.is_horizontal_scribe
			same_orientation_if_vertical: is_vertical_scribe implies an_element.is_vertical_scribe
		local
			low, high, other_low, other_high: DOUBLE
			cen, other_cen: DOUBLE
		do
			if is_horizontal_scribe then
			else
			end
		end

	misalignment_amount (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
		require
			is_scribe: is_scribe
			an_element_is_scribe: an_element.is_scribe
			same_orientation_if_horizontal: is_horizontal_scribe implies an_element.is_horizontal_scribe
			same_orientation_if_vertical: is_vertical_scribe implies an_element.is_vertical_scribe
		local
			low, high, other_low, other_high: DOUBLE
			low_diff, high_diff: DOUBLE
		do
			if is_horizontal_scribe then
			else
			end
			if low_diff = 0.0 then
			elseif high_diff = 0.0 then
			else
			end
		end

	is_marked: BOOLEAN

	invalid_elements: LIST [RETICLE_VIEW_ELEMENT]

	virtual_scribe_cut_die: CONST_RECTANGLE
		do
		end

	actual_scribe_cut_die: CONST_RECTANGLE
		do
		end

	virtual_oriented_scribe_cut_die: CONST_RECTANGLE
		do
		end

	actual_oriented_scribe_cut_die: CONST_RECTANGLE
		do
		end

	virtual_scribe_cut_die_size_x: DOUBLE
		do
		end

	virtual_scribe_cut_die_size_y: DOUBLE
		do
		end

	actual_scribe_cut_die_size_x: DOUBLE
		do
		end

	actual_scribe_cut_die_size_y: DOUBLE
		do
		end

	virtual_edge_cut_die: CONST_RECTANGLE
		do
		end

	virtual_field_relative_cut_cut_die: CONST_RECTANGLE
		do
		end

	virtual_oriented_cut_cut_die: CONST_RECTANGLE
		do
		end

	actual_oriented_cut_cut_die: CONST_RECTANGLE
		do
		end

	virtual_cut_cut_die: CONST_RECTANGLE
		do
		end

	actual_cut_cut_die: CONST_RECTANGLE
		do
		end

	virtual_cut_or_scribe_cut_die: CONST_RECTANGLE
		do
			if Result = Void then
			end
		end

	virtual_cut_cut_die_size_x: DOUBLE
		do
		end

	virtual_cut_cut_die_size_y: DOUBLE
		do
		end

	actual_cut_cut_die_size_x: DOUBLE
		do
		end

	actual_cut_cut_die_size_y: DOUBLE
		do
		end

	has_surrounding_cuts: BOOLEAN

	current_cut_pattern: RETICLE_VIEW_CUT_PATTERN
		do
		end

	virtual_isolated_cut_die: CONST_RECTANGLE
		do
		end

	is_in_current_cut_pattern_lot: BOOLEAN
		local
			cp_etest_name: STRING
			alt_etest_names: LIST [STRING]
		do
			if has_wafer_etest_id then
			else
			end
		end

	is_floating_scribe: BOOLEAN

	is_misaligned_scribe: BOOLEAN

	is_empty_partition: BOOLEAN

	is_partition_with_invalid_edge: BOOLEAN

	is_not_contained_in_partition: BOOLEAN

	is_partially_in_partition: BOOLEAN

	is_invalidly_placed_scribe: BOOLEAN

	has_wrong_lot_for_partition: BOOLEAN

	is_cut_too_close_to_adjacent_cut: BOOLEAN

	is_cut_too_close_to_adjacent_strip_cut: BOOLEAN

	all_partitions: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	last_duplicated_element: RETICLE_VIEW_ELEMENT

	center_fits_in_database (a_center: CONST_POINT): BOOLEAN
		require
			a_center_not_void: a_center /= Void
		do
		end

	moved_center_fits_in_database (a_distance: CONST_POINT): BOOLEAN
		require
			a_distance_not_void: a_distance /= Void
		do
		end

	intersecting_mbb_areas: LIST [RETICLE_MODEL_AREA]

	intersecting_scribe_cut_die_areas: LIST [RETICLE_MODEL_AREA]

	intersecting_cut_cut_die_areas: LIST [RETICLE_MODEL_AREA]

	intersecting_hscribe_areas: LIST [RETICLE_MODEL_AREA]

	intersecting_vscribe_areas: LIST [RETICLE_MODEL_AREA]

	intersecting_scribe_areas: LIST [RETICLE_MODEL_AREA]
		require
			is_scribe: is_scribe
		do
			if is_horizontal_scribe then
			else
			end
		end

	is_overlapping_another_object: BOOLEAN

	is_too_close_to_another_object: BOOLEAN

	is_unisolated_in_scribe_cut_die: BOOLEAN

	is_unisolated_in_cut_cut_die: BOOLEAN

	is_isolating_cut: BOOLEAN

	misaligned_with_other_scribe: BOOLEAN
		require
			is_scribe: is_scribe
		local
			areas: LIST [RETICLE_MODEL_AREA]
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if intersects_any_field then
				from
					areas.start
				until
					areas.after or Result
				loop
					from
						elems.start
					until
						elems.after or Result
					loop
						if elem /= Current and is_misaligned_with (elem) then
						end
						elems.forth
					end
					areas.forth
				end
			end
		end

	contains_project: BOOLEAN
		require
			is_partition: is_partition
		local
			mbb: CONST_RECTANGLE
			areas: LIST [RETICLE_MODEL_AREA]
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				areas.start
			until
				areas.after or Result
			loop
				from
					elems.start
				until
					elems.after or Result
				loop
					if elem.is_project_or_placeholder and mbb.truly_contains (create {CONST_POINT}.make_xy (elem.center_x, elem.center_y)) then
					end
					elems.forth
				end
				areas.forth
			end
		end

	is_contained_in_any_element (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			mbb: CONST_RECTANGLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				if elem.model_bounding_box.encloses (mbb) then
				end
				list.forth
			end
		end

	intersects_any_element (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			mbb: CONST_RECTANGLE
			elem: RETICLE_VIEW_ELEMENT
		do
			from
				list.start
			until
				list.after or Result
			loop
				if elem.model_bounding_box.intersects (mbb) then
				end
				list.forth
			end
		end

	unique_containing_element (list: LIST [RETICLE_VIEW_ELEMENT]): RETICLE_VIEW_ELEMENT
		local
			p: CONST_POINT
			done: BOOLEAN
			elem: RETICLE_VIEW_ELEMENT
		do
			create p.make_xy (center_x, center_y)
			from
				list.start
			until
				list.after or done
			loop
				if elem.model_bounding_box.truly_contains (p) then
					if Result = Void then
					else
					end
				end
				list.forth
			end
		end

	mismatches_partition_lot (a_partition: RETICLE_VIEW_ELEMENT): BOOLEAN
		local
			lot, required_lot: like assigned_wafer_etest_id
		do
		end

	mismatches_containing_partition_lot (list: LIST [RETICLE_VIEW_ELEMENT]): BOOLEAN
		local
			l_partition: RETICLE_VIEW_ELEMENT
		do
			if l_partition /= Void then
			end
		end

	overlaps_other_object: BOOLEAN
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if intersects_any_field then
				from
					areas.start
				until
					areas.after or Result
				loop
					from
						elems.start
					until
						elems.after or Result
					loop
						if elem /= Current and then both_or_neither_are_partitions (elem) and then mbb.intersects (elem.model_bounding_box) then
						end
						elems.forth
					end
					areas.forth
				end
			end
		end

	is_too_close_to_object: BOOLEAN
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			bigger_mbb, other_mbb: RECTANGLE
			gap, other_grow, dist_x, dist_y: DOUBLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if intersects_any_field then
				if gap > 0.0 then
					create bigger_mbb.make_copy (mbb)
					bigger_mbb.size_by (2.0 * gap, 2.0 * gap)
					from
						areas.start
					until
						areas.after or Result
					loop
						from
							elems.start
						until
							elems.after or Result
						loop
							create other_mbb.make_copy (elem.model_bounding_box)
							if elem /= Current and then neither_is_partition (elem) and then not mbb.intersects (other_mbb) then
								other_mbb.size_by (other_grow, other_grow)
							end
							elems.forth
						end
						areas.forth
					end
				end
			end
		end

	is_actual_scribe_cut_die_too_big_for (a_max_die_size: CONST_POINT): BOOLEAN
		local
			l_max: CONST_POINT
			sx, sy: DOUBLE
		do
			if is_die then
				if l_max /= Void and actual_scribe_cut_die /= Void then
				end
			end
		end

	is_actual_scribe_cut_die_too_big: BOOLEAN
		local
			alt_max: CONST_POINT
		do
			if is_die then
				if Result then
					if alt_max /= Void then
					end
				end
			end
		end

	is_actual_scribe_cut_die_too_small: BOOLEAN
		local
			min_size: DOUBLE
		do
			if is_non_filler_die and actual_scribe_cut_die /= Void then
			end
		end

	is_actual_scribe_cut_die_way_too_small: BOOLEAN
		local
			min_size: DOUBLE
		do
			if is_non_filler_die and actual_scribe_cut_die /= Void then
			end
		end

	is_actual_cut_cut_die_too_big_for (a_max_die_size: CONST_POINT): BOOLEAN
		local
			l_max: CONST_POINT
			sx, sy: DOUBLE
		do
			if is_isolated_in_current_cut_pattern then
				if l_max /= Void and actual_cut_cut_die /= Void then
				end
			end
		end

	is_actual_cut_cut_die_too_big: BOOLEAN
		local
			alt_max: CONST_POINT
		do
			if is_isolated_in_current_cut_pattern then
				if Result then
					if alt_max /= Void then
					end
				end
			end
		end

	is_actual_cut_cut_die_too_small: BOOLEAN
		local
			min_size: DOUBLE
		do
			if is_non_filler_die and is_isolated_in_current_cut_pattern and actual_cut_cut_die /= Void then
			end
		end

	is_actual_cut_cut_die_way_too_small: BOOLEAN
		local
			min_size: DOUBLE
		do
			if is_non_filler_die and is_isolated_in_current_cut_pattern and actual_cut_cut_die /= Void then
			end
		end

	is_cut_cut_die_invalid: BOOLEAN
		do
		end

	has_wrong_lot_for_cut_pattern: BOOLEAN
		do
		end

	has_non_default_cut_die_size: BOOLEAN
		local
			l_cut_cut_die: like actual_cut_cut_die
		do
		end

	shares_cut_die_with_others: BOOLEAN
		do
		end

	is_extra_cut: BOOLEAN
		do
		end

	is_external_cut_at_wrong_position: BOOLEAN
		do
		end

	offset_cut_center_x: DOUBLE
		require
			virtual_edge_cut_die_not_void: virtual_edge_cut_die /= Void
		do
		end

	offset_cut_center_y: DOUBLE
		require
			virtual_edge_cut_die_not_void: virtual_edge_cut_die /= Void
		do
		end

	is_uncentered_in_cut_die: BOOLEAN
		local
			l_cut_die: like virtual_edge_cut_die
			diff_x, diff_y: DOUBLE
		do
			if can_be_isolated and l_cut_die /= Void then
			end
		end

	unisolated_in_scribe_cut_die: BOOLEAN
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if can_be_isolated and intersects_any_field then
				from
					areas.start
				until
					areas.after or Result
				loop
					from
						elems.start
					until
						elems.after or Result
					loop
						if elem /= Current and then mbb.intersects (elem.virtual_scribe_cut_die) then
						end
						elems.forth
					end
					areas.forth
				end
			end
		end

	unisolated_in_cut_cut_die: BOOLEAN
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if can_be_isolated then
				if mbb /= Void then
					from
						areas.start
					until
						areas.after or Result
					loop
						from
							elems.start
						until
							elems.after or Result
						loop
							if elem /= Current and then mbb.intersects (elem.virtual_scribe_cut_die) then
							end
							elems.forth
						end
						areas.forth
					end
				end
			end
		end

	can_be_isolated: BOOLEAN
		do
		end

	is_isolated_by_default: BOOLEAN
		do
		end

	is_isolated_in_any_cut_pattern: BOOLEAN
		do
		end

	is_isolated_in_current_cut_pattern: BOOLEAN
		do
		end

	is_isolated_in_cut_pattern (pat: RETICLE_VIEW_CUT_PATTERN): BOOLEAN
		do
		end

	appears_isolated: BOOLEAN
		local
			l_cut_cut_die: like virtual_cut_cut_die
		do
		end

	is_reworkable: BOOLEAN
		do
		end

	is_hidden: BOOLEAN

	is_displayed: BOOLEAN
		do
		end

	has_required_rotation: BOOLEAN
		do
		end

	required_rotation: INTEGER
		require
			has_required_rotation: has_required_rotation
		do
		end

	has_wrong_rotation: BOOLEAN
		do
		end

feature -- Modification

feature -- Operations

	set_view_coordinates
		do
		end

	set_selected (a_new_value, a_filter_matches: BOOLEAN)
		do
		end

	add_to_new_element_list
		do
		end

	add_to_region_if_selected_changed
		do
		end

	add_to_changed_region
		do
		end

	add_old_and_new_to_changed_region
		do
		end

	add_change (a_change: RETICLE_SIMPLE_CHANGE)
		do
		end

	add_prepended_change (a_change: RETICLE_SIMPLE_CHANGE)
		do
		end

	move_after_rotation (dist: DOUBLE)
		do
		end

	adjust_center
		do
		end

	try_to_toggle_rotation
		do
		end

	try_to_rotate_90_clockwise
		do
		end

	add_delete_error
		do
		end

	update_move_limits
		do
		end

	update_duplicate_limits
		do
		end

	update_duplicate_lists
		do
		end

	duplicate
		do
		end

	update_resize_limits (a_left_resize, a_right_resize, a_bottom_resize, a_top_resize: BOOLEAN)
		do
		end

	resize_by (a_resize_amount: CONST_POINT is_left_resize, is_right_resize, is_bottom_resize, is_top_resize: BOOLEAN)
		do
		end

	resize_scribe_by (a_resize_amount: CONST_POINT is_left_or_bottom: BOOLEAN)
		do
		end

	change_scribe_width (a_low_change, a_high_change: DOUBLE)
		do
		end

	delete
		require
			is_die: is_die
		do
		end

	isolate
		require
			is_die: is_die
		do
		end

	unisolate
		require
			is_die: is_die
		do
		end

	set_isolated_site_cut_die
		require
			is_die: is_die
		do
		end

	copy_display_attributes (an_element: like Current)
		do
		end

	prepare_for_horizontal_spread
		do
		end

	prepare_for_vertical_spread
		do
		end

	check_move_restrictions (a_distance: POINT)
		require
			a_distance_not_void: a_distance /= Void
		do
			if (is_locked_in_x and a_distance.x /= 0.0) or (is_locked_in_y and a_distance.y /= 0.0) then
			end
		end

	check_outside_fields
		do
			if not intersects_any_field then
				add_error (identification_for_message + " is outside all fields of view " + location_description)
			end
		end

	check_overlapping_field (scribes_included: BOOLEAN)
		do
			if partially_outside_fields and (scribes_included or is_non_scribe) then
				add_error (identification_for_message + " overlaps field edge " + location_description)
			end
		end

	check_overlapping_object (scribes_included: BOOLEAN)
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if intersects_any_field then
				from
					areas.start
				until
					areas.after
				loop
					from
						elems.start
					until
						elems.after
					loop
						if elem /= Current and then both_or_neither_are_partitions (elem) and then mbb.intersects (elem.model_bounding_box) and then (scribes_included or is_non_scribe or elem.is_non_scribe) then
							if not elem.is_marked and not invalid_elements.has (elem) then
								invalid_elements.extend (elem)
								add_error (identification_for_message + " overlaps " + elem.identification_for_message + "%N" + Indent + identification_for_message + " is " + location_description + "%N" + Indent + elem.identification_for_message + " is " + elem.location_description)
							end
						end
						elems.forth
					end
					areas.forth
				end
				mark
			end
		end

	check_too_close_to_object (scribes_included: BOOLEAN)
		local
			areas: LIST [RETICLE_MODEL_AREA]
			mbb: CONST_RECTANGLE
			bigger_mbb, other_mbb: RECTANGLE
			gap, other_grow, dist_x, dist_y: DOUBLE
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
		do
			if intersects_any_field then
				if gap > 0.0 then
					create bigger_mbb.make_copy (mbb)
					bigger_mbb.size_by (2.0 * gap, 2.0 * gap)
					from
						areas.start
					until
						areas.after
					loop
						from
							elems.start
						until
							elems.after
						loop
							create other_mbb.make_copy (elem.model_bounding_box)
							if elem /= Current and then neither_is_partition (elem) and then not mbb.intersects (other_mbb) and (scribes_included or is_non_scribe or elem.is_non_scribe) then
								other_mbb.size_by (other_grow, other_grow)
								if bigger_mbb.intersects (other_mbb) and (needs_min_sep_white_space or elem.needs_min_sep_white_space or dist_x /= 0.0 or dist_y /= 0.0) then
									if not elem.is_marked and not invalid_elements.has (elem) then
										invalid_elements.extend (elem)
										report_too_close_to_object (elem, dist_x, dist_y, minimum_separation_from (elem), not needs_min_sep_white_space and not elem.needs_min_sep_white_space)
									end
								end
							end
							elems.forth
						end
						areas.forth
					end
				end
				mark
			end
		end

	check_misaligned_scribe
		local
			areas: LIST [RETICLE_MODEL_AREA]
			area: RETICLE_MODEL_AREA
			elems: LIST [RETICLE_VIEW_ELEMENT]
			elem: RETICLE_VIEW_ELEMENT
			diff: DOUBLE
		do
			if intersects_any_field then
				from
					areas.start
				until
					areas.after
				loop
					from
						elems.start
					until
						elems.after
					loop
						if elem /= Current and then is_misaligned_with (elem) then
							if not elem.is_marked and not invalid_elements.has (elem) then
								invalid_elements.extend (elem)
								add_warning (identification_for_message + " is misaligned with " + elem.identification_for_message + " by " + grid.formatted_number (diff) + "%N" + Indent + identification_for_message + " is " + location_description + "%N" + Indent + elem.identification_for_message + " is " + elem.location_description)
							end
						end
						elems.forth
					end
					areas.forth
				end
				mark
			end
		end

	check_wrong_rotation
		do
			if has_wrong_rotation and not is_processed then
				set_processed
				add_error (identification_for_message + " rotation " + rotation.out + " does not match required rotation " + required_rotation.out)
			end
		end

	check_below_minimum_size
		do
			if is_below_minimum_size and not is_processed then
				set_processed
			end
		end

	check_no_lot_assigned
		do
			if is_wafer_etest_id_missing and not is_processed then
				set_processed
				add_error (identification_for_message + " has not been assigned to a lot split")
			end
		end

	check_unlocked
		do
			if is_cust_project and is_unlocked_project and not is_processed then
				set_processed
				add_warning (identification_for_message + " " + "is not locked against customer update")
			end
		end

	check_unassigned
		do
			if is_cust_project and is_unassigned_project and not is_processed then
				set_processed
				add_error (identification_for_message + " " + "is not assigned to this run")
			end
		end

	check_unlocked_or_unassigned
		do
			if is_cust_project and not is_processed then
				set_processed
				if is_unassigned_project then
					add_error (identification_for_message + " " + "is not assigned to this run")
				end
				if is_unlocked_project then
					add_warning (identification_for_message + " " + "is not locked against customer update")
				end
			end
		end

	check_too_close_to_edge (scribes_included: BOOLEAN)
		local
			l, r, t, b: DOUBLE
			l_bad, r_bad, t_bad, b_bad: BOOLEAN
		do
			if scribes_included or is_non_scribe then
				if l_bad then
					report_too_close_to_edge ("left", l, minimum_gap, not needs_min_sep_white_space)
				end
				if r_bad then
					report_too_close_to_edge ("right", r, minimum_gap, not needs_min_sep_white_space)
				end
				if t_bad then
					report_too_close_to_edge ("top", t, minimum_gap, not needs_min_sep_white_space)
				end
				if b_bad then
					report_too_close_to_edge ("bottom", b, minimum_gap, not needs_min_sep_white_space)
				end
			end
		end

	check_actual_scribe_cut_die_too_big
		local
			l_user_max: like user_max_die_size
			l_pkg_max: like packaging_max_die_size
			l_pkg_max_alt: like packaging_max_die_size_alt
			msg: STRING
		do
			if is_actual_scribe_cut_die_too_big_for (l_user_max) then
				if is_oversize_die_always_allowed then
					add_warning (msg)
				elseif is_oversize_die_possibly_allowed then
					add_warning (msg + oversize_inclusion_text)
				else
					add_error (msg)
				end
			end
			
			if l_pkg_max_alt = Void then
				if is_actual_scribe_cut_die_too_big_for (l_pkg_max) then
					add_error (msg)
				end
			else
				if is_actual_scribe_cut_die_too_big_for (l_pkg_max) and is_actual_scribe_cut_die_too_big_for (l_pkg_max_alt) then
					add_error (msg)
				end
			end
		end

	check_actual_scribe_cut_die_too_small
		local
			msg: STRING
			min_size: DOUBLE
			way_too_small: BOOLEAN
		do
			if is_actual_scribe_cut_die_too_small then
				if way_too_small then
				else
				end
				if way_too_small then
					add_error (msg)
				else
					add_warning (msg)
				end
			end
		end

	check_unisolated_in_scribe_cut_die
		do
			if unisolated_in_scribe_cut_die then
				add_warning (identification_for_message + " is not isolated in its cut die " + location_description)
			end
		end

	compute_unisolated_in_scribe_cut_die
		do
			if unisolated_in_scribe_cut_die then
			end
		end

	check_uncentered_in_cut_die
		do
			if is_uncentered_in_cut_die then
				add_warning (identification_for_message + " is offset from cut die center by " + offset_cut_center_description + " " + location_description)
			end
		end

	check_invalid_cut_die
		local
			what: STRING
		do
			if is_cut_cut_die_invalid then
				if has_surrounding_cuts then
				else
				end
				add_error (identification_for_message + " " + what + " " + location_description)
			end
		end

	check_actual_cut_cut_die_too_big
		local
			l_user_max: like user_max_die_size
			l_pkg_max: like packaging_max_die_size
			l_pkg_max_alt: like packaging_max_die_size_alt
			msg: STRING
		do
			if is_actual_cut_cut_die_too_big_for (l_user_max) then
				if is_oversize_die_always_allowed then
					add_warning (msg)
				elseif is_oversize_die_possibly_allowed then
					add_warning (msg + oversize_inclusion_text)
				else
					add_error (msg)
				end
			end
			
			if l_pkg_max_alt = Void then
				if is_actual_cut_cut_die_too_big_for (l_pkg_max) then
					add_error (msg)
				end
			else
				if is_actual_cut_cut_die_too_big_for (l_pkg_max) and is_actual_cut_cut_die_too_big_for (l_pkg_max_alt) then
					add_error (msg)
				end
			end
		end

	check_actual_cut_cut_die_too_small
		local
			msg: STRING
			min_size: DOUBLE
			way_too_small: BOOLEAN
		do
			if is_actual_cut_cut_die_too_small then
				if way_too_small then
				else
				end
				if way_too_small then
					add_error (msg)
				else
					add_warning (msg)
				end
			end
		end

	check_wrong_lot
		do
			if has_wrong_lot_for_cut_pattern then
				add_warning (identification_for_message + " has wrong lot " + assigned_wafer_etest_id + " - cut pattern is for lot " + current_cut_pattern.wafer_etest_id + "%N    " + identification_for_message + " is " + location_description)
			end
		end

	check_non_default_cut_die_size
		local
			msg: STRING
		do
			if has_non_default_cut_die_size then
				add_urgent_warning (msg)
				add_warning (msg)
			end
		end

	check_shared_cut_die
		local
			msg: STRING
		do
			if is_isolated_in_current_cut_pattern and unisolated_in_cut_cut_die then
				add_urgent_warning (msg)
				add_warning (msg)
			end
		end

	check_extra_cut
		do
			if is_extra_cut then
				add_warning (identification_for_message + " is an extra cut that does not help isolate any isolated sites " + location_description)
			end
		end

	check_wrong_position_external_cut
		do
			if is_external_cut_at_wrong_position then
				add_error (identification_for_message + " is an external cut that is at the wrong position " + location_description)
			end
		end

	check_cut_to_cut_distance (prev_cut: like Current min_dist: DOUBLE)
		do
		end

	check_cut_to_strip_cut_distance (prev_cut: like Current min_strip_width: DOUBLE)
		do
		end

	check_empty_partition
		do
			if is_partition and intersects_any_field and not contains_project then
				add_warning (identification_for_message + " is an empty partition " + "%N" + Indent + identification_for_message + " is " + location_description)
			end
		end

	set_invalid_partition_edge_position (bad_left, bad_right, bad_bottom, bad_top: BOOLEAN)
		do
			add_error (identification_for_message + " is a partition with an edge in an invalid position (not on field edge or near edge of scribe)" + "%N" + Indent + "Invalid edge position on " + invalid_edge_position_text (bad_left, bad_right, bad_bottom, bad_top) + "%N" + Indent  + identification_for_message + " is " + location_description)
		end

	check_not_contained_in_partition (list: LIST [RETICLE_VIEW_ELEMENT])
		do
			if intersects_any_field and not is_contained_in_any_element (list) then
				add_error (identification_for_message + " is not completely inside any partition" + "%N" + Indent + identification_for_message + " is " + location_description)
			end
		end

	check_partially_in_partition (list: LIST [RETICLE_VIEW_ELEMENT])
		do
			if intersects_any_field and intersects_any_element (list) and not is_contained_in_any_element (list) then
				add_error (identification_for_message + " intersects a partition but is not completely inside any partition" + "%N" + Indent + identification_for_message + " is " + location_description)
			end
		end

	check_invalid_scribe_placement (list: LIST [RETICLE_VIEW_ELEMENT])
		require
			is_scribe: is_scribe
		do
			if intersects_any_field and not intersects_any_element (list) then
				if abuts_field_edge_on_length_side then
					add_error (identification_for_message + " is outside all partitions and its length side abuts field of view edge" + "%N" + Indent + identification_for_message + " is " + location_description)
				elseif not abuts_element_on_both_sides (list) then
					add_error (identification_for_message + " is outside all partitions and does not abut a partition on both length sides" + "%N" + Indent + identification_for_message + " is " + location_description)
				end
			end
		end

	check_wrong_lot_for_partition (list: LIST [RETICLE_VIEW_ELEMENT])
		local
			l_partition: RETICLE_VIEW_ELEMENT
			msg: STRING
		do
			if intersects_any_field then
				if l_partition /= Void and then mismatches_partition_lot (l_partition) then
					if all_compatible_etest_names_manufacturable and not any_compatible_etest_name_matches (l_partition) then
						add_error (msg)
					else
						add_warning (msg)
					end
				end
			end
		end

	set_floating_scribe
		do
			set_is_floating_scribe (True)
			add_warning (identification_for_message + " is a floating scribe " + location_description)
		end

	set_misaligned_scribe
		do
			set_is_misaligned_scribe (True)
			add_warning (identification_for_message + " is a misaligned scribe " + location_description)
		end

	report_small_but_legal (scribes_included: BOOLEAN)
		do
			if scribes_included or is_non_scribe then
				set_processed
				add_warning (identification_for_message + " size " + size_description + " is legal but small " + location_description)
			end
		end

	add_field
		do
		end

	add_error (a_message: STRING)
		require
			a_message_not_void: a_message /= Void
		do
		end

	add_warning (a_message: STRING)
		require
			a_message_not_void: a_message /= Void
		do
		end

	add_urgent_warning (a_message: STRING)
		require
			a_message_not_void: a_message /= Void
		do
		end

	set_processed
		do
			all_copies.set_processed
		end

	clear_processed
		do
			all_copies.clear_processed
		end

	set_rotation_move_distance (d: DOUBLE)
		do
			all_copies.set_rotation_move_distance (d)
		end

	uncache_all_copies_selected
		do
			all_copies.uncache_all_elements_selected
		end

	uncache_any_copies_selected
		do
			all_copies.uncache_any_elements_selected
		end

	uncache_any_copies_stationary_orientation
		do
			all_copies.uncache_any_elements_stationary_orientation
		end

	uncache_any_copies_rotation_locked
		do
			all_copies.uncache_any_elements_rotation_locked
		end

	uncache_any_copies_contain
		do
		end

	include_in_selection_bounding_box
		do
		end

	mark
		do
		end

	unmark
		do
		end

	clear_invalid_elements
		do
			create {ARRAYED_LIST [RETICLE_VIEW_ELEMENT]} invalid_elements.make (5)
			invalid_elements.compare_references
		end

	set_is_floating_scribe (b: BOOLEAN)
		do
		ensure
			value_set: is_floating_scribe = b
		end

	set_is_misaligned_scribe (b: BOOLEAN)
		do
		ensure
			value_set: is_misaligned_scribe = b
		end

	set_is_empty_partition (b: BOOLEAN)
		do
		ensure
			value_set: is_empty_partition = b
		end

	set_is_partition_with_invalid_edge (b: BOOLEAN)
		do
		ensure
			value_set: is_partition_with_invalid_edge = b
		end

	set_is_not_contained_in_partition (b: BOOLEAN)
		do
		ensure
			value_set: is_not_contained_in_partition = b
		end

	set_is_partially_in_partition (b: BOOLEAN)
		do
		ensure
			value_set: is_partially_in_partition = b
		end

	set_is_invalidly_placed_scribe (b: BOOLEAN)
		do
		ensure
			value_set: is_invalidly_placed_scribe = b
		end

	set_has_wrong_lot_for_partition (b: BOOLEAN)
		do
		ensure
			value_set: has_wrong_lot_for_partition = b
		end

	initialize_intersecting_mbb_areas (n: INTEGER)
		do
			create {ARRAYED_LIST [RETICLE_MODEL_AREA]} intersecting_mbb_areas.make (n)
		end

	initialize_intersecting_scribe_cut_die_areas (n: INTEGER)
		do
			create {ARRAYED_LIST [RETICLE_MODEL_AREA]} intersecting_scribe_cut_die_areas.make (n)
		end

	initialize_intersecting_cut_cut_die_areas (n: INTEGER)
		do
			create {ARRAYED_LIST [RETICLE_MODEL_AREA]} intersecting_cut_cut_die_areas.make (n)
		end

	initialize_intersecting_hscribe_areas (n: INTEGER)
		do
			create {ARRAYED_LIST [RETICLE_MODEL_AREA]} intersecting_hscribe_areas.make (n)
		end

	initialize_intersecting_vscribe_areas (n: INTEGER)
		do
			create {ARRAYED_LIST [RETICLE_MODEL_AREA]} intersecting_vscribe_areas.make (n)
		end

	populate_intersecting_mbb_areas
		do
		end

	populate_intersecting_scribe_cut_die_areas
		do
		end

	populate_intersecting_cut_cut_die_areas
		do
		end

	populate_intersecting_hscribe_areas
		do
		end

	populate_intersecting_vscribe_areas
		do
		end

	populate_intersecting_areas (areas: LIST [RETICLE_MODEL_AREA]  mbb: CONST_RECTANGLE intersecting_areas: like intersecting_mbb_areas)
		local
			area: RETICLE_MODEL_AREA
		do
			if intersects_any_field then
				if mbb /= Void then
					from
						areas.start
					until
						areas.after
					loop
						if mbb.intersects (area.rectangle) then
							area.intersecting_elements.extend (Current)
							intersecting_areas.extend (area)
						end
						areas.forth
					end
				end
			end
		end

	increment_centered_count
		do
		end

	report_isolation_failure
		do
			if has_surrounding_cuts then
				add_error (identification_for_message + " has a cut through the printed die " + location_description)
			else
				add_error (identification_for_message + " is not surrounded by cuts on all sides " + location_description)
			end
		end

feature {NONE} -- Implementation

	verify_rotation_allowed
		do
			if any_copies_rotation_locked then
				add_rotate_warning ("Cannot rotate " + identification_for_message + " because at least one copy is rotation-locked")
			elseif is_stationary_orientation then
				add_rotate_warning ("Cannot rotate " + identification_for_message + " because its orientation is fixed")
			elseif not is_rotatable then
			elseif not all_copies_selected then
				add_rotate_warning ("Cannot rotate " + identification_for_message + " because not all copies are selected")
			else
			end
		end

	move_distance_for_rotation_change (old_rot, new_rot: INTEGER): DOUBLE
		do
			if (grid.rounded_size_units (size_x) \\ 2) /= (grid.rounded_size_units (size_y) \\ 2) then
				if (old_rot \\ 180) = (new_rot \\ 180) then
				elseif new_rot \\ 180 = 90 then
				elseif new_rot \\ 180 = 0 then
				else
				end
			else
			end
		end

	add_rotate_warning (a_message: STRING)
		do
			if not is_processed then
				add_warning (a_message)
				set_processed
			end
		end

	last_rotation_ok: BOOLEAN

	anchored_model_element: RETICLE_MODEL_ELEMENT
		do
		end

	anchored_view_sub_element: RETICLE_VIEW_SUB_ELEMENT
		do
		end

	unselectable_elements: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	unselected_elements: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	previously_selected_elements: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	newly_selected_elements: LIST [RETICLE_VIEW_ELEMENT]
		do
		end

	report_too_close_to_edge (an_edge: STRING a_distance, a_minimum_gap: DOUBLE a_zero_ok: BOOLEAN)
		local
			zero: STRING
		do
			if a_zero_ok then
			else
			end
			add_warning (identification_for_message + " is too close to field " + an_edge + " edge (gap = " + grid.formatted_number (a_distance) + ", requires " + zero + " gap >= " + grid.formatted_number (a_minimum_gap) + ") " + location_description)
		end

	report_too_close_to_object (an_element: RETICLE_VIEW_ELEMENT a_distance_x, a_distance_y, a_minimum_gap: DOUBLE a_zero_ok: BOOLEAN)
		local
			zero: STRING
			dist: DOUBLE
		do
			if a_zero_ok then
			else
			end
			if a_distance_x = 0.0 then
			elseif a_distance_y = 0.0 then
			else
			end

			add_warning (identification_for_message + " is too close to " + an_element.identification_for_message + " (gap = " + grid.formatted_number (dist) + ", requires " + zero + " gap >= " + grid.formatted_number (a_minimum_gap) + ")%N" + Indent + identification_for_message + " is " + location_description + "%N" + Indent + an_element.identification_for_message + " is " + an_element.location_description)
		end

	oversize_inclusion_text: STRING
		do
		end

	invalid_edge_position_text (bad_left, bad_right, bad_bottom, bad_top: BOOLEAN): STRING
		do
			create Result.make (30)
			if bad_left then
				Result.append ("Left")
			end
			if bad_right then
				if not Result.is_empty then
				end
				Result.append ("Right")
			end
			if bad_bottom then
				if not Result.is_empty then
				end
				Result.append ("Bottom")
			end
			if bad_top then
				if not Result.is_empty then
				end
				Result.append ("Top")
			end
		end

	packaging_max_die_size_1: CONST_POINT
		require
			is_die: is_die
		local
			fixed_max, free_max: CONST_POINT
		do
			if free_max = Void then
			elseif fixed_max = Void then
			else
			end
		end

	packaging_max_die_size_2: CONST_POINT
		require
			is_die: is_die
		local
			fixed_max, free_max: CONST_POINT
		do
			if free_max = Void or else free_max.x = free_max.y then
			elseif fixed_max = Void then
				create Result.make_xy (free_max.y, free_max.x)
			else
			end
		end

	max_die_size_for_package_max (pkg_max: CONST_POINT): CONST_POINT
		require
			is_die: is_die
		local
			user_max: CONST_POINT
		do
			if pkg_max = Void and user_max = Void then
				
			elseif pkg_max = Void then
			elseif user_max = Void then
			else
				create Result.make_xy (pkg_max.x.min (user_max.x), pkg_max.y.min (user_max.y))
			end
		end

	Max_inclusion_length: INTEGER = 100

	Indent: STRING = "    "

end
