class CONST_LINE
	-- a line in the 2D plane
	-- A, B, and C are simply creation-time attributes

inherit
	VIRTUAL_LINE

create
	make, make_copy, make_reversed

feature
	A, B, C: DOUBLE
		-- the line parameters

feature {NONE} -- creation

	make(aa, bb, cc: DOUBLE)
	do  a := aa; b := bb; c := cc
	ensure A = aa and B = bb and C = cc
	end;

	make_copy(other: VIRTUAL_LINE)
	require other /= Void
	do  make(other.a, other.b, other.c)
	end;

	make_reversed(other: VIRTUAL_LINE)
		-- same line, but reverse direction
	require other /= Void
	do  make(-other.a, -other.b, -other.c)
	end;

end -- CONST_LINE
