class CONST_POINT
	-- a single point (units indeterminate) in the plane

inherit
	VIRTUAL_POINT

create
	make_xy,
	make_polar,
	make_polar_degrees

feature -- x and y are just attributes

	x, y: DOUBLE

feature {NONE} -- creation

	make_xy (a_x, a_y: DOUBLE)
			-- Assign `a_x' to `x' and `a_y' to `y'.
		do
			x := a_x
			y := a_y
		ensure
			x_assigned: x = a_x
			y_assigned: y = a_y
		end

	make_polar(rad, theta: DOUBLE)
		-- theta is in radians
	require rad >= 0
	do  x := rad * cosine(theta);
	    y := rad * sine(theta)
	end;

	make_polar_degrees(rad, theta: DOUBLE)
		-- theta is in degrees
	require rad >= 0
	do  if theta = 0
	     then x := rad; y := 0
	    elseif theta = 90 or theta = -270
	     then x := 0; y := rad
	    elseif theta = 180 or theta = -180
	     then x := -rad; y := 0
	    elseif theta = 270 or theta = -90
	     then x := 0; y := -rad
	     else make_polar(rad, theta/radians_to_degrees)
	    end
	end;

end -- CONST_POINT
