class LINE_SEGMENT
	-- a line segment that can be modified and/or reused

inherit
	CONST_LINE_SEGMENT
	export {ANY} make, make_xy, make_copy
				-- allow re-making
	end;

create
	make,
	make_xy,
	make_copy

feature	-- modification

	reverse
		-- switch pt1 and pt2
	local t: DOUBLE;
	do  t := x1; x1 := x2; x2 := t;
	    t := y1; y1 := y2; y2 := t
	end;

	extend(d: DOUBLE)
		-- move pt2 so that it is d farther away from pt1
	require length + d >= 0
	local  p: POINT;
	do  -- NOTE: using degrees to maintain exactitude in Manhattan
	    create p.make_polar_degrees(length+d, degrees);
					-- new vector
	    x2 := x1 + p.x;		-- and then, new pt2
	    y2 := y1 + p.y;
	ensure virtually_equal(length, old length + d)
	end;

end -- LINE_SEGMENT
