class POINT
	-- a single point (units indeterminate) in the plane

inherit
	CONST_POINT
	export {ANY} make_xy, make_polar, make_polar_degrees
		-- these routines can here be used to redefine the POINT
	end;

create
	make_xy,
	make_polar,
	make_polar_degrees

feature -- alteration

	set_x(nx: DOUBLE)
		-- just move in x
	do  x := nx
	end;

	set_y(ny: DOUBLE)
		-- just move in y
	do  y := ny
	end;

	move_by(dx, dy: DOUBLE)
		-- move me by (x,y)
	do  make_xy(x + dx, y + dy)
	end;

	transform_by(m: MATRIX)
		-- transform me by m
	require have_matrix: m /= Void
	local nx, ny: DOUBLE
	do  nx := m.transformed_x(x, y);
	    ny := m.transformed_y(x, y);
	    x := nx;
	    y := ny
	end;

	snap_to_grid(grid: DOUBLE)
		-- move myself to nearest grid point in x and y
	require valid_grid: grid > 0
	do  set_x (nu.rounded_to_resolution(x, grid))
	    set_y (nu.rounded_to_resolution(y, grid))
	end;

end -- POINT
