
note
	
	description: "An operation that checks that a value in a row %
		%retrieved from the database is not null"
	author: "David Hollenberg"
	date: "March 2, 2004"

class NULL_VALUE_CHECK_OP
inherit
	OPERATION
		rename
			try_operation as try_to_check_nullness
		end

create
	default_create

feature -- Operations

	check_not_null (col_name: STRING is_null: BOOLEAN obj: ANY)
			-- Check that value for `col_name' in object `obj'
			-- is not null
		require
			col_name_exists: col_name /= Void
			object_exists: obj /= Void
		do
			if is_null then
				column_name := col_name
				object := obj
				execute
			end
		end

feature {NONE} -- Implementation

	column_name: STRING
			-- Name of column with null value

	object: ANY
			-- Object which contains null value

	try_to_check_nullness
			-- Try to check nullness
		local
			error: NULL_VALUE_ERROR
		do
			create error
			error.set_hard_error
			error.disable_retry
			error.set_column_name (column_name)
			error.set_object_type (object.generating_type)
			error.handle
		end

end
