
note
	
	author: "David Hollenberg"
	date:	"December 11, 1995"
	description: "Description of a month in the year"
		
class MONTH_DESCRIPTION

create
	make

feature {NONE} -- Creation
	
	make (the_name, abbrev: STRING num, d, leapd: INTEGER)
			-- Create month description with name `the_name'
			-- abbreviation `abbrev'.  Month is number `num'
			-- and has `d' days if it falls in a non-leap
			-- year and `leapd' days if it falls in a leap year.
		do
			name := the_name
			abbreviation := abbrev
			number := num
			days := d
			leap_year_days := leapd
		end

feature -- Properties
	
	name: STRING
			-- Name of month
	
	abbreviation: STRING
			-- Three character abbreviation
	
	number: INTEGER
			-- Integer number of month (1-12)
	
	days: INTEGER
			-- Number of days in month
	
	leap_year_days: INTEGER
			-- Number of days in month in a leap year
	
end
